/*->c.buttons */

#include <stdafx.h>

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <locale.h>
#include <time.h>

#include "os.h"
#include "wimp.h"
#include "wimpt.h"
#include "werr.h"
#include "wos.h"
#include "colour.h"
#include "flex.h"
#include "bbc.h"
#include "akbd.h"
#include "transform.h"

#include "err.h"
#include "xext.h"
#include "poll.h"
#include "temp.h"
#include "alloc.h"
#include "fsx.h"
#include "sp.h"
#include "bits.h"

#include "key.h"
#include "wimptext.h"
#include "xhelp.h"
#include "applet.h"
#include "timex.h"
#include "deb.h"
#include "tooltips.h"


#include "etc.h"

#include "str.h"
#include "constants.h"
#include "reslink.h"
#include "file.h"
#include "page.h"


#include "viewo.h"
#include "view.h"



#include "macros.h"
#include "dbmacros.h"
#include "dbmore.h"


#include "caret.h"

#include "buttons.h"




#define TXEXTRA 20



       sprite_area * buttonarea;
static int           buttonhandle;
static getbfn        getbutton;
static wimp_icon   * buttonicon;


static int           bwidth;
static int           bheight;
static int           bfx;
static int           bfy;
static int           bstepx;
static int           bstepy;


static wimp_icon   * bticon;
static wimp_icon   * bgicon;


static int           paneheight;
static int           barwidth;
static int           halfbarwidth;
static int           scrollbarwidth;
static int           linestep;

static int           buttonbarn;



static os_error * buttonheightchanged(int oldn,int newn);




static char    * exstring;
static char    * exlimit;



static os_error * expfn(int c)
{
 if(exstring<exlimit)
 {
  *exstring++=(char)c;
  *exstring=0;
 }
 return(NULL);
}



static os_error * getmacrodata(char * string,int maxlen,int n,viewstr * view)
{
 os_error * err;
 int        macenv;

 exstring=string;
 exlimit=exstring+maxlen-1;

 macenv=MACENVBUT|(8<<8);

	xerrormode(XERRNOREPORT);
 err=expandamacro(expfn,n,macenv,(int)view);
	xerrormode(0);

//	cprintf("getmacrodata");
	if(err) cprintf("getmacdata %s",err->errmess);

 return(err);
}






static os_error * buttontipsetup(viewstr * view,int add)
{
	os_error * err;
 int        xlo;
 int        xhi;
 int        ylo;
 int        yhi;
 int        xhi2;
 int        n;
 int        r;
 int        txwidth;
	wimp_box   box;
	char     * p;
	char       tipstring[256];


	err=NULL;


 xlo=bgicon->box.x0-view->bshift;
 yhi=-bgicon->box.y0;
 ylo=-bgicon->box.y1;

 r=0;

 for(n=0;n<macrostot;n++)
 {
  if(macros[n].type==TYPEBUTTON && (macros[n].flags & MACACTIVE))
  {
   if(macros[n].flags & MACNL)
   {
    ylo-=linestep;
    yhi-=linestep;
    xlo=bgicon->box.x0-view->bshift;
    r++;
   }

   if(macros[n].flags & MACGAP) xlo+=halfbarwidth;

   if(((macros[n].flags & MACEXTEND) && !(macros[n].flags & MACEXTEXT)) ||
       (!(macros[n].flags & MACEXTEND) && (*macros[n].data.data))
      )
   {
    xhi=xlo+barwidth;
   }
   else
   {
    txwidth=(macros[n].flags & MACTXWIDTH)>>MACTXSHIFT;

    if((macros[n].flags & MACEXTEND) && txwidth) xhi=xlo+txwidth;
    else xhi=xlo+wimpfontstringwidth(macros[n].name,view->hpane)+TXEXTRA;
   }

   xhi2=xhi+bticon->box.x0-bgicon->box.x1;

			// ylo=3 yhi=48

			box.x0=xlo;
			box.x1=xhi;
			box.y0=-yhi;
			box.y1=-ylo;

//   if(r)	cprintf("ylo %d yhi %d bshift %d",ylo,yhi,view->bshift);

   macrotip(&p,n);
			if(p==NULL || *p==0)
			{
 			macrohelp(&p,n);
 			if(p!=NULL && *p!=0)
 			{
 				gstrans(tipstring,NITEM(tipstring),p,NULL);
 				p=tipstring;
 				while(1)
 				{
 					if(((*p)=='.' && (*(p+1))<=' ')	|| *p<' ')
 					{
 						*p=0;
 						break;
 					}
	 				p++;
	 			}
					p=tipstring;
				}
				else
				{
					p=NULL;
				}
			}

			if(p) tooltipadd(view->buttontips,view->hpane,n,&box,p,add?0:TTIPREPOSN);

   xlo=xhi2;
  }
 }

	return(err);
}





static os_error * buttontipsfinit(viewstr * view)
{
	os_error * err;

	err=tooltipend(view->hpane,view->buttontips,0);

	return(err);
}


// a new buttons window is created

static os_error * buttontipsinit(viewstr * view)
{
	os_error * err;

	err=NULL;

	if(ihelp)
	{
 	err=tooltipstart(view->hpane,-1,&view->buttontips,0);
 	if(!err) err=buttontipsetup(view,1);
	}
	else
	{
  view->buttontips=NULL;
	}

	return(err);
}



static os_error *	buttontipsrebuild(viewstr * view)
{
	os_error * err;

	cprintf("tipsrebuild");

 err=buttontipsfinit(view);
	if(!err) err=buttontipsinit(view);

	return(err);
}



static os_error *	buttontipsreposn(viewstr * view)
{
	os_error * err;

	cprintf("tipsreposn");

	err=buttontipsetup(view,0);

	return(err);
}





static os_error * buttonredrawsub(int handle,wimp_redrawstr * redrawstr,
                                                 int more,viewstr * view)
{
	os_error * err;
 int        oy;
 int        ox;
 int        ylo;
 int        yhi;
 int        xlo;
 int        xhi;
 int        n;
 int        x;
 int        nx;
 int        y;
 int        ny;
 char       buffer[256];
 wimp_icon  icon;
 int        r;
 int        txwidth;
 int        len;


	err=NULL;

 while(more)
 {
  ox=redrawstr->box.x0-redrawstr->scx;
  oy=redrawstr->box.y1-redrawstr->scy;

  yhi=redrawstr->g.y1-oy;
  ylo=redrawstr->g.y0-oy;
  xlo=redrawstr->g.x0-ox;
  xhi=redrawstr->g.x1-ox;

  x=bgicon->box.x0;

  y=bgicon->box.y1;
  ny=bgicon->box.y0;

  for(r=n=0;n<macrostot;n++)
  {
   if(macros[n].type==TYPEBUTTON && (macros[n].flags & MACACTIVE))
   {
    if(macros[n].flags & MACNL)
    {
     y+=linestep;
     ny+=linestep;
     x=bgicon->box.x0;
     r++;
     if(r>buttonbarn) break;
    }

    if(macros[n].flags & MACGAP) x+=halfbarwidth;

    if(y<ylo) break;

    if(ny<=yhi && x<=xhi)
    {
     if(((macros[n].flags & MACEXTEND) && !(macros[n].flags & MACEXTEXT)) ||
        (!(macros[n].flags & MACEXTEND) && (*macros[n].data.data))
       )
     {
      nx=x+barwidth;
   
      if(nx>=xlo)
      {
       icon=*bgicon;

       icon.box.x0=ox+x;
       icon.box.x1=ox+nx;
       icon.box.y1=oy+y;
       icon.box.y0=oy+ny;

       xstrncpy(buffer,icon.data.indirecttext.buffer,sizeof(buffer));
       icon.data.indirecttext.buffer=buffer;

       if(macros[n].flags & MACEXTEND)
       {
        len=strlen(buffer);
        err=getmacrodata(buffer+len,sizeof(buffer)-len,n,view);
       }
       else
       {
        strcat(buffer,macros[n].data.data);
								err=NULL;
       }

// can get errors here if redraw macro is missing

//    cprintf("x0 %d x1 %d y0 %d y1 %d",icon.box.x0,icon.box.x1,icon.box.y0,icon.box.y1);

       if(!err) wimp_ploticon(handle,&icon,buttonarea);
      }
     }
     else
     {
     /* nx=x+strlen(macros[n].name)*32; */

      txwidth=(macros[n].flags & MACTXWIDTH)>>MACTXSHIFT;

      if((macros[n].flags & MACEXTEND) && txwidth) nx=x+txwidth;
      else nx=x+wimpfontstringwidth(macros[n].name,view->hpane)+TXEXTRA;

      if(nx>=xlo)
      {
       icon=*bticon;

       icon.box.x0=ox+x;
       icon.box.x1=ox+nx;
       icon.box.y1=oy+y;
       icon.box.y0=oy+ny;

       xstrncpy(buffer,icon.data.indirecttext.buffer,sizeof(buffer));
       icon.data.indirecttext.buffer=buffer;
       len=strlen(buffer);

       if(macros[n].flags & MACEXTEND)
       {
        err=getmacrodata(buffer+len,sizeof(buffer)-len,n,view);
       }
       else
       {
        xzstrncpy(buffer+len,macros[n].name,sizeof(buffer)-len);
								err=NULL;
       }
// can get error here if macro is missing

       if(!err) wimp_ploticon(handle,&icon,buttonarea);
      }
     }
     x=nx+bticon->box.x0-bgicon->box.x1;
    }
   }
  }

  wimp_get_rectangle(redrawstr,&more);
 }

 return(NULL);
}



static os_error * buttonredraw(int handle,int userhandle)
{
 os_error       * err;
 wimp_redrawstr   redrawstr;
 int              more;
 redrawstr.w=handle;
 err=wimp_redraw_wind(&redrawstr,&more);
 if(!err) buttonredrawsub(handle,&redrawstr,more,(viewstr*)userhandle);
 return(err);
}




static int buttoninsert(int handle,int x,int y,int * row)
{
 int        xlo;
 int        xhi;
 int        xhi2;
 int        ylo;
 int        yhi;
 int        n;
 int        r;
 int        seenrow;
 int        nr;
 int        nmax;
 int        txwidth;


 xlo=bgicon->box.x0;
 yhi=-bgicon->box.y0;
 ylo=-bgicon->box.y1;

 r=0;
 nr=0;
 seenrow=0;
 nmax=0;

 for(n=0;n<macrostot;n++)
 {
  if(macros[n].type==TYPEBUTTON && (macros[n].flags & MACACTIVE))
  {
   if(macros[n].flags & MACNL)
   {
    ylo-=linestep;
    yhi-=linestep;
    xlo=bgicon->box.x0;
    r++;
    nr=0;
   }

   if(y>=ylo && y<=yhi)
   {
    seenrow=1;
    nmax=n;

    if(((macros[n].flags & MACEXTEND) && !(macros[n].flags & MACEXTEXT)) ||
       (!(macros[n].flags & MACEXTEND) && (*macros[n].data.data))
      )
    {
     xhi=xlo+barwidth;
    }
    else
    {
     txwidth=(macros[n].flags & MACTXWIDTH)>>MACTXSHIFT;

     if((macros[n].flags & MACEXTEND) && txwidth) xhi=xlo+txwidth;
     else     xhi=xlo+wimpfontstringwidth(macros[n].name,handle)+TXEXTRA;
    }

    if(macros[n].flags & MACGAP) xhi+=halfbarwidth;

    xhi2=xhi+bticon->box.x0-bgicon->box.x1;

    if((x>=xlo && x<=xhi2) || (nr==0 && x<=xhi2))
    {
     *row=(nr==0);
     return(n);
    }

    xlo=xhi2;
    nr++;
   }

   if(y<ylo) break;
  }
 }


 if(seenrow)
 {
  *row=0;
  return(nmax+1);
 }
 else
 {
  *row=1;
  return(macrostot);
 }
}








static int buttonextent(int handle)
{
 int        xlo;
 int        xhi;
 int        n;
 int        maxx;
 int        txwidth;


 xlo=bgicon->box.x0;
 maxx=0;

 for(n=0;n<macrostot;n++)
 {
  if(macros[n].type==TYPEBUTTON && (macros[n].flags & MACACTIVE))
  {
   if(macros[n].flags & MACNL)
   {
    maxx=MAX(xlo,maxx);
    xlo=bgicon->box.x0;
   }

   if(macros[n].flags & MACGAP) xlo+=halfbarwidth;

   if(((macros[n].flags & MACEXTEND) && !(macros[n].flags & MACEXTEXT)) ||
      (!(macros[n].flags & MACEXTEND) && (*macros[n].data.data))
     )
   {
    xhi=xlo+barwidth;
   }
   else
   {
    txwidth=(macros[n].flags & MACTXWIDTH)>>MACTXSHIFT;

    if((macros[n].flags & MACEXTEND) && txwidth) xhi=xlo+txwidth;
    else xhi=xlo+wimpfontstringwidth(macros[n].name,handle)+TXEXTRA;
   }

   xlo=xhi+bticon->box.x0-bgicon->box.x1;
  }
 }

 maxx=MAX(xlo,maxx);
 return(maxx+halfbarwidth);
}







static int findbutton(int handle,int x,int y,int nm,int * xl,int * xh,int * row)
{
 int        xlo;
 int        xhi;
 int        ylo;
 int        yhi;
 int        xhi2;
 int        n;
 int        r;
 int        txwidth;


 xlo=bgicon->box.x0;
 yhi=-bgicon->box.y0;
 ylo=-bgicon->box.y1;

 r=0;

 for(n=0;n<macrostot;n++)
 {
  if(macros[n].type==TYPEBUTTON && (macros[n].flags & MACACTIVE))
  {
   if(macros[n].flags & MACNL)
   {
    ylo-=linestep;
    yhi-=linestep;
    xlo=bgicon->box.x0;
    r++;
   }

   if((y>=ylo && y<=yhi) || nm>=0)
   {
    if(macros[n].flags & MACGAP) xlo+=halfbarwidth;

    if(((macros[n].flags & MACEXTEND) && !(macros[n].flags & MACEXTEXT)) ||
       (!(macros[n].flags & MACEXTEND) && (*macros[n].data.data))
      )
    {
     xhi=xlo+barwidth;
    }
    else
    {
     txwidth=(macros[n].flags & MACTXWIDTH)>>MACTXSHIFT;

     if((macros[n].flags & MACEXTEND) && txwidth) xhi=xlo+txwidth;
     else xhi=xlo+wimpfontstringwidth(macros[n].name,handle)+TXEXTRA;
    }

    xhi2=xhi+bticon->box.x0-bgicon->box.x1;

    if((nm<0 && x>=xlo && x<=xhi) || nm==n)
    {
     if(xl)  *xl=xlo;
     if(xh)  *xh=xhi;
     if(row) *row=r;
     return(n);
    }

    xlo=xhi2;
    if(xlo>x && nm<0) break;
   }

   if(y<ylo && nm<0) break;
  }
 }

 return(-1);
}








static int dragaspritestarted;


static os_error * xdragasprite(int n,wimp_dragstr * dblock,viewstr * view)
{
#ifdef NEVER
 os_error * err;
 os_regset  rx;
 char       temp[256];  /* gets around crash in DragASprite cf DP135 */

 err=NULL;

 return(err);


 if(((macros[n].flags & MACEXTEND) && !(macros[n].flags & MACEXTEXT)) ||
    (!(macros[n].flags & MACEXTEND) && (*macros[n].data.data))
   )
 {
  rx.r[0]=161;
  rx.r[1]=28;
//  err=os_swix(OS_Byte,&rx);
  if(!err && (rx.r[2] & 0x2))
  {
   memset(temp,0,sizeof(temp));

   if(macros[n].flags & MACEXTEND)
   {
    getmacrodata(temp,sizeof(temp),n,view);
   }
   else
   {
    strcpy(temp,macros[n].data.data);
   }

   rx.r[0]=(01)+((01)<<2)+((10)<<4)+((0)<<6)+((1)<<7);
   rx.r[1]=(int)buttonarea;
   rx.r[2]=(int)temp;
   rx.r[3]=(int)&dblock->box;
   rx.r[4]=(int)&dblock->parent;
//   err=os_swix(DragASprite_Start,&rx);

   dragaspritestarted=(err==NULL);
  }
 }

 return(err);
#endif
 return(NULL);

 USE(n);
 USE(dblock);
 USE(view);

}


static os_error * xdragaspritestop(void)
{
 os_error * err;
// os_regset  rx;

 err=NULL;
/*
 if(dragaspritestarted) err=os_swix(DragASprite_Stop,&rx);
 else                   err=NULL;
*/
 return(err);
}



static int startmacro;


static void buttonzero(viewstr * view);

static os_error * buttonzero2(viewstr * view,wimp_mousestr * m);







static os_error * movedragend(int handle,int userhandle,wimp_box * box)
{
 os_error   * err;
 mousestr     mouse;
 int          n;
 int          m;
 windowstr    window;
 int          x;
 int          y;
 int          row;
 int          oldrow;


 xdragaspritestop();
// remzeroevent((zerofn)dragbuttonzero,userhandle);

 getpointer(&mouse);

 err=getw(handle,&window);
 x=mouse.x-window.bx;
 y=window.by-mouse.y;

 n=buttoninsert(handle,x,y,&row);

 /* if startmacro is a line start - make the next button a line start */
 /* if n is at the start of a line make n line start, reset next button */

 oldrow=macros[startmacro].flags & MACNL;

 if(n!=startmacro || row!=oldrow)
 {
  if(oldrow)
  {
   macros[startmacro].flags&=~MACNL;
   m=nextbuttonmacro(startmacro);
   if(m!=-1)
   {
    macros[m].flags|=MACNL;
   }
  }

// these functions queue a redraw, posns etc. not calculable until after NL's etc. setup

//  if(n==startmacro) err=buttonschanged(0);
//  else              err=macrosinsert(startmacro,n);

// changed to do moving around here then buttons changed later

  if(n!=startmacro) err=macrosinsert(startmacro,n);


  if(row)
  {
   m=prevbuttonmacro(n);
   if(m!=-1)
   {
    if(startmacro<n) n--;     /* n==macrostot, special case */
    macros[n].flags|=MACNL;
    m=nextbuttonmacro(n);
    if(m!=-1)
    {
     macros[m].flags&=~MACNL;
    }
   }
  }

  m=nextbuttonmacro(-1);
  if(m!=-1)
  {
   macros[m].flags&=~MACNL;
  }

  err=buttonschanged(0);
 }

 return(err);

 USE(box);
 USE(handle);
 USE(userhandle);
}




static os_error * buttonmousedragmove(int handle,int userhandle,wimp_mousestr * mz)
{
 viewstr  * view;

 view=(viewstr*)userhandle;
 buttonzero2(view,mz);

 return(NULL);

 USE(handle);
 USE(mz);


}







static os_error * movebutton(int n,int row,int xlo,int xhi,
                                   viewstr * view,wimp_mousestr * m)
{
 wimp_dragstr dblock;
 windowstr    window;
 int          dlshift;
 int          dhshift;
 sprite_id    sid;
 sprite_info  sinfo;
 int          dx;
 int          dy;
 int          w;
 char         temp[256];


 startmacro=n;

 getw(view->hpane,&window);

 dblock.window=view->hpane;

 dblock.type=wimp_USER_FIXED;

 if(((macros[n].flags & MACEXTEND) && !(macros[n].flags & MACEXTEXT)) ||
    (!(macros[n].flags & MACEXTEND) && (*macros[n].data.data))
   )
 {
  dblock.box.y0=window.by+bgicon->box.y0+linestep*row;
  dblock.box.y1=window.by+bgicon->box.y1+linestep*row;

  sid.tag=sprite_id_name;

  if(macros[n].flags & MACEXTEND)
  {
   getmacrodata(temp,sizeof(temp),n,view);
   sid.s.name=temp;
  }
  else
  {
   sid.s.name=macros[n].data.data;
  }

  sprite_readsize((sprite_area *)buttonarea,&sid,&sinfo);
  getdeltas(sinfo.mode,&dx,&dy);
  w=sinfo.width*dx;

  dx=(xhi-xlo)-w;

  dblock.box.x0=window.bx+xlo+dx/2;
  dblock.box.x1=window.bx+xhi-dx/2;
 }
 else
 {
  dblock.box.x0=window.bx+xlo;
  dblock.box.x1=window.bx+xhi;
  dblock.box.y0=window.by+bticon->box.y0+linestep*row;
  dblock.box.y1=window.by+bticon->box.y1+linestep*row;
 }

 dlshift=m->x-dblock.box.x0;
 dhshift=dblock.box.x1-m->x;

 dblock.parent.x0=window.x0-dlshift;
 dblock.parent.y1=window.y1;
 dblock.parent.x1=window.x1+dhshift;
 dblock.parent.y0=window.y0;

 startdrag2(view->hpane,(int)view,movedragend,buttonmousedragmove);
 wimp_drag_box(&dblock);
 xdragasprite(startmacro,&dblock,view);
// addzeroevent((zerofn)dragbuttonzero,(int)view);

 return(NULL);
}




/*****************************************************************************/

static int resizey;


static os_error * resizebuttonmove(int handle,int userhandle,wimp_mousestr * mouse)
{
 windowstr    window;
 int          newbuttonbarn;
 int          old;
 viewstr    * view;

 view=(viewstr*)userhandle;

 getw(view->hpane,&window);

 newbuttonbarn=(window.y1-(mouse->y-resizey))/paneheight;
 if(newbuttonbarn<=0) newbuttonbarn=1;

 if(buttonbarn!=newbuttonbarn)
 {
  old=buttonbarn;
  buttonbarn=newbuttonbarn;
  buttonheightchanged(old,newbuttonbarn);
 }

 return(NULL);


 USE(handle);
}



static os_error * resizedragend(int handle,int userhandle,wimp_box * box)
{
// remzeroevent((zerofn)resizebuttonzero,userhandle);

 USE(handle);
 USE(userhandle);
 USE(box);
 return(NULL);
}



static os_error * resizebuttons(viewstr * view,wimp_mousestr * m)
{
 wimp_dragstr dblock;
 windowstr    window;


 getw(view->handle,&window);

 dblock.window=view->hpane;

 dblock.type=wimp_USER_HIDDEN;

 dblock.parent.x0=m->x;
 dblock.parent.y1=window.y1;
 dblock.parent.x1=m->x;
 dblock.parent.y0=window.y0;

 dblock.box.x0=dblock.box.x1=m->x;
 dblock.box.y0=dblock.box.y1=m->y;

 getw(view->hpane,&window);
 resizey=m->y-window.y0;

 startdrag2(view->hpane,(int)view,resizedragend,resizebuttonmove);
 wimp_drag_box(&dblock);
// addzeroevent((zerofn)resizebuttonzero,(int)view);

 return(NULL);
}


/*****************************************************************************/



static os_error * buttonhelp(int handle,int userhandle,int icon,char ** p)
{
 os_error * err;
 int        x;
 int        y;
 windowstr  window;
 mousestr   mouse;
 int        n;


 err=getw(handle,&window);
 if(!err)
 {
  err=getpointer(&mouse);

  x=mouse.x-window.bx;
  y=window.by-mouse.y;

  n=findbutton(handle,x,y,-1,NULL,NULL,NULL);
  if(n>=0)
  {
   macrohelp(p,n);
   if(!**p) *p=helpfindtagstring(userhandle,icon);
  }
  else
  {
   *p=helpfindtagstring(userhandle,icon);
  }
 }

 return(err);
}



static os_error * blipbutton(int selected,int handle,
                             int xlo,int xhi,int row,int n,viewstr * view)
{
 os_error        * err;
 wimp_redrawstr    r;
 windowstr         window;
 wimp_icon         icon;
 char              buffer[256];
 int               more;
 int               y0;
 int               y1;
 int               len;
 int               ox;
 int               oy;

// cprintf("blip %d",clock());


 y0=bgicon->box.y0+(linestep*row);  // both parts -ve
 y1=bgicon->box.y1+(linestep*row);

 getw(handle,&window);

 r.w=handle;
 r.box.x0=xlo;
 r.box.x1=xhi;
 r.box.y0=y0;
 r.box.y1=y1;


 err=wimp_update_wind(&r,&more);
 if(!err && more)
 {
  if(((macros[n].flags & MACEXTEND) && !(macros[n].flags & MACEXTEXT)) ||
     (!(macros[n].flags & MACEXTEND) && (*macros[n].data.data))
    )
  {
   icon=*bgicon;

   xstrncpy(buffer,icon.data.indirecttext.buffer,sizeof(buffer));
   icon.data.indirecttext.buffer=buffer;

   if(macros[n].flags & MACEXTEND)
   {
    len=strlen(buffer);
    err=getmacrodata(buffer+len,sizeof(buffer)-len,n,view);
   }
   else
   {
    strcat(buffer,macros[n].data.data);
				err=NULL;
   }
  }
  else
  {
   icon=*bticon;

   xstrncpy(buffer,icon.data.indirecttext.buffer,sizeof(buffer));
   icon.data.indirecttext.buffer=buffer;
   len=strlen(buffer);

   if(macros[n].flags & MACEXTEND)
   {
    err=getmacrodata(buffer+len,sizeof(buffer)-len,n,view);
   }
   else
   {
    xzstrncpy(buffer+len,macros[n].name,sizeof(buffer)-len);
				err=NULL;
   }
  }


  if(selected) icon.flags=(wimp_iconflags)((int)icon.flags | (int)wimp_ISELECTED);
  else         icon.flags=(wimp_iconflags)((int)icon.flags & ~(int)wimp_ISELECTED);


  ox=r.box.x0-r.scx;
  oy=r.box.y1-r.scy;

  icon.box.x0=ox+xlo;
  icon.box.x1=ox+xhi;
  icon.box.y0=oy+y0;
  icon.box.y1=oy+y1;

  while(more)
  {
   if(!err) wimp_ploticon(handle,&icon,buttonarea);
   err=wimp_get_rectangle(&r,&more);
  }
 }

 return(NULL);
}





/* void refreshbutton(string & name,int view,int file); */

void refreshbutton(int fp)
{
 char    * p;
 int       nm;
 viewstr * view;
 viewstr * view1;
 filestr * file;
 filestr * file1;
 int       xlo;
 int       xhi;
 int       row;



 p=stringptr(stack[fp]);
 nm=findmacro(p,0);


 if(nm>=0)
 {

  if(macros[nm].type==TYPEBUTTON)
  {
   view1=view=(viewstr*)stack[fp+1];
   file1=file=(filestr*)stack[fp+2];

   if(!file) file=firstfile;
   if(!view) view=file->view;

   findbutton(view->hpane,0,0,nm,&xlo,&xhi,&row);


   while(file)
   {
    while(view)
    {
     if(view->hpane)
     {
      blipbutton(0,view->hpane,xlo,xhi,row,nm,view);
     }
     view=view->next;
     if(view1) break;
    }

    file=file->next;
    if(file)  view=file->view;
    if(file1) break;
   }
  }
 }
}








#define BLIPTIME 100

static int blipsmash;


static os_error * buttonclick(int handle,int userhandle,wimp_mousestr * m)
{
 os_error * err;
 int        x;
 int        y;
 windowstr  window;
 int        n;
 int        xlo;
 int        xhi;
 int        ctrl;
 int        shift;
 int        alt;
 int        time;
 int        row;
 int        macenv;

 err=getw(handle,&window);
 x=m->x-window.bx;
 y=window.by-m->y;

 ctrl=isctrl;
 shift=isshift;
 alt=isalt;

 n=findbutton(handle,x,y,-1,&xlo,&xhi,&row);

// cprintf("butn click %d",n);

 if(n>=0)
 {
  if(ctrl && shift && m->bbits==0x1)
  {
   macros[n].flags^=MACGAP;
   buttonschanged(0);
  }
  else
  if(ctrl && !shift && m->bbits==0x40)
  {
   movebutton(n,row,xlo,xhi,(viewstr*)userhandle,m);
  }
  else
  if(ctrl && !shift && m->bbits==0x4)
  {
   /* have to take this out to allow previous clause to work */
  }
  else
  if(ctrl && !shift && m->bbits==0x1)
  {
   macrodisplay(n,(viewstr*)userhandle);
  }
  else
  {
   if(m->bbits==0x4 || (macros[n].flags & MACEXTEND))
   {
    time=BLIPTIME+clock();
    blipbutton(1,handle,xlo,xhi,row,n,(viewstr*)userhandle);

    blipsmash=userhandle;

    macenv=MACENVBUT;
    macenv|=shift<<16;
    macenv|=ctrl<<17;
    macenv|=alt<<18;

    if(m->bbits==0x4)  macenv|=(1<<8);
    else
    if(m->bbits==0x40) macenv|=(3<<8);
    else
    if(m->bbits==0x1)  macenv|=(4<<8);
    else
    if(m->bbits==0x10) macenv|=(6<<8);
    else
    if(m->bbits==0x2)  macenv|=(7<<8);

    err=expandtoolmacro(n,(viewstr*)userhandle,macenv);
				if(err && err->errnum==EREPORTED) err=NULL;

    while(clock()<time && blipsmash);

    if(blipsmash) blipbutton(0,handle,xlo,xhi,row,n,(viewstr*)userhandle);
   }
  }
 }
 else
 {
  if(ctrl && !shift)
  {
   if(m->bbits==0x10)
   {
    resizebuttons((viewstr*)userhandle,m);
   }
  }
 }

 return(err);
}


#define MINTIME 8

static viewstr * buttonview;
//static int       lastscroll;

static void buttonzero(viewstr * view);

static os_error * buttonzero2(viewstr * view,wimp_mousestr * m)
{
 wimp_wstate   winds;
 int           x;

 buttonview=NULL;

// cprintf("button zero2");

 if(m->w==view->hpane)
 {
  wimp_get_wind_state(view->hpane,&winds);

  x=m->x-winds.o.box.x0;
  if(x<scrollbarwidth)
  {
//    cprintf("scroll left");
   if(winds.o.x>0)
   {
    winds.o.x-=barwidth;
    wimp_open_wind(&winds.o);
    wimp_get_wind_state(view->hpane,&winds);
				if(view->bshift!=winds.o.x)
				{
     view->bshift=winds.o.x;
				 buttontipsreposn(view);
				}
    buttonview=view;
   }
  }

  x=winds.o.box.x1-m->x;
  if(x<scrollbarwidth)
  {
//    cprintf("scroll right");
   if((winds.o.x+(winds.o.box.x1-winds.o.box.x0))<view->bextent)
   {
    winds.o.x+=barwidth;
    wimp_open_wind(&winds.o);
    wimp_get_wind_state(view->hpane,&winds);
				if(view->bshift!=winds.o.x)
				{
     view->bshift=winds.o.x;
				 buttontipsreposn(view);
				}
    buttonview=view;
   }
  }

//   lastscroll=monotime;
  if(buttonview)
  {
   addscheduledevent((zerofn)buttonzero,(int)view,MINTIME);
  }
 }

 return(NULL);
}


static void buttonzero(viewstr * view)
{
 wimp_mousestr m;

 wimp_get_point_info(&m);

 buttonzero2(view,&m);
}



static os_error * buttonmousemove(int handle,int userhandle,wimp_mousestr * mz)
{
 os_error * err;
 viewstr  * view;

 err=NULL;

 view=(viewstr*)userhandle;
 if(buttonview) remscheduledevent((zerofn)buttonzero,(int)buttonview);
 buttonzero2(view,mz);

 return(err);

 USE(handle);
}





os_error * closebuttons(viewstr * view)
{
 os_error * err;

 if(view->data.buttons)
 {
  if(blipsmash==(int)view) blipsmash=0;

  if(buttonview) remscheduledevent((zerofn)buttonzero,(int)buttonview);
  buttonview=NULL;

		buttontipsfinit(view);

  remclickevent(buttonclick,view->hpane,(int)view);
  remredrawevent(buttonredraw,view->hpane,(int)view);
  remmousemoveevent(buttonmousemove,view->hpane,(int)view);
  remhelpevent(buttonhelp,view->hpane,THPANE);
  err=closedown(&view->hpane);
  viewmarginadjust(view,0,0,-view->hshift,0);
  view->hshift=0;
 }
 else err=NULL;

 return(err);
}


static int buttonheight(void)
{
 return(paneheight*buttonbarn);
}


os_error * createbuttons(viewstr * view)
{
 os_error * err;
 windowstr  window;
 wimp_icon  result;

 if(view->data.buttons)
 {

//cprintf("createbuttons %d",buttonbarn);

  err=createwindowparent(THPANE,&view->hpane,view->handle);
  if(!err)
  {
   getw(view->hpane,&window);
   paneheight=window.y1-window.y0;

   wimp_lose_icon_info(&bgicon);
   wimp_get_icon_info(view->hpane,0,&result);
   wimp_copy_icon_info(&bgicon,&result);

   barwidth=bgicon->box.x1-bgicon->box.x0;

   wimp_lose_icon_info(&bticon);
   wimp_get_icon_info(view->hpane,1,&result);
   wimp_copy_icon_info(&bticon,&result);

   wimp_delete_icon(view->hpane,0);
   wimp_delete_icon(view->hpane,1);

   halfbarwidth=barwidth/2;
   scrollbarwidth=barwidth/3;
   linestep=-paneheight;

   view->hshift=buttonheight();
   viewmarginadjust(view,0,0,view->hshift,0);
   addclickevent(buttonclick,view->hpane,(int)view);
   addredrawevent(buttonredraw,view->hpane,(int)view);
   addmousemoveevent(buttonmousemove,view->hpane,(int)view);
   addhelpevent(buttonhelp,view->hpane,THPANE);

			buttontipsinit(view);


  }
 }
 else err=NULL;

 return(err);
}



static os_error * addbuttons(viewstr * view)
{
 os_error * err;

 if(!view->data.buttons)
 {
  view->data.buttons=1;
  view->hextent=0;
  view->bshift=0;
  err=createbuttons(view);
  updateviewextent(view);
  viewopenshift(view,0,buttonheight());
 }
 else err=NULL;

 return(err);
}



static os_error * rembuttons(viewstr * view)
{
 os_error * err;

 if(view->data.buttons)
 {
  err=closebuttons(view);
  view->data.buttons=0;
  updateviewextent(view);
  viewopenshift(view,0,-buttonheight());
 }
 else err=NULL;

 return(err);
}


static os_error * getbuttonextent(viewstr * view,int force)
{
 if(!view->bextent || force) view->bextent=buttonextent(view->hpane);
 view->hextent=(view->extent.x1-view->extent.x0);
 view->hextent=MAX(view->bextent,view->hextent);
 return(extent(view->hpane,0,-2*buttonheight(),view->hextent,0));
}


os_error * openbuttons(viewstr * view,wimp_openstr * o)
{
 os_error   * err;
 wimp_openstr r;
 wimp_wstate  winds;

 if(view->hextent!=MAX((view->extent.x1-view->extent.x0),view->bextent))
 {
  getbuttonextent(view,0);
 }

 r.w=view->hpane;
 r.x=view->bshift;
 r.y=0;
 r.behind=o->behind;
 r.box.x0=o->box.x0+view->vshift;
 r.box.x1=o->box.x1;
 r.box.y1=o->box.y1;
 r.box.y0=r.box.y1-buttonheight();

// cprintf("open buttons x=%d x0=%d x1=%d y0=%d y1=%d",r.x,r.box.x0,r.box.x1,r.box.y0,r.box.y1);

 err=wimp_open_wind(&r);
 wimp_get_wind_state(view->hpane,&winds);

	if(view->bshift!=winds.o.x)
 {
  view->bshift=r.x;
 	buttontipsreposn(view);
	}

 return(err);
}



int getbuttons(int fp)
{
 return(menuview->data.buttons);
 USE(fp);
}



void xsetbuttons(int open,viewstr * view)
{
 if(open && !view->data.buttons) addbuttons(view);
 else
 if(!open && view->data.buttons) rembuttons(view);
}


void setbuttons(int fp)
{
 xsetbuttons(stack[fp],menuview);
 updateviewdata(menuview);
}



static sprite_header * bnthsp(int n)
{
 sprite_header * sp;

 if(n<0 || n>=buttonarea->number) return(NULL);

 sp=(sprite_header *)(((char*)buttonarea)+buttonarea->sproff);
 while(n--)
 {
  if(sp->next) sp=(sprite_header *)(((char*)sp)+sp->next);
  else return(NULL);
 }

 return(sp);
}


static os_error * boxex(void)
{
 int             n;
 int             w;
 int             h;


 n=buttonarea->number;

 w=bfx+2*bstepx+bwidth;
 n=(n+2)/3;
 h=-bfy-n*bstepy;

 return(extent(buttonhandle,0,h,w,0));
}



/* redraw macros pane */

static os_error * bredrawsub(int handle,wimp_redrawstr * redrawstr,int more)
{
 int             oy;
 int             ox;
 int             ylo;
 int             yhi;
 int             n;
 int             i;
 int             y;
 sprite_header * sp;
 wimp_icon       icon;
 int             xhi;
 int             xlo;
 int             xs;
 int             x;
 char          * oldbuffer;
 char            buffer[64];
 char            temp[16];


 while(more)
 {
  ox=redrawstr->box.x0-redrawstr->scx;
  oy=redrawstr->box.y1-redrawstr->scy;

  icon=*buttonicon;
  oldbuffer=icon.data.indirecttext.buffer;
  icon.data.indirecttext.buffer=buffer;

  ylo=-(redrawstr->g.y1-oy);            /* small number, top of window */
  yhi=-(redrawstr->g.y0-oy);            /* bigger, bottom of window    */
  xhi=redrawstr->g.x1-ox;
  xlo=redrawstr->g.x0-ox;

  n=(ylo-bfy)/bstepy;
  if(n<0) n=0;
  y=n*bstepy+bfy;

  xs=(xlo-bfx)/bstepx;
  if(xs<0) xs=0;
  xs=xs*bstepx+bfx;
  n*=3;

  sp=bnthsp(n);
  if(sp)
  {
   while(y<yhi)
   {
    x=bfx;

    for(i=0;i<3;i++)
    {
     if(x>=xs && x<=xhi)
     {
      icon.box.x0=ox+x;
      icon.box.y1=oy-y;
      icon.box.x1=icon.box.x0+bwidth;
      icon.box.y0=icon.box.y1-bheight;

      xstrncpy(temp,sp->name,13);		// has to copy at most 12 and then add a zero, go out on <32


      strcpy(buffer,"\\C\\B\\s");
      strcat(buffer,temp);      
      strcat(buffer,"\\C\\T\\KD1\\a");
      strcat(buffer,temp);

      wimp_ploticon(buttonhandle,&icon,buttonarea);
     }

     sp=(sprite_header *)(((char*)sp)+sp->next);
     n++;
     if(n>=buttonarea->number) break;
     x+=bstepx;
    }

    if(n>=buttonarea->number) break;
    y+=bstepy;
   }
  }
  wimp_get_rectangle(redrawstr,&more);
 }

 return(NULL);
 USE(handle);
}



static os_error * bredraw(int handle,int userhandle)
{
 os_error       * err;
 wimp_redrawstr   redrawstr;
 int              more;

 redrawstr.w=handle;
 err=wimp_redraw_wind(&redrawstr,&more);
 if(!err) bredrawsub(handle,&redrawstr,more);
 return(err);
 USE(userhandle);
}


static os_error * bicon(int handle,int userhandle,wimp_mousestr * m);
static os_error * buttonskey(int handle,int userhandle,int icon,int * key);

static os_error * buttonsclose(int handle,int userhandle)
{
 os_error * err;

          err=remclickevent(bicon,buttonhandle,0);
 if(!err) err=remredrawevent(bredraw,buttonhandle,0);
 if(!err) err=remhelpevent(NULL,buttonhandle,TBUTTONBOX);
 if(!err) err=remcloseevent(buttonsclose,handle,userhandle);
 if(!err) err=remkeyevent(buttonskey,handle,0);
 if(!err) err=remparentcloseevent(buttonsclose,buttonhandle,0);
 if(!err) err=closedown(&buttonhandle);

 return(err);
}


static os_error * buttonskey(int handle,int userhandle,int icon,int * key)
{
 os_error * err;

 err=NULL;
 
 if(*key==ESCAPE)
 {
  *key=-1;
  err=buttonsclose(handle,userhandle);
 }

 return(err);

 USE(icon);
}


static os_error * bicon(int handle,int userhandle,wimp_mousestr * m)
{
 os_error      * err;
 windowstr       window; 
 int             x;
 int             y;
 int             n;
 sprite_header * sp;
 char            temp[16];

 err=NULL;

 if(m->bbits==0x4)
 {
  getw(handle,&window);
  x=m->x-window.bx;
  y=-(m->y-window.by);

  n=(y-bfy)/bstepy;
  n=n*3+(x-bfx)/bstepx;

  if(n>=0 && n<buttonarea->number)
  {
   sp=bnthsp(n);
   if(getbutton) 
   {
    strncpy(temp,sp->name,12);
    temp[12]=0;
    err=getbutton(temp);
   }
   buttonsclose(handle,userhandle);
  }
 }

 return(err);

 USE(userhandle);
}



os_error * getabutton(getbfn gx,int parent)
{
 os_error  * err;
 wimp_icon   result;

 err=NULL;

 getbutton=gx;

 if(!buttonhandle)
 {
  err=createwindowparent(TBUTTONBOX,&buttonhandle,parent);
  if(!err)
  {
   wimp_lose_icon_info(&buttonicon);
   wimp_get_icon_info(buttonhandle,0,&result);
   wimp_copy_icon_info(&buttonicon,&result);
   wimp_delete_icon(buttonhandle,0);
   bheight=buttonicon->box.y1-buttonicon->box.y0;
   bstepy=bheight+bheight/4;
   bwidth=buttonicon->box.x1-buttonicon->box.x0;
   bstepx=bwidth+bwidth/4;
   bfy=-buttonicon->box.y1;
   bfx=buttonicon->box.x0;

   
   addclickevent(bicon,buttonhandle,0);
   addredrawevent(bredraw,buttonhandle,0);
   addhelpevent(NULL,buttonhandle,TBUTTONBOX);
   addcloseevent(buttonsclose,buttonhandle,0);
   addkeyevent(buttonskey,buttonhandle,0);
   addparentcloseevent(buttonsclose,buttonhandle,0);


   boxex();
  }
 }

 if(!err)
 {
  popup(buttonhandle,0);
  setfocus(buttonhandle);
 }

 return(err);
}




static os_error * buttonheightchanged(int oldn,int newn)
{
 os_error * err;
 filestr  * file;
 viewstr  * view;

 err=NULL;


 file=firstfile;
 while(file)
 {
  view=file->view;
  while(view)
  {
   if(view->data.buttons && view->hpane)
   {
    viewmarginadjust(view,0,0,buttonheight()-view->hshift,0);
    view->hshift=buttonheight();
    updateviewextent(view);
    getbuttonextent(view,1);
    viewopenshift(view,0,paneheight*(newn-oldn));
    refreshwindow(view->hpane);
				buttontipsrebuild(view);
   }
   view=view->next;
  }
  file=file->next;
 }
 return(err);
}




static int buttonscheck(void)
{
 int        n;
 int        r;

 for(r=1,n=0;n<macrostot;n++)
 {
  if(macros[n].type==TYPEBUTTON && (macros[n].flags & MACACTIVE) &&
                                   (macros[n].flags & MACNL))
  {
   r++;
  }
 }

 return(r);
}




os_error * buttonschanged(int checkheight)
{
 os_error * err;
 filestr  * file;
 viewstr  * view;
 int        old;
 int        xnew;

 err=NULL;

// cprintf("buttons changed checkheight %d xnew %d",checkheight,buttonscheck());

 if(checkheight && (xnew=buttonscheck())!=buttonbarn)
 {
  old=buttonbarn;
  buttonbarn=xnew;
  err=buttonheightchanged(old,xnew);
 }
 else
 {
  file=firstfile;
  while(file)
  {
   view=file->view;
   while(view)
   {
    if(view->data.buttons && view->hpane)
    {
     getbuttonextent(view,1);
     refreshwindow(view->hpane);
					buttontipsrebuild(view);
    }
    view=view->next;
   }
   file=file->next;
  }
 }

 return(err);
}



static os_error * bsprites(char * string)
{
 return(addspritesxs(string,"Buttons.spr",&buttonarea));
}



static char * respath=NULL;


os_error * buttoninit(void)
{
 os_error   * err;
// wimp_wind  * w;

 err=addspritesxs(respath,"Buttons.spr",&buttonarea);
 if(!err) err=event(EVENT_BUTTONLOAD,NULL,0);
 if(!err) err=appletscan(bsprites);

 return(err);
}




os_error * buttonalloc(void)
{
 return(initspritess(&buttonarea));
}

