/*->c.section */

#include <stdafx.h>

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <locale.h>

#include "os.h"
#include "wimp.h"
#include "wimpt.h"
#include "werr.h"
#include "wos.h"
#include "flex.h"
#include "transform.h"

#include "err.h"
#include "fsx.h"
#include "xext.h"
#include "poll.h"
#include "alloc.h"
#include "trans.h"
#include "bits.h"
#include "etc.h"
#include "bf.h"
#include "deb.h"


#include "constants.h"
#include "str.h"

#include "object.h"
#include "chain.h"

#include "view.h"
#include "file.h"

#include "pref.h"

#include "txstr.h"
#include "tx.h"
#include "vl.h"
#include "new.h"
#include "newx.h"
#include "dbnew.h"


#include "dscript.h"

#include "section.h"




static int cmpmap(const void * map1,const void * map2)
{
 return(((sectionmapstr*)map1)->msource-((sectionmapstr*)map2)->msource);
}




os_error *	sectionscrapmap(int section,filestr * file)
{
	os_error      * err;
	sectionstr    * sectionp;
	int             source;
	int             vsource;
	int             i;

	err=NULL;

//	cprintf("sectionscrapmap");

	i=0;
	while(1)
	{
  sectionp=(sectionstr*)fob_find(section,file);
		if(i>=sectionp->mapentries) break;

//		cprintf("ms %d mv %d ds %d dv %d",sectionp->map[i].msource,sectionp->map[i].mvsource,sectionp->map[i].dsource,sectionp->map[i].dvsource);

		if(sectionp->branch)
		{
			source=sectionp->map[i].msource;
			vsource=sectionp->map[i].mvsource;
		}
		else
		{
			source=sectionp->map[i].dsource;
			vsource=sectionp->map[i].dvsource;
		}

  err=txsourcedel(source,file,1);
  if(!err) err=vsourcedel(vsource,file);
		if(err) break;

		i++;
	}

	return(err);
}




os_error * sectionclearmap(int section,filestr * file)
{
 sectionstr    * sectionp;

 sectionp=(sectionstr*)fob_find(section,file);
 sectionp->mapentries=0;

 return(NULL);
}



os_error * sectionaddmap(sectionmapstr * map,int section,
                                             filestr * file,int branch)
{
 os_error      * err;
 sectionstr    * sectionp;
 sectionmapstr * target;
 int             n;
 int             i;

 err=NULL;

 for(i=0;i<2;i++)
 {
  if(section)
  {
   sectionp=(sectionstr*)fob_find(section,file);
   if(branch<0 || branch==(int)sectionp->branch)
   {
    target=(sectionmapstr*)bnearest(map,sectionp->map,sectionp->mapentries,
                                   sizeof(sectionmapstr),cmpmap);

    n=target-sectionp->map;

    if(n<sectionp->mapentries && target->msource==map->msource)
    {
     sectionp->map[n]=*map;
    }
    else
    {
     fob_change(section,file,sizeof(sectionstr)+
             sectionp->mapentries*sizeof(sectionmapstr),(fobjptr)&sectionp);

     memmove(sectionp->map+n+1,sectionp->map+n,
                         sizeof(sectionmapstr)*(sectionp->mapentries-n));

     sectionp->map[n]=*map;
     sectionp->mapentries++;
    }
   }
   section=sectionp->dual;
  }
 }
 return(err);
}



os_error * sectionfindmap(int msource,sectionmapstr * map,int section,
                                                          filestr * file)
{
 os_error      * err;
 sectionstr    * sectionp;
 sectionmapstr * target;
 sectionmapstr   temp;

 err=NULL;

 sectionp=(sectionstr*)fob_find(section,file);

 temp.msource=msource;

 target=(sectionmapstr*)bsearch(&temp,sectionp->map,sectionp->mapentries,
                                    sizeof(sectionmapstr),cmpmap);

 if(target) *map=*target;
 else        map->msource=0;

 return(err);
}




os_error * sectionfindmapds(int dsource,sectionmapstr * map,int section,
                                                          filestr * file)
{
 os_error      * err;
 sectionstr    * sectionp;
 int             i;

 err=NULL;

 sectionp=(sectionstr*)fob_find(section,file);
 for(i=0;i<sectionp->mapentries;i++)
 {
  if(sectionp->map[i].dsource==dsource)
  {
   *map=sectionp->map[i];
   return(err);
  }
 }

 map->msource=0;
 return(err);
}






os_error * sectionremmap(int msource,int section,filestr * file,int branch)
{
 os_error      * err;
 sectionstr    * sectionp;
 sectionmapstr * target;
 sectionmapstr   temp;
 int             n;
 int             i;


 err=NULL;

 for(i=0;i<2;i++)
 {
  if(section)
  {
   sectionp=(sectionstr*)fob_find(section,file);

   if(branch<0 || branch==(int)sectionp->branch)
   {
    temp.msource=msource;

    target=(sectionmapstr*)bsearch(&temp,sectionp->map,sectionp->mapentries,
                                          sizeof(sectionmapstr),cmpmap);

    if(target)                                                                      {
     n=target-sectionp->map;

     memmove(target,target+1,(sectionp->mapentries-n-1)*sizeof(sectionmapstr));
     sectionp->mapentries--;

     fob_change(section,file,sizeof(sectionstr)+
             sectionp->mapentries*sizeof(sectionmapstr),(fobjptr)&sectionp);
    }
   }
   section=sectionp->dual;
  }
 }
 return(err);
}



int findsectioni(int index,filestr * file,int branch)
{
 int          section;
 sectionstr * sectionp;

 section=file->hdr.section[branch];
 while(section && --index>0)
 {
  sectionp=(sectionstr*)fob_find(section,file);
  section=sectionp->chain.next;
 }

 return(section);
}


int findsection(int number,filestr * file,int branch)
{
 prefdatastr * pref;
 pref=prefp(file);
 return(findsectioni(number-pref->chapterstart+1,file,branch));
}





static os_error * newsection(objectloc * loc,void * data)
{
 os_error   * err;
 sectionstr * section;
 int          handle;
 filestr    * file;

 file=loc->file;

 err=fob_create(sizeof(sectionstr),file,OSECTION,(fobjptr)&section);
 if(!err)
 {
  section->data=*((sectiondatastr*)data);
  section->branch=loc->branch;

  handle=section->key;

  loc->object=handle;
 }
 return(err);
}




/*****************************************************************************/

#define DSTSECTION          0x400
#define DSTPAPERSIZE        0x401
#define DSTOMITHEADER       0x402
#define DSTOMITFOOTER       0x403
#define DSTSECTIONNUMBER    0x404
#define DSTPAGESTARTNUMBER  0x405
#define DSTPAGENUMBERFORMAT 0x406
#define DSTSIDEWAYS         0x407
#define DSTSTARTONLEFT      0x408



static os_error * papersub(sectiondatastr * data,int sp)
{
 dsobjectstr * ds;
 dsobjectstr * ds1;
 int           nsp;
 int           i;

 sp+=2;

 for(i=0;i<4;i++)
 {
  ds=(dsobjectstr*)(dsstack+sp);
  nsp=sp+ds->len/sizeof(int);
  ds1=(dsobjectstr*)(dsstack+sp+2);

  switch(ds->type)
  {
   case      DSTINT:  /* only int is user size? */
                    data->usersize=ds->data.integer;
                    break;

   case      DSTSTR:
                    strcpy(data->size,ds->data.string);
                    break;

   case        DSTW:
                    data->width=ds1->data.integer;
                    break;

   case        DSTH:
                    data->height=ds1->data.integer;
                    break;

   case DSTSIDEWAYS:
                    data->shape=ds1->data.integer;
                    break;
  }
  sp=nsp;
 }

 return(NULL);
}




static os_error * dssection(int fp,int argc,objectloc * loc)
{
 os_error       * err;
 filestr        * file;
 dsobjectstr    * ds;
 dsobjectstr    * ds1;
 int              sp;
 int              nsp;

 sectiondatastr   data;
 int              msection;
 int              dsection;
 int              oldmsection;
 int              olddsection;
 sectionstr     * sectionp;

 file=loc->file;

 data=defnewdata.sectiondata;
 data.pagenumber.start=0;

 sp=fp+2;

 while(argc--)
 {
  ds=(dsobjectstr*)(dsstack+sp);
  nsp=sp+ds->len/sizeof(int);
  ds1=(dsobjectstr*)(dsstack+sp+2);

  switch(ds->type)
  {

   case DSTOMITHEADER:
                      data.pagenumber.omitheader=ds1->data.integer;
                      break;

   case DSTOMITFOOTER:
                      data.pagenumber.omitfooter=ds1->data.integer;
                      break;

   case  DSTPAPERSIZE:
                      papersub(&data,sp);
                      break;

   case DSTSECTIONNUMBER:
                         data.number=ds1->data.integer;
                         break;

   case      DSTSTARTONLEFT:
                            data.pagenumber.left=ds1->data.integer; 
                            break;

   case  DSTPAGESTARTNUMBER:
                            data.pagenumber.start=1;
                            data.pagenumber.number=ds1->data.integer;
                            break;

   case DSTPAGENUMBERFORMAT:
                            data.pagenumber.format=ds1->data.integer;
                            break;
  }

  sp=nsp;
 }


 oldmsection=loc->section;
 if(oldmsection)
 {
  sectionp=(sectionstr*)fob_find(oldmsection,file);
  olddsection=sectionp->dual;
 }
 else
 {
  olddsection=0;
 }

 if(!loc->branch) SWOP(olddsection,oldmsection);


 if(!data.pagenumber.start)
 {
  if(olddsection)
  {
   sectionp=(sectionstr*)fob_find(olddsection,file);
   data.pagenumber.number=sectionp->data.pagenumber.number+sectionp->np;
  }
  else
  {
   data.pagenumber.start=1;
   data.pagenumber.number=1;
  }
 }


 loc->branch=1;
 err=objectnew(loc,OSECTION,&data);
 msection=loc->object;

 loc->branch=0;
 err=objectnew(loc,OSECTION,&data);
 dsection=loc->object;

// cprintf("dssection %d %d",dsection,msection);

 sectionp=(sectionstr*)fob_find(msection,file);
 sectionp->dual=dsection;
 sectionp=(sectionstr*)fob_find(dsection,file);
 sectionp->dual=msection;

 loc->branch=1;
 loc->parent=0;
 loc->page=0;
 loc->section=msection;

 if(!oldmsection)
 {
  file->hdr.section[MST]=msection; /* link here */
  file->hdr.section[DOC]=dsection;
  file->hdr.ns[MST]=1;
  file->hdr.ns[DOC]=1;

  file->hdr.maxpagewidth[MST]=file->hdr.maxpagewidth[DOC]=data.width;
  file->hdr.maxpageheight[MST]=file->hdr.maxpageheight[DOC]=data.height;
 }
 else
 {
  insafter(msection,oldmsection,0,0,file);
  insafter(dsection,olddsection,0,0,file);

  file->hdr.ns[MST]++;
  file->hdr.ns[DOC]++;

  file->hdr.maxpagewidth[MST]=
  file->hdr.maxpagewidth[DOC]=MAX(file->hdr.maxpagewidth[DOC],data.width);

  file->hdr.maxpageheight[MST]=
  file->hdr.maxpageheight[DOC]=MAX(file->hdr.maxpageheight[DOC],data.height);
 }


 ds=(dsobjectstr*)(dsstack+fp);
 ds->data.integer=msection;
 ds->len=3*sizeof(int);

 return(err);

 USE(argc);
}







static os_error * dsmessage(sectionstr * sectionp,int * message,
                                            filestr * file,buffer * bf)
{
 os_error * err;
 int        dsect;
 int        msect;
 int        dpage;
 int        mpage;
 int        xmessage;


 dsect=sectionp->key;
 msect=sectionp->dual;
 dpage=sectionp->chain.child;

 err=bf_printf(bf,"CHAP_%02x={chapter ",dsect);

 err=bf_printfeol(bf,"{papersize \"%s\" %d {w %d} {h %d} {sideways %d}}",
                                       sectionp->data.size,
                                       sectionp->data.usersize,
                                       sectionp->data.width,
                                       sectionp->data.height,
                                       sectionp->data.shape);

 err=bf_printfeol(bf,"{omitheader %d} {omitfooter %d}",
                                       sectionp->data.pagenumber.omitheader,
                                       sectionp->data.pagenumber.omitfooter);

 err=bf_printfeol(bf,"{chapternumber %d}",sectionp->data.number);


 if(sectionp->data.pagenumber.start)
 {
  err=bf_printfeol(bf,"{pagestartnumber %d}",
                                     sectionp->data.pagenumber.number);
 }

 err=bf_printfeol(bf,"{pagenumberformat %d}",
                                     sectionp->data.pagenumber.format);

 err=bf_printfeol(bf,"{startonleft %d}",sectionp->data.pagenumber.left);

 err=bf_printfeoln(bf,2,"}");

 sectionp=(sectionstr*)fob_find(msect,file);
 mpage=sectionp->chain.child;
 err=objectchainmessage(mpage,file,message,bf);
 xmessage=OM_DSSECT;
 err=objectchainmessage(mpage,file,&xmessage,bf);

 err=objectchainmessage(dpage,file,message,bf);
 err=objectchainmessage(dpage,file,&xmessage,bf);

 return(err);
}



static void dsname(sectionstr * sectionp,char * data)
{
 sprintf(data,"CHAP_%02x",sectionp->key);
}



static int dszerolist[]={
                         DSTENDLIST
                        };



static dscreator dsdefs[]=
{
 0,0,0,0, "chapter",    dssection, 0, DSTSECTION,   dszerolist,
 0,0,0,0, "papersize",  NULL,      0, DSTPAPERSIZE, dszerolist,
 0,0,0,0, "omitheader", NULL,      0, DSTOMITHEADER,dszerolist,
 0,0,0,0, "omitfooter", NULL,      0, DSTOMITFOOTER,dszerolist,
 0,0,0,0, "chapternumber",NULL,    0, DSTSECTIONNUMBER,dszerolist,
 0,0,0,0, "pagestartnumber",NULL,  0, DSTPAGESTARTNUMBER,dszerolist,
 0,0,0,0, "pagenumberformat",NULL, 0, DSTPAGENUMBERFORMAT,dszerolist,
 0,0,0,0, "sideways",   NULL,      0, DSTSIDEWAYS,  dszerolist,
 0,0,0,0, "startonleft",NULL,      0, DSTSTARTONLEFT,dszerolist,
};



static os_error * message(sectionstr * sectionp,filestr * file,
                                                   int * message,void * data)

{
 if(*message==OM_DSSAVE) 
         return(dsmessage(sectionp,message,file,(buffer*)data));
 else
 if(*message==OM_DSNAME) dsname(sectionp,(char*)data);
 else    return(objectchainmessage(sectionp->chain.child,file,message,data));

 return(NULL);
}




static objectstr sectionobject=
{
 OSECTION,
 newsection,                      /* new         */
 NULL,                            /* copy        */
 NULL,                            /* redraw      */
 NULL,                            /* create      */
 NULL,                            /* find        */
 NULL,                            /* select      */
 NULL,                            /* transform   */
 NULL,                            /* load type   */
 NULL,                            /* load        */
 NULL,                            /* load post   */
 (objectmessagefn)message,        /* message     */
 NULL,                            /* object db's */
 NULL,                            /* text flow   */
 NULL,                            /* delete      */
 NULL,                            /* text reflow */
 NULL,                            /* object set flow */
 NULL,                            /* master object?  */
 NULL,                            /* local object    */
 NULL,                            /* x9 */
 NULL,                            /* x10 */
 NULL,                            /* x12 */

};


os_error * sectioninit(void)
{
 dsaddblock(dsdefs,sizeof(dsdefs)/sizeof(dscreator));
 return(objectregister(&sectionobject));
}


