/*->c.viewo */

#include <stdafx.h>

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <locale.h>

#include "os.h"
#include "wimp.h"
#include "wimpt.h"
#include "werr.h"
#include "wos.h"
#include "flex.h"
#include "transform.h"

#include "err.h"
#include "xext.h"
#include "poll.h"
#include "temp.h"
#include "alloc.h"
#include "fsx.h"

#include "trans.h"
#include "xmath.h"
#include "key.h"
#include "dbhi.h"
#include "colour.h"
#include "deb.h"
#include "osunits.h"

#include "etc.h"

#include "str.h"
#include "constants.h"
#include "object.h"

#include "mhi.h"
#include "reslink.h"
#include "file.h"
#include "page.h"
#include "xpage.h"
#include "posn.h"
#include "dbmore.h"

#include "rulers.h"
#include "tools.h"
#include "buttons.h"
#include "infopal.h"
#include "selaction.h"
#include "tabruler.h"
#include "txchoices.h"

#include "dbscale.h"

#include "view.h"
#include "viewr.h"

#include "viewo.h"





static os_error * reopenview(viewstr * view,int omul,int odiv,int mul,int div,
                              int xshift,int yshift,int axshift,int ayshift);





os_error * viewmarginadjust(viewstr * view,int dleft,int dright,int dtop,int dbottom)
{

 view->top+=dtop;
 view->bottom+=dbottom;
 view->left+=dleft;
 view->right+=dright;

 return(NULL);
}







/* is a given page with given x coord, a ghost page */


int isghostleft(int left,int x)
{
 if(left && x)   return(1);
 else
 if(!left && !x) return(1);
 else            return(0);
}


int isghost(viewstr * view,int page,int section,int x)
{
 pagestr    * pagep;
 sectionstr * sectionp;
 int          base;
 filestr    * file;

 if(!page)                     return(1);
 else
 if(!view->data.dble)          return(0);
 else
 {
  file=view->file;
  sectionp=(sectionstr*)fob_find(section,file);
  base=getpagebase(sectionp);
  pagep=(pagestr*)fob_find(page,file);
  return(isghostleft(islhpb(pagep,base),x));
 }
}



int isghostb(viewstr * view,int page,int base,int x)
{
 pagestr    * pagep;

 if(!page)                     return(1);
 else
 if(!view->data.dble)          return(0);
 else
 {
  pagep=(pagestr*)fob_find(page,view->file);
  return(isghostleft(islhpb(pagep,base),x));
 }
}





static void zeroviewvars(viewstr * view,filestr * file)
{
 sectionstr * section;

 view->section=file->hdr.section[view->branch];
 section=(sectionstr*)fob_find(view->section,file);
 view->page=section->chain.child;
 view->ps=0;
}


static void zeroviewvarsf(viewstr * view,filestr * file)
{
 zeroviewvars(view,file);
 view->dpage=0;
 view->dsection=0;
}


void setviewborders(viewstr * view)
{
 int width;
 int height;


 if(view->data.pasteboard)
 {
  width=view->data.pasteboardxwidth;
  height=view->data.pasteboardywidth;
 }
 else
 {
  width=height=0;
 }


 view->border.leftpb=width;
 view->border.rightpb=width;
 view->border.mid1pb=0;
 view->border.mid2pb=0;
 view->border.toppb=height;
 view->border.botpb=height;

 view->border.firstborder=0;
 view->border.lastborder=0;
 view->border.leftborder=0;
 view->border.rightborder=0;
 view->border.hmidborder=HPBORDER;
 view->border.vmidborder=VPBORDER;
}



static os_error * getworkarea(viewstr * view,filestr * file,int * w,int * h)
{
 int             width;
 int             height;
 int             section;
 sectionstr    * sectionp;
 int             first;
 int             right;
 int             oldheight;
 int             snp;
 int             base;
 pagestr       * pagep;
 int             pageno;
 int             ys;
 int             nextsection;
 int             np;


 *w=595276;
 *h=841890;

 {
  width=file->hdr.maxpagewidth[view->branch];

  if(view->data.dble)
  {
   width*=2;
   width+=view->border.leftpb+view->border.mid1pb+view->border.mid2pb+
          view->border.rightpb;
   width+=view->border.leftborder+view->border.vmidborder+
          view->border.rightborder;
  }
  else
  {
   width+=view->border.leftpb+view->border.rightpb;
   width+=view->border.leftborder+view->border.rightborder;
  }

  ys=view->border.firstborder+view->border.lastborder;

  section=file->hdr.section[view->branch];
  first=1;

  if(view->data.dble)
  {
   right=0;
   height=0;

   while(section)
   {
    sectionp=(sectionstr*)fob_find(section,file);
    snp=sectionp->np;
    nextsection=sectionp->chain.next;
    oldheight=height;
    height=sectionp->data.height;
    base=getpagebase(sectionp);

    pagep=(pagestr*)fob_find(sectionp->chain.child,file);
    pageno=pagep->data.number;

    if(right) /* mate left and right pages from sections */
    {
     if(!isghostleft(islhpnb(pageno,base),right) && snp)
     {
      oldheight=MAX(oldheight,height);
      snp--;
      pageno++;
     }

     /* just add the previous page */

     if(first) ys+=oldheight+view->border.toppb+view->border.botpb;
     else      ys+=oldheight+view->border.toppb+view->border.botpb+
                                                view->border.hmidborder;
     right=0;
    }

    if(isghostleft(islhpnb(pageno,base),right)) right=1;

    /* find out how many strips of 2 pages this section makes */

    if(snp)
    {
     np=(snp+right)/2;
     right=(snp+right) & 0x1;

     if(np)
     {
      if(first) 
      {
       ys+=height+view->border.toppb+view->border.botpb;
       np--;
       first=0;
      }

      ys+=(height+view->border.toppb+view->border.botpb+
                                     view->border.hmidborder)*np;
     } 
    }
    section=nextsection;
   }

   if(right)
   {
    if(first) ys+=height+view->border.toppb+view->border.botpb;
    else      ys+=height+view->border.toppb+view->border.botpb+
                                            view->border.hmidborder;
   }
  }
  else  /* not dble */
  {
   while(section)
   {
    sectionp=(sectionstr*)fob_find(section,file);
    section=sectionp->chain.next;

    ys+=(sectionp->np-first)*(view->border.hmidborder);

    ys+=sectionp->np*
            (sectionp->data.height+view->border.toppb+view->border.botpb);

    first=0;
   }
  }

  *h=ys;
  *w=width;
 }

 return(NULL);
}



os_error * setviewextent(viewstr * view)
{
 os_error       * err;
 wimp_redrawstr   eblock;
 int              w;
 int              h;

 setviewborders(view);

// cprintf("set view extent");

 view->extent.x0=xpix2os(xos2pix(-view->left));
 view->extent.y1=view->top; // rem hshift for mainpane

 getworkarea(view,view->file,&w,&h);

 view->extent.x1=osunits(w,view);
 view->extent.y0=-osunits(h,view);   /* height        */

 view->extent.x1+=view->right;
 view->extent.y0-=view->bottom;

 eblock.w=view->handle; //mainpane;
 eblock.box=view->extent;

 err=wimp_set_extent(&eblock);

 if(!err) err=setextentrulers(view);

 return(err);
}


os_error * filenewextent(filestr * file)
{
 os_error * err;
 viewstr  * view;

 err=NULL;
 view=file->view;
 while(view)
 {
  err=setviewextent(view);
  if(err) break;
  view=view->next;
 }

 return(err);
}



os_error * fileresetviews(filestr * file,int flags)
{
 os_error * err;
 viewstr  * view;

 err=NULL;
 view=file->view;
 while(view)
 {
  if(!
     (
      ((flags & FRVMST) && !view->branch) ||
      ((flags & FRVDOC) &&  view->branch)
     )
    )
  {
   reopenview(view,1,1,1,1,0,0,0,0);
   if(flags & FRVREFRESH) refreshview(view);
  }
  if(err) break;
  view=view->next;
 }

 return(err);
}


os_error * updateviewextent(viewstr * view)
{
 os_error * err;
 wimp_redrawstr eblock;

 view->extent.x0=-view->left;
 view->extent.y1=view->top;  // rem hshift for mainpane

 eblock.w=view->handle; //mainpane;
 eblock.box=view->extent;

 err=wimp_set_extent(&eblock);

 if(!err) err=setextentrulers(view);

 return(err);
}


/* step view variables forward one page */

static int fwrdpage(viewstr * view,filestr * file)
{
 pagestr    * page;
 sectionstr * section;

 page=(pagestr*)fob_find(view->page,file);
 if(page->chain.next) view->page=page->chain.next;
 else
 {
  section=(sectionstr*)fob_find(view->section,file);
  if(section->chain.next)
  {
   view->section=section->chain.next;
   section=(sectionstr*)fob_find(view->section,file);
   view->page=section->chain.child;
  }
  else return(0);
 }

 return(1);
}



/* step view variables backwards one page */

static int bckpage(viewstr * view,filestr * file)
{
 pagestr    * page;
 sectionstr * section;

 page=(pagestr*)fob_find(view->page,file);
 if(page->chain.prev)
 {
  view->page=page->chain.prev;
 }
 else
 {
  section=(sectionstr*)fob_find(view->section,file);
  if(section->chain.prev)
  {
   view->section=section->chain.prev;
   view->page=lastpageinsection(view->section,file);
  }
  else return(0);
 }
 return(1);
}



int viewpageheight(viewstr * view,int page,int section,int * yshift)
{
 pagestr    * pagep;
 sectionstr * sectionp;
 int          height;
 int          ys;
 int          left;
 int          right;
 int          prevsection;
 int          lastpage;
 int          nextsection;
 int          firstpage;
 filestr    * file;
 int          base;


 file=view->file;

 sectionp=(sectionstr*)fob_find(section,file);
 base=getpagebase(sectionp);

 pagep=(pagestr*)fob_find(page,file);
 height=pagep->box.h;
 ys=0;

 if(view->data.dble)
 {
  if(!islhpb(pagep,base))  /* need to get any left hand pages */
  {
   left=pagep->chain.prev;
   lastpage=!pagep->chain.next;
   sectionp=(sectionstr*)fob_find(section,file);
   lastpage=lastpage && (!sectionp->chain.next);

   if(!left)
   {
    if(sectionp->chain.prev)
    {
     section=sectionp->chain.prev;
     sectionp=(sectionstr*)fob_find(section,file);
     base=getpagebase(sectionp);
     prevsection=sectionp->chain.prev!=0;
     left=sectionp->chain.child;
     pagep=(pagestr*)fob_find(left,file);

     if(islhpb(pagep,base))
     {
      height=MAX(height,pagep->box.h);
      if(pagep->chain.prev || prevsection) ys=view->border.hmidborder;
      else                                 ys=view->border.firstborder;
     }
     else  /* prev page is a row above */
     {
      ys=view->border.hmidborder;
     }
    }
    else
    {
     ys=view->border.firstborder;
    }
   }
   else
   {
    if(!sectionp->chain.prev) ys=view->border.firstborder;
    else                      ys=view->border.hmidborder;
   }

   if(lastpage) height+=view->border.lastborder;
  }
  else    /* need to get any right hand pages */
  {
   right=pagep->chain.next;
   firstpage=!pagep->chain.prev;
   sectionp=(sectionstr*)fob_find(section,file);
   base=getpagebase(sectionp);
   nextsection=sectionp->chain.next!=0;
   firstpage=firstpage && !sectionp->chain.prev;

   if(!right)
   {
    if(sectionp->chain.next)
    {
     section=sectionp->chain.next;
     sectionp=(sectionstr*)fob_find(section,file);
     right=sectionp->chain.child;
     pagep=(pagestr*)fob_find(right,file);

     if(!islhpb(pagep,base))
     {
      height=MAX(height,pagep->box.h);
      if(!pagep->chain.next && !nextsection) height+=view->border.lastborder;
     }
    }
    else
    {
     height+=view->border.lastborder;
    }
   }
   else
   {
    if(!sectionp->chain.next) height+=view->border.lastborder;
   }

   if(firstpage) ys=view->border.firstborder;
   else          ys=view->border.hmidborder;
  }
 }
 else
 {
  if(!pagep->chain.prev)
  {
   sectionp=(sectionstr*)fob_find(section,file);
   if(!sectionp->chain.prev) ys=view->border.firstborder;
   else                      ys=view->border.hmidborder;
  }
  else
  {
   ys=view->border.hmidborder;
  }

  if(!pagep->chain.next)
  {
   sectionp=(sectionstr*)fob_find(section,file);
   if(!sectionp->chain.next) height+=view->border.lastborder;
  }
 }

 height+=view->border.toppb+view->border.botpb+ys;
 *yshift=ys+view->border.toppb;

 return(height);
}



static os_error * calcviewvars(viewstr * view,filestr * file,int toggle)
{
 os_error   * err;
 int          scroll;
 pagestr    * page;
 sectionstr * section;
 int          yshift;
 int          height;
 int          n;
 posnstr      posn;
 int          dpg;
 int          base;




          err=getw(view->handle,&view->mainwindow);
// if(!err) err=getw(view->handle,&view->mainwindow);  //mainpane

 if(!toggle)
 {
  view->prevbox.x0=view->mainwindow.x0;
  view->prevbox.x1=view->mainwindow.x1;
  view->prevbox.y0=view->mainwindow.y0;
  view->prevbox.y1=view->mainwindow.y1;
 }


 /* find out if the current top page is still the top page */



 scroll=ourunits(-view->mainwindow.scy+view->extent.y1,view);//mainpane

//  cprintf("scroll %d scy %d y1 %d y0 %d",scroll,view->mainwindow.scy,view->extent.y1,view->extent.y0);
 
 if(scroll<=0)
 {
  zeroviewvars(view,file);
 }
 else 
 if(scroll<view->ps)
 {
  while(scroll<view->ps)
  {
   if(!bckpage(view,file)) break;

   if(view->data.dble && !isghost(view,view->page,view->section,1))
   {
    page=(pagestr*)fob_find(view->page,file);
    if(page->chain.prev && !isghost(view,page->chain.prev,view->section,0))
                                                       bckpage(view,file);
    else
    {
     section=(sectionstr*)fob_find(view->section,file);
     if(section->chain.prev)
     {
      section=(sectionstr*)fob_find(section->chain.prev,file);
      n=section->np;
      base=getpagebase(section);

    /*  page=fob_find(section->chain.child,file); */
    /*  n+=page->data.number-1; */

      /* next line wrong for master pages, because of start number */
      n+=section->data.pagenumber.number-1;
      if(!isghostleft(islhpnb(n,base),0)) bckpage(view,file);
     }
    }
   }

   view->ps-=viewpageheight(view,view->page,view->section,&yshift);
  }
 }
 else
 {
  height=viewpageheight(view,view->page,view->section,&yshift);
  if(scroll>(view->ps+height))
  {
   while(scroll>(view->ps+height))
   {
    if(view->data.dble && !isghost(view,view->page,view->section,0))
    {
     page=(pagestr*)fob_find(view->page,file);
     if(page->chain.next && !isghost(view,page->chain.next,view->section,1))
                                                           fwrdpage(view,file);
     else
     {
      section=(sectionstr*)fob_find(view->section,file);
      if(section->chain.next)
      {
       section=(sectionstr*)fob_find(section->chain.next,file);
       if(!isghost(view,section->chain.child,section->key,1)) 
                                                           fwrdpage(view,file);
      }
     }
    }

    if(!fwrdpage(view,file)) break;

    view->ps+=height;
    height=viewpageheight(view,view->page,view->section,&yshift);
   }
  }
 }

 /* set up variables on opening window */

 posn.view=view;
 posn.file=file;
 posn.mousex=(view->mainwindow.x0+view->mainwindow.x1)/2; //mainpane
 posn.mousey=(view->mainwindow.y0+view->mainwindow.y1)/2;

 getposn(&posn);

 dpg=view->dpage;
 view->dpage=posn.page;
 view->dsection=posn.section;

// cprintf("dsection=%d",view->dsection);

 updateinfopal(view,dpg);

 vxcopen(view);

 return(err);
}


/*
static int wisopen(int handle)
{
 windowstr window;

 getw(handle,&window);
 return(window.wflags & 0x10000);
}
*/

/* handle is pane handle, return handle of pane behind it */

int viewprevpane(viewstr * view,filestr * file,int handle)
{
 int toolshandle;
 int last;

 gettoolshandle(view,file,&toolshandle);
 last=0;

 if(toolshandle==handle) last=1;

 if(view->info)
 {
  if(last) return(view->info);
  if(view->info==handle) last=1;
 }

 if(view->vpane)
 {
  if(last) return(view->vpane);
  if(view->vpane==handle) last=1;
 }

 if(view->hpane)
 {
  if(last) return(view->hpane);
  if(view->hpane==handle) last=1;
 }

 if(view->vruler)
 {
  if(last) return(view->vruler);
  if(view->vruler==handle) last=1;
 }

 if(view->hruler)
 {
  if(last) return(view->hruler);
  if(view->hruler==handle) last=1;
 }


 if(view->hpane2)
 {
  if(last) return(view->hpane2);
  if(view->hpane2==handle) last=1;
 }

 if(last) return(view->handle);

 return(0);
}



// this is called by clipboard code, get window position to open another cb in.

os_error * viewsetwindow(viewstr * view,windowstr * cwindow)
{
// int        toolshandle;
// int        handle;
// int        code;
// windowstr  window;

 getw(view->handle,cwindow);

//	cprintf("viewset behind %x",cwindow->bhandle);

// cwindow->bhandle=wimp_NOCHANGE;		wrong because cb window is deleted

	return(NULL);

#ifdef NEVER

 gettoolshandle(view,view->file,&toolshandle);

 code=((handle=toolshandle)!=0) ||
      ((handle=view->info)!=0) ||
      ((handle=view->vruler)!=0) ||
      ((handle=view->hruler)!=0) ||
      ((handle=view->vpane)!=0) ||
      ((handle=view->hpane)!=0) ||
      ((handle=view->hpane2)!=0);

 if(code)
 {
  getw(handle,&window);
  cwindow->bhandle=window.bhandle;
 }

#endif

 return(NULL);
}



// we've opened the main window, now open panes and tools
// would be better dropping the 'o' argument, since it is not always correct
// and this function uses calcviewvars to read data anyway.

os_error * viewopen(int handle,int userhandle,wimp_openstr * o)
{
 os_error     * err;
 viewstr      * view;
 filestr      * file;
 windowstr      oldwindow;
 int            toolshandle;

// cprintf("view open");

 view=(viewstr*)userhandle;
 file=view->file;
 gettoolshandle(view,file,&toolshandle);

 oldwindow=view->mainwindow;

 rulersave(file);

#ifdef NEVER

 if(view->handle) //mainpane
 {
  wimp_openstr op;
  windowstr    window;

  getw(view->handle,&window); //mainpane

  op.w=view->mainpane;
  op.box.x0=o->box.x0;
  op.box.y0=o->box.y0;   
  op.box.x1=o->box.x1;
  op.box.y1=o->box.y1-view->hshift;
  op.x=window.scx;       
  op.y=window.scy;
               
  op.behind=-2;

  wimp_open_wind_ex(&op);

  o->behind=view->mainpane;
 }

#endif


 err=calcviewvars(view,file,0);

// outside tool panes

 o->behind=-1;


 if(toolshandle)
 {
  opentoolspane(view,file,o,&oldwindow);
  o->behind=toolshandle;
 }

 if(view->info)
 {
  openinfopalpane(view,o,&oldwindow);
  o->behind=view->info;
 }

// internal panes

 o->behind=-1;


 if(view->vpane)
 {
  o->behind=view->vpane;
 }

 if(view->hpane)
 {
  openbuttons(view,o);
  o->behind=view->hpane;
 }


 if(view->rulerpatch)
 {
  openrulerpatch(view,o);
  o->behind=view->rulerpatch;
 }


 if(view->vruler)
 {
  openvruler(view,o);
  o->behind=view->vruler;
 }

 if(view->hruler)
 {
  openhruler(view,o);
  o->behind=view->hruler;
 }


 rulerload(file);

 opentabruler(view,o);
 if(view->hpane2) o->behind=view->hpane2;


 return(err);

 USE(handle);
}



#ifdef NEVER

os_error * viewopenmainpane(int handle,int userhandle,wimp_openstr * o)
{
 os_error    * err;
 viewstr     * view;
 wimp_wstate   wstate;

 view=(viewstr*)userhandle;

          err=wimp_get_wind_state(view->handle,&wstate);
 if(!err) err=viewopen(view->handle,userhandle,&wstate.o);

 return(err);

 USE(handle);
 USE(o);
}

#endif





os_error * viewopenbehind(viewstr * view,filestr * file,int b)
{
 os_error    * err;
 wimp_wstate   wstate;

 err=wimp_get_wind_state(view->handle,&wstate);
 wstate.o.behind=b;
 if(!err) err=wimp_open_wind(&wstate.o);
 if(!err) err=viewopen(view->handle,(int)view,&wstate.o);

 return(err);
 USE(file);
}


/*

static int countviews(void)
{
 int       count;
 filestr * file;

 count=0;

 file=firstfile;
 while(file)
 {
  count+=file->viewn[DOC]+file->viewn[MST];
  file=file->next;
 }

 return(count);
}

*/


 // change here is that viewopen() is called when the main window has been opened
 // by outside events. viewopen() no longer calls wimp_open_wind() since
 // it has already been opened
 // so we wimp_open_wind() which opens the window and then call viewopen()
 // to open the panes
 // if viewopen() isn't called view->dsectoin can end up as null which will cause
 // crashes  - look for zeroviewvars



os_error * viewopenat(viewstr * view,filestr * file,int scx,int scy)
{
 os_error    * err;
 wimp_wstate   wstate;

 err=wimp_get_wind_state(view->handle,&wstate);  //mainpane

 wstate.o.behind=-3;
 wstate.o.x=scx;
 wstate.o.y=scy;

 if(!err) err=wimp_open_wind(&wstate.o);
// if(!err) err=wimp_get_wind_state(view->handle,&wstate);
 if(!err) err=viewopen(view->handle,(int)view,&wstate.o);

 return(err);
 USE(file);
}



os_error * viewopenshift(viewstr * view,int dx,int dy)
{
 os_error    * err;
 wimp_wstate   wstate;

 err=wimp_get_wind_state(view->handle,&wstate);  //mainpane

 wstate.o.behind=-3;
 wstate.o.x+=dx;
 wstate.o.y+=dy;

 if(!err) err=wimp_open_wind(&wstate.o);
 if(!err) err=wimp_get_wind_state(view->handle,&wstate); // was commented, but drag on tabs scrolls wrongly
 if(!err) err=viewopen(view->handle,(int)view,&wstate.o);

 return(err);
}




os_error * viewopencrash(viewstr * view)
{
 os_error    * err;
 wimp_wstate   wstate;

 err=NULL;

 if(view->handle)
 {
  err=wimp_get_wind_state(view->handle,&wstate);

  wstate.o.box.x0=0;
  wstate.o.box.x1=0;
  wstate.o.box.y0=cvdu.screeny-40;
  wstate.o.box.y1=cvdu.screeny-40;

  if(!err) err=err=wimp_open_wind(&wstate.o);
  if(!err) err=viewopen(view->handle,(int)view,&wstate.o);
 }

 return(err);
}










#define YSLIMIT 100


static void viewdiddle(viewstr * xview)
{
 filestr * file;
 viewstr * view;
 int       xshift;
 int       yshift;
 int       x0=0;
 int       x1=0;
 int       y0=0;
 int       y1=0;
 int       loop;
 windowstr wi;
 windowstr wo;
 int       dx;
 int       dy;

 xshift=yshift=loop=0;

 getw(xview->handle,&wi);
 geto(xview->handle,&wo);

 dx=MAX((wi.x0-wo.x0),(wo.x1-wi.x1));
 dy=MAX((wi.y0-wo.y0),(wo.y1-wi.y1));

 
 cprintf("wi x0 %d x1 %d y0 %d y1 %d",wi.x0,wi.x1,wi.y0,wi.y1);
 cprintf("wo x0 %d x1 %d y0 %d y1 %d",wo.x0,wo.x1,wo.y0,wo.y1);
 
 while(1)
 {
  x0=xview->mainwindow.x0+xshift;
  x1=xview->mainwindow.x1+xshift;
  y0=xview->mainwindow.y0+yshift;
  y1=xview->mainwindow.y1+yshift;

		cprintf("xshift %d yshift %d wx1 %d wyo %d",xshift,yshift,wo.x1,wo.y0);

  if(loop>1) break;

  file=firstfile;
  while(file)
  {
   view=file->view;
   while(view)
   {
    if(view!=xview)
    {
     if((ABS(view->mainwindow.x0-x0)<cvdu.extrax) &&
        (ABS(view->mainwindow.x1-x1)<cvdu.extrax) &&
        (ABS(view->mainwindow.y0-y0)<cvdu.extray) &&
        (ABS(view->mainwindow.y1-y1)<cvdu.extray)) break;
    }
    view=view->next;
   }
   if(view) break;
   file=file->next;
  }
  if(!file) break;

  yshift-=dy;
  if((xview->mainwindow.y0-(wi.y0-wo.y0)+yshift)<YSLIMIT)
  {
   xshift+=dx;
   if((xview->mainwindow.x1+(wo.x1-wi.x1)+xshift)>=cvdu.screenx)
   {
    xshift=-wo.x0;
    loop++;
   }
   if(loop>1) xshift=yshift=0;
   else
   if(loop>0) yshift=cvdu.screeny-xview->mainwindow.y1-(wo.y1-wi.y1);
   else       yshift=0;
  }
 }

 xview->mainwindow.x0=x0;
 xview->mainwindow.x1=x1;
 xview->mainwindow.y0=y0;
 xview->mainwindow.y1=y1;
}



os_error * popupview(viewstr * view,filestr * file,windowstr * window,
                                                         int page,int section)
{
 os_error     * err;
 wimp_wstate    wstate;
 int            xpo;
 int            ypo;


 zeroviewvarsf(view,file);
 setviewextent(view);

 if(window)
 {
  view->mainwindow=*window;
 }
 else
 {
/* getw(view->handle,&view->window); */
/* view->window.scy=view->extent.y1; */

  if(defwindowx0<defwindowx1 && defwindowy1>defwindowy0)
  {
   view->mainwindow.x0=defwindowx0;
   view->mainwindow.x1=defwindowx1;
   view->mainwindow.y0=defwindowy0;
   view->mainwindow.y1=defwindowy1;
  }

  view->mainwindow.bhandle=-1;

  if(!page) page=view->page;
  if(!section) section=view->section;

  getpagecoords(view,page,section,&xpo,&ypo);
  view->mainwindow.scy=-osunits(ypo,view)+view->top; //mainpane
  view->mainwindow.scx= osunits(xpo,view)-view->left;

  viewdiddle(view);
 }

 wstate.o.w=view->handle;
 wstate.o.box.x0=view->mainwindow.x0;
 wstate.o.box.y0=view->mainwindow.y0;
 wstate.o.box.x1=view->mainwindow.x1;
 wstate.o.box.y1=view->mainwindow.y1;
 wstate.o.x=view->mainwindow.scx;
 wstate.o.y=view->mainwindow.scy;
 wstate.o.behind=view->mainwindow.bhandle;

// cprintf("window %x bhandle %x",window,view->mainwindow.bhandle);

 if(window) wcheckopen(&wstate.o,0);

// cprintf("window %x bhandle %x",window,view->mainwindow.bhandle);

// have to open twice because the window as created is not the size we think
// it is, due having added the menu bar
// in other words it opens in the wrong place

          err=wimp_open_wind(&wstate.o);
          updateviewextent(view);

 if(!err) err=wimp_open_wind(&wstate.o);
	cprintf("open x0 %d x1 %d y0 %d y1 %d",wstate.o.box.x0,wstate.o.box.x1,wstate.o.box.y0,wstate.o.box.y1);

 wimp_get_wind_state(view->handle,&wstate);

 if(!err) err=wimp_open_wind(&wstate.o); // add for Wine

	cprintf("open x0 %d x1 %d y0 %d y1 %d",wstate.o.box.x0,wstate.o.box.x1,wstate.o.box.y0,wstate.o.box.y1);

//	cprintf("behind %x",wstate.o.behind);

// {
//  windowstr w;
//  getw(view->handle,&w);
//  cprintf("behind %x",w.bhandle);

// }

 if(err) cprintf("leaving view pop up with error %s",err->errmess);


 if(!err) err=viewopen(view->handle,(int)view,&wstate.o);


 return(err);
}





/* kill vdi and reopen it to refresh things */

static os_error * reopenview(viewstr * view,int omul,int odiv,int mul,int div,
                             int xshift,int yshift,int axshift,int ayshift)
{
 os_error    * err;
 wimp_wstate   winds;
 int           scx;
 int           scy;

 err=NULL;

 wimp_get_wind_state(view->handle,&winds);

 scx=winds.o.x+xshift+axshift;
 scy=winds.o.y+yshift+ayshift;

 zeroviewvarsf(view,view->file);
 setviewextent(view);

 scx=scale(scx,mul*odiv,omul*div);
 scy=scale(scy,mul*odiv,omul*div);

 winds.o.x=scx-xshift;
 winds.o.y=scy-yshift;


 err=wimp_open_wind(&winds.o);
 if(!err) err=viewopen(view->handle,(int)view,&winds.o);

 return(err);
}



static os_error * xsetzoom(viewstr * view,int mul,int div,int opt,
                           int xshift,int yshift,int axshift,int ayshift)
{
 os_error * err;
 int        omul;
 int        odiv;

 omul=view->data.zoom.mul;
 odiv=view->data.zoom.div;

 view->data.zoom.mul=mul;
 view->data.zoom.div=div;
 view->data.zoomopt=opt;

 setviewscalefactor(view);

 refreshview(view);

 err=reopenview(view,omul,odiv,mul,div,xshift,yshift,axshift,ayshift);

 event(EVENT_ZOOM,view->file,(int)view);

 updateviewdata(view);

 updateviewtitle(view);

 refreshrulers(view);

 return(err);
}



static os_error * zoom200(viewstr * view)
{
 os_error * err;

 if(view->data.zoomopt!=ZOOM200)
 {
  err=xsetzoom(view,2,1,ZOOM200,0,0,0,0);
 }
 else err=NULL;

 return(err);
}



static os_error * zoom50(viewstr * view)
{
 os_error * err;

 if(view->data.zoomopt!=ZOOM50)
 {
  err=xsetzoom(view,1,2,ZOOM50,0,0,0,0);
 }
 else err=NULL;

 return(err);
}



static os_error * zoomnorm(viewstr * view)
{
 os_error * err;

 if(view->data.zoomopt!=ZOOM100)
 {
  err=xsetzoom(view,1,1,ZOOM100,0,0,0,0);
 }
 else err=NULL;

 return(err);
}



static os_error * zoom75(viewstr * view)
{
 os_error * err;

 if(view->data.zoomopt!=ZOOM75)
 {
  err=xsetzoom(view,3,4,ZOOM75,0,0,0,0);
 }
 else err=NULL;

 return(err);
}



static os_error * zoom150(viewstr * view)
{
 os_error * err;

 if(view->data.zoomopt!=ZOOM150)
 {
  err=xsetzoom(view,3,2,ZOOM150,0,0,0,0);
 }
 else err=NULL;

 return(err);
}




static os_error * zoom400(viewstr * view)
{
 os_error * err;

 if(view->data.zoomopt!=ZOOM400)
 {
  err=xsetzoom(view,4,1,ZOOM400,0,0,0,0);
 }
 else err=NULL;

 return(err);
}




static void zoomfitsub(viewstr * view,int scrnx,int scrny,
                                      int * mul,int * div,int bits)
{
 filestr * file;
 int       height;
 int       width;
 int       scrn;
 int       page;


 file=view->file;

/* dprintf(0,"sx=%d sy=%d",scrnx,scrny); */

 height=file->hdr.maxpageheight[view->branch];
 width =file->hdr.maxpagewidth[view->branch];

 height+=view->border.toppb+view->border.botpb;
 width+=view->border.leftpb+view->border.rightpb;
 width+=view->border.leftborder+view->border.rightborder;

 if(view->data.dble)
 {
  width+=view->border.mid1pb+view->border.mid2pb;
  width+=view->border.vmidborder;
 }

 height=bosunits(height);
 width=bosunits(width);

 if((height*scrnx>width*scrny || bits & 0x2) && !(bits & 0x1))
 {
  page=height;
  scrn=scrny;
 }
 else
 {
  page=width;
  scrn=scrnx;
 }

/* while(page>100 && scrn>100)
 {
  page/=10;
  scrn/=10;
 } */

 scrn=scale(100,scrn,page);
 page=100;

 *mul=scrn;
 *div=page;

 /* has to be some sort of cut! */
}



void zoomfitgetscr(viewstr * view,int * mul,int * div,int bits)
{
 wimp_openstr o;

 o.box.x0=0;
 o.box.x1=cvdu.screenx-vscrlbar;
 o.box.y1=cvdu.screeny-hscrlbar;
 o.box.y0=hscrlbar;

 toolsclip(&o,view,1);
 infopalclip(&o,view,1);

 zoomfitsub(view,o.box.x1-o.box.x0-view->left,
                 o.box.y1-o.box.y0-view->top,
                 mul,div,bits);
}


static os_error * zoomfitscr(viewstr * view,int bits)
{
 os_error * err;
 int        mul;
 int        div;

 err=NULL;

 zoomfitgetscr(view,&mul,&div,bits);

 if(view->data.zoomopt!=ZOOMDEF ||
    mul!=view->data.defzoom.mul ||
    div!=view->data.defzoom.div
   )
 {
  view->data.defzoom.mul=mul;
  view->data.defzoom.div=div;
  err=xsetzoom(view,mul,div,ZOOMDEF,0,0,0,0);
 }

 return(err);
}



/* would rather this not change the size of the window */


void zoomfitget(viewstr * view,int * mul,int * div)
{
 zoomfitsub(view,view->mainwindow.x1-view->mainwindow.x0-view->left-view->right,
                 view->mainwindow.y1-view->mainwindow.y0-view->top-view->bottom,
                 mul,div,0); //mainpane
}


static os_error * zoomfit(viewstr * view)
{
 os_error * err;
 int        mul;
 int        div;

 err=NULL;

 zoomfitget(view,&mul,&div);

 if(view->data.zoomopt!=ZOOMDEF ||
    mul!=view->data.defzoom.mul ||
    div!=view->data.defzoom.div
   )
 {
  view->data.defzoom.mul=mul;
  view->data.defzoom.div=div;
  err=xsetzoom(view,mul,div,ZOOMDEF,0,0,0,0);
 }

 return(err);
}



/* here xshift and yshift are offset coords  of a point in the window */
/* whose position is preserved under zooming                          */


os_error * zoomdef(viewstr * view,int xshift,int yshift)
{
 os_error * err;

 if(view->data.zoomopt!=ZOOMDEF || 
    view->data.zoom.mul!=view->data.defzoom.mul ||
    view->data.zoom.div!=view->data.defzoom.div)
 {
  err=xsetzoom(view,view->data.defzoom.mul,view->data.defzoom.div,ZOOMDEF,
                                                        xshift,yshift,0,0);
 }
 else err=NULL;

 return(err);
}


/* here xshift and yshift are actual shifts of the window */

os_error * zoomdef2(viewstr * view,int xshift,int yshift,
                                   int axshift,int ayshift)
{
 os_error * err;

 if(view->data.zoomopt!=ZOOMDEF || 
    view->data.zoom.mul!=view->data.defzoom.mul ||
    view->data.zoom.div!=view->data.defzoom.div || axshift || ayshift)
 {
  err=xsetzoom(view,view->data.defzoom.mul,view->data.defzoom.div,ZOOMDEF,
                                              xshift,yshift,axshift,ayshift);
 }
 else err=NULL;

 return(err);
}




/* called when changing vdi to reset zoom */
/*
int zoomcheck(void)
{
 if(vdi_zoomopt[vdi]==0) {vdi_zoomopt[vdi]=-1;zoomfit();return(1);}

 return(0);
}
*/



os_error * zoomopt(viewstr * view,int opt)
{
 os_error * err;

 err=NULL;

 switch(opt)
 {
   case ZOOMFIT:                  /* fit */
          err=zoomfit(view);
          break;

   case ZOOMDEF:
          err=zoomdef(view,0,0);
          break;

   case ZOOMSCR:
          err=zoomfitscr(view,0);
          break;


   case ZOOM50:
          err=zoom50(view);
          break;

   case ZOOM75:
          err=zoom75(view);
          break;

   case ZOOM100:
          err=zoomnorm(view);
          break;

   case ZOOM150:
          err=zoom150(view);
          break;

   case ZOOM200:
          err=zoom200(view);
          break;

   case ZOOM400:
          err=zoom400(view);
          break;

   case ZOOMSCRW:
          err=zoomfitscr(view,0x1);
          break;

   case ZOOMSCRH:
          err=zoomfitscr(view,0x2);
          break;


 }

 return(err);
}


/***************************************************************************/

#ifdef NEVER

/* something spectacular goes here */
/* basically, preserve vdi_dpg     */

void toggledouble(void)
{
 vec v;
 vec u;
 int xshift;
 int yshift;

 u.box=v.box=vdi_dpg[vdi]->u.page.child;
 setpage(&v);
 xshift=vdi_scx[vdi]-osunits(v.xps);
 yshift=-vdi_scy[vdi]-osunits(v.yps);


 vdi_double[vdi]^=1;
 resetvdis();
 if(!zoomcheck()) refreshvdi();
 if(actex)
 { 
  setpage(act);
  if(zone) setpage(zon);
 }

 setpage(&u);
 xshift+=osunits(u.xps);
 yshift+=osunits(u.yps);
 goffset(xshift,yshift);

 placecaret();
/* modfile(); */
}

#endif



os_error * xsetdouble(viewstr * view,int newdble,int repaint)
{
 os_error * err;
 int        xshift;
 int        yshift;
 int        xpo;
 int        ypo;
 int        page;
 int        section;
 filestr  * file;

 err=NULL;

 file=view->file;

 page=view->dpage;
 section=view->dsection;

 getpagecoords(view,page,section,&xpo,&ypo);

 xshift=view->mainwindow.scx-osunits(xpo,view); //mainpane
 yshift=-view->mainwindow.scy-osunits(ypo,view);

 view->data.dble=newdble;
 setviewborders(view);

 zeroviewvarsf(view,file);
 setviewextent(view);

 getpagecoords(view,page,section,&xpo,&ypo);

 xshift+=osunits(xpo,view);
 yshift+=osunits(ypo,view);

 if(repaint)
 {
  refreshview(view);
  refreshrulers(view);
 }

 viewopenat(view,file,xshift,-yshift);

 return(err);
}


/*****************************************************************************/



os_error * gotopagek(viewstr * view,int page,int section)
{
 os_error * err;
 int        xpo;
 int        ypo;

 err=NULL;

 if(page && section)
 {
  getpagecoords(view,page,section,&xpo,&ypo);
  viewopenat(view,
             view->file,
              osunits(xpo,view)-view->left,
             -osunits(ypo,view)+view->top);
 }

 return(err);
}



os_error * gotopagea(viewstr * view,int pn)
{
 int page;
 int section;

 if(pn<0) pn=0;
 psapageno(pn,&page,&section,view->file,view->branch);
 return(gotopagek(view,page,section));
}




/* better method may be to work out page sizes and jump accordingly */


static os_error * prevpage(int n)
{
 os_error   * err;
 int          page;
 int          dp;
 int          section;
 pagestr    * pagep;
 sectionstr * sectionp;
 int          fix;
 int          m;

 err=NULL;
 fix=8;
 dp=page=menuview->dpage;
 section=menuview->dsection;

 while(dp==menuview->dpage && fix-->0)
 {
  m=n;

  while(m--)
  {
   pagep=(pagestr*)fob_find(page,menufile);
   page=pagep->chain.prev;
   if(!page)
   {
    sectionp=(sectionstr*)fob_find(section,menufile);
    section=sectionp->chain.prev;
    if(section)
    {
     page=lastpageinsection(section,menufile);
    }
    else
    {
     break;
    }
   }
  }

  if(!section) break;

  err=gotopagek(menuview,page,section);
 }

 return(err); 
}


static os_error * nextpage(int n)
{
 os_error   * err;
 int          page;
 int          dp;
 int          section;
 pagestr    * pagep;
 sectionstr * sectionp;
 int          fix;
 int          m;

 err=NULL;
 dp=page=menuview->dpage;
 section=menuview->dsection;
 fix=8;


 while(dp==menuview->dpage && fix-->0)
 {
  m=n;

  while(m--)
  {
   pagep=(pagestr*)fob_find(page,menufile);
   page=pagep->chain.next;
   if(!page)
   {
    sectionp=(sectionstr*)fob_find(section,menufile);
    section=sectionp->chain.next;
    if(section)
    {
     sectionp=(sectionstr*)fob_find(section,menufile);
     page=sectionp->chain.child;
    }
    else
    {
     break;
    }
   }
  }

  if(!section) break;

  err=gotopagek(menuview,page,section); 
 }

 return(err);
}


static os_error * firstpage(void)
{
 return(gotopagea(menuview,0));
}


static os_error * lastpage(void)
{
 return(gotopagea(menuview,menufile->hdr.np[menuview->branch]-1));
}



static os_error * gotofirstpageinsection(void)
{
 int       page;
 int       section;
 filestr * file;

 file=menuview->file;

 section=menuview->dsection;

 page=((sectionstr*)fob_find(section,file))->chain.child;

 return(gotopagek(menuview,page,section));
}



static os_error * gotolastpageinsection(void)
{
 return(gotopagek(menuview,
                  lastpageinsection(menuview->dsection,menuview->file),
                  menuview->dsection));
}



os_error * nextscreen(int n)
{
 int dx;
 int dy;
 dx=0;
 dy=-(menuview->mainwindow.y1-menuview->mainwindow.y0-
                     menuview->top-menuview->bottom)*n; //mainpane
 return(viewopenshift(menuview,dx,dy));
}



os_error * prevscreen(int n)
{
 int dx;
 int dy;
 dx=0;
 dy=(menuview->mainwindow.y1-menuview->mainwindow.y0-
                    menuview->top-menuview->bottom)*n; //mainpane
 return(viewopenshift(menuview,dx,dy));
}



/*****************************************************************************/

static int vcount;
static int vkey;


static os_error * viewkeyflush(void)
{
 os_error * err;

 err=NULL;

 if(vcount)
 {
  switch(vkey)
  {

   case      PAGEDOWN:
                      err=nextscreen(vcount);  /* page down          */
                      break;

   case        PAGEUP:
                      err=prevscreen(vcount);  /* page up            */
                      break;
                                  
   case   SHFT_PAGEUP:
                      err=prevpage(vcount);    /* SHIFT page up   */
                      break;

   case SHFT_PAGEDOWN:
                      err=nextpage(vcount);    /* SHIFT page down */
                      break;

   case   CTRL_PAGEUP:                         /* CTRL page up     */
                      err=gotofirstpageinsection();
                      break;


   case   CTSH_PAGEUP:
                      err=firstpage();
                      break;


   case CTRL_PAGEDOWN:                         /* CTRL page down   */
                      err=gotolastpageinsection();
                      break;


   case CTSH_PAGEDOWN:
                      err=lastpage();   
                      break;


   case       CTRL_K6:
                      err=zoomdef(menuview,0,0);
                      break;

    case      CTRL_K1:
                      err=zoomnorm(menuview);
                      break;

    case      CTRL_K5:
                      err=zoom50(menuview);       /* check on keypad */
                      break;

    case      CTRL_K2:
                      err=zoom200(menuview);
                      break;

    case      CTRL_K3:
                      err=zoom150(menuview);
                      break;

    case      CTRL_K4:
                      err=zoom400(menuview);
                      break;

//    case       CTRL_G:
//                      toggleguides(menuview);
//                      break;

    case       CTSH_I:
                      toggleinvisibles(menuview);
                      break;

    case       CTRL_M:
                      togglemargins(menuview);
                      break;

    case       CTSH_R:
                      togglerulers(menuview);
                      break;


    case       INSERT:
                      err=pasteselection2(menuview);
                      break;


    case      CTRL_F4:
                      closeviews(menuview,menufile);
                      break;

              default:
                      if(vkey==keycanonical2code(DIGIT6|KEYCTRL))
                                                     err=zoomdef(menuview,0,0);
                      else
                      if(vkey==keycanonical2code(DIGIT1|KEYCTRL))
                                                     err=zoomnorm(menuview);
                      else
                      if(vkey==keycanonical2code(DIGIT2|KEYCTRL))
                                                     err=zoom200(menuview);
                      else
                      if(vkey==keycanonical2code(DIGIT3|KEYCTRL))
                                                     err=zoom150(menuview);
                      else
                      if(vkey==keycanonical2code(DIGIT4|KEYCTRL))
                                                     err=zoom400(menuview);
                      else
                      if(vkey==keycanonical2code(DIGIT5|KEYCTRL))
                                                     err=zoom50(menuview);

                      break;
  }
  vcount=0;
 }
 return(err);
}



os_error * viewkey(int * key)
{
 int ch;

 ch=*key;

 switch(ch)
 {
   case      PAGEDOWN:
   case        PAGEUP:
   case   SHFT_PAGEUP:
   case SHFT_PAGEDOWN:
   case   CTRL_PAGEUP:
   case CTRL_PAGEDOWN:
   case   CTSH_PAGEUP:
   case CTSH_PAGEDOWN:



//    case       CTRL_G:

    case       CTSH_I:

    case       CTRL_M:

    case       CTSH_R:

    case       INSERT:

    case      CTRL_F4:


    case      CTRL_K1:
    case      CTRL_K2:
    case      CTRL_K3:
    case      CTRL_K4:
    case      CTRL_K5:
    case      CTRL_K6:
                      break;

             default:
                     if(/*ch==keycanonical2code(DIGIT0|KEYCTRL) ||*/
                        ch==keycanonical2code(DIGIT1|KEYCTRL) ||
                        ch==keycanonical2code(DIGIT2|KEYCTRL) ||
                        ch==keycanonical2code(DIGIT3|KEYCTRL) ||
                        ch==keycanonical2code(DIGIT4|KEYCTRL) ||
                        ch==keycanonical2code(DIGIT5|KEYCTRL) ||
                        ch==keycanonical2code(DIGIT6|KEYCTRL)) break;

                     viewkeyflush();
                     return(NULL);
                     break;
 }

 if(ch==vkey) vcount++;
 else
 {
  viewkeyflush();
  vkey=ch;
  vcount++;
 }

 *key=-1;
 return(NULL);
}

