/*->c.xrline */

#include <stdafx.h>

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <locale.h>

#include "os.h"
#include "wimp.h"
#include "wimpt.h"
#include "werr.h"
#include "wos.h"
#include "flex.h"
#include "bbc.h"
#include "transform.h"
#include "BezierArc.h"


#include "err.h"
#include "xmath.h"
#include "etc.h"
#include "colour.h"

#include "str.h"

#include "view.h"

#include "xrline.h"









void setxlineboxoffends(xlinestr * box)
{
 int b;
 int p;


 b=(box->ex-box->ox);
 p=(box->ey-box->oy);

 box->hy=pythag(b,p);


 if(box->ex<box->ox)
 {
  box->x=box->ex;
  box->w=box->ox-box->ex;
 }
 else
 { 
  box->x=box->ox;
  box->w=box->ex-box->ox;
 }

 if(box->ey<box->oy)
 {
  box->y=box->ey;
  box->h=box->oy-box->ey;
 }
 else
 {
  box->y=box->oy;
  box->h=box->ey-box->oy;
 }
}






static void transf(int ox,int oy,int * nx,int * ny,
                                          int p,int b,int hy,xlinestr * line)
{
 *nx=scale(ox,b,hy)-scale(oy,p,hy)+line->ox;
 *ny=scale(oy,b,hy)+scale(ox,p,hy)+line->oy;
}




/* calc line length, calc bounding box for line */

os_error * setxlinevars(xlinestr * line,int dr,viewredrawstr * v)
{
 os_error * err;
 int        x0;
 int        x1;
 int        y0;
 int        y1;
 int        p;
 int        b;
 int        hy;
 int        e1x;
 int        e1y;
 int        e2x;
 int        e2y;
 int        ech;
 int        ecw;
 viewstr  * view;


 err=NULL;

 if(dr) view=v->view;
 else   view=NULL;        /* compiler */


 b=(line->ex-line->ox);
 p=(line->ey-line->oy);
 hy=pythag(b,p);

 if(!hy) hy=1;

 line->hy=hy;

 x0=line->x;
 x1=line->x+line->w;
 y0=line->y+line->h;
 y1=line->y;

 ech=line->ech*line->thickness;
 ecw=line->ecw*line->thickness;
 if(ech>hy/2) ech=hy/2;



 if(dr & 0x2)
 {
  transf(hy,-line->thickness/2,&e1x,&e1y,p,b,hy,line);
  bbc_move(v->ox+osunits(e1x,view),v->oy-osunits(e1y,view));

  transf(hy, line->thickness/2,&e2x,&e2y,p,b,hy,line);
  bbc_move(v->ox+osunits(e2x,view),v->oy-osunits(e2y,view)); 

  transf(ech,line->thickness/2,&e2x,&e2y,p,b,hy,line);
  bbc_plot(bbc_ParallelFill+5,v->ox+osunits(e2x,view),v->oy-osunits(e2y,view));

/*  transf(ech,-line->thickness/2,&e2x,&e2y,p,b,hy,line);
  bbc_move(v->ox+osunits(e2x,view),v->oy-osunits(e2y,view));

  bbc_plot(85,v->ox+osunits(e1x,view),v->oy-osunits(e1y,view));  */
 }


 if(line->endcaps & 1)
 {
  transf(hy-ech,-ecw,&e1x,&e1y,p,b,hy,line);
  transf(hy-ech, ecw,&e2x,&e2y,p,b,hy,line);
  if(dr & 0x1)
  {
   if(!err) err=bbc_move(v->ox+osunits(line->ex,view),
                         v->oy-osunits(line->ey,view));
   if(!err) err=bbc_move(v->ox+osunits(e1x,view),
                         v->oy-osunits(e1y,view));
   if(!err) err=bbc_plot(bbc_TriangleFill+5,v->ox+osunits(e2x,view),
                            v->oy-osunits(e2y,view));
  }
 }
 else
 {
  transf(hy,-line->thickness/2,&e1x,&e1y,p,b,hy,line);
  transf(hy, line->thickness/2,&e2x,&e2y,p,b,hy,line);
 }


 if(e1x<x0) x0=e1x;
 if(e1x>x1) x1=e1x;
 if(e2x<x0) x0=e2x;
 if(e2x>x1) x1=e2x;
 if(e1y<y1) y1=e1y;
 if(e1y>y0) y0=e1y;
 if(e2y<y1) y1=e2y;
 if(e2y>y0) y0=e2y;


 if(line->endcaps & 2)
 {
  transf(ech, ecw,&e1x,&e1y,p,b,hy,line);
  transf(ech,-ecw,&e2x,&e2y,p,b,hy,line);

  if(dr & 0x1)
  {
   if(!err) err=bbc_move(v->ox+osunits(line->ox,view),
                         v->oy-osunits(line->oy,view));
   if(!err) err=bbc_draw(v->ox+osunits(e1x,view),
                         v->oy-osunits(e1y,view));
   if(!err) err=bbc_plot(bbc_TriangleFill+5,v->ox+osunits(e2x,view),
                            v->oy-osunits(e2y,view));
  }
 }
 else
 {
  transf(0,-line->thickness/2,&e1x,&e1y,p,b,hy,line);
  transf(0, line->thickness/2,&e2x,&e2y,p,b,hy,line);
 }

 if(e1x<x0) x0=e1x;
 if(e1x>x1) x1=e1x;
 if(e2x<x0) x0=e2x;
 if(e2x>x1) x1=e2x;
 if(e1y<y1) y1=e1y;
 if(e1y>y0) y0=e1y;
 if(e2y<y1) y1=e2y;
 if(e2y>y0) y0=e2y;


 line->bx=x0;
 line->by=y1;
 line->bw=x1-x0;
 line->bh=y0-y1;

 return(err);
}



/* return 1/0 if point lies within line */


int insidexline(int x,int y,xlinestr * line,viewstr * view)
{
 int p,b,hy;
 int t=line->thickness;
 int t2;
 int xlo,xhi;
 int ox;
 int oy;
 int ech,ecw;

 if(t<(t2=2*ourunits(cvdu.extrax+cvdu.extray,view))) t=t2;

 t2=t>>1;

 ox=x-line->ox;
 oy=y-line->oy;

 b=(line->ex-line->ox);
 p=(line->ey-line->oy);
 hy=line->hy;

 ech=line->ech*t;
 ecw=line->ecw*t;
 if(ech>(hy/2)) ech=hy/2;


 x=scale(ox,b,hy)+scale(oy,p,hy);
 y=scale(oy,b,hy)-scale(ox,p,hy);

 if(x<0 || x>hy) return(0);
 if(y<-ecw || y> ecw) return(0);

 xlo=0;
 xhi=hy;
                                                /* in line body */
 if(line->endcaps & 0x2) xlo=ech;
 if(line->endcaps & 0x1) xhi=hy-ech;

 if(y<t2 && y>-t2 && x>xlo && x<xhi) return(XLBODY);
 if(!(line->endcaps & 0x3))   return(0);  /* no endcaps */


 if(x>=0 && x<=xlo && (line->endcaps & 0x2))
 {                                           /* maybe inside origin endcap  */
  if(   (((double)y*(double)ech<=(double)x*(double)ecw)  && y>=0)
     || (((double)y*(double)ech>=-(double)x*(double)ecw) && y<=0)
    )
                                                        return(XLEC0);
 }
 else
 if(x>=xhi && x<=hy && (line->endcaps & 0x1))
 {                                           /* maybe inside leading endcap */
  x=x-xhi;
  if(   (((double)(y-ecw)*(double)ech<=-(double)x*(double)ecw) && y>=0)
     || (((double)(y+ecw)*(double)ech>= (double)x*(double)ecw) && y<=0)
    )
                                                        return(XLEC1); 
 }

 return(0);
}



