/*->c.dbchoices */



#include "stdafx.h"

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <locale.h>

#include "os.h"
#include "wimp.h"
#include "wimpt.h"
#include "werr.h"
#include "akbd.h"
#include "transform.h"


#include "etc.h"
#include "filetype.h"
#include "wos.h"
#include "err.h"
#include "xext.h"
#include "poll.h"
#include "key.h"
#include "temp.h"
#include "trans.h"
#include "fsx.h"
#include "bf.h"
#include "bits.h"
#include "conf.h"
#include "colour.h"
#include "deb.h"
#include "sp.h"


#include "dbhi.h"
#include "mhi.h"


#include "str.h"
#include "constants.h"

#include "object.h"

#include "reslink.h"
#include "units.h"

#include "file.h"
#include "view.h"
#include "viewo.h"
#include "viewr.h"
#include "rulers.h"
#include "infopal.h"
#include "main.h"

#include "undo.h"

#include "txext.h"
#include "new.h"

#include "dbscale.h"
#include "dbmore.h"

#include "pref.h"
#include "dbpref.h"

#include "dbchoices.h"
#include "choices.h"


/*****************************************************************************/

static wimp_icon * choiceicon0;  /* border      */
static wimp_icon * choiceicon1;  /* text/sprite */

static viewstr * choiceview;


static subchoicestr * nth(int n,subchoicestr * first)
{
 subchoicestr * choice;
 int            i;

 choice=first;
 i=0;

 while(choice) 
 {
  if(choice->sprite)
  {
   if(i==n) break;
   i++;
  }
  choice=choice->next;
 }

 return(choice);
}



static os_error * choicesadds(subchoicestr * subchoice,subchoicestr ** first,
                                                int * n,int * ni)
{
 subchoicestr * choice;

 if(*first)
 {
  choice=*first;
  while(choice->next) choice=choice->next;
  choice->next=subchoice;
 }
 else
 {
  *first=subchoice;
 }

 (*n)++;
 if(subchoice->sprite) (*ni)++;

 return(NULL);
}


// filename0 is the users !Choices
// filename1 is the system !Choices
// Problem here is if you allow the multiuser variable to be set from choices
// doing so means inventing a new !!Choices file that only exists in the program
// folder
// for now multiuser on/off support is not enabled


static os_error * savechoices1(char * filename0,char * filename1,subchoicestr * first)
{
 os_error     * err;
 buffer         bf[2];
 subchoicestr * choice;

 err=bf_open(filename0,'w',DEFBUFFSIZE,&bf[0]);
 if(!err)
 {
//  err=bf_open(filename1,'w',DEFBUFFSIZE,&bf[1]);
  if(!err)
  {
   stdfileheader(&bf[0],fs_leaf(filename0));
   bf_printf(&bf[0],"void main(void)\r\n{\r\n");

//   stdfileheader(&bf[1],fs_leaf(filename1));
//   bf_printf(&bf[1],"void main(void)\n{\n");

   choice=first;
   while(choice)
   {
    if(choice->save) err=choice->save(&bf[0]);
    choice=choice->next;
   }

//   bf_printf(&bf[1],"}\n\n");
//   err=bf_closec(&bf[1],err,filename1,SCRIPT2);

   bf_printfeoln(&bf[0],2,"}");
   err=bf_closec(&bf[0],err,filename0,SCRIPT2);
  }
 }

 return(err);

 USE(filename1);
}


/*****************************************************************************/

#define MACFY 12
#define MACDY 94
#define MACHY 98

static int         macwidth;


/* redraw macros pane */

static os_error * choicespaneredrawsub(int handle,wimp_redrawstr * redrawstr,
                  int more,subchoicestr * first,int curchoice)
{
 int            oy;
 int            ox;
 int            ylo;
 int            yhi;
 int            n;
 int            y;
 int            h0;
 int            h1;
 subchoicestr * choice;
 char           buffer[128];
 char           temp[64];
 char         * oldbuffer;



 while(more)
 {
  ox=redrawstr->box.x0-redrawstr->scx;
  oy=redrawstr->box.y1-redrawstr->scy;

  ylo=-(redrawstr->g.y1-oy);            /* small number, top of window */
  yhi=-(redrawstr->g.y0-oy);            /* bigger, bottom of window */

  n=(ylo-MACFY)/MACDY;
  if(n<0) n=0;

  choice=nth(n,first);

  y=n*MACDY+MACFY;

  while(y<=(yhi+MACFY) && choice)
  {
   if(choice->sprite)
   {
    h0=choiceicon0->box.y1-choiceicon0->box.y0;
    choiceicon0->box.y1=oy-MACFY-n*MACDY;
    choiceicon0->box.y0=choiceicon0->box.y1-h0;

    h1=choiceicon1->box.y1-choiceicon1->box.y0;
    h1=(h0-h1)/2;

    choiceicon1->box.y1=choiceicon0->box.y1-h1;
    choiceicon1->box.y0=choiceicon0->box.y0+h1;

    oldbuffer=choiceicon1->data.indirecttext.buffer;

    tsprintf(sizeof(temp),temp,choice->name);

    choiceicon1->data.indirecttext.buffer=buffer;
    strcpy(buffer,"\\C\\B\\s");
    strcat(buffer,temp);
    strcat(buffer,"\\C\\T\\KD1\\a");
    strcat(buffer,choice->sprite);

    if(n==curchoice) 
    {
     choiceicon0->flags=(wimp_iconflags)(choiceicon0->flags | wimp_ISELECTED);
    }
    else
    {
     choiceicon0->flags=(wimp_iconflags)(choiceicon0->flags & (~wimp_ISELECTED));
    }

    wimp_ploticon(handle,choiceicon0,(sprite_area*)sprites);
    wimp_ploticon(handle,choiceicon1,(sprite_area*)sprites);

    choiceicon1->data.indirecttext.buffer=oldbuffer;

    y+=MACDY;
    n++;
   }
   choice=choice->next;
  }
  wimp_get_rectangle(redrawstr,&more);
 }

 return(NULL);
 USE(handle);
}



static os_error * choicespaneredraws(int handle,subchoicestr * first,
                                                int curchoice)
{
 os_error       * err;
 wimp_redrawstr   redrawstr;
 int              more;

 redrawstr.w=handle;
 err=wimp_redraw_wind(&redrawstr,&more);
 if(!err) choicespaneredrawsub(handle,&redrawstr,more,first,curchoice);
 return(err);
}





static void choicesrefreshentry(int n,dboxstr * dbox,subchoicestr * first,
                                                           int curchoice)
{
 wimp_redrawstr r;
 int            more;

 r.box.x0=0;
 r.box.x1=macwidth;
 r.box.y1=-n*MACDY+cvdu.deltay;
 r.box.y0=r.box.y1-MACHY-cvdu.deltay-MACFY;

 r.w=dbox[1].handle;

 wimp_update_wind(&r,&more);
 choicespaneredrawsub(dbox[1].handle,&r,more,first,curchoice);
}





static os_error * choicepaneicons(int handle,wimp_mousestr * m,dboxstr * dbox,
                                  subchoicestr * first,int * curtot,
                                                       int * curchoice)
{
 os_error     * err;
 windowstr      window;
 int            y;
 int            n;
 int            old;
 subchoicestr * oldchoice;
 subchoicestr * newchoice;

 err=NULL;

 if(m->bbits==4)
 {
  getw(handle,&window);

  y=m->y-window.by;
  n=(-y-MACFY)/MACDY;
  if(!(n<0 || n>=*curtot)) 
  {
   if(n!=*curchoice)
   {
    err=dbreadvalues(&dbox[2]);
    if(!err)
    {
     oldchoice=nth(*curchoice,first);

     if(oldchoice)
     {
      if(oldchoice->pane) oldchoice->pane(0);
     }
    
     old=*curchoice;
     *curchoice=-1;

     choicesrefreshentry(old,dbox,first,*curchoice);

     *curchoice=n;
     newchoice=nth(n,first);

     if(newchoice)
     {
      if(newchoice->pane) newchoice->pane(1);
     }

     dbchangepane(&dbox[2],newchoice->dbox,dbox);

     if(newchoice)
     {
      if(newchoice->pane) newchoice->pane(2);
     }

     choicesrefreshentry(n,dbox,first,*curchoice);
    }
   }
  }
 }

 return(err);
}



static os_error * choicecloses(int code,subchoicestr * first,dboxstr * dbox)
{
 os_error     * err;
 subchoicestr * choice;

 if(code!=DBCANCEL) err=dbreadvalues(&dbox[2]);
 else               err=NULL;

 if(!err)
 {
  choice=first;
  while(choice)
  {
   if(choice->close) err=choice->close(code);
   if(err) break;
   choice=choice->next;
  }
 }

 return(err);
}



static os_error * choicechanges(subchoicestr * first,void * old,
                                                     void * xnew,viewstr * view)
{
 os_error     * err;
 subchoicestr * choice;

 err=NULL;

 choice=first;
 while(choice)
 {
  if(choice->change) err=choice->change(old,xnew,view);
  if(err) break;
  choice=choice->next;
 }

 return(err);
}



/*****************************************************************************/

extern      dboxstr     choicebox[3];

static int         curchoice;

       dbstackstr  dbchoicestack;


static int            curtotchoices;
static int            curtotchoicesi;
static subchoicestr * firstchoice;




static os_error * choicespaneredraw(int handle,int userhandle)
{
 return(choicespaneredraws(handle,firstchoice,curchoice));
 USE(userhandle);
}



static os_error * choicepaneicon(int handle,int userhandle,wimp_mousestr * m)
{
 return(choicepaneicons(handle,m,choicebox,firstchoice,&curtotchoicesi,&curchoice));
 USE(userhandle);
}




static int choicechangesflag;


void choicechange(int flag)
{
 choicechangesflag|=flag;
}




static os_error * choiceclose(int code)
{
 os_error * err;

 choicechangesflag=0;

 err=choicecloses(code,firstchoice,choicebox);

 event(EVENT_CHOICES,NULL,0);

 if(choicechangesflag & CHOICEVIEW) refreshall();

 return(err);
}



static char * choicespath="<HKEY_CURRENT_USER\\Software\\Microsoft\\Windows\\CurrentVersion\\Explorer\\Shell Folders\\AppData>\\DavidPilling\\OvationPro\\AutoRun\\!Choices.csc";
static char * choicesbasepath="<HKEY_LOCAL_MACHINE\\Software\\DavidPilling\\OvationPro\\>\\AutoRun\\!Choices.csc";
static char * choicessystempath="<HKEY_LOCAL_MACHINE\\Software\\DavidPilling\\OvationPro\\>\\AutoRun\\!!Choices.csc";

static os_error * savechoices(int handle,int userhandle,wimp_mousestr * m)
{
 os_error * err;
 int        result;

 err=confirmparent(NULL,CONYN,&result,"{PREC}");
 if(result==1)
 {
  choiceclose(DBAPPLY);
  err=fs_validatepath(multiuser?choicespath:choicesbasepath,0);
  if(!err) err=savechoices1(multiuser?choicespath:choicesbasepath,choicessystempath,firstchoice);
  if(!err) event(EVENT_CHOICESSAVE,NULL,NULL);
 }

 return(err);


 USE(userhandle);
 USE(handle);
 USE(m);
}



static dbiconstr choiceicondefs[]=
{
 /* N   &V           Type     Grp   Flags   R   L   D   U     In    Out */


    0, NULL,        DBACTION, 0,   0,      0, 0, 0, 0, (dbreadfn)savechoices,0,
    1, NULL,        DBACTION, 0,   0,      DBOK,RETURN, 0,0,    NULL, 0,
    2, NULL,        DBACTION, 0,   0,      DBCANCEL,ESCAPE, 0,0,NULL, 0,

   -1, NULL,         0,       0,    0,      0,  0,  0,  0,  0,      0
};




dboxstr choicebox[3]=
{
 0,
 TCHOICES,
 DBFIX,
 0,
 choiceclose,
 NULL,
 NULL,
 NULL,
 choiceicondefs,
 0,
 0,
 0,0,0,0,

 0,
 TCHOICESP,
 DBPANE,
 0,
 NULL,
 choicepaneicon,
 NULL,
 choicespaneredraw,
 NULL,
 0,
 0,
 0,0,0,0,

 0,
 TCHTEXT,
 DBPANE,
 DBFITICON,
 NULL,
 NULL,
 NULL,
 NULL,
 NULL,
 0,
 0,
 0,0,0,
 CHPANEICON

};




dbstackstr * getchoicestack(void)
{
 return(&dbchoicestack);
}


dboxstr * getchoicedbox(void)
{
 return(choicebox);
}



dboxstr * choicepanedbox(void)
{
 return(choicebox+2);
}


os_error * choicechangevalue(int * value)
{
 return(dbchangevalue(value,choicebox));
}


os_error * choicesadd(subchoicestr * subchoice)
{
 return(choicesadds(subchoice,&firstchoice,&curtotchoices,&curtotchoicesi));
}


static os_error * initchoiceboxopen(subchoicestr * first)
{
 os_error     * err;
 subchoicestr * choice;

 err=NULL;

 choice=first;
 while(choice)
 {
  if(choice->open) choice->open();
  choice=choice->next;
 }

 return(err);
}


static os_error * initchoicebox(int handle,int curtot)
{
 os_error     * err;
 int            miny;
 int            sety;
 windowstr      window;
 wimp_icon      result;


 wimp_lose_icon_info(&choiceicon0);
 wimp_get_icon_info(handle,0,&result);
 wimp_copy_icon_info(&choiceicon0,&result);

 wimp_lose_icon_info(&choiceicon1);
 wimp_get_icon_info(handle,1,&result);
 wimp_copy_icon_info(&choiceicon1,&result);

 wimp_delete_icon(handle,0);
 wimp_delete_icon(handle,1);


 err=getw(handle,&window);

 macwidth=window.x1-window.x0;
 miny=window.y1-window.y0;
 sety=MACFY+MACDY*curtot;
 if(sety>miny) miny=sety;

 extent(handle,0,-miny,macwidth,0);

 return(err);
}


viewstr * choicesview(void)
{
	return(choiceview);
}


void openchoicesbox(int fp)
{
 os_error     * err;
 subchoicestr * choice;
 dboxstr      * dboxp;

 if(!choicebox[0].handle)
 {

		choiceview=menuview;

  curchoice=0;
  choice=firstchoice;

  while(choice)
  {
   dboxp=choice->dbox;
   if(dboxp)
   {
    dboxp->flags|=DBFITICON;
    dboxp->z=CHPANEICON;

   }
   choice=choice->next;
  }

  choice=firstchoice;

  while(choice)
  {
   if(choice->dbox)
   {
    choicebox[2]=*choice->dbox;
    break;
   }
   choice=choice->next;
  }


           err=initchoiceboxopen(firstchoice);
  if(!err) err=dodboxspparent(choicebox,3,choicebox,&dbchoicestack,menuview->handle);
  if(!err) err=initchoicebox(choicebox[1].handle,curtotchoicesi);
 }
 else
 {
  err=dboxforward(choicebox);
 }

 zreport(err);

 USE(fp);
}

/***************************************************************************/

static filestr      * cfile;
static viewstr      * cview;

prefdatastr           prefdata;
prefdatastr           defprefdata;

int                   prefcompatability;


static int            curpref;
static int            curtotpref;
static int            curtotprefi;
       subchoicestr * firstpref;

extern dboxstr        prefbox[3];





static os_error * prefpaneredraw(int handle,int userhandle)
{
 return(choicespaneredraws(handle,firstpref,curpref));
 USE(userhandle);
}



static os_error * prefpaneicon(int handle,int userhandle,wimp_mousestr * m)
{
 return(choicepaneicons(handle,m,prefbox,firstpref,&curtotpref,&curpref));
 USE(userhandle);
}




static int prefchangesflag;


void prefchanges(int flag)
{
 prefchangesflag|=flag;
}


filestr * preffile(void)
{
	return(cfile);
}




#define UPREF       0xA000
#define UPREFF      0xA001
#define UPREFS      0xA002
#define UPREFCOMPAT 0xA003



static os_error * undoprefsub(filestr * file,viewstr * view,prefdatastr * xnew)
{
 os_error     * err;
 prefdatastr    oldprefdata;

 if(!view) view=file->view;

 prefread(&oldprefdata,file);

 undowritefn(file,UPREF,&oldprefdata,sizeof(prefdatastr));

 err=prefwrite(xnew,file);

 prefchangesflag=0;

 event(EVENT_PREFERENCES,view,(int)&oldprefdata);

 choicechanges(firstpref,&oldprefdata,xnew,view);

 if(prefchangesflag & PREFVDATA) updateviewdata(view);

 if(prefchangesflag & PREFDBLE)  xsetdouble(view,view->data.dble,1);

 if(prefchangesflag & (PREFMST|PREFDOC))
 {
  if(prefchangesflag & PREFDOC) viewrefreshall(file,0,VRBACK);
  if(prefchangesflag & PREFMST) viewrefreshall(file,1,VRBACK);
 }
 else
 if(prefchangesflag & PREFCURRENT)
 {
  refreshview(view);
 }

 if(prefchangesflag & PREFRULERS) refreshrulers(view);

 if(prefchangesflag & PREFFLOW) reflowfile(file);

 if(prefchangesflag & PREFCHAP) 
 {
  changechapterstart(file);
  infopalfile(file,DOC);
 }

 if(prefchangesflag & PREFAUTOSAVE) autosavereset(file);


 return(err);
}


static os_error * undopref(filestr * file)
{
 prefdatastr newprefdata;
 undoread(file,&newprefdata,sizeof(prefdatastr));
 return(undoprefsub(file,NULL,&newprefdata));
}




/* this function is always called last in undo/redo */

static os_error * undoprefs(filestr * file)
{
 event(EVENT_PREFERENCES1,file,NULL);
 return(undowritefn(file,UPREFF,NULL,0));
}


/* this function is always called first in undo/redo */

static os_error * undopreff(filestr * file)
{
 undowritefn(file,UPREFS,NULL,0);
 return(event(EVENT_PREFERENCES0,file,NULL));
}




static os_error * undoprefcompat(filestr * file)
{
	int compatability;

 undowritefn(file,UPREFCOMPAT,&file->compatability,sizeof(int));
	undoread(file,&compatability,sizeof(int));
	file->compatability=compatability;

	return(NULL);
}





static os_error * prefclose(int code)
{
 os_error     * err;
	prefteststr    preftest;

 err=choicecloses(code,firstpref,prefbox);
 if(!err && (code==DBOK || code==DBAPPLY)) 
 {
		preftest.compatability=prefcompatability;
		preftest.pref=&prefdata;

		err=event(EVENT_TESTCOMPATABILITY,cfile,(int)&preftest);
  if(!err) err=modfile(cfile,-1);
  if(!err)
  {
   err=undostart(cfile);
   if(!err)
   {
				if(cfile->compatability!=prefcompatability)
				{
     undowritefn(cfile,UPREFCOMPAT,&cfile->compatability,sizeof(int));
		   cfile->compatability=prefcompatability;
				}

    undopreff(cfile);
    err=undoprefsub(cfile,cview,&prefdata);
    undoprefs(cfile);
    undoend(cfile);
   }
  }

 }
 return(err);
}


static char * prefpath="<HKEY_CURRENT_USER\\Software\\Microsoft\\Windows\\CurrentVersion\\Explorer\\Shell Folders\\AppData>\\DavidPilling\\OvationPro\\AutoRun\\!Prefs.csc";
static char * prefbasepath="<HKEY_LOCAL_MACHINE\\Software\\DavidPilling\\OvationPro\\>\\AutoRun\\!Prefs.csc";

static os_error * savepref(int handle,int userhandle,wimp_mousestr * m)
{
 os_error * err;
 int        result;

 err=confirmparent(NULL,CONYN,&result,"{PREF}");
 if(result==1)
 {
  prefclose(DBAPPLY);

  defprefdata=prefdata;
		workcompatability=prefcompatability;

  err=fs_validatepath(multiuser?prefpath:prefbasepath,0);
  if(!err) err=savechoices1(multiuser?prefpath:prefbasepath,NULL,firstpref);
  if(!err) err=event(EVENT_PREFERENCESSAVE,cview,NULL);
 }


 return(err);

 USE(userhandle);
 USE(handle);
 USE(m);
}




static dbiconstr preficondefs[]=
{
 /* N   &V           Type     Grp   Flags   R   L   D   U     In    Out */


    0, NULL,        DBACTION, 0,   0,      0, 0, 0, 0, (dbreadfn)savepref,0,
    1, NULL,        DBACTION, 0,   0,      DBOK,RETURN, 0,0,    NULL, 0,
    2, NULL,        DBACTION, 0,   0,      DBCANCEL,ESCAPE, 0,0,NULL, 0,

   -1, NULL,         0,       0,    0,      0,  0,  0,  0,  0,      0
};




static dboxstr prefbox[3]=
{
 0,
 TPREFERENCES,
 DBFIX,
 0,
 prefclose,
 NULL,
 NULL,
 NULL,
 preficondefs,
 0,
 0,
 0,0,0,0,

 0,
 TCHOICESP,
 DBPANE,
 0,
 NULL,
 prefpaneicon,
 NULL,
 prefpaneredraw,
 NULL,
 0,
 0,
 0,0,0,0,

 0,
 TPREFTEXT,
 DBPANE,
 DBFITICON,
 NULL,
 NULL,
 NULL,
 NULL,
 NULL,
 0,
 0,
 0,0,0,
 CHPANEICON,

};





os_error * prefchangevalue(int * value)
{
 return(dbchangevalue(value,prefbox));
}


os_error * prefadd(subchoicestr * subchoice)
{
 return(choicesadds(subchoice,&firstpref,&curtotpref,&curtotprefi));
}



void openprefbox(int fp)
{
 os_error * err;

 cfile=menufile;
 cview=menuview;

 prefread(&prefdata,cfile);

	prefcompatability=cfile->compatability;


 if(!prefbox[0].handle)
 {
  curpref=0;
  if(firstpref) prefbox[2]=*firstpref->dbox;
 }

          err=initchoiceboxopen(firstpref);
 if(!err) err=dodboxspparent(prefbox,3,prefbox,&dbviewstack,cview->handle);
 if(!err) err=initchoicebox(prefbox[1].handle,curtotpref);

 zreport(err);

 USE(fp);
}


/**************************************************************************/



#define UNDOS 4

static undofnstr undos[UNDOS]=
{
 undopref,   NULL,                 UPREF,          NULL,
 undoprefs,  NULL,                 UPREFS,         "{UPREF}",
 undopreff,  NULL,                 UPREFF,         "{UPREF}",
 undoprefcompat,NULL,														UPREFCOMPAT,				NULL,
};


os_error * choicesinit(void)
{
 os_error      * err=NULL;


 if(!err) err=prefinit();

 if(!err) err=undoaddblock(undos,UNDOS);

 return(err);
}


