/*->c.dbgline */



#include "stdafx.h"

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <locale.h>

#include "os.h"
#include "wimp.h"
#include "wimpt.h"
#include "werr.h"
#include "akbd.h"
#include "transform.h"
#include "etc.h"

#include "wos.h"
#include "err.h"
#include "xext.h"
#include "poll.h"
#include "key.h"
#include "temp.h"
#include "redraw.h"
#include "trans.h"
#include "fsx.h"
#include "bf.h"


#include "dbhi.h"
#include "mhi.h"

#include "str.h"
#include "reslink.h"
#include "units.h"
#include "xcolour.h"
#include "file.h"
#include "geometry.h"

#include "dbcolour.h"
#include "view.h"
#include "posn.h"
#include "object.h"
#include "select.h"
#include "pref.h"

#include "dbscale.h"

#include "gline.h"
#include "dbgline.h"




/*****************************************************************************/

static boxbitstr ob;
static boxbitstr nb;



static filestr   * cfile;
static viewstr   * cview;
static int         cobject;

static int         coord;


static os_error * lineclose(int code)
{
 os_error * err;

 err=NULL;

 if(code==DBOK || code==DBAPPLY)
 {
  if(!nb.width)  nb.orgx=coord;
  else           nb.orgy=coord;

  setboxtrans(&ob,&nb);
  transformselection(boxtrans,0);
  ob=nb;
 }

 return(err);
}



static os_error * outu(int value,char * string)
{
 strcpy(string,unitstostring(value-(nb.width?prefp(cfile)->rulery:
                                    prefp(cfile)->rulerx),cview->data.units));
 return(NULL);
}


static os_error * inu(int * value,char * string)
{
 os_error * err;
 int        n;
 err=stringtounits(string,&n,cview->data.units);
 *value=n+(nb.width?prefp(cfile)->rulery:prefp(cfile)->rulerx);
 return(err);
}




static dbiconstr lineicondefs[18]=
{
 /* N   &V           Type     Grp   Flags   R   L   D   U     In    Out */

    3,  &coord,      DBWRITE,  0,   0,      -1, -1, -1, -1,   inu,  outu,

 /* N   &V           Type     Grp   Flags   Act Key     - -   clickfn 0 */

    1, NULL,         DBACTION, 0,   0,      DBOK,RETURN, 0,0,    NULL, 0,
    2, NULL,         DBACTION, 0,   0,      DBCANCEL,ESCAPE, 0,0,NULL, 0,

   -1, NULL,                     0,     0,     0,  0,  0,  0,  0,  0,  0
};



static dboxstr linebox=
{
 0,
 TGLINE,
 DBFIX,
 0,
 lineclose,
 NULL,
 NULL,
 NULL,
 lineicondefs,
 0,
 0,
 0,NULL,
 0,
 0,
};




os_error * openguidelinebox(glinestr * linep,filestr * file,viewstr * view)
{
 os_error * err;

 cfile=file;
 cview=view;
 cobject=linep->key;

 getboxbits(&linep->fcurve.box,&linep->transform,&ob);
 nb=ob;

 if(!nb.width) coord=nb.orgx;
 else          coord=nb.orgy;

 err=dodboxspparent(&linebox,1,&linebox,&dbviewstack,view->handle);

 return(err);
}


