/*->c.dbmodchap */



#include "stdafx.h"

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <locale.h>

#include "os.h"
#include "wimp.h"
#include "wimpt.h"
#include "werr.h"
#include "akbd.h"
#include "transform.h"

#include "wos.h"
#include "err.h"
#include "xext.h"
#include "poll.h"
#include "key.h"
#include "temp.h"
#include "redraw.h"
#include "trans.h"
#include "fsx.h"
#include "bf.h"
#include "etc.h"


#include "str.h"
#include "reslink.h"

#include "dbhi.h"
#include "mhi.h"

#include "units.h"
#include "xcolour.h"

#include "dbscale.h"

#include "dbcolour.h"

#include "object.h"
#include "view.h"
#include "file.h"

#include "new.h"
#include "modchap.h"


#include "dbmodchap.h"





static viewstr  *    cview;

static int           insafter;
static int           csection;
static int           basechapter;


static int           comitheader;
static int           comitfooter;

static int           cformat;        /* page number format               */
static int           cstart;         /* 1 == start numbering from here   */

static int           cleft;          /* start on left                    */
static int           cblanks;        /* count blank pages when numbering */

static int           cnumber;        /* starting number                  */







static os_error * modchapterclose(int code)
{
 os_error       * err;
 pagenumberstr    cpagenumber;

 err=NULL;

 if(code==DBOK || code==DBAPPLY)
 {
  cpagenumber.omitheader=comitheader;
  cpagenumber.omitfooter=comitfooter;
  cpagenumber.format=cformat;
  cpagenumber.start=cstart;
  cpagenumber.left=cleft;
  cpagenumber.blanks=cblanks;
  cpagenumber.number=cnumber;

  if(insafter>=0)
  {
   err=newchapter(csection,insafter,&cpagenumber,cview,-1,basechapter);
  }
  else
  {
   err=modifychapter(cview,csection,&cpagenumber);
  }
 }

 return(err);
}


static os_error * pageout(int value,char * string)
{
 if(cstart) strcpy(string,numbertostring(value));
 else       *string=0;
 return(NULL);
}



static os_error * pagein(int * value,char * string)
{
 os_error * err;

 if(strlen(string))
 {
  err=stringtonumber(string,value);
  cstart=1;
 }
 else
 {
  *value=0;
  cstart=0;
  err=NULL;
 }

 return(err);
}




static os_error * out(int value,char * string)
{
 strcpy(string,numbertostring(value));
 return(NULL);
}


static os_error * in(int * value,char * string)
{
 os_error * err;
 err=stringtonumber(string,value);
 return(err);
}





static dbiconstr modchaptericondefs[]=
{
 /* N   &V           Type     Grp   Flags   R   L   D   U     In    Out */

    5, &cnumber,     DBWRITE,0,   0,      -1, -1, -1, -1,pagein,pageout,

   14, &basechapter       ,DBWRITE,1,   0,      -1, -1, -1, -1,in,    out,


 /* N   &V           Type     Grp   Flags   Act Key     - -   clickfn 0 */

    1, NULL,         DBACTION, 0,   0,      DBOK,RETURN, 0,0,    NULL, 0,
    2, NULL,         DBACTION, 0,   0,      DBCANCEL,ESCAPE,0,0, NULL, 0,

 /* N   &V           Type     Grp   Flags   Msk Key   -   -   clickfn 0 */

    6,  &cformat,    DBRADIO, 0,   0,PNFNUMERIC,  F2,    1,0,NULL,0,
    8,  &cformat,    DBRADIO, 0,   0,PNFROMANLOWER,F3,   1,0,NULL,0,
    7,  &cformat,    DBRADIO, 0,   0,PNFROMANUPPER,F4,   1,0,NULL,0,

    9,  &comitheader,DBTOGGLE,0,0,1, F3,  0, 0,      NULL,   0,
   10,  &comitfooter,DBTOGGLE,0,0,1, F4,  0, 0,      NULL,   0,


   11,  &cleft,      DBRADIO, 0,   0,1,F5,   2,0,NULL,0,
   12,  &cleft,      DBRADIO, 0,   0,0,F6,   2,0,NULL,0,

   15,  &cblanks,    DBTOGGLE,0,   0,1,F7,   0,0,NULL,0,



 /* N   &V           Type     Grp   Flags   Msk Key -  -      clickfn 0 */

   -1, NULL,         0,       0,    0,      0,  0,  0,  0,  0,      0
};



static dboxstr modchapterdbox=
{
 0,
 TMODCHAPTER,
 DBFIX,
 0,
 modchapterclose,
 NULL,
 NULL,
 NULL,
 modchaptericondefs,
 0,
 0
};



static os_error * openmodchapter(int after)
{
 os_error   * err;
 char         temp[128];
 sectionstr * sectionp;
 int          csectioni;


 cview=menuview;

 csection=cview->dsection;

 sectionp=(sectionstr*)fob_find(csection,menufile);
 basechapter=csectioni=sectionp->data.number;
 if(after>0) csectioni++;
 else
 if(after==0 && sectionp->chain.prev) basechapter--;

 insafter=after;

 comitheader=sectionp->data.pagenumber.omitheader;
 comitfooter=sectionp->data.pagenumber.omitfooter;
 cformat=sectionp->data.pagenumber.format;
 cstart=sectionp->data.pagenumber.start;
 cleft=sectionp->data.pagenumber.left;
 cblanks=sectionp->data.pagenumber.blanks;
 cnumber=sectionp->data.pagenumber.number;


 if(after>=0 && (after>0 || sectionp->chain.prev)) cstart=0;

 sprintf(temp,"{MOD01} %d",csectioni);
 trans(temp,sizeof(temp));

 err=dodboxsptitleparent(&modchapterdbox,1,&modchapterdbox,&dbviewstack,temp,cview->handle);

 if(!err)
 {
  dbshade(1,after<0?(DBSHADEG|DBWRITEG):0,&modchapterdbox);
 }

 return(err);
}



void modchapterbox(int fp)
{
 zreport(openmodchapter(-1));
 USE(fp);
}


/* parameter is before/after 0/1 */

void newchapterbox(int fp)
{
 zreport(openmodchapter(stack[fp]));
}

