/*->c.dbpref */



#include "stdafx.h"

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <locale.h>

#include "os.h"
#include "wimp.h"
#include "wimpt.h"
#include "werr.h"
#include "akbd.h"
#include "transform.h"
#include "etc.h"

#include "wos.h"
#include "err.h"
#include "xext.h"
#include "poll.h"
#include "key.h"
#include "temp.h"
#include "trans.h"
#include "fsx.h"
#include "bf.h"
#include "bits.h"
#include "deb.h"


#include "constants.h"
#include "dbhi.h"
#include "mhi.h"

#include "str.h"
#include "reslink.h"
#include "units.h"


#include "tools.h"
#include "infopal.h"

#include "object.h"
#include "file.h"
#include "view.h"
#include "macros.h"
#include "main.h"

#include "dscript.h"

#include "pref.h"
#include "dbchoices.h"

#include "txstr.h"
#include "codes.h"

#include "dbpref.h"



/*****************************************************************************/


static os_error * outu(int value,char * string)
{
 strcpy(string,unitstostring(value,prefdata.units));
 return(NULL);
}


static os_error * inu(int * value,char * string)
{
 return(stringtounits(string,value,prefdata.units));
}


static os_error * chviewsave(buffer * bf)
{
 return(bf_printfeol(bf,"viewpref1(%d,%d,%d,%d,%d,%d,%d);",
                      defprefdata.pasteboardx,
                      defprefdata.pasteboardy,
                      defprefdata.rulerx,
                      defprefdata.rulery,
                      defprefdata.snaprulerguidelines,
                      defprefdata.snapframes,
                      defprefdata.guidelinefb));

/*

 bf_printf(bf,"viewpref2(%d,%d,%d,%d,%d,%d,%d);\n",
               toolboxattached,
               toolboxposnx,toolboxposny,
               toolboxx,toolboxy,
               defviewdata.toolsxshift,defviewdata.toolsyshift);


 bf_printf(bf,"viewpref3(%d,%d,%d,%d,%d,%d);\n",
               infopalattached,
               infopalposnx,infopalposny,
               defviewdata.infoxshift,defviewdata.infoyshift,
               defviewdata.infowheight);

*/
}


void viewpref1(int fp)
{
 defprefdata.pasteboardx=stack[fp];
 defprefdata.pasteboardy=stack[fp+1];
 defprefdata.rulerx=stack[fp+2];
 defprefdata.rulery=stack[fp+3];
 defprefdata.snaprulerguidelines=stack[fp+4];
 defprefdata.snapframes=stack[fp+5];
 defprefdata.guidelinefb=stack[fp+6];
}



static os_error * chviewchange(prefdatastr * old,
                               prefdatastr * xnew,viewstr * view)
{
 if(xnew->rulerx!=old->rulerx || xnew->rulery!=old->rulery)
 {
  view->data.rulerx=xnew->rulerx;
  view->data.rulery=xnew->rulery;
  prefchanges(PREFVDATA|PREFRULERS|PREFCURRENT);
 }

 if(xnew->guidelinefb!=old->guidelinefb)
 {
  view->data.guidelinefb=xnew->guidelinefb;
  prefchanges(PREFVDATA|PREFCURRENT);
 }

 if(xnew->pasteboardx!=old->pasteboardx ||
    xnew->pasteboardy!=old->pasteboardy)
 {
  view->data.pasteboardxwidth=xnew->pasteboardx;
  view->data.pasteboardywidth=xnew->pasteboardy;
  prefchanges(PREFVDATA|PREFDBLE);
 }

 return(NULL);
}







static os_error * prefviewdscript(buffer * bf,prefdatastr * data,
                                  filestr * file)
{
 bf_printfeol(bf,"VIEWPREF={viewpref");
 bf_printfeol(bf,"{pasteboardwidth %d}",data->pasteboardx);
 bf_printfeol(bf,"{pasteboardheight %d}",data->pasteboardy);
 bf_printfeol(bf,"{rulerx %d}",data->rulerx);
 bf_printfeol(bf,"{rulery %d}",data->rulery);
 bf_printfeol(bf,"{snaprulerguides %d}",data->snaprulerguidelines);
 bf_printfeol(bf,"{snapframes %d}",data->snapframes);
 bf_printfeol(bf,"{guidelinefrontback %d}",data->guidelinefb);

 bf_printfeoln(bf,2,"}");

 return(NULL);

 USE(file);
}



/* NB uses range of values with general prefs below */

#define DSTVIEWPREF          0x1780
#define DSTPASTEBOARDX       0x1781
#define DSTPASTEBOARDY       0x1782
#define DSTRULERX            0x1783
#define DSTRULERY            0x1784
#define DSTSNAPRULERGUIDES   0x1785
#define DSTSNAPFRAMES        0x1786
#define DSTGUIDELINESFB      0x1787



static os_error * dsviewpref(int fp,int argc,objectloc * loc)
{
 os_error *    err;
 int           sp;
 int           nsp;
 dsobjectstr * ds;
 dsobjectstr * ds1;
 int           type;
 filestr     * file;
 prefdatastr   data;



 err=NULL;

 dsneeddoc(loc);

 file=loc->file;

 sp=fp+2; /* skip leading type/len */

 prefread(&data,file);


 while(argc--)
 {
  ds=(dsobjectstr*)(dsstack+sp);
  type=ds->type;
  nsp=sp+ds->len/sizeof(int);

  if(ds->len>2*sizeof(int)) ds1=(dsobjectstr*)(dsstack+sp+2);
  else                      ds1=NULL;

  switch(type)
  {

   case       DSTPASTEBOARDX:
                             data.pasteboardx=ds1->data.integer;
                             break;

   case       DSTPASTEBOARDY:
                             data.pasteboardy=ds1->data.integer;
                             break;

   case            DSTRULERX:
                             data.rulerx=ds1->data.integer;
                             break;

   case            DSTRULERY:
                             data.rulery=ds1->data.integer;
                             break;

   case   DSTSNAPRULERGUIDES:
                             data.snaprulerguidelines=ds1->data.integer;
                             break;

   case        DSTSNAPFRAMES:
                             data.snapframes=ds1->data.integer;
                             break;

   case      DSTGUIDELINESFB:
                             data.guidelinefb=ds1->data.integer;
                             break;

  }

  sp=nsp;
 }

 prefwrite(&data,file);

 ds=(dsobjectstr*)(dsstack+fp);
 ds->data.integer=0;
 ds->len=3*sizeof(int);

 return(err);
}





static int dsnulllist[]={
                           DSTENDLIST
                          };



static dscreator dsdefs2[]=
{
 0,0,0,0, "viewpref",         dsviewpref, 0, DSTVIEWPREF,        dsnulllist,
 0,0,0,0, "pasteboardwidth",    NULL,     0, DSTPASTEBOARDX,     dsnulllist,
 0,0,0,0, "pasteboardheight",   NULL,     0, DSTPASTEBOARDY,     dsnulllist,
 0,0,0,0, "rulerx",             NULL,     0, DSTRULERX,          dsnulllist,
 0,0,0,0, "rulery",             NULL,     0, DSTRULERY,          dsnulllist,
 0,0,0,0, "snaprulerguides",    NULL,     0, DSTSNAPRULERGUIDES, dsnulllist,
 0,0,0,0, "snapframes",         NULL,     0, DSTSNAPFRAMES,      dsnulllist,
 0,0,0,0, "guidelinefrontback", NULL,     0, DSTGUIDELINESFB,    dsnulllist,

};






static dbiconstr chviewicondefs[]=
{
 /* N   &V           Type     Grp   Flags   R   L   D   U     In    Out */

   51, &prefdata.pasteboardx,DBWRITE, 0,   0,    -1, -1, -1, -1,   inu,  outu,
    3, &prefdata.rulerx, DBWRITE,  0,    0,     -1, -1, -1, -1,   inu,  outu,
    5, &prefdata.rulery, DBWRITE,  0,    0,     -1, -1, -1, -1,   inu,  outu,

    6, &prefdata.snaprulerguidelines,DBTOGGLE, 0,  0,  1,  F2, 0, 0,  NULL, 0,
    7, &prefdata.snapframes,         DBTOGGLE, 0,  0,  1,  F2, 0, 0,  NULL, 0,

    9, &prefdata.guidelinefb,        DBRADIO,  0,  0,  1,  F2, 1, 0,  NULL, 0,
   10, &prefdata.guidelinefb,        DBRADIO,  0,  0,  0,  F2, 1, 0,  NULL, 0,

   -1, NULL,         0,       0,    0,      0,  0,  0,  0,  0,      0
};




static dboxstr chviewbox=
{
 0,
 TPREFVIEW,
 DBPANE,
 0,
 NULL,
 NULL,
 NULL,
 NULL,
 chviewicondefs,
 0,
 0,

 0,NULL,
 0,
 0,

};


static subchoicestr chview=
{
 NULL,

 &chviewbox,

 "ch_view",
 "{CHV0}",

 chviewsave,
 NULL,
 NULL,
 NULL,
 (choicechangefn)chviewchange,
 (choicedscriptfn)prefviewdscript,
};




int getsnapstate(int fp)
{
 prefdatastr * pref;
 
 pref=prefp(menufile);
 return((pref->snapframes)|((pref->snaprulerguidelines)<<1));
 USE(fp);
}


void setsnapstate(int fp)
{
 prefdatastr * pref;
 
 pref=prefp(menufile);

 pref->snapframes=((stack[fp] & 0x1)!=0);
 pref->snaprulerguidelines=((stack[fp] & 0x2)!=0);
}



/**************************************************************************/

static int xautopageinsert;
static int xautopageremove;
static int xfeature;


static os_error * outs(int value,char * string)
{
 strcpy(string,numbertostring(value/(60*100)));
 return(NULL);
}

static os_error * ins(int * value,char * string)
{
 os_error * err;
 err=stringtonumber(string,value);
 *value=(*value)*60*100;
 return(err);
}

static os_error * out(int value,char * string)
{
 strcpy(string,numbertostring(value));
 return(NULL);
}

static os_error * in(int * value,char * string)
{
 os_error * err;
 err=stringtonumber(string,value);
 return(err);
}


static os_error * outsep(int value,char * string)
{
 unsigned short temp[3];

	memcpy(temp,&value,sizeof(int));
 temp[2]=0;

 stringtomacro2(temp,string,DBWRITEMAX);

 return(NULL);
}


static os_error * insep(int * value,char * string)
{
	os_error     * err;
	unsigned short temp[3];
	filestr      * file;

	file=preffile();

          err=macrotostring2(string,temp,NITEM(temp));
	if(!err)	err=txunccheckstring(temp,file);
	if(!err)
	{
		memcpy(value,temp,2*sizeof(unsigned short));
	}

 return(err);
}





static os_error * wrunits(int value,char * string)
{
 strcpy(string,unitname(value));
 return(NULL);
}




static os_error * chgeneralsave(buffer * bf)
{
 os_error * err;


 err=bf_printfeol(bf,(defprefdata.chapterseparator>255)?
                "generalpref(%d,%d,%d,%d,%d,0x%x);":"generalpref(%d,%d,%d,%d,%d,'%c');",
                       defprefdata.autosave,
                       defprefdata.autosaveperiod,
                       defprefdata.autosaveprompt,
                       defprefdata.units,
                       defprefdata.chapterstart,
                       defprefdata.chapterseparator);



 if(!err) err=bf_printfeol(bf,"generalpref2(%d,%d,%d,%d);",
                      !defprefdata.autopageinsert,
                      !defprefdata.autopageremove,0,0);

 if(!err) err=bf_printfeol(bf,"generalpref3(%d,%d,%d,%d);",
                      workcompatability,
                      0,0,0);



 return(err);
}



void generalpref(int fp)
{
 defprefdata.autosave=stack[fp];
 defprefdata.autosaveperiod=stack[fp+1];
 defprefdata.autosaveprompt=stack[fp+2];
 defprefdata.units=stack[fp+3];
 defprefdata.chapterstart=stack[fp+4];
 defprefdata.chapterseparator=stack[fp+5];
}



void generalpref2(int fp)
{
 defprefdata.autopageinsert=!stack[fp];
 defprefdata.autopageremove=!stack[fp+1];
}


void generalpref3(int fp)
{
 workcompatability=stack[fp];

}




static os_error * setprefunits(int units)
{
/* dbreadvalues(newboxp); */
 prefdata.units=units;
 return(prefchangevalue(&prefdata.units));
/* return(dbwritevalues(newboxp)); */
}



/* getnewpageunits(void) */

static os_error * getprefunits(int * units)
{
 *units=prefdata.units;
 return(NULL);
}





static os_error * chgeneralicon(int handle,int userhandle,wimp_mousestr * m)
{
 os_error * err;

 err=NULL;

 if(m->i==7) err=openunitsmenu(setprefunits,getprefunits,handle);

 return(err);

 USE(handle);
 USE(userhandle);
}





static os_error * chgeneralchange(prefdatastr * old,
                                  prefdatastr * xnew,viewstr * view)
{
 if(old->units!=xnew->units) 
 {
  view->data.units=xnew->units;
  prefchanges(PREFVDATA|PREFRULERS);
 }

 if(old->chapterstart!=xnew->chapterstart) prefchanges(PREFCHAP|PREFFLOW);
 if(old->chapterseparator!=xnew->chapterseparator) prefchanges(PREFFLOW);
 if(old->autosave!=xnew->autosave ||
    old->autosaveperiod!=xnew->autosaveperiod) prefchanges(PREFAUTOSAVE);

 return(NULL);
}


static os_error * chgeneralopen(void)
{
 xautopageinsert=!prefdata.autopageinsert;
 xautopageremove=!prefdata.autopageremove;
	xfeature=prefcompatability;
 return(NULL);
}


static os_error * chgeneralclose(int code)
{
	os_error * err;

	err=NULL;

 if(code==DBOK || code==DBAPPLY)
 {
  prefdata.autopageinsert=!xautopageinsert;
  prefdata.autopageremove=!xautopageremove;

	 prefcompatability=xfeature;
 }

 return(err);
}







static os_error * prefgeneraldscript(buffer * bf,prefdatastr * data,
                                  filestr * file)
{
 unsigned short string[8];
 char           temp[256];

 bf_printfeol(bf,"GENERALPREF={generalpref");
 bf_printfeol(bf,"{autosave %d}",data->autosave);
 bf_printfeol(bf,"{autosaveperiod %d}",data->autosaveperiod);
 bf_printfeol(bf,"{autosaveprompt %d}",data->autosaveprompt);
 bf_printfeol(bf,"{units %d}",data->units);
 bf_printfeol(bf,"{chapterstart %d}",data->chapterstart);

	memcpy(string,&data->chapterseparator,sizeof(data->chapterseparator));
 string[2]=0;

 bf_printfeol(bf,"{chapterseparator %s}",dsmkunistr2(string,temp,sizeof(temp)));

 bf_printfeoln(bf,2,"}");

 return(NULL);

 USE(file);
}



#define DSTGENERALPREF       0x1700
#define DSTAUTOSAVE          0x1701
#define DSTAUTOSAVEPERIOD    0x1702
#define DSTAUTOSAVEPROMPT    0x1703
#define DSTUNITS             0x1704
#define DSTCHAPTERSTART      0x1705
#define DSTCHAPTERSEPARATOR  0x1706




static os_error * dsgeneralpref(int fp,int argc,objectloc * loc)
{
 os_error *    err;
 int           sp;
 int           nsp;
 dsobjectstr * ds;
 dsobjectstr * ds1;
 int           type;
 filestr     * file;
 prefdatastr   data;
 int  									len;


 err=NULL;

 dsneeddoc(loc);

 file=loc->file;

 sp=fp+2; /* skip leading type/len */

 prefread(&data,file);


 while(argc--)
 {
  ds=(dsobjectstr*)(dsstack+sp);
  type=ds->type;
  nsp=sp+ds->len/sizeof(int);

  if(ds->len>2*sizeof(int)) ds1=(dsobjectstr*)(dsstack+sp+2);
  else                      ds1=NULL;

  switch(type)
  {

   case       DSTAUTOSAVE:
                          data.autosave=ds1->data.integer;
                          break;

   case DSTAUTOSAVEPERIOD:
                          data.autosaveperiod=ds1->data.integer;
                          break;

   case DSTAUTOSAVEPROMPT:
                          data.autosaveprompt=ds1->data.integer;
                          break;

   case          DSTUNITS:
                          data.units=ds1->data.integer;
                          break;

   case   DSTCHAPTERSTART:
                          data.chapterstart=ds1->data.integer;
                          break;

   case DSTCHAPTERSEPARATOR:
																										if(ds1->type==DSTSTR)
																										{
																											len=strlen(ds1->data.string);
																											len=MIN(len,sizeof(int));
																											memcpy(&data.chapterseparator,ds1->data.string,len);
																										}
																										else
																										if(ds1->type==DSTUNISTR)
																										{
																											len=xstrlen2(ds1->data.unistring);
																											len=MIN(len*sizeof(unsigned short),sizeof(int));
																											memcpy(&data.chapterseparator,ds1->data.unistring,len);
																										}

                          break;

  }

  sp=nsp;
 }

 prefwrite(&data,file);

 ds=(dsobjectstr*)(dsstack+fp);
 ds->data.integer=0;
 ds->len=3*sizeof(int);

 return(err);
}





static dscreator dsdefs[]=
{
 0,0,0,0, "generalpref", dsgeneralpref, 0, DSTGENERALPREF,       dsnulllist,
 0,0,0,0, "autosave",         NULL,     0, DSTAUTOSAVE,          dsnulllist,
 0,0,0,0, "autosaveperiod",   NULL,     0, DSTAUTOSAVEPERIOD,    dsnulllist,
 0,0,0,0, "autosaveprompt",   NULL,     0, DSTAUTOSAVEPROMPT,    dsnulllist,
 0,0,0,0, "units",            NULL,     0, DSTUNITS,             dsnulllist,
 0,0,0,0, "chapterstart",     NULL,     0, DSTCHAPTERSTART,      dsnulllist,
 0,0,0,0, "chapterseparator", NULL,     0, DSTCHAPTERSEPARATOR,  dsnulllist,

};






#define MAXFEATURE 5
#define MINFEATURE 4


static dbiconstr chgeneralicondefs[]=
{
 /* N   &V           Type     Grp   Flags   R   L   D   U     In    Out */

   12, &prefdata.autosave,      DBTOGGLE, 0,  0,    1,  F2, 0, 0,  NULL,    0,
    4, &prefdata.autosaveprompt,DBTOGGLE, 0,  0,    1,  F1, 0, 0,  NULL,    0,

    9, &prefdata.chapterstart,  DBWRITE,  0,    0,  -1, -1, -1, -1,   in,  out,

   52, &prefdata.autosaveperiod,DBWRITE,  0,    0,  -1, -1, -1, -1,   ins,outs,

    6, &prefdata.units,         DBTEXT,   0,   0, -1, -1, -1, -1,NULL,wrunits,

   11, &prefdata.chapterseparator,DBWRITE, 0,  0, 1, F1, 0, 0,  insep, outsep,

   14, &xautopageinsert,        DBTOGGLE, 0,  0,    1,  F3, 0, 0,  NULL,    0,
   15, &xautopageremove,        DBTOGGLE, 0,  0,    1,  F4, 0, 0,  NULL,    0,

   17, &xfeature,  DBTEXT,   0,     0,    -1, -1, -1, -1, NULL, out,
   18, &xfeature,  DBDEC,    0,     0,     1,-1,MAXFEATURE,MINFEATURE,NULL,0,
   19, &xfeature,  DBINC,    0,     0,     1,-1,MAXFEATURE,MINFEATURE,NULL,0,



   -1, NULL,         0,       0,    0,      0,  0,  0,  0,  0,      0
};




static dboxstr chgeneralbox=
{
 0,
 TPREFGENERAL,
 DBPANE,
 0,
 NULL,
 chgeneralicon,
 NULL,
 NULL,
 chgeneralicondefs,
 0,
 0,

 0,NULL,
 0,
 0,
};


static subchoicestr chgeneral=
{
 NULL,

 &chgeneralbox,

 "ch_general",
 "{CHG0}",

 chgeneralsave,
 chgeneralclose,
 NULL,
 chgeneralopen,
 (choicechangefn)chgeneralchange,
 (choicedscriptfn)prefgeneraldscript,
};





os_error * dbprefinit(void)
{
 dsaddblock(dsdefs,sizeof(dsdefs)/sizeof(dscreator));
 dsaddblock(dsdefs2,sizeof(dsdefs2)/sizeof(dscreator));
 prefadd(&chgeneral);
 return(prefadd(&chview));
}


