/*->c.dbpixinfo */



#include "stdafx.h"

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <locale.h>

#include "os.h"
#include "wimp.h"
#include "wimpt.h"
#include "werr.h"
#include "akbd.h"
#include "transform.h"
#include "xprocess.h"
#include "etc.h"

#include "wos.h"
#include "err.h"
#include "xext.h"
#include "poll.h"
#include "key.h"
#include "temp.h"
#include "xmath.h"
#include "dbhi.h"
#include "mhi.h"
#include "fsx.h"
#include "bf.h"
#include "bits.h"



#include "str.h"
#include "reslink.h"
#include "units.h"
#include "posn.h"
#include "object.h"


#include "view.h"
#include "viewr.h"
#include "file.h"
#include "select.h"
#include "dbscale.h"



#include "pxstr.h"
#include "pict.h"
#include "dbpict.h"
#include "pixtool.h"
#include "pxtags.h"

#include "impex.h"


#include "dbpixinfo.h"




/*****************************************************************************/

extern dboxstr pictureinfobox;



static viewstr    * cview;
static filestr    * cfile;
static int          cpictbox;
static int          cpicture;









static dbiconstr pictureinfoicondefs[]=
{
 /* N   &V           Type     Grp   Flags   R   L   D   U     In    Out */


 /* N   &V           Type     Grp   Flags   Act Key     - -   clickfn 0 */

    1, NULL,         DBACTION, 0,   0,      DBOK,RETURN, 0,0,    NULL, 0,
    2, NULL,         DBACTION, 0,   0,      DBCANCEL,ESCAPE, 0,0,NULL, 0,



   -1, NULL,         0,       0,    0,      0,  0,  0,  0,  0,      0

};



static dboxstr pictureinfobox=
{
 0,
 TPICTINFO,
 DBFIX,
 DBGRAB,
 NULL, /* close */
 NULL, /* icon  */
 NULL,
 NULL,
 pictureinfoicondefs,
 0,
 0,
 0,NULL,
 0,
 0,
};








/* script function opens the picture dialogue box */

void openpictureinfobox(int fp)
{
 os_error      * err;
 pictboxstr    * pictp;
 int             info[128];
 int           * p;
 char            string[64];
 char          * q;
 int             xscale;
 int             yscale;


 err=pixselected(&cpictbox,menufile);
 if(cpictbox)
 {
  cview=menuview;
  cfile=menufile;

  pictp=(pictboxstr*)fob_find(cpictbox,cfile);

  cpicture=pictp->picture;
  yscale=pictp->pictdata.scale;
  xscale=ttmul(yscale,pictp->pictdata.aspect);

  err=dodboxspparent(&pictureinfobox,1,&pictureinfobox,&dbviewstack,cview->handle);
  if(!err)
  {
   err=impexpxinfo(cpicture,pictp->ftype,cfile,info);
   if(err)
   {
    dbclose(&pictureinfobox,DBCANCEL);
   }
   else
   {
    p=info;
    while(*p)
    {
     switch(*p)
     {
      case PT_LENGTH:
                     writeiconf(pictureinfobox.handle,3,"%s bytes",
                                                          memstring(p[2]));
                     break;

        case  PT_RES:
                     writeiconf(pictureinfobox.handle,9,
                              "%d x %d (%d x %d) dpi",
                              scale(p[2],0x10000,xscale),
                              scale(p[3],0x10000,yscale),
                              p[2],p[3]);
                     break;

        case  PT_PIX:
                     writeiconf(pictureinfobox.handle,7,"%d x %d",
                                p[2],p[3]);
                     break;

        case PT_INFO:
                     writeicon(pictureinfobox.handle,12,(char*)(p+2));
                     break;

        case  PT_DIM:
                     strcpy(string,
                       unitstostring(scale(scale(p[2],xscale,0x10000),25,16),
                                                           cview->data.units));
                     strcat(string," x ");
                     strcat(string,
                       unitstostring(scale(scale(p[3],yscale,0x10000),25,16),
                                                           cview->data.units));
                     writeiconf(pictureinfobox.handle,5,string);
                     break;


       case PT_CLASS:
                     if((p[2] & PT_CLASSFIELD)==PT_VEC)
                     {
                      strcpy(string,"Vector");
                      writeicon(pictureinfobox.handle,7,"-");
                      writeiconf(pictureinfobox.handle,9,"-");
                     }
                     else
                     {
                      sprintf(string,"%dbpp %s ",p[4]*p[5],
                              (p[3]==PT_CMYK)?"CMYK":"RGB");

                      q=string+strlen(string);

                      if(p[2] & PT_MASK)
                      {
                       strcpy(q,"- mask ");
                       q+=strlen(q);
                      }

                      if(p[2] & PT_INDEX)
                      {
                       sprintf(q,"- %d pal. entries ",(p[2] & PT_PALETTE)>>8);
                      }
                     }

                     writeiconf(pictureinfobox.handle,11,string);
                     break;
     }
     p=(int*)(((char*)p)+p[1]);
    }
   }
  }

  zreport(err);
 }

 USE(fp);
}

