/*->h.pxstr */


#define PIXMINSCALE (0x10000/100)
#define PIXMAXSCALE (0x10000*100)



typedef struct pictprocstr
{
 int process;
} pictprocstr;



typedef struct pictdatastr
{
 colourvalue    colour;    /* background colour  */
 int            i;         /* inset              */
 int            radius;
 int            changei;
 fillstr        fill;
} pictdatastr;



typedef struct unpackedpictdatastr
{
 pictdatastr pictdata;
 int         spread;
 int         lock;
} unpackedpictdatastr;



typedef struct pictchangebits
{

 unsigned int xcolour:1;
 unsigned int xinset:1;
 unsigned int xradius:1;
 unsigned int xchangei:1;
 unsigned int xfill:1;
 unsigned int xspread:1;
 unsigned int xlock:1;

 int xtransform;

} pictchangebits;



#define HBHIDE     0x1
#define HBBOTLEFT  0x2
#define HBVISIBLE  0x4


typedef struct picturedatastr
{
 int            lockmode;
 int            fixaspect;
 int            autoscale;
 int            hbits;
 int            xshift;
 int            yshift;
 int            scale;
 int            aspect;
 int            angle;
 int            skew;
 transformstr   transform;
} picturedatastr;




typedef struct unpackedpicturedatastr
{
 picturedatastr pd;

 int            tile;
 int            tiledx;
 int            tiledy;
 int            sparebits;
 int            spare[3];

} unpackedpicturedatastr;




typedef struct pictboxstr
{
 int            key;
 int            type;
 chainstr       chain;
 flagstr        flags;

 boxstr         box;
 transformstr   transform;

 curvestr       fcurve;    /* frame curve    */
 curvestr       icurve;    /* internal curve */
 curvestr       ocurve;    /* external curve */
 textflowstr    textflow;
 int            master;

 int            frame;     /* frame pointer               */
 int            picture;   /* data to render              */
 int            ftype;     /* file type of data to render */
 pictdatastr    data;
 picturedatastr pictdata;
 pictprocstr    process;
 curvestr       pcurve;    /* picture curve                 */
 int            masked;    /* icurve does not follow pcurve */

 unsigned int   tile:1;
 unsigned int   sparebits:31;

 int            tiledx;
 int            tiledy;

 int            spare[3];

} pictboxstr;




typedef struct picturestr
{
 int            key;
 int            type;

 int            ftype;
 aboxstr        abox;
 int            imagelen;

 unsigned int   zxdpi:16;      /* old versions need this lot zero */
 unsigned int   zydpi:16;      /* zero */

 unsigned int   zbpp:8;        /* zero */
 unsigned int   zmask:1;
 unsigned int   zclass:7;
 unsigned int   xxxx:16;

 int            proxylen;       /* was spare[2] */
 int            tagslen;

 char           data[1];
} picturestr;



typedef struct pxproxyimstr
{
 int            ftype;
 aboxstr        abox;
 int            imagelen;

 int            spare[8];

 char           data[1];
} pxproxyimstr;



typedef struct pxproxystr
{
 int dither;
 int scale;
 int bpp;

 int spare[5];

} pxproxystr;






extern pictdatastr            defltpictdata;
extern unpackedpicturedatastr defltpicturedata;
extern pictprocstr            defltpictprocess;
extern textflowstr            defltpicttextflow;


