/*->h.prstr */



#define PDriver_Info          0x80140
#define PDriver_SetPageSize   0x80144
#define PDriver_GiveRectangle 0x8014B
#define PDriver_DrawPage      0x8014C
#define PDriver_GetRectangle  0x8014D
#define PDriver_SelectJob     0x80145
#define PDriver_EndJob        0x80148
#define PDriver_AbortJob      0x80149
#define PDriver_PageSize      0x80143
#define PDriver_SelectIllustration 0x80153
#define PDriver_DeclareFont   0x80155
#define PDriver_CancelJob     0x8014E



#define Message_PrintSave 0x80142



#define PR00 0x600
#define PR01 0x601
#define PR02 0x602
#define PR03 0x603
#define PR10 0x610
#define PR11 0x611

#define PR13 0x613
#define PR14 0x614




#define PRNORM  0
#define PRPAM   1
#define PRGAL   2
#define PRPPAIR 3
#define PRBOOK  4
#define PRTHUMB 5
#define PRTILE  6



#define PRODD   0
#define PREVEN  1
#define PRALL   2


#define PRRANGESIZE 32
#define PRRANGEMAX  12

#define PRFROMSIZE  32

typedef struct
{
 unsigned int  mode:4;    /* normal, pamphlet, thumb, tile */
 unsigned int  fitx:1;
 unsigned int  fity:1;
 unsigned int  centrex:1;
 unsigned int  centrey:1;
 unsigned int  regm:1;
 unsigned int  sideways:1;
 unsigned int  backwards:1;
 unsigned int  collate:1;
 unsigned int  pause:1;
 unsigned int  nopics:1;
 unsigned int  draft:1;
 unsigned int  merge:1;       /* 16 bits */
 unsigned int  all:1;
 unsigned int  oddevenall:4;
 unsigned int  options:1;
 unsigned int  bleed:1;
 unsigned int  sheet:1;
 unsigned int  sheetoddeven:1;
 unsigned int  reflect:1;     
 unsigned int  mode2:6;      /* 32 bits */


 int  copies;


 int  from;         /* now cast this lot to a 32 char string PRFROMSIZE above */
 int  to;
 char froms[12];
 char tos[12];      /* ...  */


 unsigned int  headings:1;  /* more bits was thumbn */
 unsigned int  xxxx:1;      /* unknown state        */
 unsigned int  range:1;     /* support new format all= all && !range */
 unsigned int  tumble:1;
 unsigned int  printtofile:1;
 unsigned int  sheetoddevenall:3;
	unsigned int  printproxies:1;

 int  tile;
 int  scale;
 int  aspect;
 int  cx;
 int  cy;

 int  record;
 int  sheetn;

 unsigned int  marks:12;    /* more bits  */


 int  spare[13];

 char mergepath[256];

} printstr;



/* object of type OPRINT */

typedef struct
{
 int      key;
 int      type;

 printstr pr;

} oprintstr;


typedef struct
{
 int          id;
 int          angle;
 int          scale;
 int          scalex;
 int          scaley;

 int          page;
 int          section;
 int          xpo;
 int          ypo;

 aboxstr      abox;
 aboxstr      cbox;
 int          marks;

 transformstr tr;
	transformstr trs;

} psetstr;




#define DEFPSET 1
#define MAXPSET 1


typedef struct
{
 int          n;       /* pages */

 transformstr tr;
 aboxstr      abox;    /* bounding box */
 aboxstr      cbox;    /* marks box    */
 aboxstr      mbox;    /* max box      */
 aboxstr      ebox;    /* max box + marks */
 int          marks;

 psetstr      pset[DEFPSET];

} paperstr;



typedef union
{
 paperstr paper;
 char     stuff[sizeof(paperstr)+MAXPSET*sizeof(psetstr)];

} xpaperstr;





typedef struct
{
 int xscale;
 int yscale;
 int xshift;
 int yshift;
} prscalestr;


#define PRPS         0
#define PRNORMAL     1

#define PRCOLOUR     (1<<0)
#define PSDIRECT     (1<<1)
#define PRCANPRESCAN (1<<13)
#define PRPRESCAN    (1<<24)
#define PRFONTCACHE  (1<<29)


typedef struct prjobstr
{
 int        prtype;
 char     * paper;
 int        papern;
 int        paperwidth;
 int        papersize;
 int        pn;
 viewstr  * view;
 int        xxxlowx;
 int        xxxlowy;
 int        newprinthandle;
 int        oldprinthandle;
 printstr * prints;
 int        nopics;
 int        xres;
 int        yres;
 int        hxres;
 int        hyres;
 int        bits;
 int        separations;
 int        doseparations;
 int        separation;
 int        rawmode;
 int        ps;
 aboxstr    maxbox;
 int        copiesbits;

 coordstr   scale;
 viewstr  * launchview;

	aboxstr    papermaxbox;			// real max box on printed page i.e. after all transforms

 int        spare[2];

} prjobstr;




typedef struct prmarginstr
{
 int paperxsize;
 int paperysize;
 int leftarea;
 int rightarea;
 int toparea;
 int botarea;
} prmarginstr;



#define PRJOBP(prjob,n) ((paperstr*)(((char*)prjob.paper)+prjob.papersize*(n)))
#define PRJOBPP(prjob,n) ((paperstr*)(((char*)prjob->paper)+prjob->papersize*(n)))



