/*->c.pstext */



#include "stdafx.h"

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <locale.h>
#include <math.h>

#include "os.h"
#include "wimp.h"
#include "wimpt.h"
#include "bbc.h"
#include "font.h"
#include "flex.h"
#include "transform.h"
#include "xprocess.h"


#include "alloc.h"
#include "xext.h"
#include "wos.h"
#include "err.h"
#include "poll.h"
#include "colour.h"
#include "xmath.h"
#include "etc.h"
#include "bits.h"
#include "dbhi.h"
#include "fsx.h"
#include "bf.h"
#include "osprint.h"
#include "drawmod.h"
#include "deb.h"
#include "imlib.h"
#include "timex.h"



#include "str.h"
#include "constants.h"
#include "object.h"
#include "reslink.h"

#include "geometry.h"
#include "xredraw.h"

#include "view.h"
#include "viewr.h"
#include "file.h"
#include "page.h"
#include "main.h"



#include "xxcolour.h"
#include "xcolour.h"
#include "cconv.h"
#include "colsep.h"
#include "splink.h"

#include "curve.h"


#include "prstr.h"
#include "xprint.h"
#include "prstat.h"
#include "pract.h"
#include "preg.h"

#include "txstr.h"
#include "codes.h"
#include "fx.h"
#include "fox.h"
#include "fcache.h"
#include "txchoices.h"

#include "psinternal.h"

#include "postscript.h"

#include "psppd.h"


static int epsmode=1;


int postscriptlevel=3;

int ps_fonttype=1;


int ps_level(int fp)
{
	return(postscriptlevel);
	USE(fp);
}




static int ps_copies;
static int ps_collate;





static void * pscachehandle;
#define USERCHUNK 256


static void * psstringmaphandle;
#define PSSTRINGMAPCHUNK 64





typedef struct fontplanestr
{
	int            encoding;
	int            unicode[256];


}	fontplanestr;




typedef struct pscachestr
{
	int    userfont;
	char * psname;										// e.g. Helvetica
	void * charmaphandle;
	int    aliasto;									// userfont value for font which this font is aliased to - >= zero means this font is an alias
	int    fontplanen;					 // number of font planes
	fontplanestr * fontplane;							// array of font plane structures

} pscachestr;




/************************************************************************************/


#define CHARMAPCHUNK	64


typedef struct	pscharmapstr
{
	int c1;
	int c2;


}	pscharmapstr;


static int pscmcmp(void * key1,void * key2)
{
 pscharmapstr	* p1;
 pscharmapstr	* p2;

	p1=(pscharmapstr	*)key1;
	p2=(pscharmapstr	*)key2;

	if(p2->c1>p1->c2) return(-1);
	if(p2->c2<p1->c1) return(1);

 return(0);
}




static os_error *	psaddcharmap(pscachestr * ps)
{
	os_error * err;

 err=xmapinit(&ps->charmaphandle,sizeof(pscharmapstr),CHARMAPCHUNK,pscmcmp);

	return(err);
}



static os_error * psremcharmap(pscachestr * ps)
{
	os_error * err;

	sfree((flex_ptr)&ps->fontplane);
	err=xmapfinit(&ps->charmaphandle);

	return(err);
}


// some characters should be mapped e.g. fl -> f + l


os_error * printercachefontchar(int c1,int c2,void * cachehandle)
{
	os_error     * err;
 pscharmapstr * psc;
 pscharmapstr			map;
	pscachestr   * ps;
	void         * charmaphandle;

	err=NULL;

//	cprintf("cachefont %d %d",c1,c2);

	if(cachehandle)
	{
 	ps=(pscachestr*)cachehandle;
 	charmaphandle=ps->charmaphandle;

 	while(1)
 	{
  	map.c1=c1-1;
  	map.c2=c2+1;

   psc=(pscharmapstr*)xmapsearch(&map,charmaphandle);
 		if(!psc) break;

  	c1=MIN(c1,psc->c1);
  	c2=MAX(c2,psc->c2);

 		if(c1==psc->c1 && c2==psc->c2)
   {
   	return(NULL);
 		}

 		xmaprem(psc,charmaphandle);
 	}

 	map.c1=c1;
 	map.c2=c2;
 	err=xmapadd(&map,&charmaphandle);

  if(!err)
  {
   ps->charmaphandle=charmaphandle;
		}

/*
		psc=NULL;
		while(1)
		{
   psc=(pscharmapstr*)xmapnext(psc,charmaphandle);
			if(!psc) break;
			cprintf("charmap %d %d",psc->c1,psc->c2);
		}
*/
	}

	return(err);
}


static int pscharmapunicodepresent(void * charmaphandle)
{
 pscharmapstr	  map;
 pscharmapstr * psc;

	map.c1=0x100;
	map.c2=0xFFFF;

/*
		psc=NULL;
		while(1)
		{
   psc=(pscharmapstr*)xmapnext(psc,charmaphandle);
			if(!psc) break;
			cprintf("%d %d\r\n",psc->c1,psc->c2);
		}
*/

 psc=(pscharmapstr*)xmapsearch(&map,charmaphandle);

//	cprintf("unicode present %d map %x",psc,charmaphandle);

	return(psc!=NULL);
}



static os_error * pscharmapmerge(pscachestr * dest,pscachestr* src)
{
	os_error     * err;
 pscharmapstr * psc;


/*		psc=NULL;
		while(1)
		{
   psc=(pscharmapstr*)xmapnext(psc,src->charmaphandle);
			if(!psc) break;
			cprintf("cmap merge1 %d %d",psc->c1,psc->c2);
		}

*/


	err=NULL;

	psc=NULL;
	while(1)
	{
  psc=(pscharmapstr*)xmapnext(psc,src->charmaphandle);
		if(!psc) break;
//		cprintf("charmapmerge %d %d\r\n",psc->c1,psc->c2);

  err=printercachefontchar(psc->c1,psc->c2,dest);
		if(err) break;
	}


	return(err);
}



// return glyph index from unicode
// return -1	if don't know about the code
// that is for kerning code
// presumably when used for text output we don't call for anything we don't know about




int pscharmapindex(int userfont,int * fontplane,int unicode)
{
	pscachestr   ps;
	pscachestr * psp;
	int          fp;
	int          c;

	
	memset(&ps,0,sizeof(ps));
	ps.userfont=userfont;
	psp=(pscachestr*)xmapsearch(&ps,pscachehandle);

	if(psp)
	{
 	if(psp->aliasto>=0)
 	{
  	ps.userfont=psp->aliasto;
  	psp=(pscachestr*)xmapsearch(&ps,pscachehandle);
 	}

		if(psp)
		{
  	for(fp=0;fp<psp->fontplanen;fp++)
	  {
  		for(c=0;c<256;c++)
	  	{
		  	if((psp->fontplane+fp)->unicode[c]==unicode)
  			{
//						cprintf("charmapindex hit %x",unicode);
	  			*fontplane=fp;
		  		return(c);
			  }
  		}
	  }
		}
	}

	*fontplane=0;
	return(-1);
}





// return unicode for glyph index
// return -1 for glyph not used

int pscharmapunicode(int userfont,int fontplane,int c)
{
	pscachestr   ps;
	pscachestr * psp;


	memset(&ps,0,sizeof(ps));
	ps.userfont=userfont;
	psp=(pscachestr*)xmapsearch(&ps,pscachehandle);
	if(psp)
	{
		if(psp->aliasto>=0)
		{
			ps.userfont=psp->aliasto;
	  psp=(pscachestr*)xmapsearch(&ps,pscachehandle);
		}

		if(psp)
		{
			if(fontplane>=0 && fontplane<psp->fontplanen && c>=0 && c<256)
			{
				return((psp->fontplane+fontplane)->unicode[c]);
			}
		}
	}

	return(-1);
}



os_error * pscharmapinfo(int userfont,int * fontplanes)
{
	pscachestr   ps;
	pscachestr * psp;

	*fontplanes=1;

	memset(&ps,0,sizeof(ps));
	ps.userfont=userfont;
	psp=(pscachestr*)xmapsearch(&ps,pscachehandle);
	if(psp)
	{
		if(psp->aliasto>=0)
		{
			ps.userfont=psp->aliasto;
	  psp=(pscachestr*)xmapsearch(&ps,pscachehandle);
		}

		if(psp)
		{
			*fontplanes=psp->fontplanen;
		}
	}

	return(NULL);
}



os_error * pscharmapfontinfo(int userfont,int fontplane,int * encodingtype)
{
	pscachestr   ps;
	pscachestr * psp;

	*encodingtype=PS_ENCLATIN1;

	memset(&ps,0,sizeof(ps));
	ps.userfont=userfont;
	psp=(pscachestr*)xmapsearch(&ps,pscachehandle);
	if(psp)
	{
		if(psp->aliasto>=0)
		{
			ps.userfont=psp->aliasto;
	  psp=(pscachestr*)xmapsearch(&ps,pscachehandle);
		}

		if(psp)
		{
			if(fontplane>=0 && fontplane<psp->fontplanen)
			{
				*encodingtype=(psp->fontplane+fontplane)->encoding;
			}
		}
	}

	return(NULL);
}


static os_error * pscalculatefontplanes(pscachestr * psp)
{
	os_error     * err;
	int            osfont;
	int            charset;
	int            userfont;
 pscharmapstr * psc;
	int            i;
	int            c;
	int            isunicode;
	int            code;
	int            total;
	int            fp;

	err=NULL;

	userfont=psp->userfont;
	osfont=fontosfromuser(userfont);
	charset=fontcharset(osfont);
 isunicode=pscharmapunicodepresent(psp->charmaphandle);

	if(charset==SYMBOL_CHARSET)
	{
		// going to be one font plane	with symbol encoding

		psp->fontplanen=1;
		salloc((flex_ptr)&psp->fontplane,sizeof(fontplanestr));
		(psp->fontplane)->encoding=PS_ENCSYMBOL;
		for(i=0;i<256;i++)
		{
			(psp->fontplane)->unicode[i]=-1;
		}

		psc=NULL;
		while(1)
		{
   psc=(pscharmapstr*)xmapnext(psc,psp->charmaphandle);
			if(!psc) break;

			for(c=psc->c1;c<=psc->c2;c++)
			{
				if(c>255) break;
    code=code8symbol(c);
    if(txunicode)
    {
     code=code16win(code);
    }
				(psp->fontplane)->unicode[c]=code;
			}
		}
	}
	else
	if(charset==ANSI_CHARSET)
	{
		if(!isunicode || !txunicode)
		{
			// going to be one font plane	with LATIN1 encoding

 		psp->fontplanen=1;
 		salloc((flex_ptr)&psp->fontplane,sizeof(fontplanestr));
 		(psp->fontplane)->encoding=PS_ENCLATIN1;
 		for(i=0;i<256;i++)
 		{
 			(psp->fontplane)->unicode[i]=-1;
 		}

 		psc=NULL;
 		while(1)
 		{
    psc=(pscharmapstr*)xmapnext(psc,psp->charmaphandle);
 			if(!psc) break;

 			for(c=psc->c1;c<=psc->c2;c++)
 			{
 				if(c>255) break;

   		if(c==160) (psp->fontplane)->unicode[32]=32;	// nbspace
  			else
	    if(c==172) (psp->fontplane)->unicode[45]=45; // hyphen

    	if(txunicode) code=code16(c);
    	else										code=code8(c);

 				(psp->fontplane)->unicode[c]=code;
 			}
	 	}
		}
		else		// many font planes, custom encoding
		{
			total=0;
 		psc=NULL;
 		while(1)
 		{
    psc=(pscharmapstr*)xmapnext(psc,psp->charmaphandle);
 			if(!psc) break;
				total+=(psc->c2-psc->c1)+1;
			}

 		psp->fontplanen=(total+255)/256;
 		salloc((flex_ptr)&psp->fontplane,sizeof(fontplanestr)*psp->fontplanen);
	
			for(fp=0;fp<psp->fontplanen;fp++)
			{
  		(psp->fontplane+fp)->encoding=(userfont<<8)+fp;
  		for(i=0;i<256;i++)
				{
	  		(psp->fontplane+fp)->unicode[i]=-1;
		  }
			}

			fp=0;
			i=0;
 		psc=NULL;
 		while(1)
 		{
    psc=(pscharmapstr*)xmapnext(psc,psp->charmaphandle);
 			if(!psc) break;

 			for(c=psc->c1;c<=psc->c2;c++)
 			{
    	code=code16(c);
 				if(c<256) (psp->fontplane+fp)->unicode[c]=code;
					else
					{
						while(1)
						{
							if((psp->fontplane+fp)->unicode[i]==-1)
							{
								(psp->fontplane+fp)->unicode[i]=code;
								break;
							}
							else
							{
								i++;
								if(i>=256)
								{
									i=0;
									fp++;
									if(fp>=psp->fontplanen) break;			// something has gone wrong
								}
							}
						}
					}
 			}
	 	}
		}
	}
	else					// fonts without ANSI charset, just do custom encoding
	{
		total=0;
		psc=NULL;
		while(1)
		{
   psc=(pscharmapstr*)xmapnext(psc,psp->charmaphandle);
			if(!psc) break;
			total+=(psc->c2-psc->c1)+1;
		}

		if(!txunicode)	psp->fontplanen=1;
		else         		psp->fontplanen=(total+255)/256;

		salloc((flex_ptr)&psp->fontplane,sizeof(fontplanestr)*psp->fontplanen);
	
		for(fp=0;fp<psp->fontplanen;fp++)
		{
 		(psp->fontplane+fp)->encoding=(userfont<<8)+fp;
 		for(i=0;i<256;i++)
			{
  		(psp->fontplane+fp)->unicode[i]=-1;
	  }
		}

		fp=0;
		i=0;
		psc=NULL;
		while(1)
		{
   psc=(pscharmapstr*)xmapnext(psc,psp->charmaphandle);
			if(!psc) break;

			for(c=psc->c1;c<=psc->c2;c++)
			{
    if(c<256)
    {
     code=code8symbol(c);
     if(txunicode)
     {
      code=code16wincharset(code,charset);
     }
				}
				else
				{
					if(!txunicode) break;
					code=c;
				}

				if(c<256) (psp->fontplane+fp)->unicode[c]=code;
				else
				{
					while(1)
					{
						if((psp->fontplane+fp)->unicode[i]==-1)
						{
							(psp->fontplane+fp)->unicode[i]=code;
							break;
						}
						else
						{
							i++;
							if(i>=256)
							{
								i=0;
								fp++;
								if(fp>=psp->fontplanen) break;			// something has gone wrong
							}
						}
					}
				}
			}
		}
	}

	return(err);
}



// going from unicode to OP charset
// require that resulting OP charset code *must* map to unicode


static os_error * printercachefontcode(int unicode,int charset,int fxuni,void * cachehandle)
{
	int code;


 if(charset==SYMBOL_CHARSET)
 {
  if(fxuni)
  {
   code=code16symbolinv(unicode);
  }
  else
  {
   code=code8symbolinv(unicode);
  }
 }
 else
 if(charset!=ANSI_CHARSET)
 {
  if(fxuni)
  {
   code=code16winindexcharset(unicode,charset);
  }
  else
  {
   code=code8symbolinv(unicode);
  }

		if(code<0) code=unicode;
  else       code=code8symbolinv(code);
 }
 else
 {
  if(fxuni)
  {
   code=code16inv(unicode);  // sort out unicode to char set
			if(code<0) code=unicode;
		}
  else
  {
   code=code8inv(unicode);
		}
 }

//	cprintf("cacheline code %x unicode %x fxuni %d",code,unicode,fxuni);

 return(printercachefontchar(code,code,cachehandle));
}



/**************************************************************************************/




static int pscmp(void * key1,void * key2)
{
 return((*((int*)key1))-(*((int*)key2)));
}



typedef struct psmapstr
{
	char * psname;										// e.g. Helvetica


} psmapstr;


static int psmapcmp(void * key1,void * key2)
{
 return(cstrcmp((*((char**)key1)),(*((char**)key2))));
}



static os_error * printfontcachefinit(void)
{
	os_error   * err;
	int          n;
	int          i;
 pscachestr *	psp;

	n=xmapcount(pscachehandle);

	for(i=0;i<n;i++)
	{
		psp=(pscachestr*)xmaprecord(pscachehandle,i);
  psremcharmap(psp);
	}


          err=xmapfinit(&pscachehandle);
	if(!err) err=xmapfinit(&psstringmaphandle);

 return(err);
}



static os_error * printfontcacheinit(void)
{
	os_error * err;

          err=xmapinit(&pscachehandle,sizeof(pscachestr),USERCHUNK,pscmp);
	if(!err) err=xmapinit(&psstringmaphandle,sizeof(psmapstr),PSSTRINGMAPCHUNK,psmapcmp);

 return(err);
}








os_error * pscodefontname(char * buffer,char * fontname,int fontplane,int max)
{
	char * s;
	char * d;
	char * lt;
	int    ch;
	int    used;

	s=fontname;
	d=buffer;
	lt=buffer+max;

	*d++='O';
	*d++='P';
	*d++='_';

	while(1)
	{
		ch=*s++;
		if(ch==' ') ch='_';
		*d++=(char)ch;
		if(ch==0) break;
		if(d>=lt) break;
	}

	if(fontplane>0)
	{
		d--;
		xsprintf(lt-d,&used,d,"_%02X",fontplane);
		d+=used;
	}

	*(lt-1)=0;

	return(NULL);
}



static void	psgetfontname(int userfont,int fontplane,char * buffer,int max)
{
	char * p;

 p=fontusername(userfont);

	pscodefontname(buffer,p,fontplane,max);
}




static os_error * printfontneeded(void)
{
 os_error   * err;
 int          i;
 int          n;
	psmapstr   * psmp;

 err=NULL;

	n=xmapcount(psstringmaphandle);

	for(i=0;i<n;i++)
	{
		psmp=(psmapstr*)xmaprecord(psstringmaphandle,i);


  err=oswriteprinterf("%%%%+ font %s\r\n",psmp->psname);
  if(err) break;
	}


 return(err);
}


static os_error * printfontsupplied(void)
{
 os_error   * err;
 int          i;
 int          n;
	pscachestr * psp;
 char         buffer[MAXFONTNAMELEN];
 char       * p;
	int          fp;

 err=NULL;

	n=xmapcount(pscachehandle);

	for(i=0;i<n;i++)
	{
		psp=(pscachestr*)xmaprecord(pscachehandle,i);

//		if(psp->psname)
		{
		 p=fontusername(psp->userfont);

			for(fp=0;fp<psp->fontplanen;fp++)
			{
		 	pscodefontname(buffer,p,fp,sizeof(buffer));

    err=oswriteprinterf("%%%%+ font %s\r\n",buffer);
    if(err) break;
			}
		}
	}

 return(err);
}






typedef struct psfontdatastr
{
 char * family;
 char * regular;
 char * bold;
 char * italic;
 char * bolditalic;

} psfontdatastr;



static psfontdatastr psfontdata[]=
{
 "Arial","Arial","Arial-Bold","Arial-Oblique","Arial-BoldOblique",
 "Arial-Narrow","Arial-Narrow","Arial-Narrow-Oblique","Arial-Narrow-Bold","Arial-Narrow-BoldOblique",
 "AvantGarde","AvantGarde-Book","AvantGarde-Demi","AvantGarde-BookOblique","AvantGarde-DemiOblique",
 "Bookman","Bookman-Light","Bookman-Demi","Bookman-LightItalic","Bookman-DemiItalic",
 "Courier","Courier","Courier-Bold","Courier-Oblique","Courier-BoldOblique",
 "Garamond","Garamond-Light","Garamond-Bold","Garamond-LightItalic","Garamond-BoldItalic",
 "Helvetica","Helvetica","Helvetica-Bold","Helvetica-Oblique","Helvetica-BoldOblique",
 "Helvetica-Condensed","Helvetica-Condensed","Helvetica-Condensed-Bold","Helvetica-Condensed-Oblique","Helvetica-Condensed-BoldObl",
 "Helvetica-Narrow","Helvetica-Narrow","Helvetica-Narrow-Bold","Helvetica-Narrow-Oblique","Helvetica-Narrow-BoldOblique",
 "Korinna","Korinna-Regular","Korinna-Bold","Korinna-KursivRegular","Korinna-KursivBold",
 "LubalinGraph","LubalinGraph-Book","LubalinGraph-Demi","LubalinGraph-BookOblique","LubalinGraph-DemiOblique",
 "NewCenturySchlbk","NewCenturySchlbk-Roman","NewCenturySchlbk-Bold","NewCenturySchlbk-Italic","NewCenturySchlbk-BoldItalic",
 "Palatino","Palatino-Roman","Palatino-Bold", "Palatino-Italic","Palatino-BoldItalic",
 "Souvenir","Souvenir-Light","Souvenir-Demi","Souvenir-LightItalic","Souvenir-DemiItalic",
 "Symbol","Symbol",NULL,NULL,NULL,
 "Times","Times-Roman","Times-Bold","Times-Italic","Times-BoldItalic",
 "Times-New-Roman","Times-New-Roman","Times-New-Roman-Bold","Times-New-Roman-Italic","Times-New-Roman-BoldItalic",
 "ZapfCalligraphic","ZapfCalligraphic-Roman","ZapfCalligraphic-Bold","ZapfCalligraphic-Italic","ZapfCalligraphic-BoldItalic",
 "ZapfChancery",NULL,NULL,"ZapfChancery-MediumItalic",NULL,
 "ZapfDingbats","ZapfDingbats",NULL,NULL,NULL,
};






// Win font sub table work with family names so get family name, map then find extensions for PS name


static int    ps_subttypes;

static char * getpostscriptname(int osfont)
{
 char * windows;
 char * printer;
 char * psname;
 int    i;
 int    style;

 psname=NULL;

 windows=fontosfamilyname(osfont);
 style=fontosstyle(osfont);

 osxprintmapfont(windows,&printer);

 if(printer)
 {
  for(i=0;i<(sizeof(psfontdata)/sizeof(psfontdatastr));i++)
  {
   if(!cstrcmp(psfontdata[i].family,printer))
   {
    psname=(((char**)&psfontdata[i].regular)[style]);
    break;
   }
  }
 } 

 cprintf("getps name %s %s %s",windows,printer,psname);

 return(psname);
}









/*

		Two cases

		(1) It's a printer font in which case we generate a font based on it - psname set
		(2) We have to download the font - psname null
		(3) We've already downloaded a font on which this one is based

*/





os_error * printercachecomplete(void)
{
 os_error   * err;
	int          n;
 int          i;
	int          j;
	char       * p;
	char       * q;
	pscachestr * psp;
	pscachestr * psp2;
 int          osfont;
	psmapstr     psm;
	psmapstr   * psmp;
	int          result;
	char         buffer[MAXFONTNAMELEN];
	char         buffer2[MAXFONTNAMELEN];
	int          upload;
	int          pass;
	int          propmode;
 int          ttsubs;
	int          fp;

 err=NULL;


 // over, so now output table

  osxprintpropttoption(0,&ttsubs,PRPROP_READ,&propmode);
		if(propmode & PRPROP_SET)
		{
			ps_subttypes=(ttsubs==DMTT_SUBDEV);
		}
		else
		{
			ps_subttypes=0;
		}

		cprintf("sub ttypes %d",ps_subttypes);


  osxprintcachefontsubs();

		n=xmapcount(pscachehandle);

		cprintf("printercachecomplete mapcount %d",n);

		for(i=0;i<n;i++)
		{
			psp=(pscachestr*)xmaprecord(pscachehandle,i);

			p=fontusername(psp->userfont);

/*
   old way using font manager PS map
			q=findpostscriptfont(p);
			if(!q)
			{
				osfont=fontosfromuser(psp->userfont);
 			p=fontosname(osfont);
 			q=findpostscriptfont(p);
			}
*/

			// looking up built in PS font name
			// problem 1, the built in fonts are not going to have every glyph in Unicode


			if(!pscharmapunicodepresent(psp->charmaphandle))
			{
 			osfont=fontosfromuser(psp->userfont);
    q=getpostscriptname(osfont);

 			psp->psname=q;

 // psstringmaphandle is another map used just for PS names

 			if(q)
 			{
  			memset(&psm,0,sizeof(psm));
 			 psm.psname=q;

  			psmp=(psmapstr*)xmapsearch(&psm,psstringmaphandle);
  			if(psmp==NULL)
  			{
      err=xmapadd(&psm,&psstringmaphandle);
  			}
				}
			}
			else
			{
				cprintf("font uses unicode %s",p);
			}
		}


		n=xmapcount(psstringmaphandle);

		for(i=0;i<n;i++)
		{
			psmp=(psmapstr*)xmaprecord(psstringmaphandle,i);
   oswriteprinterf("%%%%IncludeResource: font %s\r\n",psmp->psname);
		}


		n=xmapcount(pscachehandle);

		cprintf("cached fonts %d",n);

		// pass 0 merge charmaps of aliased fonts
		// pass 1 output real fonts
		// pass 2 output aliased fonts

		for(pass=0;pass<3;pass++)
		{
 		for(i=0;i<n;i++)
 		{
 			psp=(pscachestr*)xmaprecord(pscachehandle,i);
 			osfont=fontosfromuser(psp->userfont);


 			if(psp->psname)
 			{
 				if(pass==1)
 				{
 		 	 p=fontusername(psp->userfont);

 	 			pscodefontname(buffer,p,0,sizeof(buffer));

//				pssupport_addfont(string & base,string & name)

      xexec("pssupport_addfont0",&result,"SS",psp->psname,buffer);

      pscalculatefontplanes(psp);

      ps_kerndata(osfont,psp->userfont,0);

      xexec("pssupport_addfont1",&result,"SS",psp->psname,buffer);
 				}
 			}
 			else
 			{
   	 p=fontusername(psp->userfont);
 				upload=1;

// see if this is a mapped font and the base font is going to be downloaded
// if so alias to it
// two passes to get font definitions out before alias's

     if(fontuserpseudo(psp->userfont))
  			{
  				for(j=0;j<n;j++)
  				{
	 		   psp2=(pscachestr*)xmaprecord(pscachehandle,j);
  					if(!fontuserpseudo(psp2->userfont))
	 					{
	 						if(osfont==fontosfromuser(psp2->userfont))
	 						{
									if(pass==0)
									{
										pscharmapmerge(psp2,psp);
										psp->aliasto=psp2->userfont;
									}
									else
	 							if(pass==2)
	 							{
										for(fp=0;fp<psp2->fontplanen;fp++)
										{
       	 	 pscodefontname(buffer,p,fp,sizeof(buffer));
       	 	 pscodefontname(buffer2,fontusername(psp2->userfont),fp,sizeof(buffer2));
           xexec("pssupport_aliasfont",&result,"SS",buffer2,buffer);
										}
	 							}
	 							upload=0;
	 						}
		 				}
	  			}
	  		}

		 		if(pass==1)
		 		{
						if(psp->aliasto<0) pscalculatefontplanes(psp);

		  		if(upload)
      {
       err=ps_uploadfont(p,psp->userfont);
		  		}
		 		}
		 	}
		 }
		}

// cprintf("osfont %s %s",fontosname(ffont),findpostscriptfont(fontosname(ffont)));

// 1 %%Include built in fonts
// 2 download os fonts


 return(err);
}



// expect names like Homerton.Medium


os_error * printercachefont(char * name,int userfont,void ** cachehandle)
{
	os_error   * err;
	pscachestr   ps;
	pscachestr * psp;

	err=NULL;

 if(name) userfont=findxuserfont(name);
 if(userfont>=0)
	{
		memset(&ps,0,sizeof(ps));
		ps.userfont=userfont;
		ps.aliasto=-1;

		psp=(pscachestr*)xmapsearch(&ps,pscachehandle);
		if(psp==NULL)
		{
   err=xmapadd2(&ps,&pscachehandle,(void**)&psp);
			if(!err)
			{
				psaddcharmap(psp);
			}
		}

		if(!err)
		{
		 if(cachehandle) *cachehandle=(void*)psp;
		}
	}

	return(err);
}


/*************************************************************************************/


#define FXZSCALEX(a) ((a))
#define FXZSCALEY(a) ((a))

/*

  (1) find font - download, or internal, char set mapping

  (2) output text


*/


#define MAXPS 128



static os_error * ps_setfont(int font,int fontplane,int xpts,int ypts,transformstr * tr)
{
 os_error * err;
 char       buffer[MAXFONTNAMELEN];

 err=NULL;

 if(ps_stackp->font!=font || ps_stackp->fontplane!=fontplane ||
    ps_stackp->fxpts!=xpts || ps_stackp->fypts!=ypts || tr_cmp(&ps_stackp->ftr,tr))
 {
 	psgetfontname(font,fontplane,buffer,sizeof(buffer));

//  err=oswriteprinterf("/%s findfont [%d %d %d %d 0 0 ] makefont setfont\r\n",buffer,tr_cos(-fxangle,xpts),tr_sin(-fxangle,xpts),-tr_sin(-fxangle,ypts),tr_cos(-fxangle,ypts));
//  err=oswriteprinterf("%d %d %d %d /%s opms\r\n",tr_cos(-fxangle,xpts),tr_sin(-fxangle,xpts),-tr_sin(-fxangle,ypts),tr_cos(-fxangle,ypts),buffer);
  err=oswriteprinterf("/%s [%d %d %d %d 0. 0.] opms\r\n",buffer,ttmul(tr->a,xpts),ttmul(tr->b,xpts),ttmul(tr->c,ypts),ttmul(tr->d,ypts));
  if(!err)
  {
   ps_stackp->font=font;
   ps_stackp->fontplane=fontplane;
   ps_stackp->fxpts=xpts;
   ps_stackp->fypts=ypts;
   ps_stackp->ftr=*tr;
  }
 }

 return(err);
}






os_error * ps_paint(char * s,int x,int y,int fxuni,int ffont,int ffxpt,int ffypt,colourvalue ffcol,transformstr * fxtr,int fxlineakern,int fxlinedx,int fxlineddx,viewredrawstr * v)
{
 os_error   * err;
 char       * p;
 char       * q;
 int          ch;
	int          c;
 int          fcol;
 int          font;
 int          fontos;
 int          xpts;
 int          ypts;
 font_string  fs;
 char         string[MAXPS];
 int          fxs[MAXPS];
 char       * b;
 char       * lt;
 int          lastch;
 int          dx;
 int          dy;
 int          ddx;
 int          ddy;
 int          transparent;
 transformstr tr;
 int          fdx;
 int          fdy;
 int          charset;
	int          fp;
	int          cfp;
	int          shift;



 err=NULL;


// fxvalidfont(ffont,ffxpt,ffypt,(-fxangle*10)/0x10000,&fh,NULL);


// err=font_setcolour(fh,PALTRANSPARENT,ffcol,0);   // was fbcol

// cprintf("ffx %d ffy %d fxa %x",ffxpt,ffypt,fxangle);


 ps_setcolour(&ffcol,&transparent,v->view);


 xpts=ffxpt;
 ypts=ffypt;
 font=ffont;
 if(fxtr) tr=*fxtr;
 else     tr_setidentity(&tr);

 fontos=fontosfromuser(font);
 charset=fontcharset(fontos);

	cfp=-1;

 p=q=s;
 b=string;
 lt=string+MAXPS-2;
 ch=-1;

 dy=0;
 dx=fxlinedx;
 ddy=0;
 ddx=fxlineddx;
 tr_delta(&tr,&dx,&dy);
 tr_delta(&tr,&ddx,&ddy);


 while(1)
 {
		lastch=ch;
  if(fxuni) ch=(*p)+((*(p+1))<<8);
  else      ch=*p;

		if(ch>=32)	c=pscharmapindex(font,&fp,ch);

  if(ch<32 || b>=lt || (ch>=32 && cfp!=fp))
  {
   if(p>q)
   {
				err=ps_setfont(font,cfp,xpts,ypts,&tr);
				if(err) break;

    fs.term=p-q;
    fs.s=q;
    fs.x=0;

    if(fxuni)
    {
     fontplacement(fontos,xpts,ypts,&fs,fxs,(fxlineakern?FP_KERNING:0)|FPWCS,fxlinedx,fxlineddx);
    }
    else
    {
     fontplacement(fontos,xpts,ypts,&fs,fxs,fxlineakern?FP_KERNING:0,fxlinedx,fxlineddx);
    }

    *b=0;

    if(fxlineakern)
    {
     oswriteprinterf("(%s) %d %d %d %d %d %d optk\r\n",string,dx,dy,ddx,ddy,x,y);
    }
    else
    if(fxlinedx!=0 && fxlineddx==0)    // normal justification
    {
     oswriteprinterf("%d %d 32 (%s) %d %d optj\r\n",dx,dy,string,x,y);
    }
    else
    if(fxlinedx==0 && fxlineddx==0)    // normal text
    {
     oswriteprinterf("(%s) %d %d optx\r\n",string,x,y);
					cprintf("string %s",string);
    }
    else
    {
     oswriteprinterf("%d %d 32 %d %d (%s) %d %d opte\r\n",dx,dy,ddx,ddy,string,x,y);
    }


    b=string;

//				cprintf("fs.x %d",fs.x);

				if(fxlineakern && ch>=32 && lastch>=32)		// match kerning between strips
				{
					shift=fontkernshift(fontos,lastch,ch);
					shift=scale(shift,xpts,fontdesignsize(fontos));
					fs.x+=shift;

					cprintf("kern match shift %d c1 %x c2 %x",shift,lastch,ch);
				}

    fs.x=FXZSCALEX(fs.x);

    fdx=fs.x;
    fdy=0;
    tr_delta(&tr,&fdx,&fdy);
    y+=fdy;
    x+=fdx;

//				cprintf("fs.x %d fdx %d fdy %d",fs.x,fdx,fdy);

//    if(fxangle)
//    {
//     y-=tr_sin(fxangle,fs.x);
//     x+=tr_cos(fxangle,fs.x);
//    }
//    else
//    {
//     x+=fs.x;
//    }

   }

   if(ch==0) break;
			else
			if(ch>=32)
			{
				cfp=fp;
			}
			else
//   if(ch<32)
   {
    while((ch=(*p)+((*(p+1))<<8))<32 && ch!=0)
    {
     if(ch==FXHM)      // transform already done on these moves
     {
      x+=FXZSCALEX((*(p+2))+((*(p+3))<<8)+((*(p+4))<<16)+((*(p+5))<<24));
      p+=FXHMLEN;
     }
     else
     if(ch==FXVM)
     {
      y+=FXZSCALEY((*(p+2))+((*(p+3))<<8)+((*(p+4))<<16)+((*(p+5))<<24));
      p+=FXVMLEN;
     }
     else
     if(ch==FXFONTCODE)
     {
      font=(*(p+2))+((*(p+3))<<8)+((*(p+4))<<16)+((*(p+5))<<24);
      xpts=(*(p+6))+((*(p+7))<<8)+((*(p+8))<<16)+((*(p+9))<<24);
      ypts=(*(p+10))+((*(p+11))<<8)+((*(p+12))<<16)+((*(p+13))<<24);
						fontos=fontosfromuser(font);
      charset=fontcharset(fontos);
      p+=FXFCLEN;
     }
     else
     if(ch==FXCOLCODE2)
     {
//      bcol=(*(p+2))+((*(p+3))<<8)+((*(p+4))<<16)+((*(p+5))<<24);
      fcol=(*(p+6))+((*(p+7))<<8)+((*(p+8))<<16)+((*(p+9))<<24);

      ps_setcolour((colourvalue*)&fcol,&transparent,v->view);

      p+=FXCC2LEN;
     }
     else
     if(ch==FXTRANSFORM)
     {
      memcpy(&tr.a,p+2,4*sizeof(int));
      p+=FXTRANSLEN;
     }
     else
     {
      // dud code

      p++;
      if(fxuni) p++;
     }
    }
				ch=-1;			// so code below does not look at this code
   }

   q=p;
  }

		if(ch>=32)
  {
			if(c<0)		// should never happen...
			{

			}
			else
			if(c<32 || c==127)
			{
    *b++='\\';
				*b++=(char)('0'+(c/64));
				*b++=(char)('0'+((c/8) % 8));
				*b++=(char)('0'+(c % 8));
			}
			else
   if(c=='(')
   {
    *b++='\\';
    *b++='(';
   }
   else
   if(c==')')
   {
    *b++='\\';
    *b++=')';
   }
   else
   if(c=='\\')
   {
    *b++='\\';
    *b++='\\';
   }
   else
   {
				*b++=(char)c;
			}

   p++;
   if(fxuni) p++;
  }
 }


 return(err);

 USE(v);
}




os_error * ps_string(char * font,int xsize,int ysize,int fcol,char * string,int options,int x,int y,viewredrawstr *v)
{
	os_error  * err;
 int         userfont;
	colourvalue fcolv;


	err=NULL;

	cvfrompal(&fcolv,fcol);

	if(options & font_OSCOORDS)
	{
 	x*=400;
 	y*=400;
	}

 userfont=findxuserfont(font);
	if(userfont>=0)
	{
  err=ps_paint(string,x,y,0,userfont,xsize,ysize,fcolv,NULL,0,0,0,v);
	}

	return(err);
}












os_error * ps_cacheline(char * s,int fxuni,int font)
{
 os_error   * err;
 char       * p;
 int          ch;
 int          fontos;
 int          charset;
	void       * cachehandle;


 err=NULL;


 printercachefont(NULL,font,&cachehandle);
 fontos=fontosfromuser(font);
 charset=fontcharset(fontos);

 p=s;

 while(1)
 {
  if(fxuni) ch=(*p)+((*(p+1))<<8);
  else      ch=*p;

  if(ch<32)
  {
   if(ch==0) break;
   if(ch<32)
   {
    while((ch=(*p)+((*(p+1))<<8))<32 && ch!=0)
    {
     if(ch==FXHM)      // transform already done on these moves
     {
      p+=FXHMLEN;
     }
     else
     if(ch==FXVM)
     {
      p+=FXVMLEN;
     }
     else
     if(ch==FXFONTCODE)
     {
      font=(*(p+2))+((*(p+3))<<8)+((*(p+4))<<16)+((*(p+5))<<24);
      printercachefont(NULL,font,&cachehandle);
      fontos=fontosfromuser(font);
      charset=fontcharset(fontos);
      p+=FXFCLEN;
     }
     else
     if(ch==FXCOLCODE2)
     {
      p+=FXCC2LEN;
     }
     else
     if(ch==FXTRANSFORM)
     {
      p+=FXTRANSLEN;
     }
     else
     {
      // dud code

      p++;
      if(fxuni) p++;
     }
    }
   }
  }
  else
  {
   printercachefontcode(ch,charset,fxuni,cachehandle);
   p++;
   if(fxuni) p++;
  }
 }

 return(err);
}














static os_error * ps_needed(void)
{

 printfontneeded();

 return(NULL);
}


  

static os_error * ps_supplied(void)
{

 printfontsupplied();

 return(NULL);
}




static os_error * ps_printmatrix(transformstr * tr)
{
 char sa[16];
 char sb[16];
 char sc[16];
 char sd[16];
 char se[16];
 char sf[16];

 xftoa((double)tr->a/(double)0x10000,sa,sizeof(sa),6);
 xftoa((double)tr->b/(double)0x10000,sb,sizeof(sb),6);
 xftoa((double)tr->c/(double)0x10000,sc,sizeof(sc),6);
 xftoa((double)tr->d/(double)0x10000,sd,sizeof(sd),6);
 xftoa((double)tr->e,se,sizeof(se),6);
 xftoa((double)tr->f,sf,sizeof(sf),6);

	return(oswriteprinterf("[%s %s %s %s %s %s] concat\r\n",sa,sb,sc,sd,se,sf)); 
}




static int pageindex;


static int ps_pageindex(void)
{
 return(pageindex);
}



os_error * ps_startpage(prjobstr * prjob,viewstr * view,int pn,wimp_redrawstr * r,transformstr * trp)
{
	transformstr * tr;
	int            height;

 if(epsmode && pageindex>0) oswriteprinter("showpage\r\n");

 pageindex++;

 ps_stackinit();

   
 oswriteprinterf("%%%%Page: %d %d\r\n",pn+1,ps_pageindex());

 event(EVENT_PSPAGE0,view,(int)prjob);

 oswriteprinter("%%BeginPageSetup\r\n");
 oswriteprinter("/pgsave save def\r\n");

	tr=&(PRJOBPP(prjob,pn))->tr;

 oswriteprinter("[0.001 0 0 0.001 0 0] concat\r\n");

//	oswriteprinterf("[%f %f %f %f %d %d] concat\r\n",(double)tr->a/(double)0x10000,(double)tr->b/(double)0x10000,(double)tr->c/(double)0x10000,(double)tr->d/(double)0x10000,tr->e,tr->f); 
 ps_printmatrix(tr);

	cprintf("[%f %f %f %f %d %d] concat\r\n",(double)tr->a/(double)0x10000,(double)tr->b/(double)0x10000,(double)tr->c/(double)0x10000,(double)tr->d/(double)0x10000,tr->e,tr->f);

 event(EVENT_PSPAGESETUP0,view,(int)prjob);

 event(EVENT_PSPAGESETUP1,view,(int)prjob);

 oswriteprinter("%%EndPageSetup\r\n");

 event(EVENT_PSPAGE1,view,(int)prjob);


// change from bottom left quadrant to top left
	height=r->box.y1-r->box.y0;
	r->g.y1+=height;
	r->g.y0+=height;
	r->box.y1+=height;
	r->box.y0+=height;


	cprintf("r x0 %d x1 %d y0 %d y1 %d",r->g.x0,r->g.x1,r->g.y0,r->g.y1);

	r->g.x0*=400;
	r->g.x1*=400;
	r->g.y0*=400;
	r->g.y1*=400;


 getmaxinvabox((aboxstr*)&r->g,(aboxstr*)&r->g,tr);

	r->g.x0/=400;
	r->g.x1/=400;
	r->g.y0/=400;
	r->g.y1/=400;

	cprintf("r x0 %d x1 %d y0 %d y1 %d",r->g.x0,r->g.x1,r->g.y0,r->g.y1);

	tr_setidentity(trp);

 return(NULL);
}




os_error * ps_endpage(prjobstr * prjob,viewstr * view,int pn)
{

 event(EVENT_PSPAGETRAILER0,view,(int)prjob);
   
 oswriteprinter("%%PageTrailer\r\n");
   
 event(EVENT_PSPAGETRAILER1,view,(int)prjob);   

 oswriteprinter("pgsave restore\r\n");

 if(!epsmode) oswriteprinter("showpage\r\n");

 return(NULL);

 USE(pn);
}



os_error * ps_startpagebox(transformstr * tr)
{
	os_error * err;

 ps_push();

 err=oswriteprinter("gsave\r\n");
//	if(!err) err=oswriteprinterf("[%f %f %f %f %d %d] concat\r\n",(double)tr->a/(double)0x10000,(double)tr->b/(double)0x10000,(double)tr->c/(double)0x10000,(double)tr->d/(double)0x10000,tr->e,tr->f); 

 if(!err) err=ps_printmatrix(tr);

 cprintf("[%f %f %f %f %d %d] box concat\r\n",(double)tr->a/(double)0x10000,(double)tr->b/(double)0x10000,(double)tr->c/(double)0x10000,(double)tr->d/(double)0x10000,tr->e,tr->f);

	return(err);
}



os_error * ps_endpagebox(void)
{

 ps_pop();

 return(oswriteprinter("grestore\r\n"));
}






static os_error * pagecache(prjobstr * prjob,viewstr * view)
{
 int         i;
 int         page;
 int         message;
 paperstr  * p;
 int         n;


 for(prjob->pn=0;prjob->pn<prjob->papern;prjob->pn++)
 {
  p=PRJOBPP(prjob,prjob->pn);
  n=p->n;


  for(i=0;i<n;i++)
  {
   if((page=PRJOBPP(prjob,prjob->pn)->pset[i].page)!=0)
   {
//				cprintf("page cache");
    message=OM_PRCACHE;
    objectmessage2(page,view->file,&message,prjob);
   }
  }
 }

 return(NULL);
}





#define PSOSUNIT(osunits) ((2*(osunits))/5)
#define PSUNIT(ourunits) (((ourunits))/1000)

os_error * ps_startdoc(prjobstr * prjob,viewstr * view)
{
 char string[256];

#ifdef NEVER
{
	FILE * fp;

	fp=fopen("C:\\Temp\\Dist.ps","r");
	if(fp)
	{
		while(1)
		{
			if(fgets(string,sizeof(string),fp)==NULL) break;
			if(string[strlen(string)-1]=='\n') string[strlen(string)-1]=0;
			oswriteprinterf("%s\r\n",string);
		}

		fclose(fp);
	}
	return(NULL);
}

#endif


 pageindex=0;

 ps_stackinit();
 printfontcacheinit();


	if(!epsmode)
	{
  oswriteprinter("%!PS-Adobe-3.0\r\n");
  oswriteprinterf("%%%%Title: %s\r\n",(prjob->view)->name);
  oswriteprinterf("%%%%Creator: OvationPro %d.%02d\r\n",version/100,version % 100);
  writesystimedate(string);
  oswriteprinterf("%%%%CreationDate: %s\r\n",string);
  oswriteprinter("%%Pages: (atend)\r\n");
  oswriteprinterf("%%%%Requirements: numcopies(%d)\r\n",ps_copies);
  oswriteprinterf("%%%%BoundingBox: %d %d %d %d\r\n",PSUNIT(prjob->papermaxbox.x0),PSUNIT(prjob->papermaxbox.y0),PSUNIT(prjob->papermaxbox.x1),PSUNIT(prjob->papermaxbox.y1));
  oswriteprinterf("%%%%LanguageLevel: %d\r\n",postscriptlevel);
  oswriteprinter("%%DocumentNeededResources: (atend)\r\n");
  oswriteprinter("%%DocumentSuppliedResources: (atend)\r\n");

  event(EVENT_PSHEADER0,view,(int)prjob);
  event(EVENT_PSHEADER1,view,(int)prjob);
  
  oswriteprinter("%%EndComments\r\n");
	}


 oswriteprinter("%%BeginProlog\r\n");

 event(EVENT_PSPROLOG0,view,(int)prjob);

 event(EVENT_PSPROLOG1,view,(int)prjob);

 oswriteprinter("%%EndProlog\r\n");


 oswriteprinter("%%BeginSetup\r\n");
 oswriteprinterf("/#copies %d def\r\n",ps_copies);

 if(epsmode) oswriteprinterf("initgraphics\r\n");

 event(EVENT_PSSETUP0,view,(int)prjob);

 if(prjob->bits & PRFONTCACHE)
 {
  event(EVENT_PRCACHE0,view,(int)prjob);
  pagecache(prjob,view);
  event(EVENT_PRCACHE1,view,(int)prjob);
  printercachecomplete();
 }

 event(EVENT_PSSETUP1,view,(int)prjob);

 oswriteprinter("%%EndSetup\r\n");



 return(NULL);
}




os_error * ps_enddoc(prjobstr * prjob,viewstr * view)
{
 
 oswriteprinter("%%Trailer\r\n");
 oswriteprinterf("%%%%Pages: %d\r\n",ps_pageindex());

 event(EVENT_PSTRAILER0,view,(int)prjob);

 oswriteprinter("%%DocumentNeededResources: \r\n");

 ps_needed();

 event(EVENT_PSNEEDED,view,(int)prjob);

 oswriteprinter("%%DocumentSuppliedResources: \r\n");

 ps_supplied();

 event(EVENT_PSSUPPLIED,view,(int)prjob);

 event(EVENT_PSTRAILER1,view,(int)prjob);

 if(!epsmode) oswriteprinter("%%EOF\r\n\004");


 printfontcachefinit();

 return(NULL);
}



os_error * ps_init(prjobstr * prjob)
{
 os_error * err;
 char       ppdname[MAX_PATH];


 if(prjob->prtype==PRPS && (printbits & PRB_PSDIRECT))
 {
  postscriptlevel=defpschoice.level;
  if(postscriptlevel==0)
  {
   osprinterpslevel(&postscriptlevel);
   if(postscriptlevel==0)
   {
    err=osxprinterdata(ppdname,sizeof(ppdname));
    if(!err) err=ppdcache(ppdname);
    ppdpslevel(&postscriptlevel);
    if(postscriptlevel==0) postscriptlevel=1;
   }
  }

  cprintf("ps level %d",postscriptlevel);

  epsmode=!defpschoice.generic;

  
  ps_fonttype=defpschoice.fonttype;

  prjob->bits|=(PSDIRECT|PRFONTCACHE);
  prjob->rawmode=epsmode?PRXRAW2:PRXRAW;
 }

 return(NULL);
}



os_error * ps_printpropcopies(int newcopies,int * oldcopies,int inmode,int * outmode)
{

 if(outmode) *outmode=0;

 if(1)
 {
  if(inmode & PRPROP_READ) *oldcopies=ps_copies;
  if(inmode & PRPROP_WRITE)
  {
   ps_copies=newcopies;
  }
  if(outmode) *outmode=PRPROP_SET;
 }

 return(NULL);
}




os_error * ps_printpropcollate(int newcollate,int * oldcollate,int inmode,int * outmode)
{

 if(outmode) *outmode=0;

 if(0)
 {
  if(inmode & PRPROP_READ) *oldcollate=ps_collate;
  if(inmode & PRPROP_WRITE)
  {
   ps_collate=newcollate;
  }
  if(outmode) *outmode=PRPROP_SET;
 }

 return(NULL);
}







/*************************************************************************************/


#ifdef NEVER

// return glyph index from unicode
// return -1	if don't know about the code
// that is for kerning code
// presumably when used for text output we don't call for anything we don't know about

int zzpscharmapindex(int userfont,int * fontplane,int unicode)
{
	int osfont;
	int charset;
	int psindex;
	int code;
	pscachestr   ps;
	pscachestr * psp;
 pscharmapstr	  map;
 pscharmapstr * psc;


	osfont=fontosfromuser(userfont);
	charset=fontcharset(osfont);


	*fontplane=0;

    // there is potentially some loss of data by inverting char set
    // however because we need the glyphs for calculating spacing
    // it would do no good to avoid this


	// map unicode into OP charset code

 if(charset==SYMBOL_CHARSET)
 {
  if(txunicode)
  {
   code=code16symbolinv(unicode);
  }
  else
  {
   code=code8symbolinv(unicode);
  }
 }
 else
 if(charset!=ANSI_CHARSET)
 {
  if(txunicode)
  {
   code=code16winindexcharset(unicode,charset);
  }
  else
  {
   code=code8symbolinv(unicode);
  }

		if(code<0) code=unicode;
  else       code=code8symbolinv(code);
 }
 else
 {
  if(txunicode)
  {
   code=code16inv(unicode);  // sort out unicode to char set
			if(code<0) code=unicode;
		}
  else
  {
   code=code8inv(unicode);
		}

 }

	memset(&ps,0,sizeof(ps));
	ps.userfont=userfont;

	psp=(pscachestr*)xmapsearch(&ps,pscachehandle);

	map.c1=map.c2=code;
 psc=(pscharmapstr*)xmapsearch(&map,psp->charmaphandle);
	if(!psc) return(-1);

// have to sort out counting of nbspace and nbhyphen


// know that psindex is OP char set

	psindex=code;

	return(psindex);
}




// return unicode for glyph index
// return -1 for glyph not used

int zzpscharmapunicode(int userfont,int fontplane,int c)
{
	int          osfont;
	int          charset;
	int          ossymbolfont;
	int          symbolfontencoding;
	int          code;
	pscachestr   ps;
	pscachestr * psp;
 pscharmapstr	  map;
 pscharmapstr * psc;


	osfont=fontosfromuser(userfont);
	charset=fontcharset(osfont);

 ossymbolfont=(charset==SYMBOL_CHARSET);
	symbolfontencoding=(charset!=ANSI_CHARSET);

	memset(&ps,0,sizeof(ps));
	ps.userfont=userfont;

	psp=(pscachestr*)xmapsearch(&ps,pscachehandle);

	map.c1=map.c2=c;
 psc=(pscharmapstr*)xmapsearch(&map,psp->charmaphandle);
	if(!psc)
 {
		if(charset==ANSI_CHARSET)	// amounts to have we used standard Latin1 encoding?
		{
 		if(c==32) map.c1=map.c2=160;	// nbspace
			else
		 if(c==45) map.c1=map.c2=172; // hyphen
			else
			{
				return(-1);
			}

			// for Latin1, nbspace is mapped in the encoding to space, and nbhyphen to hyphen
			// so if nbspace or nbhyphen is used ensure that space or hyphen is used
			// we know that the encoding has null's for nbspace,nbhyphen so this code will not
			// get called for those values.

		 psc=(pscharmapstr*)xmapsearch(&map,psp->charmaphandle);
			if(!psc) return(-1);
		}
		else
		{
   return(-1);
		}
	}

// know that c is OP char set


 if(ossymbolfont)
 {
  code=code8symbol(c);
  if(txunicode)
  {
   code=code16win(code);
  }
 }
 else
 if(symbolfontencoding)
 {
  code=code8symbol(c);
  if(txunicode)
  {
   code=code16wincharset(code,charset);
  }
 }
 else
 {
 	if(txunicode) code=code16(c);
 	else										code=code8(c);
 }

	return(code);
}

#endif



