/*->c.dbfind */



#include "stdafx.h"

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <locale.h>
#include <ctype.h>

#include "os.h"
#include "wimp.h"
#include "wimpt.h"
#include "werr.h"
#include "akbd.h"
#include "bbc.h"
#include "transform.h"


#include "wos.h"
#include "err.h"
#include "xext.h"
#include "poll.h"
#include "key.h"
#include "temp.h"
#include "etc.h"
#include "hourglass.h"
#include "trans.h"
#include "bits.h"

#include "dbhi.h"
#include "deb.h"


#include "str.h"
#include "constants.h"

#include "units.h"
#include "reslink.h"
#include "mhi.h"
#include "view.h"
#include "file.h"
#include "dbscale.h"
#include "undo.h"
#include "utils.h"
#include "macros.h"


#include "txstr.h"
#include "codes.h"
#include "vec.h"
#include "tx.h"

#include "act.h"
#include "wcx.h"

#include "find.h"

#include "dbfind.h"


extern  dboxstr      findboxdata;





static findstr      cfind;
static viewstr    * cview;


#define SSTR1 12

#define RSTR1 4

#define SMENU1 15

#define RMENU1 5


#define FIND1  1

#define FCAN1  2

#define FCOUNT1 14

#define FFMENU  30
#define FRMENU  31

#define FINFO1  11


#define FDOT    16
#define FDEC    17
#define FALPHA  18
#define FSTAR   19
#define FAMP    20
#define FSLASH  21
#define FLINE   22
#define FPARA   23
#define FFRAME  24
#define FTAB    25



#define FMCOUNT  1
#define FMCLEAR  0
#define FMNOFIND 2 
#define FMFOUND  3
#define FMEOF    4

/*****************************************************************************/


#define MAXHISTORY 12

static int          hstackptr;
static int          hused;

static TCHAR        hfindstring[MAXHISTORY][FMAXLEN];
static TCHAR        hreplacestring[MAXHISTORY][FMAXLEN];


static int          hfstackptr;
static int          hrstackptr;


static os_error *	findstackstrings(TCHAR * s,TCHAR * r)
{
	if(s[0])
	{
		if(hused==0 || strcmp(s,hfindstring[hstackptr]) || strcmp(r,hreplacestring[hstackptr]))
		{
			if(hused)
			{
		 	hstackptr++;
		 	if(hstackptr>=MAXHISTORY) hstackptr=0;
		 }

			xzstrncpye(hfindstring[hstackptr],s,NITEM(hfindstring[hstackptr]));
			xzstrncpye(hreplacestring[hstackptr],r,NITEM(hfindstring[hstackptr]));

			hused++;
			if(hused>MAXHISTORY) hused=MAXHISTORY;
		}

		hfstackptr=hrstackptr=hstackptr;
	}

	return(NULL);
}



#define FINDSETTIME 5


static void findsetfindevent(int n)
{
	wchar_t wstring[FMAXLEN];


	if(n>=0 && n<MAXHISTORY)
	{
		n=(hstackptr-n);
  if(n<0) n+=MAXHISTORY;

//  writeicon(findboxdata.handle,SSTR1,hfindstring[n]);
  macrotostring2(hfindstring[n],wstring,NITEM(wstring));
  writeiconunicode(findboxdata.handle,SSTR1,wstring);

		hfstackptr=n;
	}
}


void findsetfind(int fp)
{
	int n;

	n=stack[fp];
 addscheduledevent((zerofn)findsetfindevent,n,FINDSETTIME);
}



void findsetreplaceevent(int n)
{
	wchar_t wstring[FMAXLEN];


	if(n>=0 && n<MAXHISTORY)
	{
		n=(hstackptr-n);
  if(n<0) n+=MAXHISTORY;

//  writeicon(findboxdata.handle,RSTR1,hreplacestring[n]);
  macrotostring2(hreplacestring[n],wstring,NITEM(wstring));

//		cprintf("set replace %d",wstring[0]);

  writeiconunicode(findboxdata.handle,RSTR1,wstring);

		hrstackptr=n;
	}
}


void findsetreplace(int fp)
{
	int n;

	n=stack[fp];
 addscheduledevent((zerofn)findsetreplaceevent,n,FINDSETTIME);
}




int findgetfind(int fp)
{
	int n;

	n=stack[fp];
	if(n>=0 && n<MAXHISTORY && n<hused)
	{
		n=(hstackptr-n);
  if(n<0) n+=MAXHISTORY;
		assignstring(stack[fp+1],hfindstring[n]);
		return(1);
	}
	else
	{
		return(0);
	}
}


int findgetreplace(int fp)
{
	int n;

	n=stack[fp];
	if(n>=0 && n<MAXHISTORY && n<hused)
	{
		n=(hstackptr-n);
  if(n<0) n+=MAXHISTORY;
		assignstring(stack[fp+1],hreplacestring[n]);
		return(1);
	}
	else
	{
		return(0);
	}
}





extern dboxstr finderbox;

static int fseeneof;



static os_error * fswritemessage(int type,int n)
{
 char string[64];

 if(type==FMNOFIND) tsprintf(sizeof(string),string,"{FI02}");
 else
 if(type==FMFOUND)  tsprintf(sizeof(string),string,"{FI04}");
 else
 if(type==FMEOF)    tsprintf(sizeof(string),string,"{FI08}",n);

 return(writeicon(finderbox.handle,3,string));
}


static os_error * nextfind(void)
{
 os_error  * err;
 int         soffset=0;
 int         eoffset=0;
 int         found=0;
 int         valid;
 vector      v1;
 int         eof; 
 sourcestr * sourcep;


 if(fseeneof)
 {
  if(cfind.all && (!cfind.zone))
  {
   firststory(cview->branch,cview->file);
   nextstory(&v1,&eof);

   if(eof)
   {
    fswritemessage(FMNOFIND,0);
    return(NULL);
   }
   sourcep=(sourcestr*)fob_find(v1.textsrc.source,v1.file);
   setupfindo(&v1,sourcep->len);
  }
  else
  {
   findrestep();
  }

  fseeneof=0;
 }
 else
 {
  findstep();
 }


	// changed things so that if find non-valid result carry on if all stories

	valid=0;

 while(1)
 {
  search(&cfind,&found,&soffset,&eoffset);

  if(found)
  {
   validfindzone(&find1,&valid,soffset,eoffset);
   if(valid) break;
		}

  if((!cfind.all) || (cfind.zone)) break;

  nextstory(&v1,&eof);
  if(eof) break;

  sourcep=(sourcestr*)fob_find(v1.textsrc.source,v1.file);
  setupfindo(&v1,sourcep->len);
 }

 if(found && valid) 
 {
  err=undostart(find1.file);
  if(!err)
  {
   setfindzone(cview);
   fswritemessage(FMFOUND,0);
   undoend(find1.file);
  }
 }
 else
 {
  fswritemessage(FMNOFIND,0);
  fseeneof=1;
 }

 return(NULL);
}



static os_error * feofreplace(findstr * find)
{
 os_error  * err;
 int         sum;

 err=NULL;

 sum=0;

 hourglasson();

 err=globalreplace(find,&sum);
 if(!err) fswritemessage(FMEOF,sum);

 hourglassoff();

 return(err);
}


/* Continue */

static os_error * fscontinue(int handle,int userhandle,wimp_mousestr * m)
{
 return(nextfind());

 USE(handle);
 USE(userhandle);
 USE(m);
}

/* Replace */

static os_error * fsreplace(int handle,int userhandle,wimp_mousestr * m)
{
 os_error * err;

          err=freplace(&cfind);
 if(!err) err=nextfind();

 return(err);

 USE(handle);
 USE(userhandle);
 USE(m);
}

/* End of file replace */

static os_error * fseofreplace(int handle,int userhandle,wimp_mousestr * m)
{
 return(feofreplace(&cfind));

 USE(handle);
 USE(userhandle);
 USE(m);
}


/* Presumeably only closed with Cancel */

static os_error * finderclose(int code)
{
 os_error * err;

 err=NULL;

 if(act.valid && zone)
 {
  err=undostart(find1.file);
  if(!err)
  {
   unsaveact();
   unselect();
   undoend(find1.file);
  }
 }

 remkeyeventicon(finderbox.handle,0);
 remkeyeventicon(finderbox.handle,1);
 remkeyeventicon(finderbox.handle,2);
 remkeyeventicon(finderbox.handle,4);

 return(err);

 USE(code);
}


static dbiconstr findericondefs[]=
{
 /* N   &V           Type     Grp   Flags   Msk Key   -   -   clickfn 0 */

 /* N   &V           Type     Grp   Flags   R   L   D   U     In    Out */

 2, NULL,              DBACTION, 0,   0,   DBCANCEL,ESCAPE,0,0, NULL, 0,

 1, NULL,         DBACTION, 0,   0,      0,F3,    0,0,(dbreadfn)fscontinue,0,
 0, NULL,         DBACTION, 0,   0,      0,RETURN, 0,0,(dbreadfn)fsreplace,0,
 4, NULL,         DBACTION, 0,   0,      0,0,     0,0,(dbreadfn)fseofreplace,0,

-1, NULL,         0,       0,    0,      0,  0,  0,  0,  0,      0
};



static dboxstr finderbox=
{
 0,
 TFOUND,
 DBFIX,
 DBGRAB,
 finderclose,
 NULL,
 NULL,
 NULL,
 findericondefs,
 0,
 0,
 0,NULL,
 0,
 0,
};



static os_error * opensubfinder(void)
{
 os_error * err;

 err=NULL;

 err=dodboxspparent(&finderbox,1,&finderbox,&dbviewstack,cview->handle);
 if(!err)
 {
  setfocusicon(finderbox.handle,1);
  fseeneof=0;
  setfindzone(cview);
  fswritemessage(FMFOUND,0);
  addkeyeventicon(finderbox.handle,0);
  addkeyeventicon(finderbox.handle,1);
  addkeyeventicon(finderbox.handle,2);
  addkeyeventicon(finderbox.handle,4);
 }

 return(err);
}


/*****************************************************************************/




static os_error * fwritemessage(int count,int type)
{
 os_error * err;
 char       string[64];

 err=NULL;

 if(type==FMCOUNT)  tsprintf(sizeof(string),string,"%d {FI03}",count);
 else
 if(type==FMCLEAR)  string[0]=0;
 else
 if(type==FMNOFIND) 
 {
  sxbeep(FINDBEEP,0,0);
  tsprintf(sizeof(string),string,"{FI02}");
 }

 if(findboxdata.handle)
 {
  err=writeicon(findboxdata.handle,FINFO1,string);
 }

 return(err);
}






static os_error * ffindsub(int findnext)
{
 os_error  * err;
 int         soffset=0;
 int         eoffset=0;
 vector      s;
 vector      v1;
 sourcestr * sourcep;
 int         found;
 int         eof;
 int         first;
 int         valid=0;
 int         start;


 err=NULL;

 first=1;
 found=0;

 start=cfind.start;
 if(findnext) start=0;


 hourglasson();

 while(1)
 {
  if(zone) 
  {
   if(!first) break;
   else
   if(act.file==cview->file)
   {
    s=*lozon;
    setupfind(lozon,hizon);
   }
   else
    break;

			cfind.zone=1;
  }
  else
  {
			cfind.zone=0;

   if(cfind.all && (start || !first))
   {
    soffset=0;
    if(first) firststory(cview->branch,cview->file);
    nextstory(&v1,&eof);
    if(eof) break;
   }
   else
   {
    if(!first)
    {
     if(findnext)
     {
      if(start==0) start=1;
      else         break;
     }
     else
     {
      break;
     }
    }

    if(act.file!=cview->file) break;
    if(start) soffset=0;
    else      soffset=act.textsrc.offset;

    v1=act;
    if(cfind.all) setstartstory(cview->branch,&v1,&eof);
   }

   sourcep=(sourcestr*)fob_find(v1.textsrc.source,v1.file);
   eoffset=sourcep->len;

   s=v1;

   v1.textsrc.offset=soffset;
   setupfindo(&v1,eoffset);
  }

  err=search(&cfind,&found,&soffset,&eoffset);
  if(err) break;
  if(found) break;

  first=0;
 }

 hourglassoff();


 if(!err)
 {
  if(found)
  {
   validfindzone(&s,&valid,soffset,eoffset);
  }

  if(found && valid) 
  {
   err=undostart(find1.file);
   if(!err)
   {
    if(findboxdata.handle) dbclose(&findboxdata,DBOK);
    opensubfinder();
    undoend(find1.file);
   }
  }
  else
  {
   fwritemessage(0,FMNOFIND);
  }
 }

 return(err);
}




static os_error * ffind(int handle,int userhandle,wimp_mousestr * m)
{
 os_error  * err;
 char      * p;
	wchar_t     wstring[FMAXLEN];


 err=iconaddr(handle,SSTR1,&p);
 report(err);

 if(!strlen(p)) err=geterror(FI00);
 else
 {
//  readicon(handle,SSTR1,cfind.s,sizeof(cfind.s));
//  readicon(handle,RSTR1,cfind.r,sizeof(cfind.r));

		readiconunicode(handle,SSTR1,wstring,NITEM(wstring));
		stringtomacro2(wstring,cfind.s,sizeof(cfind.s));

		readiconunicode(handle,RSTR1,wstring,NITEM(wstring));
		stringtomacro2(wstring,cfind.r,sizeof(cfind.r));

		findstackstrings(cfind.s,cfind.r);

  ffindsub(0);
 }

 return(err);

 USE(m);
 USE(userhandle);
}




void findnext(int fp)
{
 os_error * err;

	err=NULL;

	cview=menuview;

	if(cview)
	{
  err=ffindsub(1);

  zreport(err);
	}

 USE(fp);
}




static os_error * fcount(int handle,int userhandle,wimp_mousestr * m)
{
 os_error  * err;
 int         count;
 int         soffset;
 int         eoffset;
 vector      v1;
 sourcestr * sourcep;
 int         found;
 int         first;
 char      * p;
 int         eof;
	wchar_t     wstring[FMAXLEN];


 err=iconaddr(handle,SSTR1,&p);
 if(!strlen(p)) err=geterror(FI00);
 else
 {
//  readicon(handle,SSTR1,cfind.s,sizeof(cfind.s));
//  readicon(handle,RSTR1,cfind.r,sizeof(cfind.r));

		readiconunicode(handle,SSTR1,wstring,NITEM(wstring));
		stringtomacro2(wstring,cfind.s,sizeof(cfind.s));

		readiconunicode(handle,RSTR1,wstring,NITEM(wstring));
		stringtomacro2(wstring,cfind.r,sizeof(cfind.r));

		
		findstackstrings(cfind.s,cfind.r);

  count=0;
  first=1;
  hourglasson();

  while(1)
  {
   if(zone) 
   {
    if(!first) break;
    if(act.file==cview->file) setupfind(lozon,hizon);
    else                      break;
				cfind.zone=1;
   }
   else
   {
				cfind.zone=0;

    if(cfind.all && (cfind.start || !first))
    {
     soffset=0;
     if(first) firststory(cview->branch,cview->file);
     nextstory(&v1,&eof);
     if(eof) break;
    }
    else
    {
     if(!first) break;
     if(cfind.start) soffset=0;
     else            soffset=act.textsrc.offset;
     v1=act;

     if(cfind.all) setstartstory(cview->branch,&v1,&eof);
    }
 
    sourcep=(sourcestr*)fob_find(v1.textsrc.source,v1.file);
    eoffset=sourcep->len;

    v1.textsrc.offset=soffset;
    setupfindo(&v1,eoffset);
   }

   while(1)
   {
    err=search(&cfind,&found,&soffset,&eoffset);
    if(err) break;

    if(found) count++;
    else      break;

    find1.textsrc.offset=find2.textsrc.offset=eoffset;
   }

   if(err) break;

   first=0;
  }


  hourglassoff();

  fwritemessage(count,FMCOUNT);
 }

 return(err);

 USE(handle);
 USE(userhandle);
 USE(m);
}


/*
static os_error * prevs(int handle,int userhandle,wimp_mousestr * m)
{
 writeicon(handle,SSTR1,cfind.s);
 writeicon(handle,RSTR1,cfind.r);

 return(NULL);
 USE(handle);
 USE(userhandle);
 USE(m);
}
*/





static os_error * findicon(int handle,int userhandle,wimp_mousestr * m)
{
 os_error      * err;

 err=NULL;

 return(err);

 USE(userhandle);
	USE(handle);
	USE(m);
}


static os_error * findclose(int code)
{
 os_error    * err;


 err=NULL;



 if(!err && code!=DBAPPLY) 
 {
//  err=remkeyeventicon(findboxdata.handle,SSTR1);
//  if(!err) err=remkeyeventicon(findboxdata.handle,RSTR1);


 }

 return(err);
}




static os_error * findkey(int handle,int userhandle,int icon,int * key)
{
 int ch;
	wchar_t wstring[FMAXLEN];


 ch=*key;

	if(icon==SSTR1)
	{
		if(ch==CUP)
		{
			hfstackptr--;
			if(hfstackptr<0) hfstackptr=MAXHISTORY-1;
		}
		else
		if(ch==CDOWN)
		{
			hfstackptr++;
			if(hfstackptr>=MAXHISTORY) hfstackptr=0;
		}
		else
		{

			return(NULL);
		}

		hrstackptr=hfstackptr;

//  writeicon(findboxdata.handle,SSTR1,hfindstring[hfstackptr]);
//  writeicon(findboxdata.handle,RSTR1,hreplacestring[hrstackptr]);

  macrotostring2(hfindstring[hfstackptr],wstring,NITEM(wstring));
  writeiconunicode(findboxdata.handle,SSTR1,wstring);

  macrotostring2(hreplacestring[hfstackptr],wstring,NITEM(wstring));
  writeiconunicode(findboxdata.handle,RSTR1,wstring);
	}
	else
	if(icon==RSTR1)
	{
		if(ch==CUP)
		{
			hrstackptr--;
			if(hrstackptr<0) hrstackptr=MAXHISTORY-1;
		}
		else
		if(ch==CDOWN)
		{
			hrstackptr++;
			if(hrstackptr>=MAXHISTORY) hrstackptr=0;
		}
		else
		{

			return(NULL);
		}

//  writeicon(findboxdata.handle,RSTR1,hreplacestring[hrstackptr]);
		macrotostring2(hreplacestring[hfstackptr],wstring,NITEM(wstring));
  writeiconunicode(findboxdata.handle,RSTR1,wstring);
	}



 return(NULL);
 USE(handle);
 USE(userhandle);
 USE(icon);
}





static int wildicons[]={16,17,18,19,20,21,22,23,24,-1};
static int okicons[]={44,2,1,-1};


static os_error * dbfopen(int handle)
{
 os_error      * err;
 wimp_box        wildbox;
 wimp_box        okbox;
 wimp_wstate     wst;

 err=NULL;

 geticonbox(handle,wildicons,&wildbox);
 geticonbox(handle,okicons,&okbox);

 if((cfind.wild && wildbox.y1<okbox.y1) || (!cfind.wild && wildbox.y1>okbox.y1))
 {
  moveicongroup(handle,wildicons,0,okbox.y1-wildbox.y1);
  moveicongroup(handle,okicons,0,wildbox.y1-okbox.y1);

  okbox.y0+=wildbox.y1-okbox.y1;
  err=wimp_get_wind_state(handle,&wst); 

  wst.o.box.y0=wst.o.box.y1+okbox.y0-8;

  if(!err) wimp_open_wind(&wst.o);

 }
 
 return(err);
}





static os_error * wildmode(int handle,int userhandle,wimp_mousestr * m)
{
 os_error * err;

 err=dbfopen(handle);

 return(err);
 USE(handle);
 USE(userhandle);
 USE(m);
}




static char * wildtable[]=
{
 "\\.",
 "\\d",
 "\\a",
 "\\*",
 "\\&",
 "\\\\",
 "\\l",
 "\\n",
 "\\t",
};



static os_error * wildc(int handle,int userhandle,wimp_mousestr * m)
{
 os_error      * err;
 int             n;
 wimp_caretstr   cblock;
 int             wlen;
 int             len;
 wchar_t         temp[FMAXLEN];
	int             i;


 err=wimp_get_caret_pos(&cblock);
 if(cblock.w==handle)
 {
  n=m->i-FDOT;

//		cprintf("wildc n %d i %d",n,cblock.i);

  if(cblock.i==SSTR1 || cblock.i==RSTR1)
  {
   readiconunicode(cblock.w,cblock.i,temp,NITEM(temp));
   
   wlen=strlen(wildtable[n]);
//   len=strlen(temp);
			len=xstrlen2(temp);

   memmove(temp+cblock.startindex,temp+cblock.endindex,sizeof(wchar_t)*(len-cblock.endindex+1));
   memmove(temp+cblock.startindex+wlen,temp+cblock.startindex,sizeof(wchar_t)*(len-cblock.startindex+1));

//   memmove(temp+cblock.startindex,wildtable[n],wlen);
			for(i=0;i<wlen;i++)
			{
				temp[cblock.startindex+i]=wildtable[n][i];
			}

   writeiconunicode(cblock.w,cblock.i,temp);

   cblock.startindex+=strlen(wildtable[n]);
   cblock.endindex=cblock.startindex;
   err=wimp_set_caret_pos(&cblock);
  }
 }

 return(err);
 USE(userhandle);
}



static os_error * scombo(int event,int data,void * datap,int * hit,uservalue * userp)
{
	os_error * err;

 err=menucombo(&findboxdata,SSTR1,"find_menu",event,data,hit,userp);

	return(err);

	USE(datap);

	return(NULL);
}


static os_error * rcombo(int event,int data,void * datap,int * hit,uservalue * userp)
{
	os_error * err;

 err=menucombo(&findboxdata,RSTR1,"findreplace_menu",event,data,hit,userp);

	return(err);

	USE(datap);
	
	return(NULL);
}





static dbiconstr findicondefs[]=
{
 /* N   &V           Type     Grp   Flags   Msk Key   -   -   clickfn 0 */

 /* N   &V           Type     Grp   Flags   R   L   D   U     In    Out */

 SSTR1,(int*)&cfind.s,DBWRITE, 1,   0,      -1, -1,RSTR1,RSTR1, NULL, NULL,
 RSTR1,(int*)&cfind.r,DBWRITE, 1,   0,      -1, -1,SSTR1,SSTR1, NULL, NULL,

 SSTR1,(int*)&cfind.s,DBCOMBO, 1,  DBCOMBOX,-1, -1,RSTR1,RSTR1, NULL,(dbwritefn)scombo,
 RSTR1,(int*)&cfind.r,DBCOMBO, 1,  DBCOMBOX,-1, -1,SSTR1,SSTR1, NULL,(dbwritefn)rcombo,



 /* N   &V           Type     Grp   Flags   Act Key     - -   clickfn 0 */

 FIND1, NULL,          DBACTION, 0,   0,      0,RETURN, 0,0,(dbreadfn)ffind,0,

 FIND1, NULL,          DBACTION, 0,   0,      0,F1,     0,0,(dbreadfn)ffind,0,

 FCAN1, NULL,          DBACTION, 0,   0,   DBCANCEL,ESCAPE,0,0, NULL, 0,

 FCOUNT1,NULL,         DBACTION, 0,   0,      0,F3,     0,0,(dbreadfn)fcount,0,

// FPREV1, NULL,         DBACTION, 0,   0,      0,F2,     0,0,(dbreadfn)prevs,0,

 FDOT,   NULL,         DBACTION, 0,   0,      0,0,      0,0,(dbreadfn)wildc,0,
 FDEC,   NULL,         DBACTION, 0,   0,      0,0,      0,0,(dbreadfn)wildc,0,
 FALPHA, NULL,         DBACTION, 0,   0,      0,0,      0,0,(dbreadfn)wildc,0,
 FSTAR,  NULL,         DBACTION, 0,   0,      0,0,      0,0,(dbreadfn)wildc,0,
 FAMP,   NULL,         DBACTION, 0,   0,      0,0,      0,0,(dbreadfn)wildc,0,
 FSLASH, NULL,         DBACTION, 0,   0,      0,0,      0,0,(dbreadfn)wildc,0,
 FLINE,  NULL,         DBACTION, 0,   0,      0,0,      0,0,(dbreadfn)wildc,0,
 FPARA,  NULL,         DBACTION, 0,   0,      0,0,      0,0,(dbreadfn)wildc,0,
 FFRAME, NULL,         DBACTION, 0,   0,      0,0,      0,0,(dbreadfn)wildc,0,
 FTAB,   NULL,         DBACTION, 0,   0,      0,0,      0,0,(dbreadfn)wildc,0,

 /* N   &V           Type     Grp   Flags   Msk Key -  -      clickfn 0 */

    8, &cfind.all,   DBTOGGLE, 0,    0,       1, F7,  0, 0,     NULL,   0,
   37, &cfind.all,   DBTOGGLE, 0,    0,       1, F7,  0, 0,     NULL,   0,

    9, &cfind.start, DBTOGGLE, 0,    0,       1, F8,  0, 0,     NULL,   0,
   38, &cfind.start, DBTOGGLE, 0,    0,       1, F8,  0, 0,     NULL,   0,

   10, &cfind.wild,  DBTOGGLE, 0,    0,       1, F6,  0, 0,
                                                          (dbreadfn)wildmode,0,
   39, &cfind.wild,  DBTOGGLE, 0,    0,       1, F6,  0, 0,
                                                          (dbreadfn)wildmode,0,

    7, &cfind.whole, DBTOGGLE, 0,    0,       1, F5,  0, 0,     NULL,   0,
   36, &cfind.whole, DBTOGGLE, 0,    0,       1, F5,  0, 0,     NULL,   0,

    6, &cfind.xcase,  DBTOGGLE,0,    0,       1, F4,  0, 0,     NULL,   0,
   35, &cfind.xcase,  DBTOGGLE,0,    0,       1, F4,  0, 0,     NULL,   0,

   -1, NULL,         0,       0,    0,      0,  0,  0,  0,  0,      0
};



static dboxstr findboxdata=
{
 0,
 TFIND,
 DBFIX,
 0,
 findclose,
 findicon,
 findkey,
 NULL,
 findicondefs,
 0,
 0,
 0,NULL,
 0,
 0,
};



/* script function opens the finder dialogue box */


#define MAXFINDLEN 128


os_error * openfind2(void)
{
 os_error * err;
 char       string[MAXFINDLEN];
	wchar_t    wstring[MAXFINDLEN];
 wimp_caretstr c;
	
  
 err=NULL;

 if(act.valid && act.file==menufile)
 {
  cview=menuview;

  vgetword(&act,string,sizeof(string));

  err=dodboxspparent(&findboxdata,1,&findboxdata,&dbviewstack,cview->handle);
  if(!err)
  {
		 findstackstrings(string,"");

   macrotostring2(string,wstring,NITEM(wstring));
			writeiconunicode(findboxdata.handle,SSTR1,wstring);
   writeicon(findboxdata.handle,RSTR1,"");

   dbfopen(findboxdata.handle);

//   err=addkeyeventicon(findboxdata.handle,SSTR1);
//   if(!err) err=addkeyeventicon(findboxdata.handle,RSTR1);


//   iecarrot(findboxdata.handle,SSTR1);

   c.startindex=0;
   c.endindex=-1;
   c.w=findboxdata.handle;
   c.i=SSTR1;

   wimp_set_caret_pos(&c);

   fwritemessage(0,FMCLEAR);
  }
 }

	return(err);
}


void openfind(int fp)
{
	zreport(openfind2());
 USE(fp);
}

