/*->c.fl */


#include "stdafx.h"

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <locale.h>
#include <math.h>

#include "os.h"
#include "wimp.h"
#include "wimpt.h"
#include "werr.h"
#include "wos.h"
#include "flex.h"
#include "bbc.h"
#include "font.h"
#include "transform.h"
#include "xprocess.h"


#include "err.h"
#include "xmath.h"
#include "fsx.h"
#include "bf.h"
#include "xext.h"
#include "poll.h"
#include "alloc.h"
#include "trans.h"
#include "colour.h"
#include "bits.h"
#include "etc.h"
#include "deb.h"

#include "constants.h"
#include "str.h"

#include "object.h"

#include "geometry.h"
#include "view.h"
#include "viewr.h"
#include "file.h"
#include "xredraw.h"
#include "curve.h"
#include "posn.h"
#include "chain.h"
#include "new.h"
#include "xcolour.h"
#include "frameflow.h"
#include "border.h"
#include "units.h"


#include "txstr.h"
#include "tx.h"
#include "text.h"
#include "codes.h"
#include "vl.h"
#include "fx.h"
#include "vec.h"
#include "tabs.h"
#include "hp.h"
#include "style.h"
#include "act.h"
#include "fox.h"


#include "fl2.h"

#include "fl.h"



/* flowing boxes */


typedef struct vstripstr
{
 int           nl;
 int           len;
 int           maxld;
 int           maxht;
 int           maxpt;
 int           maxas;
 int           cfstyle;
 int           font;
 int           liney;
 int           ecode;
 int           object;
 int           bullet;


 vlstr  vline[1];

} vstripstr;


#define DEFLTSTRIPSIZE 128



#define FLCONTINUE 0

#define NOFIT      1
#define ENDOFTEXT  2
#define ENDOFBOX   3
#define FLOWEDOUT  4
#define ONELINE    5
#define ENDOFPAGE  6

#define MORE       7
#define NOMORE     8
#define MOVEOUT    9

#define ENDOFSTRIP 10


       vector flv;
       int    flentered;
static int    flextent;
static int    coffset;                 /* additional column offsets */
static int    cvoffset;

static unsigned short fldectab[MAXDECTABCHAR+1];



static int    leadabs;                 /* absolute leading in effect       */
static int    absshift;                /* base line at axy+absshift        */
static int    firstline;               /* firstline in box                 */
static int    firstbaselinemode;
static int    notbefore;               /* should we add the space before ? */
static int    newpara;

static int    canbaselock;
static int    blanked;
static int    boxangle;


static int    axy;                     /* is the top of the next line box  */
static int    xleft;          
static int    xfirst;
static int    xright;
static int    xlefttype;
static int    xrighttype;
static int    xboxwidth;
static int    xboxleftmargin;
static int    xbaselock;
static int    xboxy;



static bulletdatastr flbullet;
static int           fldobullet;
static int           flbulletoffset;



static int    fldodrop;                /* tell formating code to make drop */
static int    fldroplen;
static int    fldropzone;              /* drop cap is in effect */
static int    fldropzonex;
static int    fldropzoney;




static int       cfstyle;     /* style at end of what we just formatted */
static xstylestr flstyle;





#define INITSIZE 128
#define STEPSIZE 128

#define YLIMIT 0x7FFFFFFF



static int flstate;                  /* what is going on */
static int delta;
static int flbulletstate;

static int flsize;




static vstripstr * cstrip[2];
static vstripstr * fstrip;
static boxstr    * xbox;
static boxstr    * ybox;

static int flmask[]={FLV0,FLV1};



static os_error *nextflbox(vector * v,int * more,int * coffset,int * cvoffset);




/*****************************************************************************/


static void flbulletstartstate(void)
{
 int i;

 flbulletoffset=-1;

 for(i=0;i<MAXBLEVEL;i++)
 {
  flbullet.levels[i]=0xFFFF;
 }
}



static void flbulletnullstate(void)
{
 flbulletoffset=-2;
}



static void flbulletsetstate(vlstr * vline,int loffset)
{
 flbulletoffset=loffset;
 expandbulletdata(vline,&flbullet);
}




static void flsetbulletdata(void)
{
 int            level;
 int            i;
 int            voffset;
 vlstr        * line;
 vlstr        * nxline;
 absstylestr  * sp;
 int            clrlevel0;


/* dprintf(6,"set offset %d %d",flbulletoffset,flv.textsrc.loffset); */

 if(flbulletoffset!=flv.textsrc.loffset)
 {
  if(flbulletoffset==-2)
  {
   voffset=flv.textsrc.voffset-sizeof(vlstr);
   nxline=NULL;
   clrlevel0=0;

   while(voffset)
   {
    line=vlptr(flv.textsrc.vsourcep,voffset);
    if(line->line.xl)
    {
     if(line->ext.type==VLBULLET)
     {
      expandbulletdata(line,&flbullet);
      if(clrlevel0) flbullet.levels[0]=0xFFFF;
      break;
     }
    }
    else
    {
     if(line->line.eol==ISNL && nxline)
     {
      findabsstylep(flv.file,nxline->line.style,&sp);
      if(!sp->style.data.bullet && sp->style.data.layer==0)
      {
       clrlevel0=1;
      }
     }
     nxline=line;
    }

    voffset-=sizeof(vlstr);
   }

   if(voffset<=0) flbulletstartstate();
  }

  flbulletoffset=flv.textsrc.loffset;

  level=flstyle.data.layer;

/*
  for(i=0;i<MAXBLEVEL;i++)
  {
   dprintf(0,"level=%d levels[level]=%x",i,flbullet.levels[i]);
  }
*/

  if(flstyle.data.bulletornumber) 
  {
   flbullet.levels[level]=0xFFFF;
  }
  else
  {
   if(flbullet.levels[level]==0xFFFF)
                               flbullet.levels[level]=flstyle.data.bulletstart;
   else                        flbullet.levels[level]++;
  }

  if(level>0)
  {
   for(i=level+1;i<MAXBLEVEL;i++) flbullet.levels[i]=0xFFFF;
   flbullet.levels[0]=0xFFFF;
  }

/* dprintf(0,"level=%d levels[level]=%x",level,flbullet.levels[level]); */
 }

}


/* called when we know we're producing a level 0 new para with no numbering */ 

static void flclrbullet1(void)
{
 if(flbulletoffset>=0 && flstyle.data.layer==0 && !flstyle.data.bullet)
 {
  flbullet.levels[0]=0xFFFF;
 }
}




/* return 1 if bullet data is equal */
/* make tab shifts equal            */

static int cmpbulletlinedata(vlstr * line,bulletdatastr * bdata)
{
 bulletdatastr bdata2;
 int           i;

 expandbulletdata(line,&bdata2);

 for(i=0;i<MAXBLEVEL;i++)
 {
  if(bdata->levels[i]!=bdata2.levels[i]) break;
 }

 if(i>=MAXBLEVEL)
 {
  bdata->tabshift=bdata2.tabshift;
 }

 return(i>=MAXBLEVEL);
}


/*****************************************************************************/


static os_error * flsetstyle(int sn)
{
 os_error * err;

 flv.astyle=sn;

 err=findabsstylex(flv.file,sn,&flstyle);
 if(!err)
 {
  gettabruler(flv.file,flstyle.data.tab);

  xleft=flstyle.data.leftshift;
  xlefttype=flstyle.data.lefttype;
  xfirst=xleft+flstyle.data.firstshift;
  xright=flstyle.data.rightshift;
  xrighttype=flstyle.data.righttype;
  xbaselock=flstyle.data.baselinelock && canbaselock;
 }

 return(err);
}



static void setcoffsets(int * coffsetp,int * cvoffsetp,vector * v)
{
 int      i;
 texsub * texup;
 int      coffset;
 int      cvoffset;

 coffset=v->boffset;
 cvoffset=v->bvoffset;

 texup=(texsub*)(((char*)v->textsrc.textp)+v->textsrc.usize);

 for(i=0;i<v->textsrc.s;i++)
 {
  cvoffset+=texup[i].vlines;
  coffset+=texup[i].bytes;
 }

 *coffsetp=coffset;
 *cvoffsetp=cvoffset;
}



static void setupbox(void)
{
 int             gwidth;
 int             height;
 int             header;
 int             footer;
 texhdr        * texhp;
 transformbitstr bits;


 tr_getbits(&flv.textsrc.textp->transform,&bits);

 frflblanked(flv.file,flv.textsrc.text,&blanked);

 boxangle=bits.angle;
 fxboxsetup(boxangle);

 firstbaselinemode=flv.textsrc.textp->data.valign>>2;

 canbaselock=(bits.angle==0);
 if(canbaselock)
 {
  xboxy=scale(flv.textsrc.textp->fcurve.box.y,bits.yscale,0x10000);
  xboxy+=bits.yshift;
 }

 xboxwidth=txcolwidthb(flv.textsrc.textp,flv.textsrc.u,&gwidth,&bits);
 xboxleftmargin=(gwidth+xboxwidth)*flv.textsrc.s;

 if(bits.skewxy)
 {
  height=scale(flv.textsrc.textp->fcurve.box.h,bits.yscale,0x10000);

  header=flv.textsrc.textp->data.header;
  footer=flv.textsrc.textp->data.footer;

  if(header || footer)
  {
   texhp=(texhdr*)(((char*)flv.textsrc.textp)+
                                     sizeof(textboxstr)+3*sizeof(texsrc));
   header=texhp->header;
   footer=texhp->footer;
  }

  if(flv.textsrc.u==0)
  {
   height=scale(flv.textsrc.textp->fcurve.box.h,bits.yscale,0x10000)
                                                       -header-footer;
  }
  else
  if(flv.textsrc.u==1) height=header;
  else
  if(flv.textsrc.u==2) height=footer;
  else                 height=0;

  xboxwidth+=scale(height,(bits.skewxy>0)?bits.skewxy:-bits.skewxy,0x10000);
 }
}


/*****************************************************************************/

static int        fvboxhk;        /* this strip          */
static int        fvboxvk;        /* next strip          */
static curvestr   ccurve;         /* current vbox curve  */
static int        fvnc;           /* current curve index */
static int        canvertalign;

static int        vertbottom;


/* set up next vertical vbox */
/* return 1 if no more left  */

static int nextvboxv(void)
{
 textvbox * cvbox;

 if(!fvboxvk) return(1);
 else
 {
  fvboxhk=fvboxvk;
  cvbox=(textvbox*)fob_find(fvboxhk,flv.file);
  fvboxvk=cvbox->down;
/*  dprintf(0,"nextvbox %d",fvboxvk);  */

  fvnc=0;
  ccurve=cvbox->curve[fvnc];
  return(0);
 }
}


/* set up next horizontal vbox */
/* return 1 if no more left    */
/*
static int nextvboxh(void)
{
 textvbox * cvbox;

 cvbox=(textvbox*)fob_find(fvboxhk,flv.file);
 fvnc++;
 if(fvnc<cvbox->nc)
 {
  ccurve=cvbox->curve[fvnc];
  return(0);
 }
 else
 {
  return(1);
 }
}
*/

/* set up first horizontal vbox in a strip */
/* return 1 if none                        */ 

static int firstvboxh(void)
{
 textvbox * cvbox;

 cvbox=(textvbox*)fob_find(fvboxhk,flv.file);
 fvnc=0;
 ccurve=cvbox->curve[fvnc];
 return(0);
}




/* set up first vbox */
/* return 1 if none  */

static int firstvboxv(void)
{
 int        vbox;
 textvbox * cvbox;
 texsub   * texup;

 texup=(texsub*)(((char*)flv.textsrc.textp)+flv.textsrc.usize);
 vbox=texup[flv.textsrc.s].vbox;

/* dprintf(2,"s=%d vbox=%d",flv.textsrc.s,vbox); */

 if(vbox)
 {
  cvbox=(textvbox*)fob_find(vbox,flv.file);

 /* dprintf(3,"type=%x nc=%d x=%d w=%d",cvbox->type,cvbox->nc,
                       cvbox->curve[0].box.x,cvbox->curve[0].box.w); */


  fvboxhk=vbox;
  fvboxvk=cvbox->down;
  fvnc=0;
  ccurve=cvbox->curve[fvnc];

  canvertalign=(!fvboxvk && cvbox->nc==1 && ccurve.type==CBOX);
  if(canvertalign)
  {
   vertbottom=ccurve.box.y+ccurve.box.h;
  }

  return(0);
 }
 else return(1);
}


/****************************************************************************/
/* handle flow blocks */

/* flow stacks, have lowest flow on top */

static flowdatastr   fldfixed;
static flowdatastr * fldstack;
       int           fldkey;


static int           flzero;           /* flag daemon active */
static void          flowdaemon(int handle);


os_error * flowstackunlink(int vsource,filestr * file)
{
 os_error    * err;
 vsourcestr  * vsourcep;
 sectionstr  * sectionp;
 flowdatastr * flp;
 int           flkey;
 int           next;
 int           prev;
 int           section;

 err=NULL;
 if(vsource)
 {
  err=fob_mod(vsource,file,(fobjptr)&vsourcep);

  if(vsourcep)
  {
   if((flkey=vsourcep->fldstack)!=0)
   {
    vsourcep->fldstack=0;

    flp=(flowdatastr*)fob_find(flkey,file);
    if(flp)
    {
     section=flp->fv.section;
     next=flp->next;
     prev=flp->prev;

   /* dprintf(0,"unlink sect=%d",section); */

     if(next)
     {
      fob_mod(next,file,(fobjptr)&flp);
      flp->prev=prev;
     }

     if(prev)
     {
      fob_mod(prev,file,(fobjptr)&flp);
      flp->next=next;
     }
     else
     {
      fob_mod(section,file,(fobjptr)&sectionp);
      sectionp->flows=next;
      if(!next)
      {
       if(file->hdr.flowsection)
       {
        section=file->hdr.flowsection;
        sectionp=(sectionstr*)fob_find(section,file);
       }

       file->hdr.flowsection=0;

       while(1)     /* was while(sectionp->chain.next) */
       {
        if(sectionp->flows) 
        {
         file->hdr.flowsection=sectionp->key;
         break;
        }
        if(!sectionp->chain.next) break;
        sectionp=(sectionstr*)fob_find(sectionp->chain.next,file);
       }

 /* dprintf(0,"recalc flowsection fls=%d next=%d",file->hdr.flowsection,
                                                  sectionp->chain.next); */

       if(!sectionp->chain.next)
       {
        if(sectionp->branch && file->hdr.section[DOC])
        {
         sectionp=(sectionstr*)fob_find(file->hdr.section[DOC],file);
        }
        else
        if(!sectionp->branch && file->hdr.section[MST])
        {
         sectionp=(sectionstr*)fob_find(file->hdr.section[MST],file);
        }
        else
        {
         sectionp=NULL;
        }

        if(sectionp)
        {
         while(1)
         {
          if(sectionp->flows)
          {
           file->hdr.flowsection=sectionp->key;
           break;
          }
          else
          if(sectionp->chain.next)
          {
           sectionp=(sectionstr*)fob_find(sectionp->chain.next,file);
          }
          else
          {
           break;
          }
         }
        }
       }
      }
     }
    }

    fob_delete(flkey,file);
   }
  }
 }

 return(err);
}



/* link in the current flow stack */

static os_error * flowstacklink(int section,int flkey,filestr * file)
{
 int           next;
 flowdatastr * flp;
 sectionstr  * sectionp;
 int           ns;
 int           branch;

 fob_mod(section,file,(fobjptr)&sectionp);

 next=sectionp->flows;
 ns=sectionp->data.number;
 branch=sectionp->branch;
 sectionp->flows=flkey;

/* dprintf(0,"next=%d key=%d branch=%d ns=%d",next,flkey,branch,ns);  */

 if(next)
 {
  fob_mod(next,file,(fobjptr)&flp);
  flp->prev=flkey;
 }

 fob_mod(flkey,file,(fobjptr)&flp);
 flp->prev=0;
 flp->next=next;

 if(!file->hdr.flowsection) 
 {
  file->hdr.flowsection=section;
 }
 else
 {
  sectionp=(sectionstr*)fob_find(file->hdr.flowsection,file);
  if((branch && !sectionp->branch) || ns<sectionp->data.number)
  {
  /* dprintf(0,"move link back new=%d old=%d",ns,sectionp->data.number); */
   file->hdr.flowsection=section;
  }
 }

/* dprintf(0,"flowsection=%d",file->hdr.flowsection); */

 return(NULL);
}


static flowdatastr * flgetstackpointer(vector * v,
                                       int fldkey,flowdatastr * fldstack)
{
 if(fldkey) return((flowdatastr*)fob_find(fldkey,v->file));
 else       return(fldstack);
}



/* need to put block in correct order */


static int flcmp(const void * f1,const void * f2)
{
 return(((flowdatablock*)f2)->offset-((flowdatablock*)f1)->offset);
}


static os_error * fladdblock(vector * fv,flowdatablock * fld,
                                         int fldkey,flowdatastr * fldstack)
{
 int             size;
 flowdatablock * flp;
 int             insert;
 int             targetbox;
 int             fbox;
 int             targetsub;
 int             fsub;
 textboxstr    * textp;


 if(fldkey)
 {
  fldstack=(flowdatastr*)fob_find(fldkey,fv->file);

  size=((fldstack->sp+FLBLOCK)/FLBLOCK);
  size*=FLBLOCK;

  fob_change(fldkey,fv->file,
             sizeof(flowdatastr)-(FLBLOCK-size)*sizeof(flowdatablock),
             (fobjptr)&fldstack);
 }
 else
 {



 }


 flp=(flowdatablock*)bnearest(fld,fldstack->data,fldstack->sp,sizeof(flowdatablock),flcmp);
 insert=flp-fldstack->data;
 size=fldstack->sp-(flp-fldstack->data);

 if(insert<fldstack->sp)
 { 
  if(flp->offset==fld->offset)
  {
   // offsets the same, if block is identical no point adding it
   // need to flow from earliest frame - frames may have same offset

   if(insert<(fldstack->sp-1)) // only interested in if identical
   {
    if(flp->delta==fld->delta &&
       flp->length==fld->length &&
       flp->type==fld->type &&
       flp->bulletstate==fld->bulletstate)
    {
     size=-1;                  // identical, so skip
    }
   }
   else  // replacing the top element, hence vector
   {
    targetbox=fv->textsrc.text;
    targetsub=fv->textsrc.s;
    fbox=(fldstack->fv).textsrc.text;
    fsub=(fldstack->fv).textsrc.s;
    if(fbox==targetbox)
    {
     if(fsub==targetsub)
     {
      if(flp->delta==fld->delta &&
         flp->length==fld->length &&
         flp->type==fld->type &&
         flp->bulletstate==fld->bulletstate)
      {
       size=-1;                  // identical, so skip
      }
     }
     else
     if(fsub>targetsub) // current top element is after one to be inserted
     {
      size=0;
      flp++;
     }
    }
    else
    {
     while(fbox)
     {
      if(fbox==targetbox) break;
      textp=(textboxstr*)fob_find(fbox,fv->file);
      fbox=textp->fchain.prev;
     }

     if(fbox==targetbox)  // current top element is after one to be inserted
     {
      size=0;
      flp++;
     }
    }
   }

   cprintf("stack flow collision size %d",size);
  }
 }


 if(size>=0)
 {
  if(size)
  {
   memmove(flp+1,flp,size*sizeof(flowdatablock));
  }
  else
  {
   fldstack->fv=*fv;
  }

  fldstack->sp++; 

  *flp=*fld;
 }

 return(NULL);
}



static void flstackinit(vector * v,int * fldkey,
                        flowdatastr * fldfixed,flowdatastr ** fldstack)
{
 if(((*fldkey)=(v->textsrc.vsourcep)->fldstack)==0)
 {
  fldfixed->sp=0;
  *fldstack=fldfixed;
 }
}


static void flstackend(vector * v,int * fldkeyp,flowdatastr * fldstack)
{
 flowdatastr * fldp;
 int           i;
 int           size;
 int           flkey;

 flkey=*fldkeyp;

 fldstack=flgetstackpointer(v,flkey,fldstack);

 if(fldstack->sp)    /* still pending flows, stash them away */
 {
  if(!flkey)
  {
   size=((fldstack->sp+FLBLOCK)/FLBLOCK);
   size*=FLBLOCK;



   fob_create(sizeof(flowdatastr)-(FLBLOCK-size)*sizeof(flowdatablock),
                                               v->file,OFLOW,(fobjptr)&fldp);
   flkey=fldp->key;

   for(i=0;i<fldstack->sp;i++)
   {
    fldp->data[i]=fldstack->data[i];
   }

   fldp->fv=fldstack->fv;
   fldp->sp=fldstack->sp;

   (v->textsrc.vsourcep)->fldstack=flkey;

   flowstacklink(v->section,flkey,v->file);
  }

  if(!flzero) 
  {
   addzeroevent(flowdaemon,0);
   flzero=1;
  }
 }
 else         /* if there is an flstack for the vsource, scrap it */
 {
  if(flkey)
  {
   flowstackunlink(v->textsrc.vsource,v->file);
   flkey=0;
  }
 }

 *fldkeyp=flkey;
}




/* used to terminate all flowing */

static void closeflow(void)
{
 fldstack=flgetstackpointer(&flv,fldkey,fldstack);
 fldstack->sp=0;
}




static void updatestate(void)
{
 int     offset;
 int     voffset;
 int     slen;
 vlstr * line;


 fldstack=flgetstackpointer(&flv,fldkey,fldstack);

/* dprintf(0,"updatestate %d sp=%d offset=%d",
                         flstate,fldstack->sp,flv.textsrc.loffset); */

 if(flstate!=FLNONE)
 {
  if(!fldstack->sp || 
       flv.textsrc.loffset<fldstack->data[fldstack->sp-1].offset)
  {
   fldstack->sp++;
   fldstack->data[fldstack->sp-1].type=flstate;
   fldstack->data[fldstack->sp-1].bulletstate=flbulletstate;
   fldstack->data[fldstack->sp-1].offset=flv.textsrc.loffset;
   fldstack->data[fldstack->sp-1].length=0;
   fldstack->data[fldstack->sp-1].delta=delta;
   fldstack->fv=flv;
  }
  else
  {
   fldstack->data[fldstack->sp-1].delta+=delta;
   fldstack->fv=flv;
  }
 }
 else
 {
  if(fldstack->sp)
  {
   offset=fldstack->data[fldstack->sp-1].offset;

   while(1)
   {
    slen=0;
    voffset=flv.textsrc.voffset;

    while(1)
    {
     if(voffset>=flv.textsrc.vsourcep->len) break;
     line=vlptr(flv.textsrc.vsourcep,voffset);

     voffset+=sizeof(vlstr);
     if(!line->line.xl)
     {
      slen+=line->line.len;
      if(line->line.strip) break;
     }
    }

    if((flv.textsrc.loffset+slen)>offset) break;
    while(flv.textsrc.voffset<voffset)
    {
     if(!nextvlinev(&flv,0)) break;
    }

    if(flv.textsrc.voffset<voffset) break;
   }

   fldstack=flgetstackpointer(&flv,fldkey,fldstack);
   fldstack->fv=flv;
  }
 }
}


static void flsdrop(int i,flowdatastr * fldstack)
{
 memmove(fldstack->data+i,
         fldstack->data+i+1,(fldstack->sp-i)*sizeof(flowdatablock));
 fldstack->sp--;
}


static void checkstate(int eq)
{
 int     i;
 int     type;
 int     bulletstate;
 int     shift;
 int     newstate;
 vlstr * line;
 int     voffset;
 int     slen;
 int     inxline;



 fldstack=flgetstackpointer(&flv,fldkey,fldstack);

 /* scan through any stack elements which are in range */
 /* offset<=loffset                                    */

 newstate=FLNONE;

 i=fldstack->sp-1;

/* dprintf(0,"checkstate %d",i+1); */

 while(i>=0)
 {
  /* idea is that if there are no more lines, this code will swallow */
  /* all the pending flows */


  inxline=0;
  voffset=flv.textsrc.voffset;
  if(voffset<flv.textsrc.vsourcep->len)
  {
   slen=0;

   while(voffset<flv.textsrc.vsourcep->len)
   {
    line=vlptr(flv.textsrc.vsourcep,voffset);
    if(!line->line.xl)
    {
     slen+=line->line.len;
     if(line->line.strip) break;
    }
    voffset+=sizeof(vlstr);
   }

   if((flv.textsrc.loffset+slen)<=fldstack->data[i].offset) break;

   inxline=(flv.textsrc.loffset<fldstack->data[i].offset);
  }

  type=fldstack->data[i].type;
  bulletstate=fldstack->data[i].bulletstate;

  if(type==FLDELTA)
  {
   if(!inxline)
   {
    delta+=fldstack->data[i].delta;
    flbulletstate=flbulletstate || bulletstate;
    flsdrop(i,fldstack);
    if(newstate==FLNONE || newstate==FLBULLET) newstate=FLDELTA;
   }
   else
   {
    newstate=FLDIRTY;
    break;
   }
  }
  else
  if(type==FLDIRTY || type==FLQUICK)
  {
   if(!inxline)
   {
    delta+=fldstack->data[i].delta;
    flbulletstate=flbulletstate || bulletstate;
    fldstack->data[i].bulletstate=0;
    fldstack->data[i].delta=0;
    shift=flv.textsrc.loffset-fldstack->data[i].offset;
    fldstack->data[i].offset=flv.textsrc.loffset;
    fldstack->data[i].length-=shift;
    if(fldstack->data[i].length<0) flsdrop(i,fldstack);
    if((type==FLQUICK && 
        (newstate==FLNONE || newstate==FLDELTA || newstate==FLBULLET)) ||
        type==FLDIRTY) newstate=type;
   }
   else
   {
    if((type==FLQUICK && 
        (newstate==FLNONE || newstate==FLDELTA || newstate==FLBULLET)) ||
        type==FLDIRTY) newstate=type;
    break;
   }
  }
  else
  if(type==FLBULLET)
  {
   if(!inxline)
   {
    flbulletstate=flbulletstate || bulletstate;
    flsdrop(i,fldstack);
   }
   if(newstate==FLNONE) newstate=type;
  }

  i--;
 }

 if((newstate==FLNONE || newstate==FLBULLET) && (delta || !eq)) 
                                                        newstate=FLDELTA;

 if(newstate==FLNONE && flbulletstate)  newstate=FLBULLET;

 flstate=newstate;

/*
dprintf(1,"checkstate %d delta=%d eq=%d flb=%d",flstate,delta,eq,flbulletstate);
*/

}


/*****************************************************************************/
/* code to refresh area of object being flowed */

#define FRCHUNK 16*sizeof(sboxstr)

static viewredrawstr fv;
static aboxstr       fbbox;
static int           fseen;
static int           fvisible;   /* is the flowing on screen ?       */

static int           oldvshift;
static int           oldvdelta;

static int           oldvalign;
static int           curvalign;

static int           voffsetdelta;



typedef struct rvlinestr
{
 vlstr vline;
 int   shift;

 union
 {
  struct
  {
   unsigned int   repaint:1;
   unsigned int   newline:1;
   unsigned int   blanked:1;

  } bits;

  int word;
 } data;

} rvlinestr;


#define FRVCHUNK 8*sizeof(rvlinestr)

static rvlinestr * rlines;
static int         rlinesize;


static os_error * refreshstart(void)
{
 texsub * texup;

 vvisible(&flv,&fvisible);
 if(fvisible)
 {
  initviewredraw(&fv);
  fv.file=flv.file;
  fv.page=flv.page;
  fv.section=flv.section;
  fv.sobject=flv.textsrc.text;
  fv.sboxn=0;
 /* fv.sbox=NULL; */
  fv.szone=0;
  fv.sunit=flv.textsrc.u;
  fv.ssub=flv.textsrc.s;
  fseen=0;

  texup=(texsub*)(((char*)flv.textsrc.textp)+flv.textsrc.usize);
  txgetvshifts(flv.textsrc.textp,texup+flv.textsrc.s,&oldvshift,&oldvdelta);
  oldvalign=(oldvshift || oldvdelta);
 }

 return(NULL);
}




static os_error * refreshline(vlstr * line,int blank,int voffset)
{
 os_error * err;
 aboxstr    abox;
 int        shift;


 err=NULL;


 if(fvisible)
 {
  if(!line->line.xl)
  {
   if(blank)
   {
    if(!blanked)
    {
     if(!fv.sbox) err=flex_alloc((flex_ptr)&fv.sbox,FRCHUNK);
     else         err=flex_chunk((flex_ptr)&fv.sbox,
                                    (fv.sboxn+1)*sizeof(sboxstr),FRCHUNK);

     if(!err)
     {
      fv.sbox[fv.sboxn].box.x0=line->line.x;
      fv.sbox[fv.sboxn].box.x1=line->line.x+MAXW(line);
      fv.sbox[fv.sboxn].box.y0=LY(line->line.yy);
      fv.sbox[fv.sboxn].box.y1=LY(line->line.yy)+line->line.h;

      if(oldvalign)
      {
       if(rlines)
       {
        rlines[(voffset-cvoffset)/sizeof(vlstr)].data.bits.blanked=1;
       }

       voffset+=voffsetdelta;
       shift=oldvshift+((voffset-cvoffset)/sizeof(vlstr))*oldvdelta;
       fv.sbox[fv.sboxn].box.y0+=shift;
       fv.sbox[fv.sboxn].box.y1+=shift;
      }

      if(!fv.sboxn && !fseen) fbbox=fv.sbox[fv.sboxn].box;
      else                    getsumabox(&fbbox,&fv.sbox[fv.sboxn].box);

      fv.sboxn++;
     }
    }
   }
   else
   {
    if(rlines)
    {
     rlines[(voffset-cvoffset)/sizeof(vlstr)].data.bits.repaint=1;
    }
    else
    {
     abox.x0=line->line.x;
     abox.x1=line->line.x+MAXW(line);
     abox.y0=LY(line->line.yy);
     abox.y1=LY(line->line.yy)+line->line.h;

     if(!fseen) fbbox=abox;
     else       getsumabox(&fbbox,&abox);
    }
   }

   fseen=1;
  }
 }

 return(err);
}



/* only used to refresh lines being changed on screen        */

static os_error * refreshstrip(vstripstr * strip,int blank)
{
 os_error * err;
 int        i;
 int        voffset;

 err=NULL;


 voffset=flv.textsrc.voffset;
 for(i=0;i<strip->nl;i++)
 {
  err=refreshline(&strip->vline[i],blank,voffset);
  voffset+=sizeof(vlstr);
 }


 return(err);
}



static os_error * refreshvadd(int n,int offset)
{
 os_error * err;
 int        size;
 int        voffset;
 int        i;
 int        roffset;

 err=NULL;

 if(curvalign && rlines)
 {
  size=n*sizeof(rvlinestr);
  voffset=offset-cvoffset;
  i=voffset/sizeof(vlstr);
  roffset=i*sizeof(rvlinestr);

  err=flex_chunk((flex_ptr)&rlines,rlinesize+size,FRVCHUNK);
  if(!err)
  {
   memmove(((char*)rlines)+roffset+size,
           ((char*)rlines)+roffset,rlinesize-roffset);
   memset(((char*)rlines)+roffset,0,size);
   rlinesize+=size;

   n+=i;
   while(i<n)
   {
    rlines[i].data.bits.newline=1;
    i++;
   }
  }
 }

 return(err);
}

static os_error * refreshvrem(int n,int offset)
{
 int size;
 int voffset;

 if(curvalign && rlines)
 {
  size=n*sizeof(rvlinestr);
  voffset=(offset-cvoffset)/sizeof(vlstr);
  voffset*=sizeof(rvlinestr);

  memmove(((char*)rlines)+voffset,
         ((char*)rlines)+voffset+size,rlinesize-voffset);

  rlinesize-=size;
 }

 return(NULL);
}


static os_error * refreshvstart(void)
{
 os_error * err;
 int        ln;
 texsub   * texup;
 int        shift;
 int        voffset;
 int        i;

 curvalign=(canvertalign &&
                ((flv.textsrc.textp->data.valign & 0x3)!=VTOP) && fvisible);
 if(curvalign)
 {
  texup=(texsub*)(((char*)flv.textsrc.textp)+flv.textsrc.usize);
  ln=texup[flv.textsrc.s].vlines/sizeof(vlstr);
  rlinesize=ln*sizeof(rvlinestr);

  if(!rlines) err=flex_alloc((flex_ptr)&rlines,rlinesize+FRVCHUNK);
  else        err=flex_chunk((flex_ptr)&rlines,rlinesize,FRVCHUNK);

  if(!err)
  {
   shift=oldvshift;
   voffset=cvoffset;

   for(i=0;i<ln;i++)
   {
    rlines[i].vline=*vlptr(flv.textsrc.vsourcep,voffset);
    rlines[i].shift=shift;
    rlines[i].data.word=0;

   /* dprintf(0,"v y=%d h=%d shift=%d",rlines[i].vline.y,
                                     rlines[i].vline.h,shift); */

    shift+=oldvdelta;
    voffset+=sizeof(vlstr);
   }
  }
 }

 return(NULL);
}


static os_error * refreshvend(flowstr * op)
{
 os_error * err;
 texsub   * texup;
 int        vshift;
 int        vdelta;
 int        voffset;
 int        i;
 vlstr    * line;
 aboxstr    abox;
 int        maxline;
 int        vblank;
 int        shift;
 int        roff;


 if(curvalign && rlines)
 {
  texup=(texsub*)(((char*)flv.textsrc.textp)+flv.textsrc.usize);
  texup=texup+flv.textsrc.s;
  maxline=texup->vlines;
  txgetvshifts(flv.textsrc.textp,texup,&vshift,&vdelta);

  if(op->opcode & (FLV0|FLV1))
  {
   for(i=0;i<2;i++)
   {
    if((op->opcode & flmask[i]) && !(flextent & flmask[i]))
    {
     roff=op->roff[i];

     if(roff>=coffset && roff<(coffset+texup->bytes))
     {
      shift=vshift+
           ((op->resultv[i]->textsrc.voffset-cvoffset)/sizeof(vlstr))*vdelta;
      op->resultv[i]->y+=shift;
     }
    }
   }
  }

  vblank=!blanked && (vshift!=oldvshift || vdelta!=oldvdelta);

  i=0;
  for(voffset=0;voffset<maxline;voffset+=sizeof(vlstr))
  {
  /* dprintf(0,"voff=%d new=%d blank=%d repaint=%d",
       voffset,rlines[i].data.bits.newline,
               rlines[i].data.bits.blanked,
               rlines[i].data.bits.repaint); */

   if(vblank && !rlines[i].data.bits.newline && !rlines[i].data.bits.blanked)
   {
    if(!fv.sbox) err=flex_alloc((flex_ptr)&fv.sbox,FRCHUNK);
    else         err=flex_chunk((flex_ptr)&fv.sbox,
                                   (fv.sboxn+1)*sizeof(sboxstr),FRCHUNK);

    if(!err)
    {
     line=&rlines[i].vline;
     if(!line->line.xl)
     {
      fv.sbox[fv.sboxn].box.x0=line->line.x;
      fv.sbox[fv.sboxn].box.x1=line->line.x+MAXW(line);
      fv.sbox[fv.sboxn].box.y0=LY(line->line.yy)+rlines[i].shift;
      fv.sbox[fv.sboxn].box.y1=LY(line->line.yy)+line->line.h+rlines[i].shift;

   /*  dprintf(0,"y=%d h=%d shift=%d",line->y,line->h,rlines[i].shift); */

      if(!fv.sboxn && !fseen) fbbox=fv.sbox[fv.sboxn].box;
      else                    getsumabox(&fbbox,&fv.sbox[fv.sboxn].box);

      fv.sboxn++;
      fseen=1;
     }
    }
   }

   if(rlines[i].data.bits.repaint || vblank)
   {
    line=vlptr(flv.textsrc.vsourcep,cvoffset+voffset);
    if(!line->line.xl)
    {
     abox.x0=line->line.x;
     abox.x1=line->line.x+MAXW(line);
     abox.y0=LY(line->line.yy)+vshift;
     abox.y1=LY(line->line.yy)+line->line.h+vshift;

     if(!fseen) fbbox=abox;
     else       getsumabox(&fbbox,&abox);
     fseen=1;
    }
   }

   i++;
   vshift+=vdelta;
  }

  flex_free((flex_ptr)&rlines);
 }

 return(NULL);
}



/* it is quite possible to call refreshend, when there has been no reflow */
/* but when the frame has been redrawn when in the unflowed state         */
/* e.g. move a frame with no flowaround about                             */
/* an optimisation is to check if there are cached redraws for the object */
/* and set fseen, remembering to then remove the frame from the cache     */



static os_error * refreshend(void)
{
 os_error     * err;
 transformstr   trx;
 transformstr   trw;
 transformstr   trz;
 texsub       * texup;

/* dprintf(0,"refresh end y0=%d y1=%d",fbbox.y0,fbbox.y1); */

 err=NULL;

/* dprintf(4,"refresh end %d seen=%d sboxn=%d fvisible=%d",
              flv.textsrc.text,fseen,fv.sboxn,fvisible); */

 if(fvisible)
 {
  if(fv.sboxn || fseen)
  {
   trx=flv.textsrc.textp->data.transform;
   tr_setshift(&trw,flv.textsrc.textp->fcurve.box.x,
                    flv.textsrc.textp->fcurve.box.y);
   tr_multiply(&trz,&trw,&trx);

   /* wrong, because may depend on view */

   fv.ignore=(vfindcolour(flv.file->view,&flv.textsrc.textp->data.colour)!=-1);

   fv.sshortcuts=fv.ignore;


   texup=(texsub*)(((char*)flv.textsrc.textp)+flv.textsrc.usize);

   if(flvalidsource==flv.textsrc.source) fv.sflush=2;
   else fv.sflush=(flv.textsrc.voffset>=texup[flv.textsrc.s].vlines);


   err=viewrefreshsobject(&fv,&fbbox,&trz);


   flex_free((flex_ptr)&fv.sbox);
   fv.sboxn=0;
   fseen=0;
  }
 }


/* dprintf(4,"refresh exit"); */

 return(err);
}



static os_error * flflush(int fldkey)
{
 textboxstr * textp;
 int          text;
 int          s;
 int          usize;
 texsub     * texup;
 int          vloffset;
 int          offset;
 int          i;
 int          dorefresh;

 if(!fldkey)
 {
  while(1)
  {
   vxcflush(flv.file,flv.textsrc.source,&text,&s);

 /* dprintf(1,"fflush source=%d frame=%d",flv.textsrc.source,text); */

   if(!text) break;

   flowvalidatesource(flv.textsrc.source);

   dorefresh=0;

   /* move vector */

   if((flv.textsrc.text==text && flv.textsrc.s==s) ||
      flv.textsrc.u)
   {
    /* dprintf(1,"fflush hit flv"); */
    dorefresh=1;
   }
   else
   {
    textp=(textboxstr*)fob_find(text,flv.file);  /* uncat may have lost frame */
    if(textp)
    {
     settextoffset(flv.file,textp,&vloffset,&offset);
     if(textp->data.header || textp->data.footer) 
     usize=sizeof(textboxstr)+3*sizeof(texsrc)+sizeof(texhdr)+2*sizeof(texsub);
     else 
     usize=sizeof(textboxstr)+sizeof(texsrc);

     texup=(texsub*)(((char*)textp)+usize);
     for(i=0;i<s;i++) offset+=texup[i].bytes;
     resetpoint(&flv,offset);
     dorefresh=1;
    }
   }


   if(dorefresh)
   {
    refreshstart();
    fseen=1;
    memset(&fbbox,0,sizeof(aboxstr));
    refreshend();
   }

 /* dprintf(4,"end+1"); */


   flowvalidatesource(0);

   vxcclear(flv.file,text,s);
  }
 }

 return(NULL);
}


/****************************************************************************/

/* handle consequences of removing line from box */

static void remboxline(vlstr * line,int shift)
{
 texsub * texup;

 texup=(texsub*)(((char*)flv.textsrc.textp)+flv.textsrc.usize);

 texup[flv.textsrc.s].vlines-=sizeof(vlstr);

 if(!line->line.xl)
 {
  texup[flv.textsrc.s].bytes-=line->line.len;
 }

 refreshline(line,1,flv.textsrc.voffset+shift);
}


static void remboxstrip(vstripstr * strip)
{
 int i;
 int shift;

 shift=0;

 for(i=0;i<strip->nl;i++)
 {
  remboxline(&strip->vline[i],shift);
  shift+=sizeof(vlstr);
 }
}


/* idea here, is that when we add a line, we clear any lines higher up
   the buffer that overlap it */

static void addboxline(vlstr * line,int shift)
{
 texsub * texup;

 texup=(texsub*)(((char*)flv.textsrc.textp)+flv.textsrc.usize);

 texup[flv.textsrc.s].vlines+=sizeof(vlstr);

 if(!line->line.xl)
 {
  texup[flv.textsrc.s].bytes+=line->line.len;
 }

 refreshline(line,0,flv.textsrc.voffset+shift);
}


static void addboxstrip(vstripstr * strip)
{
 int i;
 int shift;

 shift=0;

 for(i=0;i<strip->nl;i++)
 {
  addboxline(&strip->vline[i],shift);
  shift+=sizeof(vlstr);
 }
}

/****************************************************************************/

#define eqline(line1,line2) (!memcmp(&line1,&line2,sizeof(vlstr)))

/*
static int eqstrip(vstripstr * strip1,vstripstr * strip2)
{
 if(strip1->nl==strip2->nl)
 {
  if(strip1->len==strip2->len)
  {
   return(!memcmp(strip1->vline,strip2->vline,sizeof(vlstr)*strip1->nl));
  }
 }
 return(0);
}
*/



static coordstr     eobcx;
static transformstr eitr;
static transformstr etz;
static transformstr etrz;
static int          eobject;


static int fltrfn(transformstr * r,transformstr * t,
                                    curvestr * c,transformstr * ct)
{
 transformstr    t1;
 boxstr          maxbox;
 coordstr        cx;
 outlineinfostr  oinfo;
 int             borderwidth[4];
 boxstr          box;
 transformbitstr bits;


 box=c->box;

 objectoread(SELECTINFO,eobject,flv.file,&oinfo);
 if(oinfo.frame)
 {
  getbordersize(oinfo.frame,flv.file,borderwidth,&oinfo.fcurve);
  tr_getbits(ct,&bits);
  borderwidth[0]=scale(borderwidth[0],0x10000,bits.yscale);
  borderwidth[1]=scale(borderwidth[1],0x10000,bits.xscale);
  borderwidth[2]=scale(borderwidth[2],0x10000,bits.yscale);
  borderwidth[3]=scale(borderwidth[3],0x10000,bits.xscale);

  box.x=oinfo.fcurve.box.x-borderwidth[3];
  box.y=oinfo.fcurve.box.y-borderwidth[0];
  box.w=oinfo.fcurve.box.w+borderwidth[1]+borderwidth[3];
  box.h=oinfo.fcurve.box.h+borderwidth[0]+borderwidth[2];
 }

 tr_multiply(&t1,ct,&eitr);
 getmaxbox(&maxbox,&box,&t1);

 cx.x=maxbox.x;
 cx.y=maxbox.y;

 tr_transformset(&cx,1,&etz);

 tr_setshift(&t1,eobcx.x-cx.x,eobcx.y-cx.y);

 tr_multiply(r,t,&t1);

 return(TR_SHIFT);
}



static int fltrfn2(transformstr * r,transformstr * t,
                                    curvestr * c,transformstr * ct)
{
 tr_multiply(r,t,&etz);
 return(TR_ROTATE);
 USE(c);
 USE(ct);
}



static void formateobsetup(void)
{
 transformstr  trx;
 transformstr  trw;

 trx=flv.textsrc.textp->data.transform;
 tr_setshift(&trw,flv.textsrc.textp->fcurve.box.x,
                  flv.textsrc.textp->fcurve.box.y);

 tr_multiply(&etrz,&trw,&trx);
 tr_inverse(&etrz,&eitr);
}



static os_error * formateobline(int loffset,vlstr * vline,int maxld)
{
 int           c;
 int           bits;
 int           maxoffset;
 char        * p;
 sobjectstr  * sob;
 int           oldangle;
 int           height;
 int           base;
 int           sl;
 int           ns;
 int           nc;
 int           totns;
 int           totnc;
 int           dx;
 int           offset;


 if(!vline->line.xl)
 {
  offset=loffset;
  maxoffset=offset+vline->line.len;

  while(offset<maxoffset)
  {
   p=txptr(flv.textsrc.sourcep,offset);
   c=*p;
   bits=codex[c];

   if(c==EOB)
   {
    eobject=(*(p+1))+((*(p+2))<<8)+((*(p+3))<<16)+((*(p+4))<<24);
    eobcx.x=(*(p+5))+((*(p+6))<<8)+((*(p+7))<<16);
    oldangle=(*(p+11))+((*(p+12))<<8)+((*(p+13))<<16)+((*(p+14))<<24);
    height=(*(p+15))+((*(p+16))<<8)+((*(p+17))<<16);
    base=(*(p+21))+((*(p+22))<<8)+((*(p+23))<<16)+((*(p+24))<<24);

    base=scale(height,base,0x10000);
    eobcx.y=maxld-(height+base); /* distance from top of box to line y coord */
                                 /* top of box at (height+base)              */

    *(p+8)=(char)eobcx.y;
    *(p+9)=(char)(eobcx.y>>8);
    *(p+10)=(char)(eobcx.y>>16);

    if(oldangle!=boxangle)
    {
     *(p+11)=(char)boxangle;
     *(p+12)=(char)(boxangle>>8);
     *(p+13)=(char)(boxangle>>16);
     *(p+14)=(char)(boxangle>>24);

     tr_setidentity(&etz);
     tr_setrotationa(&etz,boxangle-oldangle);

     sob=(sobjectstr*)fob_find(eobject,flv.file);

     objecttransform((objhdrstr *)sob,flv.file,
              fltrfn2,TRNOREFLOW|TRNOREFLOWS|TRNOREFLOWD|TRNOUPDATE|TRNOUNDO);
    }

    eobcx.x+=vline->line.x;
    eobcx.y+=LY(vline->line.yy);

    if(vline->line.just==RIGHT)  eobcx.x+=(MAXW(vline)-vline->line.w);
    else
    if(vline->line.just==CENTRE) eobcx.x+=(MAXW(vline)-vline->line.w)>>1;
    else
    if(vline->line.just==JUSTIFY)
    {
     sl=striplen(flv.textsrc.sourcep,vline->line.len,loffset);

     fxtotals2(&flv,loffset,offset-loffset,&ns,&nc);
     fxtotals2(&flv,loffset,sl,&totns,&totnc);

     dx=MAXW(vline)-vline->line.w;

     fxcalcdxs(dx,totns,totnc);

     eobcx.x+=fxlinedx*ns+fxlineddx*nc; /* == ns*(dx+ddx)+(nc-ns)*ddx */
    }

    tr_transformset(&eobcx,1,&etrz);

    sob=(sobjectstr*)fob_find(eobject,flv.file);
    sob->chain.parent=flv.textsrc.text;
  
    etz=etrz;
    objecttransform((objhdrstr *)sob,flv.file,
              fltrfn,TRNOREFLOW|TRNOREFLOWS|TRNOREFLOWD|TRNOUPDATE|TRNOUNDO);



   }
   offset+=bits & CODELEN;
  }
 }

 return(NULL);
}





static os_error * formateob(vstripstr * strip)
{
 os_error    * err;
 int           offset;
 vlstr         vline;
 int           i;

 err=NULL;

 formateobsetup();

 offset=flv.textsrc.loffset;

 for(i=0;i<strip->nl;i++)
 {
  vline=strip->vline[i];
  if(!vline.line.xl)
  {
   formateobline(offset,&vline,strip->maxld);
   offset+=vline.line.len;
  }
 }

 return(err);
}

                            
static os_error * vformateobs(void)
{
 vlstr     * vlinep;
 vlstr       vline;
 int         offset;
 int         len;
 int         maxline;
 int         vshift;
 int         vdelta;
 texsub    * texup;
 int         voffset;
 int         style;
 int         hasfont;
 int         ecode;

 if(curvalign)
 {
  formateobsetup();

  texup=(texsub*)(((char*)flv.textsrc.textp)+flv.textsrc.usize);
  texup=texup+flv.textsrc.s;
  maxline=texup->vlines;
  txgetvshifts(flv.textsrc.textp,texup,&vshift,&vdelta);

  offset=coffset;
  for(voffset=0;voffset<maxline;voffset+=sizeof(vlstr))
  {
   vlinep=vlptr(flv.textsrc.vsourcep,cvoffset+voffset);
   if(!vlinep->line.xl)
   {
    len=vlinep->line.len;
    if(vlinep->line.object)
    {
     vline=*vlinep;
     vline.line.yy=LY(vline.line.yy)+vshift;
     style=vline.line.style;
     fxinitjust(style,flv.file);
     fontstate(&flv,offset,len,&style,&hasfont,0,&ecode);
     formateobline(offset,&vline,fmaxld);
    }
    offset+=len;
    vshift+=vdelta;
   }
  }
 }

 return(NULL);
}




/* search until find a '.' or return -1 */

static int finddot(sourcestr * source,int offset,int maxlen)
{
 char   c;
 int    bits;
 int    type;
 int    len;
 int    wasnum;
 int    curnum;
 int    dec;

 len=0;
 wasnum=0;
 curnum=0;

 while(len<maxlen)
 {
  c=*txptr(source,offset+len);
  bits=codex[c];
  type=bits & CODETYPE;

  switch(c)
  {
         case  TABSEQ:
         case  MACSEQ:
       case  SPACESEQ:
                      if(wasnum) goto finished;
                      goto failed;

              default:
                      if(type!=CODECODE)
                      {
                       dec=0;
                       while(fldectab[dec])
                       {
                        if(c==fldectab[dec]) goto finished;
                        dec++;
                       }

                       curnum=(c==',' || c=='.' || (type==CODEDIGIT) ||
                               c=='+' || c=='-' || 
                               c==SPACE || c==NBSPACE ||
                                       (curnum && (c=='E' || c=='e')));

                       if(!curnum && wasnum) goto finished;
                       wasnum=curnum;
                      }
                      else
                      {
                       if(bits & CODETERMINATOR)
                       {
                        if(wasnum) goto finished;
                        else       goto failed;
                       }
                      }
                      break;
  }

  len+=(bits & CODELEN);
 }

  failed:
          return(-1);

finished:
          return(len);
}



static os_error * findtab(int posn,int * tabtype,int * tabposn,int first)
{
 int  i;
 int  tposn=0;              /* make compiler happy */
 int  ttype=TABBAD;
	char string[(DECTABMAXLEN+1)*3];
	int  decptr;

	XMEMCPYX(fldectab,fxdectab,MAXDECTABCHAR+1);
	decptr=0;

 gettabruler(flv.file,flstyle.data.tab);

 for(i=0;i<tabrulern;i++)
 {
  if(tabruler[i].type==TABDATA)
  {
   tposn=(tabruler[i].posn>>24);
   if(tposn==TSUBDEC)
   {
				if(decptr<(DECTABMAXLEN*3))
				{
 		 	memcpy(string+decptr,&tabruler[i],3);
 		 	decptr+=3;
				}
   }
  }
  else
  if((int)tabruler[i].posn>posn && tabruler[i].type!=TVRULE)
  {
			if(decptr)
			{
				string[decptr]=0;
		  txstring12(string,decptr,fldectab,NITEM(fldectab),NULL);
				decptr=0;
			}

   tposn=tabruler[i].posn;
   ttype=tabruler[i].type;
   break;
  }
 }



/* dprintf(10,"ttype=%d posn=%d first=%d leftshift=%d left=%d",ttype,
       posn,first,flstyle.data.leftshift,flstyle.data.left); */


 if(first && flstyle.data.leftshift)
 {
  if(flstyle.data.leftshift>posn)
  {
   if(ttype==TABBAD || tposn>flstyle.data.leftshift)
   {
    tposn=flstyle.data.leftshift;
    ttype=TLEFT;
   }
  }
 }

 if(ttype==TABBAD)
 {
  ttype=TLEFT;

  tposn=scalenr(posn+1,MMDIV,TABDEFSTEP*MMMUL)+1;/*tposn in units of defstep*/
  tposn=scale(tposn,TABDEFSTEP*MMMUL,MMDIV);
 }

 *tabtype=ttype;
 *tabposn=tposn;

 return(NULL);
}



static os_error * flmore(vector * fv,int step)
{
 flsize+=step;
 return(fxexpand(fv,FXMORE|FXTABS|FXEOBA,flsize,NULL));
}



/*

  There is a problem with lines with -ve tracking.
  Because the split will occur at the final space, the width of the
  line is actually slightly less than the width of the characters in it
  i.e. the line ends
            <char> <step backwards>

*/



static os_error * flwidth(vector * fv,font_string * fs,int off,int flags)
{
 os_error    * err=NULL;
 font_string   tfs;
 
 tfs=*fs;

 while(1)
 {                             /* can optimise this - just add width */
  err=fxstrwidth(fs,0,0,flstyle.data.akern|flags);
// cprintf("fxstrwidth term+off %d fmaxlen %d",fs->term+off,fmaxlen);
  if((fs->term+off)<fmaxlen || fterminated || err) break;

  err=flmore(fv,STEPSIZE);
  if(err) break;
  *fs=tfs;
 }

 return(err);
}




static int findprevc(sourcestr * s,int offset,int len,int t)
{
 char   c;
 int    bits;
 int    slen;
 int    xslen;

 slen=0;
 xslen=-1;

 while(slen<len)
 {
  c=*txptr(s,offset+slen);
  bits=codex[c];
		if(c==t) xslen=slen;
  slen+=bits & CODELEN;
  if(bits & CODETERMINATOR) break;
 }

 return(xslen);
}




static os_error * fxjcheck(font_string * tfs,font_string * fs,
                                             int * lenp,int dx,int ddx)
{
 os_error * err;
 int        llen;
 int        item;



 *fs=*tfs;

//	cprintf("1 fxjcheck fs->x %d fs->term %d llen=%d dx %d ddx %d",fs->x,fs->term,*lenp,dx,ddx);

 while(1)
 {
  err=fxstrwidth(fs,dx,ddx,flstyle.data.akern);
  if(fs->term<fmaxlen || fterminated || err) break;

  flsize+=STEPSIZE;
  err=fxexpand(&flv,FXMORE|FXTABS|FXEOBA|FXNBSP,flsize,NULL);	// FXNBSP is correct because by now NBSPACE's have been mapped out

  *fs=*tfs;
 }


 llen=fequivi(fs->term,&item);

//	cprintf("2 fxjcheck fs->x %d fs->term %d llen=%d",fs->x,fs->term,llen); 
	
	if(tfs->split==SPACE)
 {
  if(*txptr(flv.textsrc.sourcep,flv.textsrc.loffset+llen)==NBSPACE)
  {
// big problem here is to measure the width up to the last space not including it
   llen=findprevc(flv.textsrc.sourcep,flv.textsrc.loffset,llen,' ');
   *fs=*tfs;
//   fs->split=SPACE; must be from if() above
   fs->term=(llen==-1)?fxmaxl:fequivcode(llen);
   fxstrwidth(fs,dx,ddx,flstyle.data.akern);
   llen=fequivi(fs->term,&item);
//			cprintf("3 fxjcheck fs->x %d fs->term %d llen=%d",fs->x,fs->term,llen);
  }
 }

 *lenp=llen;

 return(NULL);
}




static os_error * fxwidth(vector * fv,font_string * fs,int width)
{
 os_error    * err=NULL;
 font_string   tfs;
 font_string   sfs;
 int           spacesize;
 int           spare;
 int           llen;
 int           item;
 int           maxallowed;
 int           maxletterallowed;
 int           step3;
 int           dx;
 int           ddx;
 int           nc;
 int           ns;
 int           font;
 int           xpts;
 int           ypts;

 tfs=*fs;

 while(1)
 {
//  cprintf("fs->term %d fmaxlen %d fterm %d split %d flags %d",fs->term,fmaxlen,fterminated,fs->split,flstyle.data.akern);
//  cprintf("[0]=%d [1]=%d",fbuff[0],fbuff[1]);

  err=fxstrwidth(fs,0,0,flstyle.data.akern);

  if(err) break;
  else
  if(fs->term<fmaxlen)
  {
   if(flstyle.data.justification && flstyle.data.align==JUSTIFY)
   {
    sfs=*fs;

    validfontstyle(&flstyle,&font,&xpts,&ypts);
//    cprintf("xpts %d ypts %d",xpts,ypts);
    fontcharwidth(font,xpts,ypts,' ',&spacesize,NULL);

    /* what is the spare space in the line?   */
    /* is it within max word space - yes quit */

    spare=width-fs->x;
    llen=fequivi(fs->term,&item);
    fxtotals(fv,llen,&ns,&nc);

    if(!ns) break;        /* no spaces, can't do anything */

    maxallowed=((((int)(flstyle.data.justwordmax*JUSTWORDSCALE))-100)*spacesize)/100;

//    cprintf("spare %d maxallowed %d spacesize %d justwordmax %d llen=%d",spare,maxallowed,spacesize,flstyle.data.justwordmax,llen);

    if(spare<(maxallowed*ns)) break;
    maxletterallowed=(flstyle.data.justlettermax*spacesize)/100;
    step3=spare<(maxallowed*ns+maxletterallowed*(nc-ns));

//    cprintf("step 3 %d",step3);

    /* set min word space                */
    /* get width again                   */
    /* calc spare space - get word space */
    /* must be >= min, <max quit         */

    fxmapout(&flv,flsize,NBSPACE,' ');

    dx=((((int)(flstyle.data.justwordmin*JUSTWORDSCALE))-100)*spacesize)/100;

    fxjcheck(&tfs,fs,&llen,dx,0);

//   cprintf("jcheck llen %d ->x=%d",llen,fs->x);

    spare=width-fs->x;
    fxtotals(fv,llen,&ns,&nc);

    spare=spare+dx*ns; 

// assertion - if we set min spacing and get more stuff in then the word space is less than a normal space
// otherwise we would have got this much in with standard space size


//	cprintf("spare %d, dx %d ns %d, newspare %d maxallowed %d *ns %d",width-fs->x,dx,ns,spare,maxallowed,maxallowed*ns);

    if(spare<(maxallowed*ns))
    {
//     cprintf("clause 1");

     fs->x-=ns*dx;
    }
    else
    if(step3) 
    {
//     cprintf("clause 2");

     /* back a step, if we had set max letter space and max word space */
     /* would it have fit? yes -> quit */
     *fs=sfs;
    }
    else
    {
     /* use min word space           */
     /* set min letter space         */
     /* get width again              */
     /* calc letter space < max quit */

     ddx=(flstyle.data.justlettermin*spacesize)/100;

     fxjcheck(&tfs,fs,&llen,dx,ddx);

//     cprintf("check again dx %d ddx %d llen %d spacesize %d letmin %d",dx,ddx,llen,spacesize,flstyle.data.justlettermin);

     spare=width-fs->x;
     fxtotals(fv,llen,&ns,&nc);
     spare=spare+dx*ns+ddx*(nc-ns);

//	 cprintf("orig spare %d new spare %d nc %d ns %d maxallowed %d maxletter %d limit=%d",
//		       width-fs->x,spare,nc,ns,maxallowed,maxletterallowed,(maxallowed*ns+maxletterallowed*(nc-ns)));

     if(spare<(maxallowed*ns+maxletterallowed*(nc-ns)))
     {
//      cprintf("clause 3");

      fs->x-=ns*dx+ddx*(nc-ns);
     }
     else
     {
      *fs=sfs;

//      cprintf("clause 4");
     }
    }

    fxmapout(&flv,flsize,NBSPACE,NBSPACE);

    /* if line width is > max width */
      /* can get line in with min word width -> */
      /* set min word width, and calc letter space */

    /* else */
      /* fits within max word space -> */
      /* max word space, inc letter space */
      /* max letter space, and inc word space */
   }
   break;
  }
  else
  if(fterminated) break;

  err=flmore(fv,STEPSIZE);
  if(err) break;
  *fs=tfs;
 }

 return(err);
}



static os_error * flcalcobjectposns(int llen)
{
 os_error    * err;
 int           c;
 int           bits;
 int           maxoffset;
 int           offset;
 int           xoffset;
 char        * p;
 font_string   fs;


 err=NULL;

 offset=flv.textsrc.loffset;

 maxoffset=offset+llen;

 while(offset<maxoffset)
 {
  p=txptr(flv.textsrc.sourcep,offset);
  c=*p;
  bits=codex[c];

  if(c==EOB)
  {
   fs.s=fbuff;
   fs.x=YLIMIT;
   fs.y=YLIMIT;
   fs.split=-1;
   xoffset=offset-flv.textsrc.loffset;
   fs.term=fequivcode(xoffset);

   flwidth(&flv,&fs,0,0);



   p=txptr(flv.textsrc.sourcep,offset);
   *(p+5)=(char)fs.x;
   *(p+6)=(char)(fs.x>>8);
   *(p+7)=(char)(fs.x>>16);
  }
  offset+=bits & CODELEN;
 }

 return(err);
}


static os_error * flashhp(vector * flv,int hpcount)
{
 /* flashtrash(); */
 /* dprintf(0,"fxhp hpount=%d split len=%d",hpcount,hyphens[hpcount]); */

 return(fxexpand(flv,FXHPEND|(fldobullet?FXBULLET:0),
                              hyphens[hpcount]-1,&flbullet));
}




static int consecmiss(textsrcstr * src,xstylestr * flstyle)
{
 int     n;
 int     voffset;
 int     offset;
 int     len;
 int     slen;
 vlstr * vline;
 int     c;
 int     bits;
 int     hpchar;
	char  * p=NULL;


 if(flstyle->data.hyphenation && (n=flstyle->data.hpconsec)!=0)
 {
  voffset=src->voffset;
  offset=src->loffset;

  while(1)
  {
   voffset-=sizeof(vlstr);
   if(voffset<0) return(0);

   vline=vlptr(src->vsourcep,voffset);
   if(!vline->line.xl)
   {
    if(n--<=0) break;

    len=vline->line.len;
    offset-=len;
    if(offset<0) return(0);

    if(vline->line.eol!=ISHYP)
    {
     if(vline->line.eol==ISTEXT)
     {
      slen=c=0;
      while(slen<len)
      {
       p=txptr(src->sourcep,offset+slen);
							c=*p;
       bits=codex[c];
       slen+=bits & CODELEN;
       if(bits & CODETERMINATOR) break;
      }

						if(c==UNC16) c=(*(p+1))+((*(p+2))<<8);

// asking does this line end with a hyphen? if not return(0)
// new logic 2.77, is to compare end of line to all hyphens, now if end of line is different to all return 0, was different to any (which for more than one is certain)
      hpchar=0;
      while(fxhyphenchar[hpchar])
      {
//       if(c!=fxhyphenchar[hpchar]) return(0);		old
       if(c==fxhyphenchar[hpchar]) break;
       hpchar++;
      }
						if(!fxhyphenchar[hpchar]) return(0);				// new

     }
     else return(0);
    }
   }
  }

  return(1);
 }
 return(0);
}


static os_error * hyphenateline(int * hyp,font_string * fs,int hastabbed,
       int tterm,int ttermx,int width,int * llenp,int * itemp,char ** text)
{
 os_error * err;
 int        hterm;
 int        htermx;
 int        hyphens;
 int        hpcount;
 int        hptype;
 int        hhterm;
 int        hhtermx;
 int        llen;
 int        curx;
 int        zonemiss;
 int        hpchar;

 err=NULL;

// cprintf("hyphenate line in ");

 *hyp=0;
 llen=*llenp;

 if(flstyle.data.wordwrap)
 {
  /* possibility of hyphenation */

  if(!fs->term && !(fterminated && fmaxlen<=1))
  {
   if(hastabbed)
   {
    llen=fequivi(tterm,itemp);
   }
  }

  if(hastabbed) curx=ttermx;
  else          curx=fs->x;


  hptype=hyphenate(&flv.textsrc,llen,&hyphens,&flstyle,fxhyphenchar);
  cprintf("hptype %d",hptype);

  if(hptype)
  {
   zonemiss=(hptype!=HPHARDTYPE) &&
            (flstyle.data.align==ISLEFT) &&
            flstyle.data.hyphenation    &&
            flstyle.data.hpzone         &&
            ((width-curx)<flstyle.data.hpzone);
   if(!zonemiss && !consecmiss(&flv.textsrc,&flstyle))
   {
    if(!fs->term && !(fterminated && fmaxlen<=1))
    {
     if(hastabbed)
     {
      fs->term=tterm;
      fs->x=ttermx;
     }
    }

    hterm=fs->term;
    htermx=fs->x;


    if(hptype==HPHARDTYPE)
    {
     /* handle hard hyphens */

     hpchar=0;
     hhterm=fmaxlen;

//     cprintf("hp lp1 in");
//     int loopcount=0;

     while(1)
     {
      cprintf("hpchar %d",hpchar);

      fs->split=fxhyphenchar[hpchar];				// go out before changing fs->x etc.
						if(!fs->split) break;

      fs->s=fbuff;
      fs->x=width;
      fs->y=YLIMIT;
      fs->term=hhterm;

//!!      fxstrwidth(fs,0,0,flstyle.data.akern);

      //      flwidth(&flv,fs,0,0);

      fxwidth(&flv,fs,width);


      if(fs->term>hterm)		// looking for 1 of 3 hyphens here, since in general all three may be in hyphenation zone, could optimise on best fit
      {            /* hit a '-' somewhere */

//#ifdef NEVER  
       hhterm=fs->term;
       hhtermx=fs->x;

       cprintf("hhterm %d hhtermx %d",hhterm,hhtermx);

       fs->s=fbuff;
       fs->x=width;
       fs->y=YLIMIT;
       fs->term=hhterm+((fxuni)?2:1);
       fs->split=-1;

       fxstrwidth(fs,0,0,flstyle.data.akern);

        cprintf("fs term %d fstermx %d width %d",fs->term,fs->x,width);

       llen=fequivi(fs->term,itemp);
       *text=txptr(flv.textsrc.sourcep,flv.textsrc.loffset+llen);
       break;
//#endif
       
#ifdef NEVER       
       
       hhterm=fs->term;
       hhtermx=fs->x;
 
       fs->s=fbuff+fs->term;
       fs->x=width-fs->x;
       fs->y=YLIMIT;

       fs->term=(fxuni)?2:1;
       fs->split=-1;

       cprintf("hp limit %d term %d",fs->x,fs->term);

       fxstrwidth(fs,0,0,flstyle.data.akern);

							cprintf("hp term %d x %d",fs->term,fs->x);

// the logic here is wrong, the split char hyphen does fit in the space for the line
// split chars always do fit in
// so we will never backtrack
// 29/10/2007 - example of backtracking discovered...
// presume due to inter char kerning

       if(fs->term)
       {
        fs->term=hhterm+((fxuni)?2:1);
        fs->x=hhtermx+fs->x;
        llen=fequivi(fs->term,itemp);
        *text=txptr(flv.textsrc.sourcep,flv.textsrc.loffset+llen);
        break;
       }
       else
       {        /* backtrack */
        hhterm-=(fxuni)?2:1; 
								cprintf("hp back track hhterm %d",hhterm);

       }
#endif


      }
      else
      {
       fs->term=hterm;
       fs->x=htermx;
       hhterm=fmaxlen;
       hpchar++;
      }

//    loopcount++;
//    if(loopcount>5) while(1);
     }

//     cprintf("hp lp1 ex");
    }
    else
    if(hyphens)
    {
     hpcount=hyphens-1;

//     cprintf("hp lp2 in");

     while(1)
     {
      flashhp(&flv,hpcount);
       
      fs->s=fbuff;
      fs->x=width; /* axw-axxs; */
      fs->y=YLIMIT;
      fs->term=fmaxlen;
      fs->split=-1;

      fxstrwidth(fs,0,0,flstyle.data.akern);
//      flwidth(&flv,fs,0,0);

//      fxwidth(&flv,fs,width);

      if(fs->term==fmaxlen) /* hit a new hyphen */
      {
       llen=fequivi(fs->term,itemp);

       *hyp=1;
       if(hptype==HPDCTYPE) llen++;         /* means hit a dc hyphen */
       *text=txptr(flv.textsrc.sourcep,flv.textsrc.loffset+llen);
       break;
      }

      if(!hpcount)
      {
       fs->term=hterm;
       fs->x=htermx;
       break;
      }

      hpcount--;
     }

//     cprintf("hp lp1 ex");
    }
   }
  }
 }

 *llenp=llen;

//  cprintf("hyphenate line ex ");


 return(err);
}



#ifdef NEVER

     if(0 && *text==EOB)
     {
      ewidth=(*(text+18))+((*(text+19))<<8)+((*(text+20))<<16);

      dprintf(0,"x=%d ew=%d w=%d",fs.x,ewidth,width);

      if((fs.x+ewidth)<width)
      {
       llen+=EOBLEN;
       item++;
       text=txptr(flv.textsrc.sourcep,flv.textsrc.loffset+llen);
       fs.term=1;  /* !!! fix to get past next clause */
       fs.x=fs.x+ewidth;

       dprintf(0,"x=%d item=%d llen=%d",fs.x,item,llen);
      }
     }

#endif









static int ecode;                    /* code at end of current vline */


static os_error * formatlines(flowstr * op,vlstr * line,int width,int xposn)
{
 os_error  * err=NULL;
 font_string fs;
 int         llen=0; /* compiler */
 char *      text;
 int         tabtype=0;
 int         tabposn=0;
 int         shift;
 int         oldterm=0;
 int         oldtermx=0;
 int         dlen;
 int         xlen;
 int         item;
 int         goodtab;
 int         hastabbed=0;
 int         tterm=0;
 int         ttermx=0;
 int         hyp;
// font_state  fxx;


 ecode=-1;

 memset(line,0,sizeof(vlstr));

 if(fldodrop)
 {
//  cprintf("droplen %d",fldroplen);

  err=fxexpand(&flv,FXDROP|((firstline?firstbaselinemode:0)<<FXBLSHIFT),
               fldroplen,NULL);
  fs.s=fbuff;
  fs.x=width;

  if(fs.x<0) op->result=NOFIT;
  else
  {
   fs.y=YLIMIT;
   fs.term=fxmaxl;
   fs.split=-1;

   err=fxstrwidth(&fs,0,0,flstyle.data.akern|FXSBBOX);

   if(!fs.term) op->result=NOFIT;
   else
   {
    line->line.len=fldroplen;
    if(fs.x>=0) line->line.w=fs.x;
    else        line->line.w=0;
    SETMAXW(line,line->line.w);
    line->line.eol=ISDROP;
   }
  }

  return(err);
 }


 flsize=INITSIZE;
 err=fxexpand(&flv,FXTABS|FXEOBA|(fldobullet?FXBULLET:0),flsize,&flbullet); /* stopping on tabs */


 if(!err)
 {
  while(1)
  {
   fs.s=fbuff;
   fs.x=width;
   if(fs.x<0)
   {
    op->result=NOFIT;
    break;
   }

   fs.y=YLIMIT;
   fs.term=fxmaxl;

//   cprintf("formatlines fxmaxl=%d",fxmaxl);


   if(flstyle.data.wordwrap)  fs.split=SPACE;
   else                       fs.split=-1;


   fxwidth(&flv,&fs,width);

   if(hastabbed && fs.term<tterm)  /* situation of SPACE TAB no room */
   {
    fs.term=tterm;
    fs.x=ttermx;
   }


   llen=fequivi(fs.term,&item);

//			cprintf("llen %d item %d fs.term %d",llen,item,fs.term);

   if(llen>=0) 
   {
    text=txptr(flv.textsrc.sourcep,flv.textsrc.loffset+llen);
    xlen=llen;
   }
   else
   {
    text=NULL;
    xlen=0;
   }

   goodtab=0;

//  cprintf("llen=%d term=%d item=%d code=%d ",llen,fs.term,item,*text);
// cprintf("llen=%d term=%d item=%d fmax=%d ",llen,fs.term,item,fmaxlen);

   if((llen<0 && fxbullettab) || (text && *text==TABSEQ) && !fbuff[fs.term]) 
   {
    oldterm=fs.term;
    oldtermx=fs.x;

    findtab(fs.x+xposn,&tabtype,&tabposn,newpara);
    tabposn-=xposn;

    fbuff[fs.term]=FXHM;
    fbuff[fs.term+1]=0;

    if(!hastabbed || tabposn<=width) goodtab=1; /* was < */
   }

   if((llen<0 && fxbullettab) && !goodtab)
   {
    op->result=NOFIT;
    break;
   }


 /* dprintf(0,"good=%d ttype=%d tabposn=%d",goodtab,tabtype,tabposn); */

   if(goodtab)
   {
    if(tabposn>width) shift=width-fs.x;
    else
    {
     shift=tabposn-fs.x;

     if(tabtype!=TLEFT) 
     {
      fs.s=fbuff+fs.term+FXHMLEN;

//      font_future(&fxx);

      if((fs.term+FXHMLEN)>=fmaxlen && !fterminated) flmore(&flv,STEPSIZE);	// added to prevent going past end of text source

      fs.x=shift;
      fs.y=YLIMIT;


      if(flstyle.data.wordwrap) fs.split=SPACE;
      else                      fs.split=-1;


      fs.term=fxmaxl;


      switch(tabtype)
      {
       case TRIGHT: /* right tab   */
                     flwidth(&flv,&fs,fs.s-fbuff,FXSFFONT); //|(fxx.f<<16));
                     shift=shift-fs.x;
                     break;

       case   TDEC: /* decimal tab */
                     dlen=finddot(flv.textsrc.sourcep,
                                  flv.textsrc.loffset+xlen+TSLEN,fxmaxl-xlen);
                     if(dlen<0) 
                     {
                      /* shift=0; */
                      flwidth(&flv,&fs,fs.s-fbuff,FXSFFONT); //|(fxx.f<<16));
                      shift=shift-fs.x;
                     }
                     else
                     {
                      dlen+=xlen+TSLEN;
                      if(dlen>flsize) flmore(&flv,dlen-flsize);

                      fs.split=-1;
                      fs.term=fequivcode(dlen)-fequivcode(xlen+TSLEN);
                      flwidth(&flv,&fs,fs.s-fbuff,FXSFFONT); //|(fxx.f<<16));
                      shift=shift-fs.x;
                     }
                     break;

      case TCENTRE: /* centre tab  */

                     fs.x=shift<<1;
                     flwidth(&flv,&fs,fs.s-fbuff,FXSFFONT); //|(fxx.f<<16));
                     shift=shift-(fs.x>>1);
                     break;
      }
     }
    }


    if(shift<0) shift=0;
    fbuff[oldterm+2]=(char)shift;
    fbuff[oldterm+3]=(char)(shift>>8);
    fbuff[oldterm+4]=(char)(shift>>16);
    fbuff[oldterm+5]=0;

    if(llen>=0)
    {
     *(text+1)=(char)shift;
     *(text+2)=(char)(shift>>8);
     *(text+3)=(char)(shift>>16);
    }
    else
    {
     flbullet.tabshift=shift;
    }

    hastabbed=1;
    tterm=oldterm+FXHMLEN;
    ttermx=oldtermx+shift;  /* fs.x */
   }
   else 
   {
    /* if we get here, we know that we've finished */

    /* first have a go at hyphenation */



    hyphenateline(&hyp,&fs,hastabbed,tterm,ttermx,width,&llen,&item,&text);


    /* if hyphenation attempted fbuff now corrupt */
    /* but whatever is going to fit, will be less */
    /* than the hyphen position                   */

    /* attempted hyphenation - now sort things out */

    /* dprintf(3,"fs.term=%d fterminated=%d fmaxlen=%d",
              fs.term,fterminated,fmaxlen);  */



    if(!fs.term && flstyle.data.wordwrap && !(fterminated && fmaxlen<=1))
    {
     if(!hastabbed)
     {
      fs.s=fbuff;
      fs.x=width;
      fs.y=YLIMIT;
      fs.term=fxmaxl;
      fs.split=-1;
      flwidth(&flv,&fs,0,0);
     }
     else
     {
      fs.term=tterm;
      fs.x=ttermx;
     }


     llen=fequivi(fs.term,&item);
     text=txptr(flv.textsrc.sourcep,flv.textsrc.loffset+llen);


    }

    if(!fs.term && !(fterminated && fmaxlen<=1))
    {
     op->result=NOFIT;
     break;
    }

    switch(ecode=*text)
    {
     case SPACE:
                   line->line.eol=ISSPACE;
                   dlen=striplen(flv.textsrc.sourcep,llen,flv.textsrc.loffset);

                   if(dlen<llen)
                   {
                    fs.s=fbuff;
                    fs.x=2*width;
                    fs.y=YLIMIT;
                    fs.term=fequivcode(dlen);
                    fs.split=-1;
                    flwidth(&flv,&fs,0,0);
                   }

                   while(*txptr(flv.textsrc.sourcep,flv.textsrc.loffset+llen)
                                                              ==SPACE) llen++; 
                   break;


       case     NL:
       case  EOBOX:
       case EOPAGE:
                   line->line.eol=ISNL;
                   llen++;
                   break;

       case     CR:
       case    EOT:
                   line->line.eol=ISBREAK;
                   llen++;
                   break;

           default:
                   while(item)
                   {
                    text=txptr(flv.textsrc.sourcep,flv.textsrc.loffset+
                                                              fitem(item-1));
                    if(*text==SNO) {item--;llen-=SNLEN;}
                    else           break;
                   }
                   ecode=*text;
                   line->line.eol=ISTEXT;
                   break;
    }

    if(llen<=0)
    {
     op->result=NOFIT;
     break;
    }

    if(hyp)  line->line.eol=ISHYP; /* this is probably more useful elsewhere */

    break; /* escape from the tab loop */
   }     
  }        /* while() loop */


  if(!op->result)
  {
   line->line.len=llen;
   if(fs.x>=0) line->line.w=fs.x;
   else        line->line.w=0;
   SETMAXW(line,width);

   if(fxfirsteob>=0 && fxfirsteob<llen) flcalcobjectposns(llen);
  }
 }


 return(err);
}




static os_error * formatline(flowstr * op,vlstr * nline,
                                vlstr * oline,int width,int xposn,int * eq)
{
 os_error  * err;
 int         maxwidth;
 int         hasfont;
 font_string fs;

 err=NULL;

 *eq=0;


 if(oline && !fldodrop)   /* forcing fxexpand for drop caps */
 {
  maxwidth=MAXW(oline);   /* below not correct for hp zone... */
  if(width==maxwidth)
  {
   *nline=*oline;
   *eq=2;
  }
  else 
  if(width<maxwidth && width>=(int)oline->line.w)
  {
   *nline=*oline;
   SETMAXW(nline,width);
   *eq=1;
  }
  else err=formatlines(op,nline,width,xposn);
 }
 else err=formatlines(op,nline,width,xposn);

 cfstyle=flv.astyle;

 /* dprintf(0,"cfstyle=%d",cfstyle); */

 /* hasfont = font|objects */

 /* eob angles in force */

 fontstate(&flv,flv.textsrc.loffset,nline->line.len,
                                       &cfstyle,&hasfont,fldodrop,&ecode);

 if(firstline && firstbaselinemode==FBLFIT && !fldodrop)
 {
  fs.s=fbuff;
  fs.x=width;
  fs.y=YLIMIT;
  fs.term=fmaxlen;
  fs.split=-1;

  if((*eq)!=0)
  {
   err=fxexpand(&flv,FXEOBA|(fldobullet?FXBULLET:0),nline->line.len,&flbullet);
  }

  err=fxstrwidth(&fs,0,0,flstyle.data.akern|FXSBBOX);

  fmaxas=fxfmaxld;
 }

 if(fldodrop)   /* only valid if fxsmaxht is set up */
 {
//  cprintf("fmaxht %d fxdropdiff %d",fxsmaxht,fxdropdiff);
  fmaxht=fxsmaxht-fxdropdiff;
 }



 nline->line.font=hasfont & 0x1;
 nline->line.object=((hasfont & 0x2)!=0);

 nline->line.style=flv.astyle;
 nline->line.h=fmaxht;


 if(flstyle.data.align==JUSTIFY)
 {
  if((nline->line.eol==ISNL) || (nline->line.eol==ISBREAK))
  {
			cprintf("styledata.just %d delta w %d flushzone %d",flstyle.data.justification, 
      (MAXW(nline)-nline->line.w),flstyle.data.justflushzone);

   if(flstyle.data.justification && 
      (((int)MAXW(nline))-((int)nline->line.w))<(int)flstyle.data.justflushzone)
			{
    nline->line.just=ISJUST;
//				cprintf("align 0 JUST");
			}
   else
			{
//						cprintf("align 1 LEFT");
				nline->line.just=ISLEFT;
			}
  }
  else
		{
//					cprintf("align 2 JUST");
			nline->line.just=ISJUST;
		}
 }
 else
	{
//		cprintf("align 3 %d",flstyle.data.align);
  nline->line.just=flstyle.data.align;
	}

 return(err);
}

/*****************************************************************************/

/* used to see if there is another line - return 1 and get it */
/*
static int getnextline(vlstr * fline)
{
 if(flv.textsrc.voffset<flv.textsrc.vsourcep->len)
 {
  if(flv.textsrc.voffset<(flv.bvoffset+
                              flv.textsrc.textp->sub[flv.textsrc.s].vlines))
  {
   getvline(fline,flv.textsrc.vsourcep,flv.textsrc.voffset);
   return(1);
  }
 }
 return(0);
}
*/

static int getnextstrip(vstripstr * strip)
{
 int      n;
 int      len;
 int      vdelta;
 texsub * texup;
 int      seenstrip;


 strip->bullet=0;
 n=0;
 len=0;
 vdelta=0;
 seenstrip=0;

              /* has to be like this to work between vboxes */
 if(flv.textsrc.voffset<flv.textsrc.vsourcep->len) 
/* while((flv.textsrc.voffset+vdelta)<flv.textsrc.vsourcep->len) */
 {
  while(1) 
  {
   texup=(texsub*)(((char*)flv.textsrc.textp)+flv.textsrc.usize);
   if((flv.textsrc.voffset+vdelta)>=(cvoffset+
                                      texup[flv.textsrc.s].vlines)) break;

   getvline(&strip->vline[n],flv.textsrc.vsourcep,flv.textsrc.voffset+vdelta);
   if(!strip->vline[n].line.xl)
   {
    if(seenstrip) break;
    len+=strip->vline[n].line.len;
    n++;
    seenstrip=(strip->vline[n-1].line.strip);
   }
   else
   if(strip->vline[n].ext.type==VLBULLET)
   {
    n++;
    strip->bullet=1;
    if(seenstrip) break;
   }

   vdelta+=sizeof(vlstr);
  }
 }

 strip->nl=n;
 strip->len=len;

 /* ecode and other fields are not set */

 return(n);
}


/*
static void stepline(vlstr * line)
{
 flv.textsrc.voffset+=sizeof(vlstr);
 flv.textsrc.loffset+=line->len;
}
*/


static void stepstrip(vstripstr * strip)
{
 flv.textsrc.voffset+=sizeof(vlstr)*strip->nl;
 flv.textsrc.loffset+=strip->len;
}




static os_error * checkvectors(flowstr * op,vstripstr * strip)
{
 os_error * err;
 int        i;
 int        roff;
 int        j;
 int        loffset;
 int        voffset;
 int        lstyle;

 err=NULL;

 for(i=0;i<2;i++)
 {
  if(flextent & flmask[i])
  {
   roff=op->roff[i];

   if(roff>=flv.textsrc.loffset && roff<(flv.textsrc.loffset+strip->len))
   {
    loffset=flv.textsrc.loffset;
    lstyle=flv.astyle;
    voffset=flv.textsrc.voffset;
    flv.textsrc.offset=roff;

    for(j=0;j<strip->nl;j++)
    {
     if(!strip->vline[j].line.xl)
     {
      if(roff>=flv.textsrc.loffset && 
         roff<(int)(flv.textsrc.loffset+strip->vline[j].line.len))
      {
       flv.astyle=vvlptr(&flv)->line.style;

      /* dprintf(2,"set vstyle %d",flv.astyle); */
       err=vsetxy(&flv);
       break;
      }
      else
      {
       flv.textsrc.loffset+=strip->vline[j].line.len;
      }
     }
     flv.textsrc.voffset+=sizeof(vlstr);
    }

    flv.valid=VVECTOR;
    *op->resultv[i]=flv;

    flv.textsrc.loffset=loffset;
    flv.astyle=lstyle;
    flv.textsrc.voffset=voffset;

    flextent&=~flmask[i];
   }
   else
   if(roff<flv.textsrc.loffset)
   {
    flextent&=~flmask[i];
   }
  }
 }
 return(err);
}




/* one test of this is dnd copy backwards  */
/* so that the flow does not reach zone    */

// we accept that vloffset may be left pointing at the len of the vlstr buffer
// means this vectors position is beyond the end of the vlines


static os_error * cleanupvectors(flowstr * op)
{
 os_error * err;
 int        i;

 err=NULL;

// cprintf("flv voffset %d vlen %d",flv.textsrc.voffset,flv.textsrc.vsourcep->len);


 for(i=0;i<2;i++)
 {
  if(flextent & flmask[i])
  {
   *op->resultv[i]=flv;

   err=txlock(&op->resultv[i]->textsrc,flv.file);
   if(!err)
   {
    resetpoint(op->resultv[i],op->roff[i]);
    if(op->resultv[i]->valid & VALIDPOSN) err=vsetxy(op->resultv[i]);
    txunlock(&op->resultv[i]->textsrc,flv.file);
   }
  }
 }

 return(err);
}



/*****************************************************************************/

#define FLNOGOOD     0x0
#define FLGOODDROP   0x1
#define FLGOODBULLET 0x2


static int flgooddrop(int * size)
{
 int    offset;
 int    c;
 char * p;
 int    bits;
 int    type;

 offset=flv.textsrc.loffset;

 while(1)
 {
  p=txptr(flv.textsrc.sourcep,offset);
  c=*p;
  bits=codex[c];
  offset+=(bits & CODELEN);

  if(c!=SNO)
  {
   type=bits & CODETYPE;

   if(type==CODEALPHA || type==CODEDIGIT || type==CODESYMBOL) 
   {
    *size=offset-flv.textsrc.loffset;
    return(FLGOODDROP);
   }
   else
   if(c==NL || c==EOBOX || c==EOPAGE) return(FLNOGOOD);
   else                               return(FLGOODBULLET);
  }
 }
 return(FLNOGOOD);
}


static os_error * getrectangles(int ylo,int yhi,int * nboxes,boxstr ** boxesp)
{
 os_error * err;
 int        leftvboxk;
 int        vboxk;
 textvbox * cvbox;
 curvestr * curvep;
 curvestr   ccurve;
 int        nc;
 int        nb;
 int        lnb;
 boxstr *   boxes;
 boxstr *   lboxes;
 boxstr *   temp;
 int        i;
 int        firsttime;
 int        ymin;
 int        ymax;
 int        xmin;
 int        xmax;


 err=NULL;

 boxes=xbox;
 lboxes=ybox;
 nb=0;
 lnb=0; /* compiler */
 firsttime=1;

 leftvboxk=fvboxhk;

/* dprintf(0,"leftvbpx=%d",leftvboxk); */

 while(1)
 {
  cvbox=(textvbox*)fob_find(leftvboxk,flv.file);
  curvep=cvbox->curve;
  if((curvep->box.y+curvep->box.h)>=ylo) break;
  leftvboxk=cvbox->down;
  if(!leftvboxk) break;
 }


/* dprintf(5,"leftvbpx=%d x=%d y=%d",leftvboxk,curvep->box.x,curvep->box.y); */



 if(leftvboxk)
 {
  nc=0;
  vboxk=leftvboxk;
  while(1)
  {
   cvbox=(textvbox*)fob_find(vboxk,flv.file);
   nc=MAX(nc,cvbox->nc);
//   dprintf(0,"nc %d",nc);
   vboxk=cvbox->down;
   if(!vboxk) break;
   for(i=0;i<cvbox->nc;i++)
   {
    if((cvbox->curve[i].box.y+cvbox->curve[i].box.h)>=yhi) break;
   }
   if(i<cvbox->nc) break;
  }

  err=schunk((flex_ptr)&xbox,nc*sizeof(boxstr),sizeof(boxstr)*DEFLTSTRIPSIZE);
  err=schunk((flex_ptr)&ybox,nc*sizeof(boxstr),sizeof(boxstr)*DEFLTSTRIPSIZE);
  boxes=xbox;
  lboxes=ybox;

  while(1)
  {
   vboxk=leftvboxk;
   nc=0;

   while(1)
   {
    cvbox=(textvbox*)fob_find(leftvboxk,flv.file);
    if(nc>=cvbox->nc) break;
    ccurve=cvbox->curve[nc];

/* dprintf(0,"ccurve box ylo=%d yhi=%d y=%d y+h=%d",
                          ylo,yhi,ccurve.box.y,ccurve.box.y+ccurve.box.h);  */

    curvebox(flv.file,&ccurve,ylo,yhi);

    if(ccurve.box.w>=0)
    {
     if(firsttime)
     {
      boxes[nb++]=ccurve.box;

     }
     else   /* merge this box with any on the previous row */
     {
      for(i=0;i<lnb;i++)
      {
       ymin=lboxes[i].y;
       ymax=ymin+lboxes[i].h;
       xmin=lboxes[i].x;
       xmax=xmin+lboxes[i].w;

       if(ymax==ccurve.box.y)
       {
        xmin=MAX(xmin,ccurve.box.x);
        xmax=MIN(xmax,(ccurve.box.x+ccurve.box.w));

        if(xmin<=xmax)
        {
         boxes[nb].y=ymin;
         boxes[nb].h=lboxes[i].h+ccurve.box.h;

         boxes[nb].x=xmin;
         boxes[nb++].w=xmax-xmin;
        }
       }
      }
     }
    }

    nc++;
   }

   if((ccurve.box.y+ccurve.box.h)>=yhi) break;
   leftvboxk=cvbox->down;
   if(!leftvboxk) break;

   temp=lboxes;
   lboxes=boxes;
   boxes=temp;
   lnb=nb;
   nb=0;
   firsttime=0;
  }
 }

 nc=0;
 for(i=0;i<nb;i++)
 {
  ymin=boxes[i].y;
  ymax=ymin+boxes[i].h;

  if(ymin<=ylo && ymax>=yhi)
  {
   if(i!=nc) boxes[nc]=boxes[i];
   nc++;
  }
 }

 *nboxes=nc;
 *boxesp=boxes;

 return(err);
}



/*****************************************************************************/

/*

  (1) work out the maxy and miny values for line of text 
  (2) project out a series of rectangles 

  (3) fill rectangles
  (4) work out maxy and miny values for line of text
  (5) project series of rectangles
  (6) goto 3

  (7) remember which set of rectangles gets most text in

  if the rectangles are of zero width - then need to move down
  if the rectangles are not high enough - skip down one vbox chain 

 */



static os_error * flowvstrip(flowstr * op,vstripstr ** rstrip,
                                          vstripstr * ostrip,int * eqp)
{
 os_error  * err;
 int         liney;
 int         ylo;
 int         yhi;
 int         cmaxpt;
 int         cmaxld;
 int         cmaxht;
 int         cmaxas;
 int         i;
 vstripstr * nstrip;
 vstripstr * lstrip;
 int         s;
 int         leftoffset;
 int         lstyle;
 int         nboxes;
 int         maxboxes;
 boxstr    * boxes;
 int         eq;
 int         ns;
 int         equal=0;
 vlstr       nline;
 vlstr     * olinep;
 int         w;
 int         xlo;
 int         xhi;
 int         temp;
 int         ix0;
 int         ix1;
 int         cxleft;


 leftoffset=flv.textsrc.loffset;
 lstyle=flv.astyle;



 err=NULL;


 s=0;
 nstrip=cstrip[s];
 lstrip=NULL;
 nstrip->len=0;
 nstrip->nl=0;
 nstrip->font=0;
 nstrip->object=0;
 maxboxes=0;

// cprintf("flowvstrip drop %d",fldodrop);


 firstfont(&flv,0 /*fldodrop */);
 cmaxld=fmaxld;
 cmaxas=fmaxas;
 cmaxht=fmaxht;
 cmaxpt=fmaxpt;


 if(firstline && firstbaselinemode==FBLFIT)
 {
  cmaxas=fmaxas/8;
  cmaxld=fmaxld/8;
 }


 while(1)
 {
//  cprintf("while loop");

  if(firstline)
  {
   if(firstbaselinemode==FBLASCENDER || firstbaselinemode==FBLFIT)
   {
    if(fldodrop && firstbaselinemode==FBLFIT) liney=axy+fxdropdiff;
    else                                      liney=axy-cmaxld+cmaxas;

   }
   else
   {
    if(cmaxpt>cmaxld) liney=axy+cmaxpt-cmaxld;
    else              liney=axy;
   }

 /*  dprintf(2,"maxld %d maxas %d liney=%d",cmaxld,cmaxas,liney); */
  }
  else
  {
   if(leadabs)
   {
    liney=axy+absshift-cmaxld;
    if(liney<ccurve.box.y) liney=ccurve.box.y;
   }
   else
   {
    if(cmaxpt>cmaxld) liney=axy+cmaxpt-cmaxld;
    else              liney=axy;
   }
  }

/* dprintf(2,"liney=%d axy=%d ccurve.box.y=%d",liney,axy,ccurve.box.y); */

  /* baseline at liney+cmaxld */

  if(xbaselock || (firstline && canbaselock && firstbaselinemode==FBLGRID))
  {
   ylo=liney+cmaxld+xboxy;
   ylo=ylo-fxbaseorigin;
   if(fxbasespacing)
   {
    ylo=(ylo+fxbasespacing-1)/fxbasespacing;
    ylo*=fxbasespacing;
   }
   ylo=ylo+fxbaseorigin;
   liney=ylo-(cmaxld+xboxy);
  }

  if(firstline &&(firstbaselinemode==FBLASCENDER || firstbaselinemode==FBLFIT))
  {
   if(fldodrop && firstbaselinemode==FBLFIT) ylo=liney-fxdropdiff;
   else                                      ylo=liney+cmaxld-cmaxas;

   yhi=liney+cmaxht;
  }
  else
  {
   ylo=liney;
   yhi=ylo+cmaxht;
  }

//  cprintf("maxld %d maxas %d maxht %d ylo=%d yhi=%d",cmaxld,cmaxas,cmaxht,ylo,yhi);


  getrectangles(ylo,yhi,&nboxes,&boxes);
  maxboxes=MAX(nboxes,maxboxes);


 /* dprintf(0,"getrectangles ylo=%d yhi=%d nboxes=%d",
                           ylo,yhi,nboxes);  */


  ns=0;
  if(ostrip) equal=1;
  else       equal=0;


  if(xlefttype==INDENTDELTA)   cxleft=boxes[0].x;
  else                         cxleft=xboxleftmargin;



  ix0=cxleft+(newpara?xfirst:xleft);

  if(xrighttype==INDENTDELTA)  ix1=boxes[nboxes-1].x+boxes[nboxes-1].w-xright;
  else
  if(xrighttype==INDENTOFFSET) ix1=xboxleftmargin+xright; /* ix0+xright; */
  else                         ix1=xboxleftmargin+xboxwidth-xright;


  for(i=0;i<nboxes;i++)
  {
//   cprintf("i %d nboxes %d",i,nboxes);


   xlo=boxes[i].x;
   xhi=xlo+boxes[i].w;

   temp=ix0;
   if(fldropzone && temp<fldropzonex) temp=fldropzonex;

   if(xlo<temp) xlo=temp;
   if(xlo<0)    xlo=0;

   if(xhi>ix1)  xhi=ix1;
   w=xhi-xlo;


   if(fldobullet && ns==0)
   {
    if(equal)
    {
     if(ostrip->nl>1) 
     {
      olinep=&ostrip->vline[1];
      if(olinep->line.xl && olinep->ext.type==VLBULLET)
      {
       equal=cmpbulletlinedata(olinep,&flbullet); /* setting tab posn */
      }
      else equal=0;
     }
     else equal=0;
    }
   }

   if(equal && ns<ostrip->nl) 
   {
    olinep=&ostrip->vline[ns];
    formatline(op,&nline,olinep,w,xlo-cxleft,&eq);
    equal=0;
    if(eq)
    {
     if((int)olinep->line.style==flv.astyle &&
        (int)olinep->line.x==xlo &&  
        LY(olinep->line.yy)==liney &&
        (flstyle.data.align==ISLEFT || eq==2)) equal=eq;
    }
   }
   else
   {
    formatline(op,&nline,NULL,w,xlo-cxleft,&eq);
    equal=0;
   }

//   cprintf("result %d w %d",op->result,w);

//   cprintf("maxpt %d %d ld %d %d ht %d %d as %d %d",fmaxpt,cmaxpt,fmaxld,cmaxld,fmaxht,cmaxht,fmaxas,cmaxas);


   if(op->result==NOFIT)
   {
    /* if fails to fit box, skip it */
//    cprintf("no fit");
    op->result=0;
   }
   else
   if(fmaxpt>cmaxpt || fmaxld>cmaxld || fmaxht>cmaxht || fmaxas>cmaxas)
   {                                                     /* another attempt */
//    cprintf("another attempt");
    nstrip->maxld=cmaxld;
    nstrip->maxas=cmaxas;
    nstrip->maxht=cmaxht;
    nstrip->maxpt=cmaxpt;
    nstrip->liney=liney;

    cmaxld=MAX(cmaxld,fmaxld);
    cmaxas=MAX(cmaxas,fmaxas);
    cmaxht=MAX(cmaxht,fmaxht);
    cmaxpt=MAX(cmaxpt,fmaxpt);

    if((!lstrip) || (lstrip->len<nstrip->len))
    {
     s^=1;
     lstrip=nstrip;
     nstrip=cstrip[s];
     nstrip->len=0;
     nstrip->nl=0;
     nstrip->font=0;
     nstrip->object=0;
    }

    flv.textsrc.loffset=leftoffset;
    flv.astyle=lstyle;

    break;
   }
   else
   {
    if(fldodrop)
    {
     cmaxld=fmaxld;
     cmaxas=fmaxas;
     cmaxht=fmaxht;
     cmaxpt=fmaxpt;
    }

    flv.textsrc.loffset+=nline.line.len;
    flv.astyle=cfstyle;

    /* baseline at liney+cmaxld */
    /* line leading is fmaxld   */
    /* coping with the first line in a strip having big point size */
    /* and second not doing */

    nline.line.yy=liney+cmaxld-fmaxld;
//    cprintf("yy=%x liney=%x cmaxld=%x fmaxld=%x",nline.line.yy,liney,cmaxld,fmaxld);

    nline.line.x=xlo;

    nstrip->vline[ns]=nline;
    nstrip->len+=nline.line.len;
    ns++;
    nstrip->nl=ns;
    nstrip->cfstyle=cfstyle;
    if(nline.line.font)   nstrip->font=1;
    if(nline.line.object) nstrip->object=1;

    nstrip->ecode=ecode;

    if(fldobullet && ns==1)
    {
     nstrip->bullet=1;
     packbulletdata(&nstrip->vline[ns],&flbullet);
     ns++;
     nstrip->nl=ns;
    }

    if(nline.line.eol==ISNL || nline.line.eol==ISBREAK 
                            || nline.line.eol==ISDROP)
    {
     i=nboxes;
     break;
    }
   }
  }

  if(i>=nboxes) 
  {
   /* look at all the attempts - pick the best one */

   if(lstrip && (lstrip->len>nstrip->len)) 
   {
    nstrip=lstrip;
   }
   else
   {
    nstrip->maxld=cmaxld;
    nstrip->maxas=cmaxas;
    nstrip->maxht=cmaxht;
    nstrip->maxpt=cmaxpt;
    nstrip->liney=liney;
   }

   *rstrip=nstrip;
   ns=nstrip->nl;
   if(ns) 
   {
    if(nstrip->bullet && ns==2) nstrip->vline[0].line.strip=1;
    else                        nstrip->vline[ns-1].line.strip=1;
    break;
   }
   else
   {
    /*     there are 2 reasons to be here                  */
    /* (a) rectangles are not high enough - return MOVEOUT */
    /* (b) rectangles are too narrow - step axy down a bit and repeat */
    /* (c) worry about axy being smaller than top of strip  */

  /* dprintf(0,"fail nbox=%d",nboxes); */

    if(nboxes) /* maxboxes) */
    {
     axy+=cmaxht;        /* go round again */
//     cprintf("go round again axy %d cmaxht %d",axy,cmaxht);
    }
    else
    {
//     cprintf("moveout 1");
     op->result=MOVEOUT;
     firstline=1;
     break;
    }
   }
  }
 }

 flv.textsrc.loffset=leftoffset;
 flv.astyle=lstyle;
 *eqp=equal;

 if(/*!equal &&*/ !op->result && nstrip->object)
 {             /* sort out coords of any embedded objects */
  if(!curvalign) formateob(nstrip);
 }

/* dprintf(6,"fvstrip result %d",op->result); */

 return(err);
}


/*****************************************************************************/


/*
static int stripheight(vstripstr * strip)
{
 int height;
 int i;

 height=strip->vline[0].h;
 for(i=0;i<strip->nl;i++)
 {
  height=MAX(strip->vline[i].h,height);
 }

 return(height);
}
*/


static os_error * removestrip(vstripstr * strip)
{
 int size;

 remboxstrip(strip);

 size=sizeof(vlstr)*strip->nl;
 voffsetdelta+=size;
 vsourceremove(size,&flv.textsrc,flv.file);
 refreshvrem(strip->nl,flv.textsrc.voffset);
 return(NULL);
}


static os_error * addstrip(vstripstr * strip)
{
 int   size;

 size=sizeof(vlstr)*strip->nl;
 voffsetdelta-=size;
 vsourceinsert(strip->vline,size,&flv.textsrc,flv.file);
 refreshvadd(strip->nl,flv.textsrc.voffset);
 addboxstrip(strip);
/* dprintf(5,"add ns=%d",strip->nl); */
 return(NULL);
}


static os_error * replacestrip(vstripstr * ostrip,vstripstr * nstrip)
{
 int io;
 int in;
 int i;
 int xnew;
 int copy;
 int vdelta;


 xnew=nstrip->nl-ostrip->nl;
 copy=MIN(nstrip->nl,ostrip->nl);
 io=in=0;
 vdelta=0;

 if(xnew>0)
 {
  vdelta=sizeof(vlstr)*xnew;
  voffsetdelta-=vdelta;
  vsourceinsert(nstrip->vline,vdelta,&flv.textsrc,flv.file);
  in=xnew;

  refreshvadd(xnew,flv.textsrc.voffset);

  vdelta=0;
  for(i=0;i<in;i++) 
  { 
   addboxline(&nstrip->vline[i],vdelta);
   vdelta+=sizeof(vlstr);
  }
 }
 else
 if(xnew<0)
 {
  xnew=-xnew;
  for(i=0;i<xnew;i++)
  {
   remboxline(&ostrip->vline[i],0); 
   voffsetdelta+=sizeof(vlstr);
   vsourceremove(sizeof(vlstr),&flv.textsrc,flv.file);
  }

  refreshvrem(xnew,flv.textsrc.voffset);
  io=xnew;
 }

 for(i=0;i<copy;i++)
 {
  remboxline(&ostrip->vline[io],vdelta);
  *vlptr(flv.textsrc.vsourcep,flv.textsrc.voffset+vdelta)=nstrip->vline[in];
  addboxline(&nstrip->vline[in],vdelta);
  vdelta+=sizeof(vlstr);
  io++;
  in++;
 }

 return(NULL);
}



/* used when nothing on screen has changed, but max width has */

static os_error * copystrip(vstripstr * nstrip)
{
 int copy;
 int i;
 int vdelta;

 copy=nstrip->nl;
 vdelta=0;

 for(i=0;i<copy;i++)
 {
  *vlptr(flv.textsrc.vsourcep,flv.textsrc.voffset+vdelta)=nstrip->vline[i];
  vdelta+=sizeof(vlstr);
 }

 return(NULL);
}

/*****************************************************************************/

/* work at the horizontal strip level */
/* a strip is a collection of vlines  */

static os_error * flowvboxh(flowstr * op)
{
 os_error  * err;
 int         more;
 int         eqfline;
 vstripstr * cstrip;
 int         temp;
 char      * p;
 int         nl;
 int         code;


/* dprintf(0,"flowvboxh"); */

 err=NULL;

 eqfline=0;

 fldodrop=fldobullet=0;

/* dprintf(8,"dze %d new %d good %d level=%d bullet=%d",fldropzone,newpara,flgooddrop(&fldroplen),flstyle.data.layer,flstyle.data.bullet);  */

 if(!fldropzone && newpara)
 {
  if(flstyle.data.drop || flstyle.data.bullet)
  {
   if((code=flgooddrop(&fldroplen))!=FLNOGOOD)
   {
    fldobullet=flstyle.data.bullet;
    if(fldobullet) flsetbulletdata();
    else
    if(code==FLGOODDROP) fldodrop=flstyle.data.drop;
   }
  }
 }

 if(newpara) flclrbullet1();


 more=getnextstrip(fstrip);

/* dprintf(0,"dobull %d more %d",fldobullet,more); */

 if(more && delta && flstate!=FLDIRTY)
 {
  if(fstrip->len<=-delta)
  {
   /* trash vline update vline to point to next vline */
   /* a scroll up                                     */
   delta+=fstrip->len; /* delta -ve. */
   if(fstrip->bullet) flbulletstate=1;
   removestrip(fstrip);
   more=getnextstrip(fstrip);
  }
 }


 /* main bit, one of these clauses, produces a new vline */

 if(more)
 {
  if(delta || flstate==FLDIRTY)
  {
   err=flowvstrip(op,&cstrip,NULL,&temp);
   if(err || op->result) return(err);

   if(cstrip->len<=delta)
   {
    /* a scroll down */
    addstrip(cstrip);
    delta-=cstrip->len;
    if(cstrip->bullet) flbulletstate=1;
   }
   else 
   {
    delta-=cstrip->len-fstrip->len;
    replacestrip(fstrip,cstrip);
    if(fstrip->bullet || cstrip->bullet) flbulletstate=1;
   }
  }
  else /*flstate==FLQUICK || (flstate==FLDELTA && !delta) || flstate=FLBULLET*/
  {
   err=flowvstrip(op,&cstrip,fstrip,&eqfline);
   if(err || op->result) return(err);

   if(!eqfline)
   {
    delta-=cstrip->len-fstrip->len;
    replacestrip(fstrip,cstrip);
    if(fstrip->bullet || cstrip->bullet)
    {
     flbulletstate=1;
    }
   }
   else
   {
    if(eqfline==1) copystrip(cstrip); /* max width has changed */
    if(fstrip->bullet && cstrip->bullet) flbulletstate=0;
    if(blanked) refreshstrip(cstrip,0);
    else
    if(oldvalign && !curvalign)
    {
     refreshstrip(cstrip,1);
     refreshstrip(cstrip,0);
    }
   }
  /* dprintf(0,"null delta eq=%d ecode=%d",eqfline,cstrip->ecode); */
  }
 }
 else  /* no more lines, flowing new space */
 {
  err=flowvstrip(op,&cstrip,NULL,&temp);
  if(err || op->result) return(err);
  flbulletstate=0;
  addstrip(cstrip);
  delta-=cstrip->len;
 }

 /* at this point, we have produced a new strip - update flow vector etc. */


 if(!op->result)
 {
  checkvectors(op,cstrip);
  stepstrip(cstrip);

  if(!fldodrop)
  {
   if(leadabs || xbaselock || 
      (firstline && 
       (firstbaselinemode==FBLASCENDER || 
        (firstbaselinemode==FBLGRID && canbaselock) ||
        firstbaselinemode==FBLFIT
       )
      )
     )
   {   
    if(cstrip->maxpt>cstrip->maxld)
                      axy=cstrip->liney+(cstrip->maxld-cstrip->maxpt);
    else              axy=cstrip->liney;
   }

   leadabs=0;
   firstline=0;
   notbefore=0;

   absshift=MAX(cstrip->maxpt,cstrip->maxld);
   /* baseline of the last line is at axy+absshift */


   switch(flstyle.data.leadingtype)
   {
     case LEADABS:
                  leadabs=1;
                  axy+=flstyle.data.leading;
                  break;

     case  LEADPC:
                  axy+=MAX(cstrip->maxpt,cstrip->maxld)+
                           scale(cstrip->maxpt,flstyle.data.leading,0x10000);
                  break;

     case  LEADDL:
                  axy+=MAX(cstrip->maxpt,cstrip->maxld)+flstyle.data.leading;
                  break;
   }

   if(fldropzone && axy>=fldropzoney) fldropzone=0;

   if(cstrip->bullet && cstrip->nl==2) nl=0;
   else                                nl=cstrip->nl-1;

   if(cstrip->vline[nl].line.eol==ISNL)
   {
    if(fldropzone && axy<fldropzoney) axy=fldropzoney;
    axy+=flstyle.data.after;    /* NB before flstyle is changed */

//    cprintf("dopzone %d axy after =%d",fldropzone,axy);
    newpara=1;
    fldropzone=0;
   }
   else
   {
    newpara=0;
   }
  }
  else /* we just generated a drop cap */
  {
   fldropzonex=cstrip->vline->line.x+cstrip->vline->line.w;
   fldropzoney=LY(cstrip->vline->line.yy)+cstrip->vline->line.h;
   fldropzone=1;

//   cprintf("fldropzone x %d y %d",fldropzonex,fldropzoney);
  }

  if(flv.textsrc.loffset<flv.textsrc.sourcep->len &&
      *(p=txptr(flv.textsrc.sourcep,flv.textsrc.loffset))==SNO)
  {
   flsetstyle(p[1]+(p[2]<<8)+(p[3]<<16));
  }
  else
  if(cstrip->font)
  {
   flsetstyle(cstrip->cfstyle);
  }

  /* at this point, we have moved the flow vector to start of next line */

  /* sort out state */


  checkstate(eqfline);

  /* these all have to be together, but must have correct priorities */

  if(flv.textsrc.loffset>=flv.textsrc.sourcep->len) op->result=ENDOFTEXT;
  else
  if(!flstate/* && eqfline */)                      op->result=FLOWEDOUT;
  else
  if(cstrip->ecode==EOPAGE)                         op->result=ENDOFPAGE;
  else
  if(cstrip->ecode==EOBOX)                          op->result=ENDOFBOX;
  else                                              op->result=ENDOFSTRIP;
 }

 fldodrop=0;


/* dprintf(8,"flowboxh result=%d",op->result); */


 return(err);
}



/* given the start of a horizontal vbox chain, fill it with strips */

static os_error * flowvboxv(flowstr * op)
{
 os_error * err;
 int        pextent;

 err=NULL;

 while(!op->result && flextent)
 {
  pextent=flextent & (FLV0|FLV1);

  if(newpara && !notbefore)
  {
   if(!firstline || flstyle.data.before>0) axy+=flstyle.data.before;
   /* this is to prevent axy getting smaller */
   /* getrectangles() can't cope with y being smaller than the top */
   notbefore=1;
  }

  firstvboxh();  /* first vbox in this strip */
  if(axy>(ccurve.box.y+ccurve.box.h)) 
  {
   op->result=MOVEOUT;
//  cprintf("moveout axy=%d limit=%d",axy,(ccurve.box.y+ccurve.box.h));
  }
  else
  {
   err=flowvboxh(op);
   if(err) break;
  }

 /* dprintf(6,"flowvboxh=%d flextent=%x",op->result,flextent);  */

  switch(op->result)
  {
    case ENDOFTEXT:
    case  ENDOFBOX:
    case ENDOFPAGE:
    case FLOWEDOUT:
                   break;

   case ENDOFSTRIP:
                   if(!pextent) flextent&=~FLINE;
                   op->result=0;
                   break;
  }
 }

// cprintf("flowvboxv result=%d\n",op->result);

 return(err);
}

/*****************************************************************************/


static void setoverflow(int set)
{
 texhdr  * texhp;

/* dprintf(0,"set overflow text=%d set=%d full=%d",
              flv.textsrc.text,set,flv.textsrc.textp->flags.full); */

 if(flv.textsrc.u==0)
 {
  if(set!=(int)flv.textsrc.textp->flags.full) 
  {
   flv.textsrc.textp->flags.full=set;
   refreshfull(&flv);
  }
 }
 else
 {
  texhp=
     (texhdr*)(((char*)flv.textsrc.textp)+sizeof(textboxstr)+3*sizeof(texsrc));

  if(flv.textsrc.u==1)
  {
   if((int)texhp->headerfull!=set)
   {
    texhp->headerfull=set;
    refreshfull(&flv);
   }
  }
  else
  if(flv.textsrc.u==2)
  {
   if((int)texhp->footerfull!=set)
   {
    texhp->footerfull=set;
    refreshfull(&flv);
   }
  }
 }
}


/* fv.vline may point to stuff, want to clean it up       */

static void cleanup(int columns)
{
 vlstr  * line;
 texsub * texup=NULL;

/* dprintf(0,"cleanup %d",columns);  */

 frflblanked(flv.file,flv.textsrc.text,&blanked);

 while(1)
 {
  voffsetdelta=0;

  while(1) 
  {
   texup=(texsub*)(((char*)flv.textsrc.textp)+flv.textsrc.usize);

  /* dprintf(0,"voff=%d cv=%d vl=%d sum=%d",flv.textsrc.voffset,
           cvoffset,texup[flv.textsrc.s].vlines,
           (cvoffset+texup[flv.textsrc.s].vlines)); */

   if(flv.textsrc.voffset>=
         (cvoffset+texup[flv.textsrc.s].vlines)) break;

   line=vvlptr(&flv);
   delta+=line->line.len;
   remboxline(line,0);
   vsourceremove(sizeof(vlstr),&flv.textsrc,flv.file);
   voffsetdelta+=sizeof(vlstr);
  }

  if(columns && (flv.textsrc.s<(flv.textsrc.columns-1)))
  {
   refreshend();
  /* dprintf(4,"end+2"); */

   flv.textsrc.loffset=(coffset+=texup[flv.textsrc.s].bytes);
   flv.textsrc.voffset=(cvoffset+=texup[flv.textsrc.s].vlines);
   flv.textsrc.s++;
   refreshstart();
  }
  else break;
 }

}


static void cleanup2(int columns)
{
 refreshstart();
 cleanup(columns);

/* dprintf(4,"end+3"); */

 refreshend();
}



/* go down chain cleaning up any boxes which still have vlines in */
/* uncat pages if mainline                                        */


/* 
   there is a sad story here... uncatpage can by calling resetvdis
   cause flows that call cleanup all. If pages are deleted one at
   a time, this leads to a crash
*/


static void cleanupall(void)
{
 int          lastpage;
 int          page;
 int          firstpage;
 int          more;
 sectionstr * sectionp;
 vector       v;

 lastpage=flv.page;
 firstpage=0;

 cleanup2(1);

 if(flv.textsrc.u==0)
 {
  sectionp=(sectionstr*)fob_find(flv.section,flv.file);
  if(!sectionp->branch)
  {
   v=flv;

   while(flv.textsrc.textp->fchain.next)
   {
    do
    {
     if(!flv.textsrc.textp->fchain.next) break;
     page=flv.page;

     nextflbox(&flv,&more,&coffset,&cvoffset);

     vvisible(&flv,&fvisible);

     cleanup2(1);

     setoverflow(0);

    } while(flv.page==page);

    if(flv.page!=lastpage && !firstpage) firstpage=flv.page;
   }

   if(fxautopageremove && firstpage && flv.textsrc.textp->data.repeat)
   {
    uncatpage(firstpage,flv.section,flv.file,1);

    txunlock(&flv.textsrc,flv.file); /* prevent flv being left pointing at */
    flv=v;                           /* fresh air, because flflush uses it */
    txlock(&flv.textsrc,flv.file);
   }
  }
 }

 /* things like changing no of columns can make extra lines appear */
 /* code for moving from one line to the next then goes wrong */

 vsourceremove(flv.textsrc.vsourcep->len-flv.textsrc.voffset,
               &flv.textsrc,flv.file);
}




/* scan down the vertical vbox chain */
/* pass horizontal vbox chains on    */

static os_error * flowbox(flowstr * op)
{
 os_error * err;
 vlstr    * line;
 int        vdelta;
 int        nlines;
 texsub   * texup;
 int        align;
 int        temp;

 err=refreshstart();

 if(flv.textsrc.loffset>=flv.textsrc.sourcep->len) op->result=ENDOFTEXT;
 else                    /* didn't used to do this */
 if(firstvboxv())
 {
  op->result=ENDOFBOX;   /* no vboxes in this box */
 /* dprintf(0,"no vboxes in this box"); */
 }
 else
 if(firstline)
 {
  axy=ccurve.box.y;
 }
 else
 if(axy<=ccurve.box.y) /* supposed to handle drop caps in ascender/fit */
 {
  firstline=1;
  axy=ccurve.box.y;
 }

/* case of drop cap + line, then enter space at start of next line    */
/* in this case we attempt to get the line position from the drop cap */
/* for ascender/fit this isn't right, and leads to a -ve axy          */


/* dprintf(3,"axy=%d",axy); */

 voffsetdelta=0;
 err=refreshvstart();
 texup=(texsub*)(((char*)flv.textsrc.textp)+flv.textsrc.usize);
 texup[flv.textsrc.s].vdelta=0;
 align=flv.textsrc.textp->data.valign & 0x3;
 flv.textsrc.textp->data.valign&=~0x3;
 flv.textsrc.textp->data.valign|=VTOP;
 if(curvalign) flextent|=FSUB;


 /* dprintf(0,"xresult=%d box=%d voff=%d",op->result,flv.textsrc.text,
                        flv.textsrc.voffset);  */

 while(1)
 {
  if(!op->result)   /* problem is that some cases come in from above */
  {
   err=flowvboxv(op);
   if(err) break;
  }

 /* dprintf(9,"result=%d box=%d voff=%d",op->result,flv.textsrc.text,
                        flv.textsrc.voffset); */


  switch(op->result)
  {

    case ENDOFTEXT:
                   /* clear all bits but makes no difference */

                   flextent&=~FLEXTENT;
                   cleanup(0);
                   break;

      case MOVEOUT:
                   if(nextvboxv())
                   {                                                                                op->result=ENDOFBOX;  /* !!! falls through */
                   }
                   else
                   {
                    /* need to do this because code in getrectangles  */
                    /* can't work out that fit is failing because axy */
                    /* is too small */

                    if(firstline || axy<ccurve.box.y) axy=ccurve.box.y;
                    op->result=0;
                    break;
                   }


     case ENDOFBOX:
                   flextent&=~(FSUB|FLINE);
                   if(flv.textsrc.s>=(flv.textsrc.columns-1))flextent&=~FBOX;
                   cleanup(0);
                   break;


    case ENDOFPAGE:
                   flextent&=~(FPAGE|FBOX|FSUB|FLINE);
                   cleanup(0);
                   break;


    case FLOWEDOUT:
                   flextent&=~FLEXTENT; /* again academic */
                   break;

  }

  if(op->result || !flextent) break;
 }

 vdelta=0;
 if(canvertalign)
 {
  texup=(texsub*)(((char*)flv.textsrc.textp)+flv.textsrc.usize);
  nlines=texup[flv.textsrc.s].vlines;
  if(nlines) /* nlines is an offset not a count */
  {                                                                                temp=cvoffset+nlines-sizeof(vlstr);
   line=vlptr(flv.textsrc.vsourcep,temp);
   if(line->line.xl)
   {
    temp-=sizeof(vlstr);
    if(temp>=cvoffset)
    {
     line=vlptr(flv.textsrc.vsourcep,temp);
    }
   }

   if(!line->line.xl)
   {
    vdelta=vertbottom-(LY(line->line.yy)+line->line.h);
   }
  }
 }

 texup=(texsub*)(((char*)flv.textsrc.textp)+flv.textsrc.usize);
 texup[flv.textsrc.s].vdelta=vdelta;
 flv.textsrc.textp->data.valign&=~0x3;
 flv.textsrc.textp->data.valign|=align;

/* dprintf(4,"vend0"); */

 if(curvalign) vformateobs();

/* dprintf(4,"vend");  */


          refreshvend(op);
 if(!err) err=refreshend();

/* dprintf(4,"end+5 s=%d",flv.textsrc.s); */
/*   debvec(&flv); */

/* dprintf(0,"flow box op->result=%d",op->result);   */


 return(err);
}



/*****************************************************************************/

static os_error * nextflbox(vector * v,int * more,int * coffset,int * cvoffset)
{
 int      s;
 int      fnext;
 texsub * texup;

 s=v->textsrc.s;

 texup=(texsub*)(((char*)v->textsrc.textp)+v->textsrc.usize);

 if(s<(v->textsrc.columns-1))
 {
  v->textsrc.loffset=(*coffset+=texup[s].bytes);
  v->textsrc.voffset=(*cvoffset+=texup[s].vlines);
  v->textsrc.s++;
  *more=1;
 }
 else
 {
  if(v->textsrc.u==0 && ((fnext=v->textsrc.textp->fchain.next)!=0))
  {
   v->textsrc.loffset=v->boffset=(*coffset+=texup[s].bytes);
   v->textsrc.voffset=v->bvoffset=(*cvoffset+=texup[s].vlines);

   txunlock(&v->textsrc,v->file);

   v->textsrc.text=fnext;

   txlock(&v->textsrc,v->file);

   v->textsrc.s=0;

   if(v->textsrc.textp->data.header || v->textsrc.textp->data.footer) 
   {
    v->textsrc.usize=sizeof(textboxstr)+3*sizeof(texsrc)+sizeof(texhdr);
    if(v->textsrc.u==0) 
    {
     v->textsrc.columns=v->textsrc.textp->data.columns;
     v->textsrc.usize+=2*sizeof(texsub);
    }
    else
    {
     if(v->textsrc.u==2) v->textsrc.usize+=sizeof(texsub);
     v->textsrc.columns=1;
    }
   } 
   else 
   {
    v->textsrc.usize=sizeof(textboxstr)+sizeof(texsrc);
    v->textsrc.columns=v->textsrc.textp->data.columns;
   }

   v->page=pageof((chainobject*)v->textsrc.textp,v->file);

   *more=1;
  /* dprintf(8,"more");  */
  }
  else
  {
   *more=0;
  /* dprintf(8,"nomore");  */
  }
 }

 return(NULL);
}




static os_error * stepline(void)
{
 axy=0;
 firstline=1;

 return(NULL);
}



static os_error * stepflv(flowstr * op,int page)
{
 os_error   * err;
 int          more;
 sectionstr * sectionp;
 int          goodcat;
 int          gooddble;
 int          dble;
 pagestr    * pagep;
 textboxstr * textp;
 int          prevpage;
 int          nextpage;
 int          text=0;



 err=nextflbox(&flv,&more,&coffset,&cvoffset);
 if(!more)
 {
  if(flv.textsrc.textp->data.repeat && flv.textsrc.u==0)
  {
   sectionp=(sectionstr*)fob_find(flv.section,flv.file);
   if(!sectionp->branch)
   {
    if(flv.file->hdr.np[DOC]<MAXPAGE)
    {
     dble=sectionp->data.dble;
     gooddble=(dble && sectionp->np<=1);
     pagep=(pagestr*)fob_find(flv.page,flv.file);
     prevpage=pagep->chain.prev;
     nextpage=pagep->chain.next;

     /* if we got something in this box, then worth trying next */

     goodcat=fxautopageinsert;
     if(goodcat) goodcat=(boxcontents(flv.textsrc.textp,0,NULL,NULL)!=0);
     if(goodcat)
     {
      /* if double page, make sure you have an empty pair */
      goodcat=gooddble;
      if(!goodcat)
      {
       /* if this page was not a copy of the master page, then try next */
       changedpage(flv.page,flv.file,&goodcat);
       if(!goodcat && dble)
       {
        if(!prevpage) goodcat=1;
        else
        {
         textp=NULL; /* compiler */

         while(1)
         {
          text=flv.textsrc.textp->fchain.prev;
          if(!text) break;
          textp=(textboxstr*)fob_find(text,flv.file);
          if(pageof((chainobject*)textp,flv.file)!=flv.page) break;
         }

         if(text)    /* should be boxpagecontents() */
         {
          goodcat=(boxcontents(textp,0,NULL,NULL)!=0);
          if(!goodcat) changedpage(pagep->chain.prev,flv.file,&goodcat);
         }
        }
       }
      }
     }

     if(goodcat)
     {                          /* many conditions upon doing this */
      if(!nextpage)
      {
       catpage(flv.page,flv.section,flv.file);
       nextflbox(&flv,&more,&coffset,&cvoffset);
      }

      if(!nextpage || !more)
      {
       pagep=(pagestr*)fob_find(flv.page,flv.file);
       if(pagep->chain.next)
       {
        catpage(pagep->chain.next,flv.section,flv.file);
        nextflbox(&flv,&more,&coffset,&cvoffset);
       }
      }
     }
    }
   }
  }
 }

 op->result=more?MORE:NOMORE;

 if(more)
 {
  setupbox();
  stepline();   /* in case flowing continues */
 }

 return(err);

 USE(page);
}



static os_error * flowboxes(flowstr * op)
{
 os_error * err;

/* dprintf(0,"flowboxes s=%d cvoffset=%d",flv.textsrc.s,cvoffset); */

 err=NULL;

 while(!op->result && flextent)
 {
/* dprintf(0,"opcode=%d type=%d delta=%d",op->opcode,op->data.type,
                                                    op->data.delta); */

  err=flowbox(op);

  if(err) break;

/* dprintf(0,"result=%d delta=%d",op->result,delta);  */

  switch(op->result)
  {
    case ENDOFTEXT:
                   op->result=NOMORE;
                   cleanupall();
                   setoverflow(0);
                   break;

    case FLOWEDOUT:
                   break;

    case ENDOFPAGE:
     case ENDOFBOX:
                   stepflv(op,op->result==ENDOFPAGE);
       /* dprintf(0,"stepflv ex res=%d flex=%d",op->result,flextent); */
                   if(op->result==MORE && flextent) 
                   {
                    op->result=0;
                   }                    
                   if(op->result==NOMORE) 
                   {
                    setoverflow(1);
                   }
                          /* in any other case the vector has moved...  */
                          /* may be some odd cases where need to clear? */
                   break;

  }
 }

 /* at this point can pick up cases where roff's not seen */

/* dprintf(4,"flow boxes ex");  */

 cleanupvectors(op);

 return(err);
}



static os_error * setupline(void)
{
 vlstr * line;
 vlstr   xline;
 int     seenbullet;
 int     llen;
 int     liney=0;  /* compiler */
 int     sn=0;     /* compiler */
 int     tsn;
 int     ecode;
 int     fsn=0;    /* compiler */
 int     hasfont;
 char  * p;
 int     first;
 int     seenfont;
 int     loffset;
 int     voffset;
 int     pvoffset=0; /* compiler */
 int     cmaxpt=0; /* compiler */
 int     cmaxld=0; /* compiler */
 int     cmaxas=0; /* compiler */
 int     cmaxht=0; /* compiler */


 fldropzone=0;


 if(flv.textsrc.voffset>0)
 {
  first=1;
  seenfont=0;
  seenbullet=0;
  flbulletnullstate();

  voffset=pvoffset=flv.textsrc.voffset;
  loffset=flv.textsrc.loffset;

  while(flv.textsrc.voffset>0)
  {
   line=vlptr(flv.textsrc.vsourcep,flv.textsrc.voffset-sizeof(vlstr));
   if(!line->line.xl)
   {
    if(line->line.strip && !first) break;

    llen=line->line.len;
    tsn=fsn=line->line.style;

    flv.textsrc.loffset-=llen;
    flv.textsrc.voffset-=sizeof(vlstr);
    pvoffset=flv.textsrc.voffset;

    /* eob angles in force */
    fontstate(&flv,flv.textsrc.loffset,llen,&tsn,&hasfont,0,&ecode); 
                                                /* has font = font|objects */
    if(!seenfont)
    {
     sn=tsn;
     seenfont=1;
    }

    if(first)
    {
     cmaxpt=fmaxpt;
     cmaxld=fmaxld;
     cmaxas=fmaxas;
     cmaxht=fmaxht;
     liney=LY(line->line.yy);
     newpara=(line->line.eol==ISNL);
     first=0;
    }
    else
    {
     if(fmaxpt>cmaxpt || fmaxld>cmaxld || fmaxht>cmaxht || fmaxas>cmaxas)
     {
      cmaxpt=MAX(cmaxpt,fmaxpt);
      cmaxld=MAX(cmaxld,fmaxld);
      cmaxas=MAX(cmaxas,fmaxas);
      cmaxht=MAX(cmaxht,fmaxht);
      liney=LY(line->line.yy);
     }
    }
   }
   else
   {
    if(!seenbullet)
    {
     if(line->ext.type==VLBULLET)
     {
      xline=*line;
      seenbullet=1;
     }
    }
    flv.textsrc.voffset-=sizeof(vlstr);
   }
  }

  if(seenbullet) flbulletsetstate(&xline,flv.textsrc.loffset);

  flsetstyle(fsn); /* here we set the style for the previous line */
                   /* if there is one to get after spacing        */

  flv.textsrc.voffset=voffset;
  flv.textsrc.loffset=loffset;
 }
 else
 {
  liney=0;   /* for compiler */
  newpara=1;
  flbulletstartstate();
 }


 if(flv.textsrc.loffset<(flv.textsrc.sourcep)->len)
 {
  p=txptr(flv.textsrc.sourcep,flv.textsrc.loffset);
  if(*p==SNO)
  {
   sn=p[1]+(p[2]<<8)+(p[3]<<16);
  }
 }

/* dprintf(10,"loffset=%d sn=%d",flv.textsrc.loffset,sn); */

 if(cvoffset==flv.textsrc.voffset)
 {
  firstline=1;
  axy=0;
 }
 else
 {
  firstline=0;

  leadabs=(flstyle.data.leadingtype==LEADABS);
  absshift=cmaxpt;

  /* need to go back one before any previous NL - case DC+NL */

  line=vlptr(flv.textsrc.vsourcep,pvoffset);
  if(!line->line.xl)
  {
   if(line->line.eol==ISDROP)    /* previous line is drop cap */
   {
    fldropzone=1;
    fldropzonex=line->line.x+line->line.w;
    fldropzoney=LY(line->line.yy)+line->line.h;

//    cprintf("setupline fldrop x %d y %d",fldropzonex,fldropzoney);

    /* this is not correct for a firstline with fit/ascent baseline */
    if(cmaxpt>cmaxld) axy=liney+cmaxld-cmaxpt;
    else              axy=liney;

   }
   else
   {
    while(pvoffset>cvoffset)
    {
     line=vlptr(flv.textsrc.vsourcep,pvoffset-sizeof(vlstr));
     if(!line->line.xl)
     {
      if(line->line.eol==ISBREAK || line->line.eol==ISNL) break;
      if(line->line.eol==ISDROP)
      {
       fldropzone=1;
       fldropzonex=line->line.x+line->line.w;
       fldropzoney=LY(line->line.yy)+line->line.h;

//       cprintf("setupline repeat scan back fldrop x %d y %d",fldropzonex,fldropzoney);

       break;
      }
     }
     pvoffset-=sizeof(vlstr);
    }

    if(cmaxpt>cmaxld) axy=liney+cmaxld-cmaxpt;
    else              axy=liney;
  
    switch(flstyle.data.leadingtype)
    {
      case LEADABS:
                   axy+=flstyle.data.leading;
                   break;

      case  LEADPC:
                   axy+=MAX(cmaxpt,cmaxld)+
                            scale(cmaxpt,flstyle.data.leading,0x10000);
                   break;

      case  LEADDL:
                   axy+=MAX(cmaxpt,cmaxld)+flstyle.data.leading;
                   break;
    }
   }
  }

  if(newpara)
  {
   if(fldropzone && axy<fldropzoney) axy=fldropzoney;
   axy+=flstyle.data.after;
   fldropzone=0;
  }
  else
  if(fldropzone && axy>=fldropzoney) fldropzone=0;

//  cprintf("dropzone %d axy %d",fldropzone,axy);
 }

 flsetstyle(sn); /* here we set the style for the line we're going to create */
 notbefore=0;

 return(NULL);
}



static os_error * flexec(flowstr * op)
{
 os_error * err;

 flentered++;

 err=NULL;


 flextent=op->opcode & (FLEXTENT|FLV0|FLV1);

 delta=0;   /* incremented by setstate() */

/*
 dprintf(0,"flexec in text=%d source=%d offset=%d loffset=%d",
flv.textsrc.text,flv.textsrc.source,flv.textsrc.offset,flv.textsrc.loffset);
*/

 fxcheckprefs(flv.file);


 setupbox();



 err=setupline();
 if(!err)
 {
  checkstate(0);


  if(!err) 
  {
   op->result=0;


   err=flowboxes(op);


   if(op->result==NOMORE) 
   {
    closeflow();

    if(!act.valid || flv.textsrc.source!=act.textsrc.source)
    {
     txsourceclose(&flv.textsrc,flv.file);
     vsourceclose(&flv.textsrc,flv.file);
    }
   }
   else /* MORE || FLOWEDOUT */
   {
    updatestate();
   }
  }
 }


// cprintf("flexec ex");


 flentered--;

 return(err);
}



static os_error * flcorrect(vector * s,int * opcode)
{
 os_error * err;
 vlstr    * vline;
 int        voffset;


 err=NULL;

 voffset=s->textsrc.voffset;

 while(voffset)
 {
  vline=vlptr(s->textsrc.vsourcep,voffset-sizeof(vlstr));
  if(!vline->line.xl)
  {
   if(vline->line.strip && vline->line.eol!=ISDROP) break;
   s->textsrc.loffset-=vline->line.len;
   (*opcode)&=~FLPREV;
   s->textsrc.voffset=voffset-sizeof(vlstr);
  }

  voffset-=sizeof(vlstr);
 }

 return(err);
}


static os_error * flprev(vector * v,int opcode,
                         int * coffsetp,int * cvoffsetp,
                         int fldkey,flowdatastr * fldstack)
{
 os_error    * err;
 vlstr       * vline;
 int           first;
 flowdatablock fld;
 int           len;
 int           s;
 int           fprev;
 int           bytes;
 int           lines;
 texsub      * texup;
 int           coffset;
 int           cvoffset;
 int           voffset;

 err=NULL;
 first=1;
 len=0;

 if(opcode & FLPREV)
 {
  if(v->textsrc.voffset)
  {
   coffset=*coffsetp;
   cvoffset=*cvoffsetp;

   voffset=v->textsrc.voffset;
   while(voffset)
   {
    vline=vlptr(v->textsrc.vsourcep,voffset-sizeof(vlstr));
    if(!vline->line.xl)
    {
     if(vline->line.strip && !first) break;
     len+=vline->line.len;
     v->textsrc.loffset-=vline->line.len;
     v->textsrc.voffset=voffset-sizeof(vlstr);
     first=0;
    }
    voffset-=sizeof(vlstr);
   }

   while(v->textsrc.voffset<cvoffset)
   {
    s=v->textsrc.s;
    texup=(texsub*)(((char*)v->textsrc.textp)+v->textsrc.usize);

    while(v->textsrc.voffset<cvoffset && s>0)      /* was v->bvoffset */
    {
     s--;
     cvoffset-=texup[s].vlines;
     coffset-=texup[s].bytes;
    }

    if(v->textsrc.voffset<cvoffset)
    {
     fprev=v->textsrc.textp->fchain.prev;
     if(fprev)
     {
      txunlock(&v->textsrc,v->file);

      v->textsrc.text=fprev;

      txlock(&v->textsrc,v->file);

      vgetusize(v);

      vsetpage(v);

      s=v->textsrc.columns-1;
     }
     else break;
     boxcontents(v->textsrc.textp,0,&bytes,&lines);

     v->boffset-=bytes;
     v->bvoffset-=lines;

     v->textsrc.s=s;                     /* used by next fn */
     setcoffsets(coffsetp,cvoffsetp,v);
     coffset=*coffsetp;
     cvoffset=*cvoffsetp;
    }

    *coffsetp=coffset;
    *cvoffsetp=cvoffset;
    v->textsrc.s=s;
   }

   fld.offset=v->textsrc.loffset;
   fld.length=len;
   fld.delta=0;
   fld.type=FLDIRTY;

   fladdblock(v,&fld,fldkey,fldstack);
  }
  else
  {
   vfirstbox(v);
  }
 }

 return(err);
}





void flowcont(int flkey)
{
 os_error * err;
 flowstr    op;

// cprintf("flowcont in");

 fldkey=flkey;
 fldstack=flgetstackpointer(&flv,fldkey,fldstack);

 /* in a file that has been loaded, the fldstack vector */
 /* will have the wrong file pointer                    */
 /* so we fix it here                                   */

 fldstack->fv.file=flv.file;
 flv=fldstack->fv;

/* delta=0; */ /* incremented by setstate() */
 memset(&op,0,sizeof(flowstr));

/* checkstate(0); */

 err=txlock(&flv.textsrc,flv.file);
 if(!err)
 {
  setcoffsets(&coffset,&cvoffset,&flv); /* NB once locked */

/*  flstackinit(&flv,&fldkey,&fldfixed,&fldstack); */


  op.opcode=FBOX;

//  cprintf("flexec from flow cont");
  flexec(&op);

  flstackend(&flv,&fldkey,fldstack);
  flflush(fldkey);

  txunlock(&flv.textsrc,flv.file);
  flv.valid=0;
 }

// cprintf("flowcont exit");
}



static void flowdaemon(int handle) 
{
 filestr    * file;
 sectionstr * sectionp;


/* dprintf(0,"flowdaemon flfile=%x section=%d fldkey=%d",flv.file,
                                                       flv.section,
                                                       fldkey); */

 if(!flv.file)
 {
  file=firstfile;
  while(file)
  {
   if(file->hdr.flowsection)
   {
    flv.file=file;
    sectionp=(sectionstr*)fob_find(flv.file->hdr.flowsection,file);
    fldkey=sectionp->flows;    /* checked below */
    break;
   }
   file=file->next;
  }

  if(!file)
  {
   remzeroevent(flowdaemon,0);
   flzero=0;
  }
 }

 if(flv.file)
 {
  if(fldkey) /* try to carry on where we were flowing */
  {
   flowcont(fldkey);
  }
  else
  {
   if(flv.file->hdr.flowsection) /* set up a new flow and start */
   {
    sectionp=(sectionstr*)fob_find(flv.file->hdr.flowsection,flv.file);

  /*  dprintf(0,"step to chapter %d %d",sectionp->data.number,
                                      flv.file->hdr.flowsection); */
    flowcont(sectionp->flows);
   }
   else
   {
   /* dprintf(0,"no flow section"); */
    flv.file=NULL;
   }
  }
 }

 USE(handle);
}



/* called when file is closed */

static os_error * flclose(int eventn,int user,filestr * file,int data1)
{
 if(flv.file==file) flv.file=NULL;
 return(NULL);
 USE(eventn);
 USE(user);
 USE(data1);
}


/* this is a fix to get rid of dud flow structures left behind */

static os_error * flopen(int eventn,int user,filestr * file,int data1)
{
 sectionstr * sectionp;
 int          section;
 int          branch;
 int          flows;
 flowdatastr * flp;
 int          vsource;
 vsourcestr  * vsourcep;

 if(!file->hdr.flowsection)
 {
  for(branch=DOC;branch<=MST;branch++)
  {
   section=file->hdr.section[branch];
   while(section)
   {
    sectionp=(sectionstr*)fob_find(section,file);
    section=sectionp->chain.next;
    flows=sectionp->flows;
    if(flows)
    {
     sectionp->flows=0;
     while(flows)
     {
      flp=(flowdatastr*)fob_find(flows,file);
      if(!flp) break;
      flows=flp->next;
      vsource=flp->fv.textsrc.vsource;
      fob_delete(flp->key,file);
      if(vsource)
      {
       vsourcep=(vsourcestr*)fob_find(vsource,file);
       if(vsourcep)
       {
        vsourcep->fldstack=0;
       }
      }
     }
    }
   }
  }
 }

 return(NULL);
 USE(eventn);
 USE(user);
 USE(data1);
}



os_error * flow(vector * start,flowstr * op)
{
 os_error    * err;
 int           opcode;

 err=NULL;

 opcode=op->opcode;

 op->data.bulletstate=0;


 if(opcode & (FLEXTENT|FLV0|FLV1))
 {
//  cprintf("immediate flow opcode=%d",opcode);

  /* we have to flow something immediately   */

  flv=*start;


  op->result=0;
  err=txlock(&flv.textsrc,flv.file);
  if(!err)
  {
   setcoffsets(&coffset,&cvoffset,&flv); 

  /* NB once locked */
  /* vsource, then set it up and start flowing */
  /* otherwise if this is an immmediate flow, insert the data in the flow 
     list, set up the flow and start flowing */
  /* otherwise, insert the flow data in the flow list */

  /* is this flow before any pending flows ? */

   flstackinit(&flv,&fldkey,&fldfixed,&fldstack);

   flcorrect(&flv,&opcode);


   fladdblock(start,&op->data,fldkey,fldstack);

  /* dprintf(0,"flv.s=%d delta=%d",flv.textsrc.s,delta); */

   flprev(&flv,opcode,&coffset,&cvoffset,fldkey,fldstack);

 /*  dprintf(0,"flv.s=%d delta=%d",flv.textsrc.s,delta);  */

  /* dprintf(0,"flexec from flow imm"); */
   err=flexec(op);

 /* dprintf(0,"flv.s=%d delta=%d",flv.textsrc.s,delta); */


   flstackend(&flv,&fldkey,fldstack);
   flflush(fldkey);

   txunlock(&flv.textsrc,flv.file);
   flv.valid=0;
  }
 }
 else
 {
  int           xcoffset;
  int           xcvoffset;
  vector        xv;
  int           xfldkey;
  flowdatastr   xfldfixed;
  flowdatastr * xfldstack;

  /* just stack the data for future use */


//  cprintf("flow stack");

  xv=*start;

  err=txlock(&xv.textsrc,xv.file);
  if(!err)
  {
   setcoffsets(&xcoffset,&xcvoffset,&xv);
 /*
   dprintf(0,"stack flow %d %d",xcoffset,xcvoffset);
   dprintf(0,"stack text=%d section=%d",xv.textsrc.text,xv.section);
  */

   flstackinit(&xv,&xfldkey,&xfldfixed,&xfldstack);

   flcorrect(&xv,&opcode);
 
   fladdblock(&xv,&op->data,xfldkey,xfldstack);


   flprev(&xv,opcode,&xcoffset,&xcvoffset,xfldkey,xfldstack);

   flstackend(&xv,&xfldkey,xfldstack);

   txunlock(&xv.textsrc,xv.file);
  }

 }

/* dprintf(0,"fldkey=%d",fldkey); */

 return(err);
}







os_error * flowinit(void)
{
 os_error * err;

 err=salloc((flex_ptr)&cstrip[0],
                          sizeof(vstripstr)+DEFLTSTRIPSIZE*sizeof(vlstr));
 if(!err)
 err=salloc((flex_ptr)&cstrip[1],
                          sizeof(vstripstr)+DEFLTSTRIPSIZE*sizeof(vlstr));
 if(!err)
 err=salloc((flex_ptr)&fstrip,
                          sizeof(vstripstr)+DEFLTSTRIPSIZE*sizeof(vlstr));

 if(!err)
 err=salloc((flex_ptr)&xbox,sizeof(boxstr)*DEFLTSTRIPSIZE);

 if(!err)
 err=salloc((flex_ptr)&ybox,sizeof(boxstr)*DEFLTSTRIPSIZE);

 if(!err) err=addevent(EVENT_FCLOSE,(eventfn)flclose,0);
 if(!err) err=addevent(EVENT_FSCRAP,(eventfn)flclose,0);
 if(!err) err=addevent(EVENT_FOPEN,(eventfn)flopen,0);

 return(err);
}

