

#include "stdafx.h"

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <locale.h>
#include <ctype.h>

#include "os.h"
#include "bbc.h"
#include "flex.h"
#include "wimp.h"
#include "wimpt.h"
#include "werr.h"
#include "akbd.h"
#include "font.h"
#include "transform.h"
#include "etc.h"


#include "osunits.h"
#include "osgraphics.h"
#include "wos.h"
#include "err.h"
#include "xext.h"
#include "poll.h"
#include "key.h"
#include "keylegacy.h"
#include "temp.h"
#include "redraw.h"
#include "colour.h"
#include "conf.h"
#include "bits.h"
#include "trans.h"
#include "xmath.h"
#include "wimptext.h"
#include "fsx.h"
#include "bf.h"
#include "timex.h"
#include "drag.h"
#include "deb.h"
#include "sp.h"


#include "dbhi.h"
#include "mhi.h"
#include "dbdec.h"
#include "save.h"


#include "str.h"
#include "constants.h"

#include "object.h"

#include "reslink.h"
#include "units.h"
#include "xcolour.h"
#include "file.h"
#include "posn.h"
#include "xredraw.h"

#include "view.h"
#include "viewr.h"

#include "dbcolour.h"
#include "dbscale.h"


#include "txstr.h"
#include "tx.h"
#include "text.h"
#include "style.h"
#include "ustyle.h"
#include "tabs.h"
#include "fox.h"
#include "fcache.h"
#include "fx.h"
#include "act.h"
#include "styleif.h"
#include "fmap.h"
#include "codes.h"
#include "vl.h"
#include "vec.h"
#include "txds.h"
#include "txchoices.h"


#include "dbtabs.h"
#include "dbul.h"

#include "dbstyle.h"


#include "fontmenu.h"




/*********************************************************************************/


static wimp_w samplehandle;
static wimp_w sampleparent;
static int    sampleosfont;





static os_error * xsampleredrawsub(int handle,wimp_redrawstr * redrawstr,
                                                 int more,uservalue userhandle)
{
	os_error * err;
 int        oy;
 int        ox;
 int        fh;
 char     * p;
	int        xshift;
	int        yshift;
 font_info  fi;
	char       string[64];
	int        ch;
	int        n=0;
	char     * sample="ABCdefg";
	int        i;

	err=NULL;

	if(more)
 {
  err=font_find4(fontosname(sampleosfont),fontcharset(sampleosfont),0,fontitalic(sampleosfont),
                      fontfamily(sampleosfont),fontpitch(sampleosfont),0,(64*cvdu.ydpi)/72,0,&fh);

  err=font_setcolour(fh,PALTRANSPARENT,PALBLACK,0);
  if(!err) err=font_align(FA_BASELINE|FA_LEFT);

		p=sample;

		i=0;

		while((ch=*p++)!=0)
		{
   if(txunicode)
   {
				if(ch<256)
				{
     fontgetcode16(ch,sampleosfont,(wchar_t*)(string+i),&n);
					i+=2*n;
				}
				else
 			{
  			*((wchar_t*)(string+i))=(wchar_t)ch;
  		}
			}
			else
			{
    if(ch<256) fontgetcode8(ch,sampleosfont,string+i,&n);
				i+=n;
			}
		}

		if(txunicode)
		{
			*((wchar_t*)(string+i))=0;
   font_stringbbox16((wchar_t*)string,&fi);
  } 
  else
  {
			*(string+i)=0;
   font_stringbbox(string,&fi);
  }


  while(more)
  {
   ox=redrawstr->box.x0-redrawstr->scx;
   oy=redrawstr->box.y1-redrawstr->scy;

   xshift=((redrawstr->box.x1-redrawstr->box.x0)-xpix2os(fi.maxx-fi.minx))/2;
   yshift=((redrawstr->box.y1-redrawstr->box.y0)-ypix2os(fi.maxy-fi.miny))/2;

   yshift+=ypix2os(fi.maxy);
   if(txunicode) font_paint16((wchar_t*)string,font_OSCOORDS,(ox+xshift),(oy-yshift));
   else          font_paint(string,font_OSCOORDS,(ox+xshift),(oy-yshift));

   wimp_get_rectangle(redrawstr,&more);
  }


	 font_lose(fh);
	}

 return(NULL);

	USE(userhandle);
	USE(handle);
}



static os_error * xsampleredraw(int handle,uservalue userhandle)
{
 os_error       * err;
 wimp_redrawstr   redrawstr;
 int              more;

 redrawstr.w=handle;
 err=wimp_redraw_wind(&redrawstr,&more);
 if(!err) xsampleredrawsub(handle,&redrawstr,more,userhandle);

 return(err);
}






static os_error * xsampleclose(int handle,int userhandle)
{

 remredrawevent(xsampleredraw,handle,userhandle);
 remcloseevent(xsampleclose,handle,userhandle);
 remparentcloseevent(xsampleclose,handle,userhandle);

 closedown(&samplehandle);

 return(NULL);
}





static os_error * xopensample(wimp_w parent,int osfont)
{
	os_error    * err;
	windowstr     window;
	int           left;
	int		   						top;
 wimp_wstate   wst;
	int           w;
	int           h;


	err=NULL;

	sampleosfont=osfont;
	sampleparent=parent;

	if((fontsample!=0)!=(isshift!=0))
	{
  err=createwindowparent(TFONTSAMPLE,&samplehandle,parent);
  if(!err)
  {
            err=wimp_setwindowflags(samplehandle,WINDOWNOTDIALOGUE,0);
   if(!err) err=wimp_setwindowbackground(samplehandle,CCRGB|PALWHITE);
 		if(!err) err=getw(parent,&window);
  	top=window.y1;
 		if(!err) err=geto(parent,&window);

   if(!err) err=wimp_get_wind_state(samplehandle,&wst);

 		if(!err)
 		{
    addredrawevent(xsampleredraw,samplehandle,0);
    addcloseevent(xsampleclose,samplehandle,0);
    addparentcloseevent(xsampleclose,samplehandle,0);
 		}


   if(!err)
   {
 			w=wst.o.box.x1-wst.o.box.x0;
 			h=wst.o.box.y1-wst.o.box.y0;

		// get left,top to open at

 			if(window.x0>w || window.x0>(cvdu.screenx-window.x1))			// open on LHS
 			{
 				left=window.x0-w;
 			}
 			else																																																				// open on RHS
 			{
 				left=window.x1;
 			}

    wst.o.behind=wimp_NOCHANGE;
    wst.o.box.x0=left;
    wst.o.box.x1=wst.o.box.x0+w;
    wst.o.box.y1=top;
    wst.o.box.y0=wst.o.box.y1-h;
 
    if(!err) err=wimp_open_wind(&wst.o);
 		}
 	}
	}

	return(err);
}



static os_error * xsamplesetfont(int osfont)
{
	os_error * err;

	err=NULL;

	if((fontsample!=0)!=(isshift!=0))
	{
		if(samplehandle==0)
		{
			err=xopensample(sampleparent,osfont);
		}
		else
		{
			if(sampleosfont!=osfont)
			{
 	  sampleosfont=osfont;
	   err=refreshwindow(samplehandle);
			}
		}
	}
	else
	{
		if(samplehandle)
		{
			err=xsampleclose(samplehandle,0);
		}
	}

 sampleosfont=osfont;

	return(err);
}


static os_error * xsamplestate(void)
{

	return(xsamplesetfont(sampleosfont));
}


/********************************************************************************/


#define LEFTMARGIN  32
#define RIGHTMARGIN 48
#define RIGHTTAB1   8



#define XM_SELECT 0x1
#define XM_CHILD  0x2
#define XM_CHANGE 0x3
#define XM_CLOSE  0x4
#define XM_SHIFT  0x5



static os_error * xmenuclose(int handle,int userhandle);


typedef os_error * (*xmenuhandler)(int code,int param0,int param1,int param2);

typedef struct xmenustr
{
 int             menufontheight;
 int             menufontlead;
 int             n;
 int           * offset;
 char          * data;
 int             selected;
 int             oldselected;
 int             ticked;
 int             maxw;
 xmenuhandler    handler;
 int             handle;
 int             event;


} xmenustr;


#define XMSTACKSIZE 2

static xmenustr xmen[XMSTACKSIZE];
static int      xmenstackptr=-1;




static os_error * xmenuclearstack(int level)
{
 os_error * err;

 err=NULL;

// setfocus first to prevent flicker as focus goes back to main window

 if((level-1)>=0 && xmenstackptr>=0)
 {
  setfocus(xmen[level-1].handle);
 }

 while(xmenstackptr>=level)
 {
		if(xmen[xmenstackptr].handler) xmen[xmenstackptr].handler(XM_CLOSE,0,0,0);

  err=xmenuclose(xmen[xmenstackptr].handle,(int)(xmen+xmenstackptr));
  if(err) break;
  xmenstackptr--;
 }


 return(err);
}




static os_error * xmenuclick(int handle,int userhandle,wimp_mousestr * m)
{
 os_error * err;
 int        n;
 xmenustr * xm;
 windowstr  window;

 xm=(xmenustr*)userhandle;

 err=getw(handle,&window);
 if(!err)
 {
  if(m->x>=window.x0 && m->x<=window.x1)
  {
   n=((window.by-m->y))/ypix2os(xm->menufontheight);

   if(n>=0 && n<xm->n)
   {
//   if(m->bbits==wimp_BLEFT)   // upsets drag end code
    {
     if(xm->handler) err=xm->handler(XM_SELECT,n,0,0);
     xmenuclearstack(0);
    }
   }
  }
 }


 return(NULL);
}


static os_error * xmdrag(int handle,int userhandle,wimp_box * box)
{
 wimp_mousestr   m;
 xmenustr      * xm;


 wimp_get_point_info(&m);

 cprintf("xmdrag");

 xm=xmen;
 while(xm<=(xmen+xmenstackptr))
 {
  if(xm->handle==m.w) break;
  xm++;
 }

 if(xm<=(xmen+xmenstackptr))
 {
  cprintf("xmclick");
  return(xmenuclick(xm->handle,(int)xm,&m));
 }

 return(NULL);

 USE(box);
 USE(userhandle);
 USE(handle);
}



#define XMSPRITEN 3
#define XMSPRITET (XMSPRITEN*2)

static char * xmaddr[XMSPRITET];
static int    xmheight[XMSPRITET];
static char * xmname[XMSPRITET]={"1type","otype","ttype","1typep","otypep","ttypep"};


static os_error * xmenucachesprites(void)
{
 os_error   * err;
 int          i;
 sprite_id    id;
 sprite_info  resultinfo;
 char       * ptr;
 static   int cached;

 err=NULL;

 if(!cached)
 {
  for(i=0;i<XMSPRITET;i++)
  {
   xmaddr[i]=ptr=(char*)spfind((sprite_area*)sprites,xmname[i]);

   id.tag=sprite_id_addr;
   id.s.addr=ptr;

   sprite_readsize((sprite_area*)sprites,&id,&resultinfo);

   xmheight[i]=resultinfo.height;
  }
  cached=1;
 }

 return(err);
}




static os_error * xmenuredrawsub(int handle,wimp_redrawstr * redrawstr,
                                                 int more,xmenustr * xm)
{
	os_error * err;
 int        oy;
 int        ox;
 int        ylo;
 int        yhi;
 int        xlo;
 int        xhi;
 int        n;
 int        x;
 int        y;
 int        fonthandle;
 int        fontheight;
 char     * p;
 char     * s;
 sprite_id  id;
 int        index;
 int        italicfont=0;

	err=NULL;

	if(more)
	{
  xmenucachesprites();


// graphicsostext2((hdcstr*)redrawstr->hdcptr);
// graphicsscaleboth(1,1,1,1);
// graphicsscaleboth2(1,1,1,1,(hdcstr*)redrawstr->hdcptr);

  err=wimp_getfont(handle,&fonthandle);
  if(!err) err=font_setfont(fonthandle);
  if(!err) err=font_align(FA_BASELINE|FA_LEFT);
  font_setcolour(0,PALTRANSPARENT,PALBLACK,0);

  fontheight=ypix2os(xm->menufontheight);

  while(more)
  {
   ox=redrawstr->box.x0-redrawstr->scx;
   oy=redrawstr->box.y1-redrawstr->scy;

   yhi=-(redrawstr->g.y0-oy);          /* small +ve number, top of window */
   ylo=-(redrawstr->g.y1-oy);          /* bigger +ve, bottom of window */
   xlo=redrawstr->g.x0-ox;
   xhi=redrawstr->g.x1-ox;

//  n=(ylo-PANETOPMARGIN)/PANESTEP;
   n=ylo/fontheight;
   if(n<0) n=0;
//  y=n*PANESTEP+PANETOPMARGIN;
   y=n*fontheight;
   x=0;

//  cprintf("n %d xmn %d y %d yhi %d ylo %d",n,xm->n,y,yhi,ylo);

   while(y<=yhi && n<xm->n)
   {
    if(n==xm->selected)
    {
     font_setcolour(0,PALTRANSPARENT,PALWHITE,0);
     setgcol(0);
     bbc_rectanglefill(ox+x+LEFTMARGIN,oy-y,xpix2os(xm->maxw)-RIGHTMARGIN-LEFTMARGIN,-fontheight);
    }

    if(n==xm->oldselected)
    {
     setgcol(PALWHITE);
     bbc_rectanglefill(ox+x+LEFTMARGIN,oy-y,xpix2os(xm->maxw)-RIGHTMARGIN-LEFTMARGIN,-fontheight);
    }


    p=xm->data+xm->offset[n];
    s=p+strlen(p)+1;

    if(s[2]=='p')
    {
     if(!italicfont) err=font_embelish(fonthandle,&italicfont,1);
     err=font_setfont(italicfont); 
    }

    font_paint(p,font_ABS|font_OSCOORDS,(ox+x+LEFTMARGIN),oy-y-ypix2os(xm->menufontlead));

    if(s[2]=='p')
    {
     err=font_setfont(fonthandle); 
    }

//   font_paint(p+strlen(p)+1,font_ABS|font_OSCOORDS,xm->maxw+xos2pix(ox+x-RIGHTMARGIN),xm->menufontlead-yos2pix(oy-y));

    id.tag=sprite_id_addr;
    if(s[0]=='1') index=0;
    else
    if(s[0]=='O') index=1;
    else          index=2;

 			if(s[1]=='+') index+=XMSPRITEN;

    id.s.addr=xmaddr[index];
    sprite_put_given((sprite_area*)sprites,&id,0,xpix2os(xm->maxw)+(ox+x-RIGHTMARGIN+RIGHTTAB1),-ypix2os(xm->menufontheight+xmheight[index])/2+(oy-y));
//   graphicsostext2((hdcstr*)redrawstr->hdcptr);


    if(n==xm->selected)
    {
     font_setcolour(0,PALTRANSPARENT,PALBLACK,0);
    }

    if(n==xm->ticked)
    {
//    graphicsriscos2((hdcstr*)redrawstr->hdcptr);
//    tickat(ox+x,oy-y-ypix2os(xm->menufontlead),n==xm->selected?(WIMPWHITE|(WIMPBLACK<<8)):(WIMPBLACK|(WIMPWHITE<<8)));
//    tickat(xos2pix(ox+x),-ypix2os(xm->menufontlead)+(oy-y),n==xm->selected?(WIMPWHITE|(WIMPBLACK<<8)):(WIMPBLACK|(WIMPWHITE<<8)));
     tickat(xos2pix(ox+x),-ypix2os(xm->menufontlead)+(oy-y),(WIMPBLACK|(WIMPWHITE<<8)));
//    graphicsostext2((hdcstr*)redrawstr->hdcptr);
    }

    y+=fontheight;
    n++;
   }


   wimp_get_rectangle(redrawstr,&more);
  }

  if(italicfont) font_lose(italicfont);
	}

 return(NULL);
}



static os_error * xmenuredraw(int handle,int userhandle)
{
 os_error       * err;
 wimp_redrawstr   redrawstr;
 int              more;

 redrawstr.w=handle;
 err=wimp_redraw_wind(&redrawstr,&more);
 if(!err) xmenuredrawsub(handle,&redrawstr,more,(xmenustr*)userhandle);

 return(err);
}





static void panerefreshline(int handle,xmenustr * xm,int n)
{
 wimp_redrawstr r;
 int            more;

 r.box.x0=0;
 r.box.x1=r.box.x0+xpix2os(xm->maxw)+cvdu.extrax;
 r.box.y1=-(n*ypix2os(xm->menufontheight))+cvdu.extray;
 r.box.y0=r.box.y1-ypix2os(xm->menufontheight)-2*cvdu.extray;
 r.w=handle;

 wimp_update_wind(&r,&more);
 xmenuredrawsub(handle,&r,more,xm);
}




static void paneopenline(int handle,xmenustr * xm,int n)
{
 wimp_wstate wblock;
 int         top;
 int         bot;

 wimp_get_wind_state(handle,&wblock);

 top=-((n)*ypix2os(xm->menufontheight));
 bot=-((n+1)*ypix2os(xm->menufontheight));

 if(top>wblock.o.y) wblock.o.y=top;

 if(bot<(wblock.o.y-(wblock.o.box.y1-wblock.o.box.y0))) wblock.o.y=bot+(wblock.o.box.y1-wblock.o.box.y0);

 wimp_open_wind(&wblock.o);
}


static void paneselectn(int handle,xmenustr * xm,int n)
{
 xm->oldselected=xm->selected;
 xm->selected=-1;
 if(xm->oldselected>=0) panerefreshline(handle,xm,xm->oldselected);
 xm->selected=n;
 xm->oldselected=-1;
 if(n>=0) panerefreshline(handle,xm,n);
 if(xm->handler) xm->handler(XM_CHANGE,xm->selected,0,0);
}


static os_error * panechild(xmenustr * xm,int force)
{
 os_error * err;
 windowstr  window;
 int        x;
 int        y;

 err=NULL;

 if(force || isctrl)
 {
  err=getw(xm->handle,&window);
  if(!err)
  {
   x=window.x1;
   y=window.by-xm->selected*ypix2os(xm->menufontheight);

   if(xm->handler) err=xm->handler(XM_CHILD,xm->selected,x,y);
  }
 }

 return(err);
}



#define XKTSIZE 32
#define XKTIME  500

static char xktemp[XKTSIZE];
static int  xkptr;
static int  xklast;


static os_error * xmenukey(int handle,int userhandle,int icon,int * key)
{
 os_error * err;
 xmenustr * xm;
 int        ch;
 int        n;
 int        page;
 char     * p;
 windowstr  window;

 err=NULL;


 ch=*key;
 xm=(xmenustr*)userhandle;

 if(ch==CTRLKEY)
 {
  panechild(xm,1);
 }
	else
	if(ch==SHIFTKEY)
	{
		if(xm->handler)	xm->handler(XM_SHIFT,ch,0,0);
	}
 else
 if(ch==ESCAPE)
 {
  *key=-1;
//  err=xmenuclose(handle,userhandle);
  err=xmenuclearstack(xm-xmen);
 }
 else
 if(ch==CUP || ch==CDOWN || ch==CTRL_CUP || ch==CTRL_CDOWN ||
    ch==SHFT_CUP || ch==SHFT_CDOWN || ch==CTSH_CUP || ch==CTSH_CDOWN)
 {
  n=xm->selected;
  n+=((ch==CDOWN || ch==CTRL_CDOWN || ch==SHFT_CDOWN || ch==CTSH_CDOWN)?1:-1);
  if(n<0) n=0;
  if(n>=xm->n) n=xm->n-1;
  xkptr=0;

  if(n!=xm->selected)
  {
   paneselectn(handle,xm,n);
   paneopenline(handle,xm,n);
  }
  *key=-1;
 }
 else
 if(ch==RETURN || ch==CTRL_RETURN || ch==SHFT_RETURN || ch==CTSH_RETURN)
 {
  if(xm->handler) err=xm->handler(XM_SELECT,xm->selected,0,0);
//  err=xmenuclose(handle,userhandle);   
  err=xmenuclearstack(0);
  *key=-1;
 }
 else
 if(ch==CRIGHT || ch==CTRL_CRIGHT || ch==SHFT_CRIGHT || ch==CTSH_CRIGHT)
 {
  xkptr=0;
  panechild(xm,1);
  *key=-1;
 }
 else
 if(ch==CLEFT || ch==CTRL_CLEFT || ch==SHFT_CLEFT || ch==CTSH_CLEFT)
 {
//  if(xm->handler) err=xm->handler(XM_CHILD,xm->selected);
  xkptr=0;
  if(xm>xmen)
  {
   err=xmenuclearstack(xm-xmen);
   *key=-1;
  }
 }
 else
 if(ch==HOME || ch==CTRL_HOME || ch==SHFT_HOME || ch==CTSH_HOME)
 {
  n=0;
  xkptr=0;
  if(n!=xm->selected)
  {
   paneselectn(handle,xm,n);
   paneopenline(handle,xm,n);
  }
  *key=-1;
 }
 else
 if(ch==COPY || ch==CTRL_COPY || ch==SHFT_COPY || ch==CTSH_COPY)
 {
  n=xm->n-1;
  xkptr=0;
  if(n!=xm->selected)
  {
   paneselectn(handle,xm,n);
   paneopenline(handle,xm,n);
  }
  *key=-1;
 }
 else
 if(ch==PAGEUP || ch==PAGEDOWN || ch==CTRL_PAGEUP || ch==CTRL_PAGEDOWN ||
    ch==SHFT_PAGEUP || ch==SHFT_PAGEDOWN || ch==CTSH_PAGEUP || ch==CTSH_PAGEDOWN)
 {
  err=getw(xm->handle,&window);
  if(!err)
  {
   page=(window.y1-window.y0)/ypix2os(xm->menufontheight);
   n=xm->selected;
   n+=((ch==PAGEDOWN || ch==CTRL_PAGEDOWN || ch==SHFT_PAGEDOWN || ch==CTSH_PAGEDOWN)?page:-page);
   if(n<0) n=0;
   if(n>=xm->n) n=xm->n-1;
   xkptr=0;

   if(n!=xm->selected)
   {
    paneselectn(handle,xm,n);
    paneopenline(handle,xm,n);
   }
   *key=-1;
  }
 }
 else
 if(ch>=' ' && ch<256)
 {
  if((key[KEYTIME]-xklast)>=XKTIME)
  {
   xkptr=0;
  }

  if(xkptr<XKTSIZE)
  {
   xktemp[xkptr++]=(char)toupper(ch);
  }

  xklast=key[KEYTIME];

  for(n=0;n<xm->n;n++)
  {
   p=xm->data+xm->offset[n];

   if(cstrmatch(p,xktemp,xkptr)==xkptr)
   {
    if(n!=xm->selected)
    {
     paneselectn(handle,xm,n);
     paneopenline(handle,xm,n);
    }
    break;
   }
  }
  *key=-1;
 }

 return(err);

 USE(icon);
}





static os_error * xmenuhilight(int handle,xmenustr * xm,wimp_mousestr * m)
{
 os_error * err;
 int        n;
 windowstr  window;

 err=getw(handle,&window);
 if(!err)
 {
  if(m->x>=window.bx && m->x<=(window.bx+xpix2os(xm->maxw)))
  {
   n=((window.by-m->y))/ypix2os(xm->menufontheight);

   if(n>=0 && n<xm->n)
   {
    if(n!=xm->selected)
    {
     if(((xm-xmen)+1)<=xmenstackptr)
     {
      xmenuclearstack((xm-xmen)+1);
     }
     
     paneselectn(handle,xm,n);
     paneopenline(handle,xm,n);
     panechild(xm,0);
    }
   }
  }
 }

 return(err);
}






#define MINTIME 8

static void xmenuzero(xmenustr * xm);


static os_error * xmenuzero2(xmenustr * xm,wimp_mousestr * m)
{
 wimp_wstate   winds;
 int           y;
 int           changed;

 if(m->w==xm->handle && !xm->event)
 {
  changed=0;
  
  wimp_get_wind_state(xm->handle,&winds);

  y=winds.o.box.y1-m->y;
  if(y<=ypix2os(xm->menufontheight) && y>=0)
  {
   if(winds.o.y<0)
   {
    winds.o.y+=ypix2os(xm->menufontheight);
    wimp_open_wind(&winds.o);
    changed=1;
   }
  }

  y=m->y-winds.o.box.y0;
  if(y<ypix2os(xm->menufontheight) && y>=0)
  {
   if((winds.o.y-(winds.o.box.y1-winds.o.box.y0))>(-ypix2os(xm->menufontheight*xm->n)))
   {
    winds.o.y-=ypix2os(xm->menufontheight);
    wimp_open_wind(&winds.o);
    changed=1;
   }
  }

  if(changed)
  {
   addscheduledevent((zerofn)xmenuzero,(int)xm,MINTIME);
   xm->event=1;
   xmenuhilight(xm->handle,xm,m);
  }
 }

 return(NULL);
}



static void xmenuzero(xmenustr * xm)
{
 wimp_mousestr m;

 wimp_get_point_info(&m);
 xm->event=0;
 xmenuzero2(xm,&m);
}

static int mx;
static int my;

static os_error * xmenumousemove(int handle,int userhandle,wimp_mousestr * m)
{
 os_error * err;
 xmenustr * xm;

 err=NULL;

 if(m->x!=mx || m->y!=my)
 {
  xm=(xmenustr*)userhandle;


  xmenuhilight(handle,xm,m);

  if(xm->event)
  {
   remscheduledevent((zerofn)xmenuzero,(int)xm);
   xm->event=0;
  }

  xmenuzero2(xm,m);
  mx=m->x;
  my=m->y;
 }

 return(err);
}


static os_error * xmenudragmove(int handle,int userhandle,wimp_mousestr * m)
{
 xmenustr      * xm;


 cprintf("xmdrag move");

 xm=xmen;
 while(xm<=(xmen+xmenstackptr))
 {
  if(xm->handle==m->w) break;
  xm++;
 }

 if(xm<=(xmen+xmenstackptr))
 {
  return(xmenumousemove(xm->handle,(int)xm,m));
 }

 return(NULL);

 USE(userhandle);
 USE(handle);
}





static os_error * xmenuopen(int handle,int userhandle,wimp_openstr * o)
{
 wimp_mousestr m;

 wimp_get_point_info(&m);
 return(xmenuhilight(handle,(xmenustr*)userhandle,&m));
 USE(o);
}



static os_error * xmenumouse(int handle,int userhandle,int eventhandle,LPARAM lp,WPARAM wparam,int * ack)
{
 os_error * err;
 xmenustr * xm;

 err=NULL;



	if(wparam==WM_NCLBUTTONDBLCLK ||
    wparam==WM_NCLBUTTONDOWN ||
//    wParam==WM_NCLBUTTONUP ||
//    wParam==WM_NCRBUTTONDBLCLK ||
    wparam==WM_NCRBUTTONDOWN ||
//    wParam==WM_NCRBUTTONUP ||
//				wParam==WM_LBUTTONDBLCLK ||
    wparam==WM_LBUTTONDOWN ||
//    wParam==WM_LBUTTONUP ||
//  		wParam==WM_RBUTTONDBLCLK ||
    wparam==WM_RBUTTONDOWN //||
//    wParam==WM_RBUTTONUP
   )
 {
  xm=xmen;
  while(xm<=(xmen+xmenstackptr))
  {
   if(xm->handle==eventhandle) break;
   xm++;
  }
 
  if(xm>(xmen+xmenstackptr))
  {
   xmenuclearstack(0);
  }
  else
  if(((xm-xmen)+1)<=xmenstackptr)
  {
   xmenuclearstack((xm-xmen)+1);
  }
 }


 return(err);

 USE(handle);
 USE(userhandle);
 USE(lp);
 USE(ack);
}



static os_error * xmenuclose(int handle,int userhandle)
{
 xmenustr * xm;

 xm=(xmenustr*)userhandle;

 if(xm->event)
 {
  remscheduledevent((zerofn)xmenuzero,(int)xm);
  xm->event=0;
 }
 remredrawevent(xmenuredraw,handle,userhandle);
 remmousemoveevent(xmenumousemove,handle,userhandle);
 remcloseevent(xmenuclose,handle,userhandle);
 remparentcloseevent(xmenuclose,handle,userhandle);
 remclickevent(xmenuclick,handle,userhandle);
 remkeyevent(xmenukey,handle,userhandle);
 remopenevent(xmenuopen,handle,userhandle);
 if(xm==xmen) remmouseevent(xmenumouse,handle,(int)xm);
 closedown(&handle);

 return(NULL);
}




// t == template id

static os_error * xmenuwindow(int t,int level,int left,int top,int parent,int * offset,int n,char * data,int ticked,xmenuhandler handler)
{
 os_error    * err;
 int           handle;
 wimp_wstate   wst;
 int           i;
 hdcstr      * hdcptr;
 font_metric   metric;
 int           fonthandle;
 font_string   fs;
 int           maxw;
 xmenustr    * xm;
 int           maxh;
 int           vshift;
 wimp_dragstr  d;
 wimp_mousestr m;


 xmenuclearstack(level);

 err=createwindowparent(t,&handle,parent);
 if(!err)
 {
  err=wimp_setwindowflags(handle,WINDOWNOTDIALOGUE,0);
  graphicscreatehdcptr(&hdcptr);
  graphicsscaleboth2(1,1,1,1,(hdcstr*)hdcptr);
//  graphicsostext2(hdcptr);

  xmenstackptr=level;
  xm=xmen+level;

  err=wimp_getfont(handle,&fonthandle);

  if(!err) err=font_setfont2(fonthandle,(oshdc)hdcptr);
  if(!err) err=font_getmetric2(&metric,(oshdc)hdcptr);

  xm->menufontheight=metric.height+metric.intleading;
  xm->menufontlead=metric.ascent;
  xm->data=data;
  xm->offset=offset;
  xm->n=n;
  xm->selected=0;
  xm->oldselected=-1;
  xm->ticked=ticked;
  xm->handler=handler;
  xm->handle=handle;
  xm->event=0;

  maxw=0;
  
  for(i=0;i<n;i++)
  {
   fs.s=data+offset[i];
   fs.split=-1;
   fs.term=strlen(fs.s);
   fs.x=0x3FFFFFFF;
   fs.y=0;

   font_strwidth2(&fs,(oshdc)hdcptr);

   maxw=MAX(maxw,fs.x);
  }

  maxw+=xos2pix(LEFTMARGIN+RIGHTMARGIN);

  xm->maxw=maxw;

  extent(handle,0,-ypix2os(xm->menufontheight)*n,xpix2os(maxw),0);
  maxh=cvdu.screeny-ypix2os(xm->menufontheight)*2;
  maxh=maxh/ypix2os(xm->menufontheight);
  maxh=maxh*ypix2os(xm->menufontheight);
  vshift=(cvdu.screeny-maxh)/2;
  maxh=MIN(maxh,(ypix2os(xm->menufontheight)*n));
  
  maxh+=ypix2os(1);    // fiddle for no scroll bar


  graphicsdeletehdcptr(&hdcptr);

  wimp_setwindowbackground(handle,CCRGB|PALWHITE);

  addclickevent(xmenuclick,handle,(int)xm);
  addredrawevent(xmenuredraw,handle,(int)xm);
  addmousemoveevent(xmenumousemove,handle,(int)xm);
  addcloseevent(xmenuclose,handle,(int)xm);
  addparentcloseevent(xmenuclose,handle,(int)xm);
  addkeyevent(xmenukey,handle,(int)xm);
  addopenevent(xmenuopen,handle,(int)xm);
  if(xm==xmen) addmouseevent(xmenumouse,handle,(int)xm);


  err=wimp_get_wind_state(handle,&wst);
  if(!err)
  {
   wst.o.behind=wimp_TOPMOST;
   wst.o.box.x0=left;
   wst.o.box.x1=wst.o.box.x0+xpix2os(maxw);
   wst.o.box.y1=top;
   wst.o.box.y0=wst.o.box.y1-maxh;
   if(wst.o.box.y0<vshift)
   {
    wst.o.box.y1+=vshift-wst.o.box.y0;
    wst.o.box.y0=vshift;
   }

   if(level==0)
   {
    wst.o.box.x0+=xpix2os(4);
    wst.o.box.x1+=xpix2os(4);
    if(wst.o.box.x1>cvdu.screenx)
    {
     wst.o.box.x1=left-xpix2os(4);
     wst.o.box.x0=wst.o.box.x1-xpix2os(maxw);
    }
   }
   else
   {
    if(wst.o.box.x1>cvdu.screenx)
    {
     wst.o.box.x0-=(wst.o.box.x1-cvdu.screenx);
     wst.o.box.x1=cvdu.screenx;
    }
   }

   wst.o.y=-(((2*ticked+1)*ypix2os(xm->menufontheight)))/2+(wst.o.box.y1-wst.o.box.y0)/2;
  }

 
  if(!err) err=wimp_open_wind(&wst.o);

  setfocus(handle);
 
  if(level==0)
  {
   wimp_get_point_info(&m);
   if(m.bbits)
   {
    startdrag2(handle,(int)xm,xmdrag,xmenudragmove);
    d.type=wimp_USER_HIDDEN;
    d.window=handle;
    wimp_drag_box(&d);
   }
  }
 }

 return(err);
}



/********************************************************************************/

static setfontmenuhandler sfmh;
static setfontmenuhandler2 sfmh2;
static getfontmenuhandler gfmh;
static getfontmenuhandler2 gfmh2;

// this bit generates a font menu - above here does not understand fonts


#define FONTENTRYCHUNK (64*sizeof(int))
#define FONTDATACHUNK  (256)


typedef os_error * (*fontsubmenuhandlerfn)(int code,int param0,int param1,int param2);


static int    fontsubtotal;
static int  * fontsubentryoffset;
static int    fontsubdatasize;
static char * fontsubtextdata;
static int    fontsubfont;        // index in parent menu

static fontsubmenuhandlerfn	fontsubmenuhandler;



static os_error * fontsubmenuevent(int code,int param0,int param1,int param2)
{

 if(code==XM_SELECT)
 {
  if(sfmh2) return(sfmh2(fontsubfont,param0));
 }
	else
	if(code==XM_CHANGE || code==XM_CLOSE || code==XM_SHIFT)
	{
  if(fontsubmenuhandler) fontsubmenuhandler(code,param0,param1,param2);
	}


 return(NULL);

 USE(param1);
 USE(param2);
}



static os_error * fontsubmenu(int handle,int parentfont,int ufn,int x,int y,fontsubmenuhandlerfn fsub)
{
 os_error * err;
 int        i;
 char     * p;
 int        len;
 int        sfont;
 int        userfont;
 char     * s;
 char       temp[32];
 int        type;
 int        slen;

 err=NULL;

 fontsubfont=ufn;

 fontsubmenuhandler=fsub;

 fontsubtotal=0;
 fontsubdatasize=0;
 if(!fontsubentryoffset) err=flex_alloc((flex_ptr)&fontsubentryoffset,FONTENTRYCHUNK);
 if(!err)
 {
  if(!fontsubtextdata)   err=flex_alloc((flex_ptr)&fontsubtextdata,FONTDATACHUNK);
 }

 if(!err)
 {
  i=0;
  userfont=ifont(ufn);
  while(1)
  {
   p=fontlocalname2(userfont,i,0);
   if(!p) break;
   len=strlen(p)+1;

   s=temp;

   type=fonttype(fontosfromuser(userfont));

   if(type==FONTENUM_TT) *s++='T';
			else
			if(type==FONTENUM_OT) *s++='O';
			else                  *s++='1';

   *s++=' ';

   if(fontuserpseudo(userfont+i)) *s++='p';
   else                           *s++=' ';

   *s++=0;
   slen=s-temp;
   
   
   err=flex_chunk((flex_ptr)&fontsubentryoffset,(fontsubtotal+1)*sizeof(int),FONTENTRYCHUNK);
   if(err) break;

   err=flex_chunk((flex_ptr)&fontsubtextdata,fontsubdatasize+len+slen,FONTDATACHUNK);
   if(err) break;

   fontsubentryoffset[fontsubtotal]=fontsubdatasize;
   strcpy(fontsubtextdata+fontsubdatasize,p);
   strcpy(fontsubtextdata+fontsubdatasize+len,temp);
   fontsubtotal++;
   fontsubdatasize+=(len+slen);
   i++;
  }
 }

 if(!err)
 {
  if(parentfont==ufn)
  {
   if(gfmh2)  err=gfmh2(&sfont);
   else       sfont=-1;
  }
  else        sfont=-1;


  err=xmenuwindow(TFONTMENU,1,x,y,handle,fontsubentryoffset,fontsubtotal,fontsubtextdata,sfont,fontsubmenuevent);
 }


 return(err);
}




/********************************************************************************/



static int    fontcount;
static int  * fontentryoffset;
static int    fontdatasize;
static char * fonttextdata;

static int    fontmenuparent;
static int    fontmenufont;        // index of ticked font



static os_error * fontmenusubmenuevent(int code,int param0,int param1,int param2)
{
	os_error * err;
 int        osfont;
	int        userfont;


	err=NULL;


	if(code==XM_CHANGE)
	{
  userfont=ifont(fontsubfont)+param0;
		osfont=fontosfromuser(userfont);
  err=xsamplesetfont(osfont);
	}
	else
	if(code==XM_CLOSE)
	{
  userfont=fontuserfromstyle(fontsubfont,0,0);
		osfont=fontosfromuser(userfont);
  err=xsamplesetfont(osfont);
	}
	else
	if(code==XM_SHIFT)
	{
		err=xsamplestate();
	}


	return(err);

	USE(param1);
	USE(param2);
}




static os_error * fontmenuevent(int code,int param0,int param1,int param2)
{
	os_error * err;
 int        osfont;
	int        userfont;


	err=NULL;


 if(code==XM_SELECT)
 {
  if(sfmh) return(sfmh(param0));
 }
 else
 if(code==XM_CHILD)
 {
  err=fontsubmenu(fontmenuparent,fontmenufont,param0,param1,param2,fontmenusubmenuevent);
		if(!err)
		{
   userfont=ifont(param0);
 		osfont=fontosfromuser(userfont);
   xsamplesetfont(osfont);
		}
 }
	else
	if(code==XM_CHANGE)
	{
  userfont=fontuserfromstyle(param0,0,0);
		osfont=fontosfromuser(userfont);
  err=xsamplesetfont(osfont);
	}
	else
	if(code==XM_SHIFT)
	{
		err=xsamplestate();
	}


 return(err);
}





os_error * fontmenu(int handle)
{
 os_error * err;
 int        i;
 char     * p;
 int        len;
 int        sub;
 int        userfont;
 char       temp[32];
 char     * s;
 int        slen;
 int        type;




 err=NULL;

 fontmenuparent=handle;

 fontcount=0;
 fontdatasize=0;
 if(!fontentryoffset) err=flex_alloc((flex_ptr)&fontentryoffset,FONTENTRYCHUNK);
 if(!err)
 {
  if(!fonttextdata)   err=flex_alloc((flex_ptr)&fonttextdata,FONTDATACHUNK);
 }



 if(!err)
 {
  i=0;
  while(1)
  {
   userfont=ifont(i);
   p=fontlocalname2(userfont,-1,0);
   if(!p) break;
   len=strlen(p)+1;

   s=temp;

   type=fonttype(fontosfromuser(userfont));

   if(type==FONTENUM_TT) *s++='T';
			else
			if(type==FONTENUM_OT) *s++='O';
			else                  *s++='1';

   sub=fontsubcount(userfont);
   if(sub) *s++='+';
			else    *s++=' ';
   
   if(fontuserpseudo(userfont)) *s++='p';
   else                         *s++=' ';

   *s++=0;
   slen=s-temp;


   err=flex_chunk((flex_ptr)&fontentryoffset,(fontcount+1)*sizeof(int),FONTENTRYCHUNK);
   if(err) break;

   err=flex_chunk((flex_ptr)&fonttextdata,fontdatasize+len+slen,FONTDATACHUNK);
   if(err) break;

   fontentryoffset[fontcount]=fontdatasize;
   strcpy(fonttextdata+fontdatasize,p);
   strcpy(fonttextdata+fontdatasize+len,temp);
   fontcount++;
   fontdatasize+=(len+slen);
   i++;
  }
 }

 if(!err)
 {
  if(gfmh)  err=gfmh(&fontmenufont);
  else      fontmenufont=-1;

  wimp_mousestr m;

  wimp_get_point_info(&m);

  err=xmenuwindow(TFONTMENU,0,m.x,m.y,handle,fontentryoffset,fontcount,fonttextdata,fontmenufont,fontmenuevent);


		xopensample(xmen[0].handle,0);
 }


 return(err);
}



/********************************************************************************/




os_error * setfonthandlers(setfontmenuhandler xsfmh,setfontmenuhandler2 xsfmh2,
                           getfontmenuhandler xgfmh,getfontmenuhandler2 xgfmh2)
{
 sfmh=xsfmh;
 sfmh2=xsfmh2;
 gfmh=xgfmh;
 gfmh2=xgfmh2;
 return(NULL);
}




os_error * openfontmenu(setfontmenuhandler xsfmh,setfontmenuhandler2 xsfmh2,
                        getfontmenuhandler xgfmh,getfontmenuhandler2 xgfmh2,int handle)
{
 sfmh=xsfmh;
 sfmh2=xsfmh2;
 gfmh=xgfmh;
 gfmh2=xgfmh2;
 return(fontmenu(handle));
// return(openmenuparent("font_menu",handle));
}


/* setfont(int font); */

void setfont(int fp)
{
 if(sfmh) zreport(sfmh(stack[fp]));
}


/* setsubfont(int font,int sub); */
void setsubfont(int fp)
{
 if(sfmh2) zreport(sfmh2(stack[fp],stack[fp+1]));
}


int getfont(int fp)
{
 int        sfont;

 if(gfmh)  zreport(gfmh(&sfont));
 else      sfont=0;

 return(sfont);

 USE(fp);
}


/* int getsubfont(void); */

int getsubfont(int fp)
{
 int        sfont;

 if(gfmh)  zreport(gfmh2(&sfont));
 else      sfont=0;

 return(sfont);

 USE(fp);
}




/*********************************************************************************/


static os_error * fontosmenuevent(int code,int param0,int param1,int param2)
{

 if(code==XM_SELECT)
 {
  if(sfmh) return(sfmh(param0));
 }
	else
	if(code==XM_CHANGE)
	{
  xsamplesetfont(param0);
	}


 return(NULL);

 USE(param1);
 USE(param2);
}





os_error * fontosmenu(int handle,setfontmenuhandler xsfmh,getfontmenuhandler xgfmh)
{
 os_error * err;
 int        i;
 char     * p;
 int        len;
 char       temp[32];
 char     * s;
 int        slen;
 int        type;



 err=NULL;

 sfmh=xsfmh;
 gfmh=xgfmh;


 fontmenuparent=handle;

 fontcount=0;
 fontdatasize=0;
 if(!fontentryoffset) err=flex_alloc((flex_ptr)&fontentryoffset,FONTENTRYCHUNK);
 if(!err)
 {
  if(!fonttextdata)   err=flex_alloc((flex_ptr)&fonttextdata,FONTDATACHUNK);
 }



 if(!err)
 {
  i=0;
  for(i=0;i<fontostotal();i++)
  {
   p=fontosname(i);

   len=strlen(p)+1;

   s=temp;

   type=fonttype(i);

   if(type==FONTENUM_TT) *s++='T';
			else
			if(type==FONTENUM_OT) *s++='O';
			else                  *s++='1';

			*s++=' ';
   
   *s++=' ';

   *s++=0;
   slen=s-temp;


   err=flex_chunk((flex_ptr)&fontentryoffset,(fontcount+1)*sizeof(int),FONTENTRYCHUNK);
   if(err) break;

   err=flex_chunk((flex_ptr)&fonttextdata,fontdatasize+len+slen,FONTDATACHUNK);
   if(err) break;

   fontentryoffset[fontcount]=fontdatasize;
   strcpy(fonttextdata+fontdatasize,p);
   strcpy(fonttextdata+fontdatasize+len,temp);
   fontcount++;
   fontdatasize+=(len+slen);
  }
 }

 if(!err)
 {
  if(gfmh)  err=gfmh(&fontmenufont);
  else      fontmenufont=-1;

  wimp_mousestr m;

  wimp_get_point_info(&m);

  err=xmenuwindow(TFONTMENU,0,m.x,m.y,handle,fontentryoffset,fontcount,fonttextdata,fontmenufont,fontosmenuevent);

		xopensample(xmen[0].handle,0);
 }


 return(err);
}



/*************************************************************************************/



static os_error * fontusermenuevent(int code,int param0,int param1,int param2)
{
	int osfont;

 if(code==XM_SELECT)
 {
  if(sfmh) return(sfmh(param0));
 }
	else
	if(code==XM_CHANGE)
	{
		osfont=fontosfromuser(param0);
  xsamplesetfont(osfont);
	}


 return(NULL);

 USE(param1);
 USE(param2);
}





os_error * fontusermenu(int handle,setfontmenuhandler xsfmh,getfontmenuhandler xgfmh)
{
 os_error * err;
 int        i;
 char     * p;
 int        len;
 char       temp[32];
 char     * s;
 int        slen;
 int        type;



 err=NULL;

 sfmh=xsfmh;
 gfmh=xgfmh;


 fontmenuparent=handle;

 fontcount=0;
 fontdatasize=0;
 if(!fontentryoffset) err=flex_alloc((flex_ptr)&fontentryoffset,FONTENTRYCHUNK);
 if(!err)
 {
  if(!fonttextdata)   err=flex_alloc((flex_ptr)&fonttextdata,FONTDATACHUNK);
 }



 if(!err)
 {
  i=0;
  for(i=0;i<totuserfonts;i++)
  {
   p=fontusername(i);

   len=strlen(p)+1;

   s=temp;

   type=fonttype(fontosfromuser(i));

   if(type==FONTENUM_TT) *s++='T';
			else
			if(type==FONTENUM_OT) *s++='O';
			else                  *s++='1';

			*s++=' ';
   
   if(fontuserpseudo(i)) *s++='p';
   else                  *s++=' ';

   *s++=0;
   slen=s-temp;


   err=flex_chunk((flex_ptr)&fontentryoffset,(fontcount+1)*sizeof(int),FONTENTRYCHUNK);
   if(err) break;

   err=flex_chunk((flex_ptr)&fonttextdata,fontdatasize+len+slen,FONTDATACHUNK);
   if(err) break;

   fontentryoffset[fontcount]=fontdatasize;
   strcpy(fonttextdata+fontdatasize,p);
   strcpy(fonttextdata+fontdatasize+len,temp);
   fontcount++;
   fontdatasize+=(len+slen);
  }
 }

 if(!err)
 {
  if(gfmh)  err=gfmh(&fontmenufont);
  else      fontmenufont=-1;

  wimp_mousestr m;

  wimp_get_point_info(&m);

  err=xmenuwindow(TFONTMENU,0,m.x,m.y,handle,fontentryoffset,fontcount,fonttextdata,fontmenufont,fontusermenuevent);

		xopensample(xmen[0].handle,0);
 }


 return(err);
}




