/*->c.fx */


#include "stdafx.h"

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <locale.h>
#include <math.h>  
#include <ctype.h>

#include "os.h"
#include "wimp.h"
#include "wimpt.h"
#include "werr.h"
#include "flex.h"
#include "alloc.h"
#include "bbc.h"
#include "font.h"
#include "transform.h"
#include "xmath.h"
#include "colour.h"
#include "xprocess.h"
#include "osgraphics.h"

#include "wos.h"
#include "poll.h"
#include "key.h"
#include "etc.h"
#include "err.h"
#include "hourglass.h"
#include "xext.h"
#include "bits.h"
#include "fsx.h"
#include "bf.h"
#include "timex.h"
#include "deb.h"
#include "osunits.h"
#include "drawmod.h"
#include "imlib.h"


#include "str.h"
#include "constants.h"

#include "reslink.h"

#include "view.h"
#include "file.h"
#include "xcolour.h"
#include "xredraw.h"
#include "xrender.h"
#include "object.h"
#include "geometry.h"
#include "pref.h"
#include "border.h"
#include "prstr.h"
#include "postscript.h"


#include "codes.h"
#include "txstr.h"
#include "tx.h"
#include "spchk.h"
#include "txchoices.h"

#include "fcache.h"
#include "fox.h"
#include "style.h"
#include "ustyle.h"
#include "blank.h"
#include "vl.h"
#include "tabs.h"

#include "roman.h"


#include "fx.h"



/*
   convert our form of text into fontman form, and perform actions with it

*/

       char      * fbuff;
       char     ** ffl;        /* offset in source */
       char     ** ffb;        /* offset in buffer */
static int       * fxs;

/* static short int * ffs; */       /* spaces so far    */

/* fbuff must not move whilst rendering because of FTRANSFORM */



       int    fxitem;
static char * w; 
/* static int    spcs; */
static char * fbuff1;          /* fixed values of pointers used */
static char * srcdata1;        /* for working out values        */
static int    srcgap;          /* gap offset                    */
static int    srcgapsize;      /* gap size                      */
                               /* There is a problem if the text */
                               /* should happen to move between  */
                               /* calls to expand to fbuff       */


static int    oldlen;          /* old length in original of stuff in buffer*/
static int    oldoffset;
static int    oldsource;


/* variables accessible from outside */

int        fmaxpt;
int        fmaxld;
int        fmaxht;
int        fmaxas;
int        fmaxlen;
int        fterminated;
int        fxsmaxht;
int        fxsmaxy;
int        fxsminy;

static int fxsmaxld;
int        fxfmaxld;

int        fxwidth;




/* mode variables, depend on what we're doing */

static filestr * ffile;        /* current file */
static viewstr * fview;


static int       fpaintmode;   /* actually rendering onto screen */


colourvalue       ffcol;        /* first values in a line         */
colourvalue       fbcol;
int       ffont;
int       ffontos;
int       ffxpt;
int       ffypt;

static int       fpchange;     /* have to be set up if this is true  */
                               /* this is flagging if the first font */
                               /* in a line is different to the last */
                               /* one. where last is whatever we     */
                               /* rendered last                      */

static int       fpfonth;      /* current values */
static colourvalue       fpfbcol;
static colourvalue       fpffcol;

static int       fpending;     /* we've seen a style code */
static int       firstone;     /* no styles seen so far   */


/* current values */

static xstylestr   fstyles;
static int         fstyle;       /* flag non-plain text */
static colourvalue         bcol;
static int         fxpts;
static int         fypts;
static int         flead;
static int         fascent;
static int         fheight;
static int         lastch;
static int         lastch2;
static int         smlsize;

       int       fxlineakern;   /* auto kern this line        */
       int       fxfirsteob;    /* first embedded object      */
       int       fxbullettab;   /* bullets are tabs here      */
       int       fxlinejustify; /* justification on this line */
       int       fxlinespace;
       int       fxlinedx;
       int       fxlineddx;
       int       fxlinedy;
       int       fxlineddy;
static int       fxjustlettermin;
static int       fxjustlettermax;
static int       fxjustsingle;
static int       fxjustwordmin;
static int       fxjustwordmax;

static int       fxinvisibles;
static int       fxspell;

static int       fxbaselinemode;

       int       fxuni;          // in unicode mode

#define FXMAXSPERR 16

static int     * fxsperrors;
static int       fxmaxsp;

static int            fxleaderwidth;
static char           fxleader[(LEADERMAXLEN+1)*3];
static unsigned short fxleader2[LEADERMAXLEN+1];
static int            fxcurrtab;
static int            fxleaderchanged;  /* has leader been changed by a tab? */
static int            fxleadercalc;     /* been a sno, need to recalc        */
static int            fxleaderlen;						/* writing point in fxleader[] */
static int            fxleaderdata;					// set once we have gone past any leading TABDATA in the ruler, includes leading TAB, this is just clearing the potential for concat TABDATA with style leader
static int            fxleaderstyle;				// set if leader set by style
static char           fxbaseleader[LEADERLEN];	// copy of style leader for tab ruler

static int       fxshift;


/* pending values */

static int       pshift;
static int       pxpt;
static int       pypt;
static colourvalue  pbcol;
static colourvalue  pfcol;
static int       pfont;
static int       pfontos;

static int       puline;    /* 0==none, 1==single, 2==double, bit 2==strike */
static colourvalue       pulcolour;
static int       pulthickness;
static int       pultype;
static colourvalue       pstcolour;
static int       pstthickness;
static int       psttype;

static int       ptrack;

static int       pht;
static int       pld;

static int       pangle;
static int       pskew;


/* running values */

static int       rfonth;
static int       rshift;
static int       rxpt;
static int       rypt;
static colourvalue rfcol;
static colourvalue rbcol;
static int       rfont;
static int       rfontos;

static int       ruline;
static colourvalue rulcolour;
static int       rulthickness;
static int       rultype;
static colourvalue rstcolour;
static int       rstthickness;
static int       rsttype;

static int       rtrack;

static int       rangle;
static int       rskew;



static int       fxspaces;   /* only used in paint expand, no of spaces */
static int       fxchars;    /* only used in paint expand, no of chars  */

static int          fxtrans; /* flags painting rotated text             */
       transformstr fxtr;

static int          fxdrop;      /* true if drop cap being expanded  */
static int          fxdropfix;   /* extra shift down to make top of  */
                                 /* drop cap match top of normal cap */
       int          fxdropdiff;  /* difference between char lead and */
                                 /* normal line lead to make top of  */
                                 /* char touch top posn, used for fit*/
                                 /* baseline                         */

static int          fxeobangle;  /* true if correcting eob angles    */
static int          fxboxangle;

static int          fxnbsp;      /* true if mapping code 160 to 32  */

static char       * fxmove;


static int          fxmulx;
static int          fxdivx;

static int          fxmuly;
static int          fxdivy;

static int          fxdpix;						// e.g. 7200, 180
static int          fxdpiy;						// e.g. 7200, 180

static int          fxzmulx;
static int          fxzdivx;

static int          fxzmuly;
static int          fxzdivy;





#define FXSCALEX(a) (scale((a),fxmulx,fxdivx))
#define FXINVSCALEX(a) (scale((a),fxdivx,fxmulx))

#define FXSCALEY(a) (scale((a),fxmuly,fxdivy))
#define FXINVSCALEY(a) (scale((a),fxdivy,fxmuly))

#define FXZSCALEX(a) (scale((a),fxzmulx,fxzdivx))
#define FXZSCALEY(a) (scale((a),fxzmuly,fxzdivy))


#define FXCVNE(c1,c2) ( (*((int*)(&(c1))))!=(*((int*)(&(c2)))) )
#define FXCVEQ(c1,c2) ( (*((int*)(&(c1))))==(*((int*)(&(c2)))) )




static void writemove(int dx,int dy);
static int  writemovesize(int dx,int dy);
static int  fxcode(int ch,int osfont);
static void writecharconvert(int ch,int osfont);




static void flushstate(void);

// assumed that none of those below need conversion for unicode

#define INVSPACE     183
#define INVHARDSPACE 175
#define INVTAB       187
#define INVNL        182
#define INVCR        172
#define INVEOT       164
#define INVEOBOX     166
#define INVEOPAGE    167
#define INVSPACESEQ  176
#define INVDCHYPH    124


/* out of band value use for lastch is a space that delimits */
// changed for unicode was 0x101

#define SPACESEQISDELIM 0x10001



/********************************************************************************/


static int          fxsmulx;
static int          fxsdivx;
static int          fxsmuly;
static int          fxsdivy;
static int          fxszmulx;
static int          fxszdivx;
static int          fxszmuly;
static int          fxszdivy;




static void fxsavescale(void)
{
 fxsmulx=fxmulx;
 fxsdivx=fxdivx;

 fxsmuly=fxmuly;
 fxsdivy=fxdivy;

 fxszmulx=fxzmulx;
 fxszdivx=fxzdivx;

 fxszmuly=fxzmuly;
 fxszdivy=fxzdivy;
}


static void fxloadscale(void)
{
 fxmulx=fxsmulx;
 fxdivx=fxsdivx;

 fxmuly=fxsmuly;
 fxdivy=fxsdivy;

 fxzmulx=fxszmulx;
 fxzdivx=fxszdivx;

 fxzmuly=fxszmuly;
 fxzdivy=fxszdivy;
}



static void fxaddscale(int xscale,int yscale)
{

 if(xscale!=0x10000)
 {
  fxmulx=scale(fxsmulx,xscale,fxsdivx);
  fxdivx=0x10000;

  fxzmulx=fxszmulx*xscale;
  fxzdivx=fxszdivx*0x10000;
 }

 if(yscale!=0x10000)
 {
  fxmuly=scale(fxsmuly,yscale,fxsdivy);
  fxdivy=0x10000;

  fxzmuly=fxszmuly*yscale;
  fxzdivy=fxszdivy*0x10000;
 }
}




static void fxsetupscale(viewstr * view)
{
 if(view)
	{
  fxzmulx=view->data.zoom.mul;
  fxmulx=view->data.zoom.mul*fxdpix;
  fxzmuly=view->data.zoom.mul;
  fxmuly=view->data.zoom.mul*fxdpiy;

  fxzdivx=fxzdivy=view->data.zoom.div;
  fxdivx=fxdivy=view->data.zoom.div*72000;
	}
	else
	{
  fxzdivx=fxzdivy=fxzmulx=fxzmuly=1;
  fxmulx=fxdpix;
  fxmuly=fxdpiy;
  fxdivx=fxdivy=72000;
	}
}


static void fxsetupresolution(int dpix,int dpiy)
{
	fxdpix=dpix;
	fxdpiy=dpiy;
}



static os_error * fontsetviewscale(viewstr * view)
{
 os_error * err;

 err=NULL;

 fxsetupresolution(cvdu.xdpi,cvdu.ydpi);
 fxsetupscale(view);

 fontsetcachetrap();

 return(err);
}





/******************************************************************************/

int fxtolower(int c)
{
 if(fxuni) return(towlower((unsigned short)c));
 else      return(riscos_tolower(c));
}


int fxtoupper(int c)
{
 if(fxuni) return(towupper((unsigned short)c));
 else      return(riscos_toupper(c));
}


int fxislower(int c)
{
 if(fxuni) return(iswlower((unsigned short)c));
 else      return(riscos_islower(c));
}



/*****************************************************************************/


#define  FXMAXI   (512)
#define  FXMAXL   (2048)
#define  FXBANDL  64
#define  FXBANDI  8


       int fxmaxl;
       int fxmaxi;


static os_error * fxchunkin(int chunki)
{
 os_error * err;

	err=NULL;

 if(chunki>fxmaxi)
 {
  chunki=((chunki/FXMAXI)+1)*FXMAXI;

           err=srealloc((flex_ptr)&ffl,chunki*sizeof(*ffl)+FXBANDI);
  if(!err) err=srealloc((flex_ptr)&ffb,chunki*sizeof(*ffb)+FXBANDI);
  if(!err) err=srealloc((flex_ptr)&fxs,chunki*sizeof(*fxs)+FXBANDI);

  if(!err) fxmaxi=chunki;
 }
 return(err);
}

       
       
os_error * fxchunki(void)
{
 os_error * err;

 err=fxchunkin(fxmaxi+FXMAXI-1);

 return(err);
}




os_error * fxchunkl(void)
{
 os_error * err;

 err=srealloc((flex_ptr)&fbuff,fxmaxl+FXMAXL+FXBANDL);

 if(!err) fxmaxl+=FXMAXL;

 return(err);
}


static os_error * fxbuffinit(void)
{
 os_error * err;

          err=salloc((flex_ptr)&fbuff,FXMAXL+FXBANDL);
 if(!err) err=salloc((flex_ptr)&ffl,(FXMAXI+FXBANDI)*sizeof(*ffl));
 if(!err) err=salloc((flex_ptr)&ffb,(FXMAXI+FXBANDI)*sizeof(*ffb));
 if(!err) err=salloc((flex_ptr)&fxs,(FXMAXI+FXBANDI)*sizeof(*fxs));


 fxmaxl=FXMAXL;
 fxmaxi=FXMAXI;

 return(err);
}



/*****************************************************************************/
/* cache prefs */

static int        supersize;
static int        subsize;
static int        smallsize;
static int        chapsep;
unsigned short    fxdectab[MAXDECTABCHAR+1];
unsigned short    fxhyphenchar[MAXHYPHENCHAR+1];
       int        fxbaseorigin;
       int        fxbasespacing;
       int        fxautopageinsert;
       int        fxautopageremove;
static filestr *  filepref;


void fxcheckprefs(filestr * file)
{
 prefdatastr * prefs;
	int           len;
	char          string[16];

 if(file!=filepref)
 {
  prefs=prefp(file);

  supersize=prefs->supersize;
  subsize=prefs->subsize;
  smallsize=prefs->smallsize;
  chapsep=prefs->chapterseparator;


		memcpy(string,prefs->decimaltab1,4);
		memcpy(string+4,prefs->decimaltab2,8);
		txstring12(string,12,fxdectab,NITEM(fxdectab),NULL);

		txstring12(prefs->hyphenchar,sizeof(prefs->hyphenchar),fxhyphenchar,NITEM(fxhyphenchar),&len);
  if(len==0)
  {
   fxhyphenchar[0]='-';
   fxhyphenchar[1]=0;
		}

  fxbaseorigin=prefs->baselinegridorigin;
  fxbasespacing=prefs->baselinegridspacing;

  if(fxbaseorigin>0)
  {
   if(fxbasespacing>0)
   {
    fxbaseorigin-=((fxbaseorigin/fxbasespacing)+1)*fxbasespacing;
   }
   else
   {
    fxbaseorigin=0;
   }
  }

  filepref=file;
  fxautopageinsert=!prefs->autopageinsert;
  fxautopageremove=!prefs->autopageremove;
 }
}



/*****************************************************************************/
/* do it yourself underline/strikeout */

#define MAXUL 32


typedef struct ulstr
{
 int  x0;        /* start   x   */
 int  x1;        /* end     x   */
 char n;
 char bits[4];
 int  y[4];      /* y coords    */
 int  d[4];      /* thickness's */
 colourvalue  cv[4];     /* colours     */
} ulstr;

static ulstr * uline;
static int     ulindex;    /* current ulstr    */
static int     ulmax;      /* max no of ulstrs */
static char  * firstlastspc;


#define XULUNITS 0x1

#define XULTYPE  0xE
#define XUL1     0x2
#define XUL2     0x4
#define XULST    0x6
#define XULSP    0x8


/* call this at start of line */

static void ulstart(void)
{
 ulindex=0;
}


/* finish off current ulstr */

static void ulend(int eol)
{            
 os_error * err;
 int        n;
 int        shortend;
 int        xuline;

 if(fpaintmode)
 {
  shortend=eol && fstyles.data.ulword && (ruline & 0x1) &&
     (lastch==SPACE || lastch==NBSPACE || lastch==TABSEQ || 
      lastch==SPACESEQISDELIM || lastch==SPACESEQ);
  xuline=ruline;

  while(1)
  {
   if(ulindex>=ulmax)
   {
    err=srealloc((flex_ptr)&uline,(ulmax+MAXUL)*sizeof(ulstr));
    if(!err) ulmax+=MAXUL-2;
    else     break;
   }

   uline[ulindex].x1=shortend?(firstlastspc-fbuff):(w-fbuff);

   if(uline[ulindex].x1>uline[ulindex].x0)
   {
    n=0;

    if(xuline & 0x1)
    {
     uline[ulindex].bits[n]=(char)(XUL1|rultype);
     uline[ulindex].d[n]=rulthickness;
     uline[ulindex].cv[n]=rulcolour;
     n++;
    }

    if((xuline & 0x3)==0x3)   /* both bits set */
    {
     uline[ulindex].bits[n]=(char)(XUL2|rultype);
     uline[ulindex].d[n]=rulthickness;
     uline[ulindex].cv[n]=rulcolour;
     n++;
    }

    if(xuline & 0x4)
    {
     uline[ulindex].bits[n]=(char)(XULST|rsttype);
     uline[ulindex].d[n]=rstthickness;
     uline[ulindex].cv[n]=rstcolour;
     n++;
    }

    if(xuline & 0x8)
    {
     uline[ulindex].bits[n]=XULSP;
     uline[ulindex].d[n]=1800;
     cvfrompal(&uline[ulindex].cv[n],0xC000);
     n++;
    }

    uline[ulindex].n=(char)n;
    ulindex++;
   }

   if(shortend && (xuline & 0x4))
   {
    xuline&=~0x3;
    uline[ulindex].x0=uline[ulindex-1].x1;
    shortend=0;
   }
   else break;
  }
 }
}


/* start a new ulstr        */

static void ulbegin(void)
{
 if(fpaintmode)
 {
  if(ulindex<ulmax)
  {
   uline[ulindex].x0=w-fbuff;
  }
 }
}



#define YLIMIT 0x7FFFFFFF
#define XLIMIT 0x7FFFFFFF

/* call this to paint underlining */

/* Would like to merge strips, e.g. don't chop up strikeout with word ul */


static os_error * underline(int x,int y,transformstr * tr,viewredrawstr * v,filestr * file)
{
 os_error   * err;
 int          path[8];
 int          caps[4];
 transformstr restr;
 transformstr restr2;
 transformstr fxtr;
 int          thickness;
 int          i;
 int          pass;
 int          type;
 int          min;
 int          transparent;



 err=NULL;

 if(ulindex)
 {
  for(i=0;i<ulindex;i++)
  {
   for(pass=0;pass<uline[i].n;pass++)
   {
    if(uline[i].bits[pass] & XULUNITS)
       uline[i].d[pass]=scale(fmaxpt,uline[i].d[pass],0x10000);

    type=uline[i].bits[pass] & XULTYPE;
    if(type==XUL1)  uline[i].y[pass]=-(32*fmaxpt)/256;
    else
    if(type==XUL2)  uline[i].y[pass]=-(64*fmaxpt)/256-2*uline[i].d[pass];
    else
    if(type==XULST) uline[i].y[pass]=fmaxld/3;
    else
    if(type==XULSP) 
    {
     uline[i].y[pass]=(8*fmaxpt)/256;
     if(uline[i].d[pass]>(3*(fmaxht-fmaxld))/4)
     {
      uline[i].d[pass]=(3*(fmaxht-fmaxld))/4;
     }
    }
   }
  }


  for(i=0;i<ulindex;i++)
  {
   for(pass=0;pass<uline[i].n;pass++)
   {
    if(!vcolourtrans((v?v->view:NULL),(v?v->file:file),&uline[i].cv[pass]))
    {
     thickness=uline[i].d[pass];

     min=MIN(cvdu.deltax,cvdu.deltay);
     if(v)
     {
      if(osunits(thickness,v->view)<(min<<1) && !v->isprinter) 
      {
       thickness=0;
      }
     }
     else
     {
      if(bosunits(thickness)<(min<<1)) thickness=0;
     }

     path[0]=2;
     path[1]=uline[i].x0;                          /* x start    */
     path[2]=path[5]=uline[i].y[pass]-thickness;   /* y star/end */
     path[3]=0x8;
     path[4]=uline[i].x1;                /* x end      */
     path[6]=0;
     path[7]=0;

     caps[0]=0;
     caps[1]=0x20000;
     caps[2]=0;
     caps[3]=0;

//       cprintf("underline x0=%d y0=%d e=%d f=%d",path[1],path[5],restr.e,restr.f);

     if(v) err=render_setcolour(&uline[i].cv[pass],&transparent,v);
					else		err=vsetcolourfile(&uline[i].cv[pass],&transparent,file);

     if(tr)
     {
      restr=*tr;
     }
     else
     {
      tr_setidentity(&restr);
     }

     tr_setscale(&fxtr,fxzdivx,fxzmulx,fxzdivy,fxzmuly);
     tr_multiply(&restr2,&restr,&fxtr);

     restr2.e=x;
     restr2.f=y;
//     restr2.e/=400;
//     restr2.f/=400;


     if(v) err=render_draw_stroke(path,thickness,DRAWMOD_FONTUNITS,caps,&restr2,0,0,v);  // flags was 0x80000038
					else		err=Draw_Stroke(path,thickness,DRAWMOD_FONTUNITS,caps,&restr2,0,0);

     if(err) break;
    }
   }
  }
 }


 return(err);
}



static os_error * ulcalc(void)
{
 font_string  fs;
 int          i;

 for(i=0;i<ulindex;i++)
 {
//  cprintf("t0=%d t1=%d",uline[i].x0,uline[i].x1);
  
  fs.s=fbuff;
  fs.split=-1;
  fs.x=XLIMIT;
  fs.y=YLIMIT;
  fs.term=uline[i].x0;

  fxstrwidth(&fs,fxlinedx,fxlineddx,fxlineakern);    /* dx, dy , akern */
  uline[i].x0=fs.x;

  fs.s=fbuff;
  fs.split=-1;
  fs.x=XLIMIT;
  fs.y=YLIMIT;
  fs.term=uline[i].x1;

  fxstrwidth(&fs,fxlinedx,fxlineddx,fxlineakern);
  uline[i].x1=fs.x;

//  cprintf("x0=%d x1=%d",uline[i].x0,uline[i].x1);
 }

 return(NULL);
}



static os_error * ulinit(void)
{
 ulmax=MAXUL-2;
 return(salloc((flex_ptr)&uline,MAXUL*sizeof(ulstr)));
}


/***************************************************************************/
/* do it yourself background colour */

#define MAXBK 16


typedef struct bkstr
{
 int x0;        /* start   x   */
 int x1;        /* end     x   */
 colourvalue cv;
} bkstr;

static bkstr * bkline;
static int     bkindex;    /* current bkstr    */
static int     bkmax;      /* max no of bkstrs */

/* call this at start of line */

static void bkstart(void)
{
 bkindex=0;
}


/* finish off current bkstr */

static void bkend(void)
{            
 os_error * err;

 if(fpaintmode)
 {
  if(bkindex>=bkmax)
  {
   err=srealloc((flex_ptr)&bkline,(bkmax+MAXBK)*sizeof(bkstr));
   if(!err) bkmax+=MAXBK-2;
  }

  if(bkindex<bkmax)
  {
   bkline[bkindex].x1=w-fbuff;
   bkindex++;
  }
 }
}


/* start a new bkstr        */

static void bkbegin(colourvalue cv)
{
 if(fpaintmode)
 {
  if(bkindex<bkmax)
  {
   bkline[bkindex].x0=w-fbuff;
   bkline[bkindex].cv=cv;
  }
 }
}




/* call this to paint filled background */

static os_error * backgroundpaint(int x,int y,transformstr * tr,viewredrawstr * v)
{
 os_error   * err;
 int          path[20];
 transformstr restr;
 transformstr restr2;
 transformstr fxtr;
 int          i;
 int          ld;
 int          transparent;

 err=NULL;

 if(bkindex)
 {
  ld=fxdrop?fxsmaxld:fmaxld;

  for(i=0;i<bkindex;i++)
  {
   if(!vcolourtrans(v->view,v->file,&bkline[i].cv))
   {
    path[0]=DRAWMOVE;
    path[1]=bkline[i].x0;                      /* x start     */
    path[2]=ld;                                /* y start/end */

    path[3]=DRAWDRAW;
    path[4]=bkline[i].x1;                      /* x end      */
    path[5]=ld;

    path[6]=DRAWDRAW;
    path[7]=bkline[i].x1;
    path[8]=ld-fmaxht;

    path[9]=DRAWDRAW;
    path[10]=bkline[i].x0;
    path[11]=ld-fmaxht;

    path[12]=DRAWDRAW;
    path[13]=bkline[i].x0;
    path[14]=ld;

    path[15]=DRAWCLOSE;
    path[16]=DRAWEND;


     if(tr)
     {
      restr=*tr;
     }
     else
     {
      tr_setidentity(&restr);
     }

//     tr_setscale(&fxtr,fxidivx,fximulx,fxidivy,fximuly);
//     tr_multiply(&restr2,&restr,&fxtr);

     tr_setscale(&fxtr,fxzdivx,fxzmulx,fxzdivy,fxzmuly);
     tr_multiply(&restr2,&restr,&fxtr);

     restr2.e=x;
     restr2.f=y;


             err=render_setcolour(&bkline[i].cv,&transparent,v);
    if(!err) err=render_draw_fill(path,&restr2,0x30,0,DRAWMOD_FONTUNITS,v);
   }
  }
 }

 return(err);
}


static os_error * bkcalc(void)
{
 font_string  fs;
 int          i;
 int          j;

 for(i=0;i<bkindex;i++)
 {
  fs.s=fbuff;
  fs.split=-1;
  fs.x=XLIMIT;
  fs.y=YLIMIT;
  fs.term=bkline[i].x0;

  fxstrwidth(&fs,fxlinedx,fxlineddx,fxlineakern);    /* dx, dy , akern */
  bkline[i].x0=fs.x;

  fs.s=fbuff;
  fs.split=-1;
  fs.x=XLIMIT;
  fs.y=YLIMIT;
  fs.term=bkline[i].x1;

  fxstrwidth(&fs,fxlinedx,fxlineddx,fxlineakern);
  bkline[i].x1=fs.x;
 }

 for(i=j=0;i<bkindex;i++)				// take out any zero width background fill example text frame with nothing in and text background colour not same as frame background
 {
		if(bkline[i].x0!=bkline[i].x1)
		{
			bkline[j]=bkline[i];
			j++;
		}
	}

	bkindex=j;

 return(NULL);
}



static os_error * bkinit(void)
{
 bkmax=MAXBK-2;
 return(salloc((flex_ptr)&bkline,MAXBK*sizeof(bkstr)));
}

/***************************************************************************/


#define MAXFK 16


typedef struct fkstr
{
 int x0;        /* start   x   */
 int x1;        /* end     x   */
 int xshift;
 int yshift;
} fkstr;


static fkstr * fkline;
static int     fkindex;    /* current fkstr    */
static int     fkmax;      /* max no of fkstrs */
static int     fkcurr;


/* call this at start of line */

static void fkstart(void)
{
 fkindex=fkcurr=0;
}


/* finish off current fkstr */

static void fkend(void)
{            
 os_error * err;

 if(fpaintmode)
 {

  
		if(fkcurr==-1)
  {
   if(fkindex>=fkmax)
   {
    err=srealloc((flex_ptr)&fkline,(fkmax+MAXFK)*sizeof(fkstr));
    if(!err) fkmax+=MAXFK-2;
   }

   if(fkindex<fkmax)
   {
    fkline[fkindex].x1=w-fbuff;
    fkindex++;
   }

		//	cprintf("fkend %d",fkindex);

   fkcurr=0;
  }
 }
}


/* start a new fkstr        */

static void fkbegin(colourvalue cv)
{
 if(fpaintmode)
 {
//		cprintf("fkbegin %d %d",vcolourtrans(fview,ffile,&cv),fkcurr!=-1);

  if(vcolourtrans(fview,ffile,&cv) && fkcurr!=-1)
  {
   if(fkindex<fkmax)
   {
    fkline[fkindex].x0=w-fbuff;
   }
   fkcurr=-1;
  }
 }
}







static void fkcopy(char * d,char * s,int size)
{
 char * e;


 e=s+size;

 while(s<e)
 {
  switch(*s)
  {

   case  FXFONTCODE:
                  XMEMCPYX(d,s,FXFCLEN);
                  s+=FXFCLEN;
                  d+=FXFCLEN;
                  break;

   case  FXCOLCODE2:
                  XMEMCPYX(d,s,FXCC2LEN);
                  s+=FXCC2LEN;
                  d+=FXCC2LEN;
                  break;

   case        FXHM:
                  XMEMCPYX(d,s,FXHMLEN);
                  s+=FXHMLEN;
                  d+=FXHMLEN;
                  break;

   case        FXVM:
                  XMEMCPYX(d,s,FXVMLEN);
                  s+=FXVMLEN;
                  d+=FXVMLEN;
                  break;

   case        FXTRANSFORM:
                  XMEMCPYX(d,s,FXTRANSLEN);
                  s+=FXTRANSLEN;
                  d+=FXTRANSLEN;
                  break;


          default:
                  *d++=*s++;
                  if(fxuni) *d++=*s++;
                  break;

  } 
 }
}






static int fkscheck8(int i,int * font,int * xpts,int * ypts,transformstr * tr,int * tflag)
{
 char * p;
 char * e;
 int    c;
 int    size;


 *font=*tflag=0;

 p=fbuff+fkline[i].x0;
 e=fbuff+fkline[i].x1;

 while(p<e)
 {
  c=*p++;

  if(c<32)
  {
   switch(c)
   {
    case  FXFONTCODE:
                   *font=(*(p))+((*(p+1))<<8)+((*(p+2))<<16)+((*(p+3))<<24);
                   *xpts=(*(p+4))+((*(p+5))<<8)+((*(p+6))<<16)+((*(p+7))<<24);
                   *ypts=(*(p+8))+((*(p+9))<<8)+((*(p+10))<<16)+((*(p+11))<<24);
                   p+=FXFCLEN-1;
                   break;

    case  FXCOLCODE2:
                   p+=FXCC2LEN-1;
                   break;

     case        FXHM:
                    p+=FXHMLEN-1;
                    break;

     case        FXVM:
                    p+=FXVMLEN-1;
                    break;

     case        FXTRANSFORM:
                    memcpy(tr,p+1,4*sizeof(int));
                    *tflag=1;
                    p+=FXTRANSLEN-1;
                    break;

            default:
                    break;

   }
  } 
 }


 if(*font) size=FXFCLEN;
 else      size=0;

 if(*tflag)
 {
  size+=FXTRANSLEN;
 }


 return(size);
}



static int fkscheck16(int i,int * font,int * xpts,int * ypts,transformstr * tr,int * tflag)
{
 char * p;
 char * e;
 int    c;
 int    size;


 *font=*tflag=0;

 p=fbuff+fkline[i].x0;
 e=fbuff+fkline[i].x1;

 while(p<e)
 {
  c=*p++;
  c+=(*p++)<<8;

  if(c<32)
  {
   switch(c)
   {
    case  FXFONTCODE:
                   *font=(*(p))+((*(p+1))<<8)+((*(p+2))<<16)+((*(p+3))<<24);
                   *xpts=(*(p+4))+((*(p+5))<<8)+((*(p+6))<<16)+((*(p+7))<<24);
                   *ypts=(*(p+8))+((*(p+9))<<8)+((*(p+10))<<16)+((*(p+11))<<24);
                   p+=FXFCLEN-2;
                   break;

    case  FXCOLCODE2:
                   p+=FXCC2LEN-2;
                   break;

     case        FXHM:
                    p+=FXHMLEN-2;
                    break;

     case        FXVM:
                    p+=FXVMLEN-2;
                    break;

     case        FXTRANSFORM:
                    memcpy(tr,p+1,4*sizeof(int));
                    *tflag=1;
                    p+=FXTRANSLEN-1;
                    break;

            default:
                    break;

   }
  } 
 }


 if(*font) size=FXFCLEN;
 else      size=0;

 if(*tflag)
 {
  size+=FXTRANSLEN;
 }

 return(size);
}



static int fkscheck(int i,int * font,int * xpts,int * ypts,transformstr * tr,int * tflag)
{
 if(fxuni) return(fkscheck16(i,font,xpts,ypts,tr,tflag));
 else      return(fkscheck8(i,font,xpts,ypts,tr,tflag));
}






static os_error * fkcalc(int * skip)
{
 font_string  fs;
 int          i;
 int          xshift;
 int          yshift;
 int          shift;
 int          size;
 int          delta;
 int          copy;
 int          sum;
 char       * r;
 char       * e;
 int          font;
 int          xpts;
 int          ypts;
 int          tflag;
 transformstr tr;

 *skip=(vcolourtrans(fview,ffile,&ffcol) && fkindex==1 && fkline[0].x1==(w-fbuff));

// cprintf("skip=%d col=%d index=%d x1=%d %d",*skip,ffcol,fkindex,fkline[0].x1,(w-fbuff));

 if(!(*skip) && fkindex>0)
 {
  for(i=0;i<fkindex;i++)
  {
   fs.s=fbuff;
   fs.split=-1;
   fs.x=XLIMIT;
   fs.y=YLIMIT;
   fs.term=fkline[i].x0;

   fxstrwidth(&fs,fxlinedx,fxlineddx,fxlineakern);    /* dx, dy , akern */
   xshift=fs.x;
   yshift=fs.y;

   fs.s=fbuff;
   fs.split=-1;
   fs.x=XLIMIT;
   fs.y=YLIMIT;
   fs.term=fkline[i].x1;

   fxstrwidth(&fs,fxlinedx,fxlineddx,fxlineakern);
   fkline[i].xshift=fs.x-xshift;
   fkline[i].yshift=fs.y-yshift;
  }


  e=w+1;
  r=w=fbuff;
  sum=0;

  for(i=0;i<fkindex;i++)
  {
   fkline[i].x0+=sum;
   fkline[i].x1+=sum;

   copy=fkline[i].x0-(r-fbuff);
   fkcopy(w,r,copy);
   r+=copy;
   w+=copy;

   delta=(fkline[i].x1-fkline[i].x0);

   size=writemovesize(fkline[i].xshift,fkline[i].yshift);
   size+=fkscheck(i,&font,&xpts,&ypts,&tr,&tflag);

//			cprintf("ypts %d",ypts);

   shift=size-(delta+r-w);
   if(font) shift+=FXFCLEN;

   if(shift>0)
   {
    /* have to make room */
    memmove(r+shift,r,e-r);
    e+=shift;
    r+=shift;
    sum+=shift;
   }

   if(tflag)
   {
    *w=FXTRANSFORM;
    memcpy(w+2,&tr,4*sizeof(int));
    w+=FXTRANSLEN;
   }


   writemove(fkline[i].xshift,fkline[i].yshift);
   if(font)
   {
    *w++=FXFONTCODE;
    *w++=0;            // padding
    *w++=(char)font;
    *w++=(char)(font>>8);
    *w++=(char)(font>>16);
    *w++=(char)(font>>24);
    *w++=(char)xpts;
    *w++=(char)(xpts>>8);
    *w++=(char)(xpts>>16);
    *w++=(char)(xpts>>24);
    *w++=(char)ypts;
    *w++=(char)(ypts>>8);
    *w++=(char)(ypts>>16);
    *w++=(char)(ypts>>24);
   }

   r+=delta;
  }

  copy=e-r;
  XMEMCPYX(w,r,copy);
  w+=copy;
 }

 return(NULL);
}



// code concerned with invisible text, replacing it with moves


static os_error * fkinit(void)
{
 fkmax=MAXFK-2;
 return(salloc((flex_ptr)&fkline,MAXFK*sizeof(fkstr)));
}


/***************************************************************************/




#define MAXOB 16

typedef struct eobstr
{              
 int object;

} eobstr;

#define MAXEOBLAYER 8


static int      eolayer;
static int      eoindex[MAXEOBLAYER];
static eobstr * eob;



static void getembeddedsize(vector * v,int object,boxstr * maxbox,int angle)
{
 textboxstr      * textp;
 transformstr      tr1;
 transformstr      tr2;
 transformstr      tr3;
 transformstr      tr4;
 transformstr      inv;
 outlineinfostr    oinfo;
 int               borderwidth[4];
 filestr         * file;
 transformbitstr   bits;


 file=v->file;

 textp=v->textsrc.textp;

 tr2=textp->data.transform;

 tr_setshift(&tr3,textp->fcurve.box.x,textp->fcurve.box.y);
 tr_multiply(&tr4,&tr3,&tr2);
 tr_inverse(&tr4,&inv);


 objectoread(SELECTINFO,object,file,&oinfo);

 if(angle)
 {
  tr_setidentity(&tr2);
  tr_setrotationa(&tr2,angle);
  tr_multiply(&tr1,&oinfo.tr,&tr2);
 }
 else
  tr1=oinfo.tr;

 if(oinfo.frame)
 {
  getbordersize(oinfo.frame,file,borderwidth,&oinfo.fcurve);
  tr_getbits(&oinfo.tr,&bits);
  borderwidth[0]=scale(borderwidth[0],0x10000,bits.yscale);
  borderwidth[1]=scale(borderwidth[1],0x10000,bits.xscale);
  borderwidth[2]=scale(borderwidth[2],0x10000,bits.yscale);
  borderwidth[3]=scale(borderwidth[3],0x10000,bits.xscale);

  oinfo.fcurve.box.x-=borderwidth[3];
  oinfo.fcurve.box.y-=borderwidth[0];
  oinfo.fcurve.box.w+=borderwidth[1]+borderwidth[3];
  oinfo.fcurve.box.h+=borderwidth[0]+borderwidth[2];
 }

 tr_multiply(&tr2,&tr1,&inv);

 getmaxbox(maxbox,&oinfo.fcurve.box,&tr2);
}



static os_error * expandembeddedobject(vector * v,char * r,int write)
{
 int          object;
 int          h;
 boxstr       maxbox;
 int          delta;
 int          angle;
 int          shift;
 int          base;

 if(fpending) flushstate();

 if(write)
 {
  object=(*(r+1))+((*(r+2))<<8)+((*(r+3))<<16)+((*(r+4))<<24);

  if(fxeobangle)
  {
   angle=(*(r+11))+((*(r+12))<<8)+((*(r+13))<<16)+((*(r+14))<<24);
   angle=fxboxangle-angle;
  }
  else
   angle=0;

  getembeddedsize(v,object,&maxbox,angle);


  *(r+15)=(char)maxbox.h;           /* r may have moved */
  *(r+16)=(char)(maxbox.h>>8);
  *(r+17)=(char)(maxbox.h>>16);

  *(r+18)=(char)maxbox.w;
  *(r+19)=(char)(maxbox.w>>8);
  *(r+20)=(char)(maxbox.w>>16);

  shift=scale(0x10000,fstyles.data.baseshift,fstyles.data.ypts);
  shift+=scale(0x10000,fxshift,maxbox.h);

  *(r+21)=(char)shift;
  *(r+22)=(char)(shift>>8);
  *(r+23)=(char)(shift>>16);
  *(r+24)=(char)(shift>>24);
 }
 else
 {
  maxbox.h=(*(r+15))+((*(r+16))<<8)+((*(r+17))<<16);
  maxbox.w=(*(r+18))+((*(r+19))<<8)+((*(r+20))<<16); /* not needed */
  shift=(*(r+21))+((*(r+22))<<8)+((*(r+23))<<16)+((*(r+24))<<24);
 }

 base=scale(maxbox.h,shift,0x10000);
 if(write) writemove(maxbox.w,0);
 h=maxbox.h+base;

 if(h>fmaxld)
 {
  delta=fmaxht-fmaxld;
  fmaxld=h;
  fmaxas=h;
  fmaxht=h+delta;
/* fmaxpt=h; */
 }

 return(NULL); 
}



static os_error * setupembeddedobject(char * r)
{
 int          object;
 int          h;
 int          delta;
 int          width;
 int          height;
 int          base;


 if(fpending) flushstate();

 object=eob[eoindex[eolayer]++].object=
                     (*(r+1))+((*(r+2))<<8)+((*(r+3))<<16)+((*(r+4))<<24);

 height=(*(r+15))+((*(r+16))<<8)+((*(r+17))<<16);
 width=(*(r+18))+((*(r+19))<<8)+((*(r+20))<<16);
 base=(*(r+21))+((*(r+22))<<8)+((*(r+23))<<16)+((*(r+24))<<24);
 base=scale(height,base,0x10000);

 writemove(width,0);

 h=height+base;

 if(h>fmaxld)
 {
  delta=fmaxht-fmaxld;
  fmaxld=h;
  fmaxas=h;
  fmaxht=h+delta;
 }

 return(NULL); 
}




static os_error * renderembeddedobject(viewredrawstr * v)
{
 os_error * err;
 int        i;

 err=NULL;

 if(eoindex[eolayer]>eoindex[eolayer-1])
 {
//  fontdefscale();
  for(i=eoindex[eolayer-1];i<eoindex[eolayer];i++)
  {
   err=objectredraw(v,(objhdrstr *)fob_find(eob[i].object,v->file));
   if(err) break;
  }
//  fontprevscale();
  fxtrash();
 }

 return(err);
}


static void embeddedobjectstart(void)
{
 eolayer++;
 eoindex[eolayer]=eoindex[eolayer-1];
}

static void embeddedobjectend(void)
{
 eolayer--;
}


static os_error * embeddedobjectinit(void)
{
 eoindex[0]=0;
 return(salloc((flex_ptr)&eob,MAXOB*sizeof(eobstr)));
}


/*****************************************************************************/



/* writes sequence to change font colour */

static os_error * setfontcol(colourvalue fcv,colourvalue bcv)
{
 int fcol;
 int bcol;

 fcol=*((int*)&fcv);
 bcol=*((int*)&bcv);

 *w++=FXCOLCODE2;
 *w++=0; // padding
 *w++=(char)(bcol);
 *w++=(char)(bcol>>8);
 *w++=(char)(bcol>>16);
 *w++=(char)(bcol>>24);
 *w++=(char)(fcol);
 *w++=(char)(fcol>>8);
 *w++=(char)(fcol>>16);
 *w++=(char)(fcol>>24);

 return(NULL);
}




/* sets up initial state */

static void initialstate(sourcestr * sourcep,int offset)
{
 firstone=1;
 fpending=0;
 puline=ruline=0;
 rtrack=0;
 rshift=0;
 rangle=0;
 rskew=0;

 fxitem=0;
 fmaxlen=0;
 fterminated=0;
 lastch=lastch2=-1;

 fxshift=0;

 oldlen=0;
 oldoffset=offset;
 oldsource=sourcep->key;

/* spcs=0; */
 w=fbuff;

 fbuff1=fbuff;
 srcdata1=txptr(sourcep,offset);
 srcgap=sourcep->goffset-offset;

 if(srcgap>0) srcgapsize=sourcep->maxlen-sourcep->len;
 else         srcgapsize=0;
}



/* called each time an sno is found */

static void setsno(xstylestr * s,int astyle)
{
 int         bshift;
 colourvalue temp;

 if(s) fstyles=*s;
 else  findabsstylex(ffile,astyle,&fstyles);


 fxpts=pxpt=fstyles.data.xpts;
 fypts=pypt=fstyles.data.ypts;
 fheight=pht=fstyles.data.height;
 flead=pld=fstyles.data.lead;
 fascent=pld=fstyles.data.ascent;

 smlsize=0;

/* if(fstyles.data.fcolour.data.tint.key==KEYTRANS) pfcol=bcol; */


// pfcol=vfindcolour2(fview,ffile,&fstyles.data.fcolour);
// if(pfcol==-1) pfcol=bcol;

 pfcol=fstyles.data.fcolour;
 if(transparentcolour(&pfcol,ffile)) pfcol=bcol;

/* if(fstyles.data.bcolour.data.tint.key==KEYTRANS) pbcol=bcol; */

// pbcol=vfindcolour2(fview,ffile,&fstyles.data.bcolour);
// if(pbcol==-1) pbcol=bcol;

 pbcol=fstyles.data.bcolour;
 if(transparentcolour(&pbcol,ffile)) pbcol=bcol;

 pfont=fstyles.data.font;
 pfontos=fontosfromuser(pfont);
 ptrack=fstyles.data.track;

 /* copy of shift code below */

 pshift=fstyles.data.baseshift;

 bshift=pshift+fxshift;

 if(bshift>0)
 {
  flead+=bshift;
  fascent+=bshift;
  fheight+=bshift;
 }
 else
 if(bshift<0)
 {
  fheight-=bshift;
 }

 if(fstyles.data.supersub==SUBS)
 {
  pshift-=scale(pht-pld,0x10000-subsize,0x10000);
  pxpt=scale(pxpt,subsize,0x10000);
  pypt=scale(pypt,subsize,0x10000);
 }
 else
 if(fstyles.data.supersub==SUPS)
 {
  pshift+=pld-scale(pld,supersize,0x10000);
  pxpt=scale(pxpt,supersize,0x10000);
  pypt=scale(pypt,supersize,0x10000);
 }

 pangle=fstyles.data.rotate;
 pskew=fstyles.data.skew;

 if(fstyles.data.reverse)
 {
  temp=pbcol;
  pbcol=pfcol;
  pfcol=temp;
 }

 puline&=~(1+2+4);
 puline|=fstyles.data.underline     |
         (fstyles.data.uldouble<<1) |
         (fstyles.data.strikeout<<2);

 if(puline)
 {
  pulthickness=fstyles.data.ulthickness;
  pultype=fstyles.data.ultype;
  pstthickness=fstyles.data.stthickness;
  psttype=fstyles.data.sttype;

// pulcolour=vfindcolour2t(fview,ffile,&fstyles.data.ulcolour,&transparent);
//  if(transparent) pulcolour=pfcol;

  pulcolour=fstyles.data.ulcolour;
  if(transparentcolour(&pulcolour,ffile)) pulcolour=pfcol;

//  pstcolour=vfindcolour2t(fview,ffile,&fstyles.data.stcolour,&transparent);
//  if(transparent) pstcolour=pfcol;

  pstcolour=fstyles.data.stcolour;
  if(transparentcolour(&pstcolour,ffile)) pstcolour=pfcol;
 }


 fstyle=fstyles.data.xcase     || fstyles.data.smlcaps   || 
        fstyles.data.underline || fstyles.data.strikeout ||
        fstyles.data.rotate    || fstyles.data.track     ||
        fxinvisibles           || fxspell;


 if(!fxleaderchanged)
 {
/*  fxleaderwidth=fstyles.data.leaderwidth; */
  XMEMCPYX(fxleader,fstyles.data.leaderchar,LEADERLEN);
		fxleaderlen=LEADERLEN;
		fxleader[fxleaderlen]=0;
		fxleaderstyle=1;
 }
 fxleadercalc=1;


 fpending=1;
}


static void setnewvshift(int vshift)
{
 int bshift;

 fxshift+=vshift;

 bshift=fstyles.data.baseshift+fxshift;

 if(bshift>0)
 {
  flead+=bshift;
  fascent+=bshift;
  fheight+=bshift;
 }
 else
 if(bshift<0)
 {
  fheight-=bshift;
 }

 if(fypts>fmaxpt)   fmaxpt=fypts;
 if(fheight>fmaxht) fmaxht=fheight;
 if(flead>fmaxld)   fmaxld=flead;
 if(fascent>fmaxas) fmaxas=fascent;
}


static void writemove(int dx,int dy)
{
 if(dx || (dy && fpaintmode && (fxtrans & (TR_ROTATE|TR_SCALE))))
 {
  if(!fxmove || w<fxmove) fxmove=w;

  *w++=FXHM;
  *w++=0; // padding
  *w++=(char)dx;
  *w++=(char)(dx>>8);
  *w++=(char)(dx>>16);
  *w++=(char)(dx>>24);

 }

 if(dy || (dx && fpaintmode && (fxtrans & (TR_ROTATE|TR_SCALE))))
 {
  *w++=FXVM;
  *w++=0; // padding
  *w++=(char)dy;
  *w++=(char)(dy>>8);
  *w++=(char)(dy>>16);
  *w++=(char)(dy>>24);
 }
}



static int writemovesize(int dx,int dy)
{
 int size;

 size=0;

 if(dx || (dy && fpaintmode && (fxtrans & (TR_ROTATE|TR_SCALE))))
 {
  size+=FXHMLEN;
 }

 if(dy || (dx && fpaintmode && (fxtrans & (TR_ROTATE|TR_SCALE))))
 {
  size+=FXVMLEN;
 }

 return(size);
}




static void transmoves(transformstr * tr)
{
 register char * p;
 register int    c;
 int             dx;
 int             dy;


 if(fxmove && (fxtrans & (TR_ROTATE|TR_SCALE)))
 {
  p=fxmove;

  while(1)
  {
   c=(*p)+((*(p+1))<<8);

   if(c<32)
   {
    switch(c)
    {
     case  FXFONTCODE:
                    p+=FXFCLEN;
                    break;

     case  FXCOLCODE2:
                    p+=FXCC2LEN;
                    break;

     case FXTRANSFORM:
                    p+=FXTRANSLEN;
                    break;

     case        FXHM:
                    if(*(p+FXHMLEN)==FXVM && *(p+FXHMLEN+1)==0)
                    {
                     p+=2;
                     dx=((*p))+((*(p+1))<<8)+((*(p+2))<<16)+((*(p+3))<<24);
                     dy=((*(p+FXHMLEN)))+((*(p+1+FXHMLEN))<<8)+
                        ((*(p+2+FXHMLEN))<<16)+((*(p+3+FXHMLEN))<<24);

                     tr_delta(tr,&dx,&dy);

                     *p++=(char)dx;
                     *p++=(char)(dx>>8);
                     *p++=(char)(dx>>16);
                     *p++=(char)(dx>>24);
                     p+=2;               // padding
                     *p++=(char)dy;
                     *p++=(char)(dy>>8);
                     *p++=(char)(dy>>16);
                     *p++=(char)(dy>>24);
                    }
                    else
                    {
                     p+=FXHMLEN-2;
                    }
                    break;

     case        FXVM:
                    p+=FXVMLEN-2;
                    break;

            default:
                    return;

    }
   }
   else
   {
    if(fxuni) p+=2;
    else      p++;
   }
  }
 }
}






static int fxcos;
static int fxsin;
static int fxq;


static void writematrix(int pskew,int pangle)
{
 transformstr     tr;
 transformbitstr  b;
 transformstr     tx;

 b.skewxy=(int)(((double)0x10000)*tan((((double)pskew)/((double)0x8000))*PI));
 b.angle=pangle*360;

 tr_setbits(&tr,&b,TR_ROTATE|TR_SKEWXY);

 *w++=FXTRANSFORM;
 *w++=0; // padding p=(int*)(((int)(w+3))&(~3));

 if(pangle)
 {
  fxcos=(int)(((double)0x10000)*cos((((double)pangle)/((double)0x8000))*PI));
  fxsin=(int)(((double)0x10000)*sin((((double)pangle)/((double)0x8000))*PI));

  if(pangle<=0x4000 && pangle>=0)     fxq=0;
  else
  if(pangle>0x4000 && pangle<=0x8000) fxq=1;
  else
  if(pangle>=-0x4000 && pangle<0)     fxq=3;
  else                                fxq=2;
 }

 if(fpaintmode)
 {
  tr_multiply(&tx,&tr,&fxtr);
  memcpy(w,&tx.a,4*sizeof(int));
 }
 else
 {
  memcpy(w,&tr.a,4*sizeof(int));
 }

 w+=4*sizeof(int);
}




static void flushstate(void)
{
 int shift;

 if(!fpending) return;

 if(pxpt!=rxpt || pypt!=rypt || pfont!=rfont || firstone)
 {
  /* logic here is that if valid font opens a new font, it is made current */
  /* so need fpchange set */

//  validfont(pfont,0,pypt,(fxangle*10)/0x10000,&rfonth,&fpchange);

//  validfont(pfont,0,pypt,&rfonth,&fpchange);

  rfont=pfont;
  rfontos=pfontos;

  if(firstone)
  {
   ffcol=pfcol;
   fbcol=pbcol;

   fmaxpt=fypts;
   fmaxht=fheight;
   fmaxld=flead;
   fmaxas=fascent;

   fpchange|=(rfonth!=fpfonth);
   ffont=pfont;
			ffontos=fontosfromuser(ffont);
   ffxpt=pxpt;
   ffypt=pypt;
  }
  else
  {
   *w++=FXFONTCODE;
   *w++=0;  // padding
   *w++=(char)pfont;
   *w++=(char)(pfont>>8);
   *w++=(char)(pfont>>16);
   *w++=(char)(pfont>>24);
   *w++=(char)pxpt;
   *w++=(char)(pxpt>>8);
   *w++=(char)(pxpt>>16);
   *w++=(char)(pxpt>>24);
   *w++=(char)pypt;
   *w++=(char)(pypt>>8);
   *w++=(char)(pypt>>16);
   *w++=(char)(pypt>>24);

   if(fypts>fmaxpt)   fmaxpt=fypts;
   if(fheight>fmaxht) fmaxht=fheight;
   if(flead>fmaxld)   fmaxld=flead;
   if(fascent>fmaxas) fmaxas=fascent;
  }

  fpfonth=rfonth;
  rxpt=pxpt;
  rypt=pypt;
 }

// if(pfcol!=rfcol || pbcol!=rbcol || firstone)
 if(FXCVNE(pfcol,rfcol) || FXCVNE(pbcol,rbcol) || firstone)
 {
  if(firstone)
  {
//   if(pbcol!=bcol && pbcol!=-1) bkbegin(pbcol);
   if(FXCVNE(pbcol,bcol) && !vcolourtrans(fview,ffile,&pbcol)) bkbegin(pbcol);
   fkbegin(pfcol);

   ffcol=pfcol;
   fbcol=pbcol;

   fpchange|=FXCVNE(fpfbcol,pbcol);
   fpchange|=FXCVNE(fpffcol,pfcol);
  }
  else
  if(!fterminated && fpaintmode)
  {
   if(FXCVNE(rbcol,bcol) && !vcolourtrans(fview,ffile,&rbcol) && FXCVNE(pbcol,rbcol)) bkend();
   if(FXCVNE(pbcol,bcol) && !vcolourtrans(fview,ffile,&pbcol) && FXCVNE(pbcol,rbcol)) bkbegin(pbcol);

   if(FXCVNE(rfcol,pfcol))
   {
    fkend();
    fkbegin(pfcol);
   }

   setfontcol(pfcol,pbcol);
  }

  rfcol=pfcol;
  rbcol=pbcol;

  fpfbcol=rbcol;
  fpffcol=rfcol;
 }


 if(rshift!=pshift)
 {
  shift=pshift-rshift;
  writemove(0,shift);
  rshift=pshift;

  if(fypts>fmaxpt)   fmaxpt=fypts;
  if(fheight>fmaxht) fmaxht=fheight;
  if(flead>fmaxld)   fmaxld=flead;
  if(fascent>fmaxas) fmaxas=fascent;
 }

 if(ruline!=puline)
 {
  if(ruline & (1+4+8)) ulend(0);
  if(puline & (1+4+8)) ulbegin();

  ruline=puline;
  rulthickness=pulthickness;
  rultype=pultype;
  rulcolour=pulcolour;
  rstthickness=pstthickness;
  rsttype=psttype;
  rstcolour=pstcolour;
 }

 rtrack=ptrack;

 if(rskew!=pskew || rangle!=pangle)
 {
  writematrix(pskew,pangle);
  rskew=pskew;
  rangle=pangle;
 }

 fpending=firstone=0;
}



static os_error * fxgetleaderwidth(void)
{
 os_error * err;
 int        llen;
 int        c;
 int        w;
 int        h;
 int        sxpts=0;
 int        sypts=0;
	int        font;


 err=NULL;


 fxleaderwidth=0;

 if(fstyles.data.smlcaps)
 {
  sxpts=scale(fxpts,smallsize,0x10000);
  sypts=scale(fypts,smallsize,0x10000);
 }

	font=fontosfromuser(rfont);

	txstring12(fxleader,sizeof(fxleader),fxleader2,sizeof(fxleader2)/sizeof(unsigned short),NULL);

 llen=0;
 while((c=fxleader2[llen])!=0)
 {
  c=fxcode(c,font);
  
  if(fstyles.data.smlcaps && fxislower(c)) 
                            err=fontcharwidth(font,sxpts,sypts,fxtoupper(c),&w,&h);
  else                      err=fontcharwidth(font,fxpts,fypts,c,&w,&h);

  if(!err) fxleaderwidth+=w;

  llen++;
 }

 return(err);
}




/* full expansion of code  */

/*

  if(fxq==0)
    xshift=scale(fi.maxy-xh,fxsin,0x10000)+scale(xh-fi.miny,fxsin,0x10000);
  else
  if(fxq==1)
    xshift=-2*scale(xc,fxcos,0x10000)+
            scale(fi.maxy-xh,fxsin,0x10000)+scale(xh-fi.miny,fxsin,0x10000);
  else
  if(fxq==2)
    xshift=-2*scale(xc,fxcos,0x10000)+
            scale(xh-fi.miny,fxsin,0x10000)-scale(fi.maxy-xh,fxsin,0x10000);
  else 
    xshift=-(xc-scale(xc,fxcos,0x10000)+scale(xh-fi.miny,fxsin,0x10000));


*/





// argument is an internal code

static void printchar(int code,int c)
{
 int       wastrack=rtrack;
 int       mh=0;
 int       mw=0;
 int       ch;
 int       wc;
 int       hc;
 int       ws;
 int       hs;
 int       xshift=0;
 int       yshift=0;
 font_info fi;
 int       xc;
 int       xh;
 int       nh;
 int       xlead;
 int       c2;

// cprintf("fxprch %d up %d lo %d",c,tolower(c),toupper(c));

//	cprintf("printchar code %x c %x",code,c);
 
 if(fstyle)
 {
  if(fstyles.data.underline)
  {
   if(fstyles.data.ulword)
   {
    if(c==SPACE || c==NBSPACE)
    {
     if(ruline & 0x1)  
     {
      puline&=~0x3;
      fpending=1;
     }
    }
    else
    {
     if(!(ruline & 0x1)) 
     {
      puline&=~(1+2+4);
      puline|=fstyles.data.underline     |
              (fstyles.data.uldouble<<1) |
              (fstyles.data.strikeout<<2);
      fpending=1;
     }
    }
   }
   else
   {
    if(!(ruline & 0x1)) 
    {
     puline&=~(1+2+4);
     puline|=fstyles.data.underline     |
             (fstyles.data.uldouble<<1) |
             (fstyles.data.strikeout<<2);
     fpending=1;
    }
   }

   if((c!=SPACE && c!=NBSPACE) || 
      (lastch!=SPACE && lastch!=NBSPACE && lastch!=TABSEQ && 
       lastch!=SPACESEQISDELIM))
   {
    firstlastspc=w;
   }
  }

  if(fstyles.data.xcase==ALLCAPS) c=fxtoupper(c);
  else
  if(fstyles.data.xcase==ALLLC) c=fxtolower(c);
  else
  if(fstyles.data.xcase==TITLE)
  {
   if(lastch==SPACE || lastch==-1 || lastch==TABSEQ || 
      lastch==SPACESEQISDELIM) 
   {
    c=fxtoupper(c);
   }
   else
   if(lastch=='\"' || lastch=='\'' || lastch==144 || 
      lastch==145  || lastch==148  || lastch==149 ||
      lastch=='('  || lastch=='['  || lastch=='{')
   {
    if(lastch2==SPACE || lastch2==-1 || lastch2==TABSEQ || 
       lastch2==SPACESEQISDELIM)
    {
     c=fxtoupper(c);
    }
   }
   else
   {
    c=fxtolower(c);
   }
  }

  if(fstyles.data.smlcaps)
  {
   if(fxislower(c) && !smlsize)
   {
    /* change from upper to lower */
    pxpt=scale(fxpts,smallsize,0x10000);
    pypt=scale(fypts,smallsize,0x10000);
    smlsize=1;
    fpending=1;
   }
   else
   if(!fxislower(c) && smlsize)
   {
    pxpt=fxpts;
    pypt=fypts;
    smlsize=0;
    fpending=1;
   }
   c=fxtoupper(c);
  }
 }

 if(fxdrop)
 {
//  if(rfont!=pfont || firstone) validfont(pfont,pxpt,pypt,0,&fh,&fpchange);
//  else                         fh=rfonth;

  fontcharbbox(fontosfromuser(pfont),pxpt,pypt,c,&fi);
  mh=fi.maxy-fi.miny;

  xlead=MAX(fypts,flead);


  switch(fstyles.data.leadingtype)
  {
     case LEADABS:
                  nh=fstyles.data.leading;
                  break;

          default:
     case  LEADPC:
                  nh=xlead+scale(fypts,fstyles.data.leading,0x10000);
                  break;

     case  LEADDL:
                  nh=xlead+fstyles.data.leading;
                  break;
  }



  nh=nh*(fstyles.data.dropno-1);

  if(fxbaselinemode==FBLFIT)
  {
   nh+=(fi.maxy-fi.miny);
   fxdropfix=0;
   fxdropdiff=fi.maxy-flead;
  }
  else
  if(fxbaselinemode==FBLASCENDER)
  {
   nh+=(fheight-(flead-fascent));
   fxdropfix=(fascent-fi.maxy);
   nh-=fxdropfix;
   nh-=((fheight-(flead-fascent))-flead)-(-fi.miny);
   fxdropdiff=0;
  }
  else
  {
   nh+=fheight;
   fxdropfix=(flead-fi.maxy);
   nh-=fxdropfix;
   nh-=(fheight-flead)-(-fi.miny);
   fxdropdiff=0;
  }


  nh+=(1000/16); /* nearest 1/16th pt */

  if(mh)
  {
   pxpt=scale(pxpt,nh,mh);
   pypt=scale(pypt,nh,mh);
   fpending=1;
  }

  /* a drop character has it's top in exactly the same position */
  /* as a normal character of the usual height                  */
  /* so the leading and points values are the same              */
  /* the difference is in the height variable                   */
  /* the resulting box is bigger than the character so it is    */
  /* given a small shift downwards.                             */
  /* the aim is for the top of the drop character to be the same */
  /* as the top of a normal character and the bottom the same as */
  /* the bottom */
 }

 if(fpending) flushstate();


 if(rangle)
 {
  xh=(flead+(flead-fheight))/2;

  fontcharbbox(fontosfromuser(pfont),pxpt,pypt,c,&fi);
  fontcharwidth(fontosfromuser(pfont),pxpt,pypt,c,&mw,&mh);

  xc=mw/2;

  if(fxq==0)
    xshift=scale(fi.maxy-fi.miny,fxsin,0x10000);
  else
  if(fxq==1)
   xshift=-2*scale(xc,fxcos,0x10000)+scale(fi.maxy-fi.miny,fxsin,0x10000);
  else
  if(fxq==2)
   xshift=-2*scale(xc,fxcos,0x10000)+scale(2*xh-fi.miny-fi.maxy,fxsin,0x10000);
  else 
   xshift=-(xc-scale(xc,fxcos,0x10000)+scale(xh-fi.miny,fxsin,0x10000));

  yshift=xh-scale(xh-fi.miny,fxcos,0x10000)-scale(xc,fxsin,0x10000);

  if(rtrack && wastrack) writemove(xshift+rtrack,yshift);
  else                   writemove(xshift,yshift);
 }
 else
 if(rtrack && wastrack)
 {
  writemove(rtrack,0);
 }



 lastch2=lastch;
 if(fxuni)
 {
  if(c==NBSPACE && fxnbsp) {c2=lastch=SPACE;}
  else                     {c2=c;lastch=code;}

  *w++=(char)c2;
  *w++=(char)(c2>>8);
 }
 else
 {
  if(c==NBSPACE && fxnbsp) {*w++=SPACE;lastch=SPACE;}
  else                     {*w++=(char)c;lastch=code;}
 }

 if(fxinvisibles)
 {
  if(c==SPACE || c==NBSPACE)
  {
   fontcharwidth(fontosfromuser(pfont),pxpt,pypt,c,&mw,&mh);
   fontcharwidth(fontosfromuser(pfont),pxpt,pypt,fxcode((c==SPACE)?INVSPACE:INVHARDSPACE,fontosfromuser(pfont)),&wc,&hc);
   wc+=fxlineddx;
   xshift=-mw+(mw-wc)/2;
   writemove(xshift,0);
   writecharconvert(((c==SPACE)?INVSPACE:INVHARDSPACE),fontosfromuser(pfont));
   writemove((mw-wc)/2,0);
  }
 }

 if(rangle)
 {
  /* first work out how much the print posn has moved */

  wc=scale(mw,fxcos,0x10000);
  hc=scale(mh,fxcos,0x10000);
  ws=scale(mw,fxsin,0x10000);
  hs=scale(mh,fxsin,0x10000);

  xshift+=wc-hs;
  yshift+=hc+ws;

//		cprintf("mw %d mh %d xshift %d yshift %d",mw,mh,xshift,yshift);

  /* now work out how much we would like it to move */

  ch=fi.maxy-fi.miny;
  hs=scale(ch,fxsin,0x10000);

  if(wc<0) wc=-wc;
  if(hs<0) hs=-hs;

  xshift=(wc+hs)-xshift;
  yshift=-yshift;

  writemove(xshift,yshift);
 }

 if(c==SPACE || c==NBSPACE) fxspaces++;
 fxchars++;
}




// unicode character

static void printchar16(int ch)
{
// cprintf("print16 %x",ch);
 if(fxuni) printchar(ch,ch);

}


// ch is RISC OS with UNICODE

static void printcharconvert(int ch)
{
 int count;
 int c;
 int code;
 int osfont;
 int exists;
 int charset;

 osfont=fontosfromuser(pfont);
 charset=fontcharset(osfont);

	if(charset==SYMBOL_CHARSET)
	{
  if(fxuni)
  {
   c=code16symbol(ch);
   if(c>=0) printchar(ch,c);
  }
  else
  {
   c=code8symbol(ch);
   if(c>=0) printchar(ch,c);
  }
 }
 else
 if(charset==ANSI_CHARSET)
 {
  if(fxuni)
  {
   c=code16(ch);
   if(c!=UNIBLANK)
   {
    if(c>=256)
    {
     fontglyph(osfont,c,&exists);
     if(!exists)
     {
      code=altcode8(ch);
      if(code!=-1)
      {
       count=0;
       while(1)
       {
        printchar(ch,code & 0xFF);
        code=code>>8;
        count++;
        if(code==0 || count>=4) break;
       }
      }
     }
     else
     {
      printchar(ch,c);
     }
    }
    else
    {
     printchar(ch,c);
    }
   }
  }
  else
  {
   c=code8(ch);
   if(c<0)
   {
    code=altcode8(ch);
   
    if(code!=-1)
    {
     count=0;
     while(1)
     {
      printchar(ch,code & 0xFF);
      code=code>>8;
      count++;
      if(code==0 || count>=4) break;
     }
    }
   }
   else
   {
    printchar(ch,c);
   }
  }
 }
 else // not ANSI or SYMBOL  change for extra charsets
 {
  c=code8symbol(ch);
		if(c>=0)
		{
   if(fxuni)
   {
    c=code16wincharset(c,charset);
   }

   printchar(ch,c);
		}
		else
		{
			printchar(ch,ch);
		}
 }
}


static int fxcode(int ch,int osfont)
{
 int charset;

 if(ch<256)
 {
  charset=fontcharset(osfont);

 	if(charset==SYMBOL_CHARSET)
 	{
   if(fxuni) return(code16symbol(ch));
   else      return(code8symbol(ch));
  }
  else
  if(charset==ANSI_CHARSET)
  {
   return(fxuni?code16(ch):code8(ch));
  }
  else
  {
   if(fxuni)
   {
    return(code16wincharset(code8symbol(ch),charset));
   }
   else
   {
    return(code8symbol(ch));
   }
  }
 }
 else
 {
  return(ch);
 }
}


static void writecharconvert(int ch,int osfont)
{
 ch=fxcode(ch,osfont);
 if(fxuni)
 {
  *w++=(char)ch;
  *w++=(char)((ch>>8)&0xFF);
 }
 else
 {
		if(ch<256)
		{
   *w++=(char)ch;
		}
 }
}




static void activedate(void)                                                   
{
 char   string[256];
 char * p;
 int    ch;

 writesysdate(string);
 p=string;

 while((ch=*p++)!=0) printcharconvert(ch);
}


static void pagenumber(vector * v,int ispage)
{
 int          plen;
 char       * number;
 int          i;
 pagestr    * pagep;
 sectionstr * sectionp;
 int          format;
 int          branch;
 int          n;

 sectionp=(sectionstr*)fob_find(v->section,v->file);
 format=sectionp->data.pagenumber.format;

 if(ispage)
 {
  branch=sectionp->branch;
  pagep=(pagestr*)fob_find(v->page,v->file);
  n=pagep->data.number;
 }
 else
 {
  branch=0;
  n=sectionp->data.number;
 }

 roman(n,format,branch,&number,&plen);

 for(i=0;i<plen;i++) printcharconvert(number[i]);
}




/*****************************************************************************/


void expandbulletdata(vlstr * vline,bulletdatastr * bdata)
{
 int i;

 bdata->tabshift=vline->bseq.tab;

 for(i=0;i<MAXBLEVEL;i++)
 {
  bdata->levels[i]=vline->bseq.levels[i];
 }
}



void packbulletdata(vlstr * vline,bulletdatastr * bdata)
{
 int i;

 vline->bseq.xl=1;
 vline->bseq.type=VLBULLET;

 vline->bseq.tab=bdata->tabshift;

 for(i=0;i<MAXBLEVEL;i++)
 {
  vline->bseq.levels[i]=(unsigned short)bdata->levels[i];
 }
}




static void bprint(int n,int format)
{
 char * number;
 int    plen;
 int    i;

 roman(n,format,0,&number,&plen);
 for(i=0;i<plen;i++) printcharconvert(number[i]);
}


static char bfmap[]={ROARABIC,ROLOWER,ROUPPER,ROALPHALC,ROALPHAUC,
                     ROARABICALPHALC,ROARABICALPHAUC};


static os_error * renderbullet(bulletdatastr * bdata,vector * v,int extab)
{
 int          level;
 int          i;
 int          j;
 int          sn;
 xstylestr    bstyle;
 int          c;
 int          d;
 sectionstr * sectionp;
 int          bullettab;
 int          printed;
 int          bulletdata;
 int          bulletornumber;
 int          bulletafter;
 int          bulletbefore;
 int          setstyle;
 int          lastlevel;



 sn=fstyles.n;

 level=fstyles.data.layer;
 bullettab=fstyles.data.bullettab;
 bulletdata=fstyles.data.bulletdata1+(fstyles.data.bulletdata2<<8);
 bulletornumber=fstyles.data.bulletornumber;
 bulletbefore=fstyles.data.bulletbefore1+(fstyles.data.bulletbefore2<<8);
 bulletafter=fstyles.data.bulletafter1+(fstyles.data.bulletafter2<<8);

 /* have to cache data above because once the style is set, may change */


 setstyle=0;
 if(fstyles.data.bulletstyle!=BULLETNOSTYLE)
 {
  finduserstylex(&bstyle,fstyles.data.bulletstyle,v->file);
  if(bstyle.n)
  {
   applystyle(&fstyles,&bstyle);
   setsno(&fstyles,0);
   setstyle=1;
  }
 }


 if(bulletbefore) printcharconvert(bulletbefore);

 if(bulletornumber)
 {
  if(bulletdata) printcharconvert(bulletdata);
 }
 else
 {
  c=bulletdata & 0xF;
  c=bfmap[c];
  d=(bulletdata>>4) & 0xF;


  if(d==0 && bdata->levels[level]<0xFFFF) bprint(bdata->levels[level],c);
  else
  if(d==1 || d==2)
  {
   printed=0;

   if(d==2)
   {
    sectionp=(sectionstr*)fob_find(v->section,v->file);
    bprint(sectionp->data.number,c);
    printed=1;
   }

   if(!level) level=MAXBLEVEL;
   lastlevel=-1;

   if(c==ROARABICALPHALC || c==ROARABICALPHAUC)
   {
    for(i=0,j=1;i<level;i++)
    {
     if(bdata->levels[j]<0xFFFF) lastlevel=i;
     j++;
     if(j>=MAXBLEVEL) j=0;
    }
   }

   for(i=0,j=1;i<level;i++)
   {
    if(bdata->levels[j]<0xFFFF)
    {
     if(printed)
     {
      printcharconvert(chapsep & 0xFFFF);
						if(chapsep & 0xFFFF0000)	printcharconvert((chapsep>>16) & 0xFFFF);
					}

     if(i==lastlevel)
     {
      if(c==ROARABICALPHALC) bprint(bdata->levels[j],ROALPHALC);
      else                   bprint(bdata->levels[j],ROALPHAUC);
     }
     else
     {
      bprint(bdata->levels[j],c);
     }
     printed=1;
    }

    j++;
    if(j>=MAXBLEVEL) j=0;
   }
  }
 }

 if(bulletafter) printcharconvert(bulletafter);

 if(bullettab)
 {
  fxbullettab=1;

  if(extab)
  {
   for(i=0;i<FXHMLEN;i++) *w++=0;
  }
  else
  if(bdata->tabshift) writemove(bdata->tabshift,0);
 }

 if(setstyle) setsno(NULL,sn);

 return(NULL);
}



/*****************************************************************************/




static void macro(char * r,int merge)
{
 int    n;
 char   string[16];
 int    len;
 int    i;

 if(!merge)
 {
  n=(*(r+1))+((*(r+2))<<8)+((*(r+3))<<16);
  len=sprintf(string,"[Merge %d]",n);
  for(i=0;i<len;i++) printcharconvert(string[i]);
 }
}


static os_error * fxrenderchunk(fxrendstr * fxr)
{
 os_error  * err;
 char      * r;
 char      * rbrk;
 char      * wbrk;
 char      * fold;
 int         ch;
 int         sn;
 int         c;
 int         shift;
 int         n;
 int         mw;
 int         mh;
 int         llen;
 int         fxspindex;
 int         seentab;
 int         over;
 int         fspace;
 int         hspace;
 int         vspace;


 err=NULL;


/*
 dprintf(0,"chunk sourcep=%x offset=%d text=%d source=%d unit=%d sub=%d",fxr->vec.textsrc.sourcep,fxr->vec.textsrc.offset,fxr->vec.textsrc.text,
 fxr->vec.textsrc.source,fxr->vec.textsrc.u,fxr->vec.textsrc.s);
*/

//	cprintf("render chunk");

 r=txptr(fxr->vec.textsrc.sourcep,fxr->vec.textsrc.offset);

// guard against corrupt story...
 if((fxr->vec.textsrc.offset+fxr->len)>fxr->vec.textsrc.sourcep->len) return(NULL);
 
 rbrk=txptrlt(fxr->vec.textsrc.sourcep,fxr->vec.textsrc.offset+fxr->len);


 fxspindex=0;
 if(fxspell)
 {
  n=0;
  while(fxsperrors[n]>=0)
  {
   fxsperrors[n]=(int)txptr(fxr->vec.textsrc.sourcep,fxsperrors[n]);
   n++;
  }
 }


 fxspaces=fxchars=0;
 wbrk=fbuff+fxmaxl;

 if(fxr->dobullet) renderbullet(&fxr->bulletdata,&fxr->vec,0);


 while(r<rbrk)
 {
  if(w>wbrk)
  {
   fold=fbuff;
   err=fxchunkl();
   if(err) break;
   wbrk=fbuff+fxmaxl;
   w=w-fold+fbuff;
  }

  if(r<rbrk)
  {
   if(fxspell)
   {
    while(((char*)fxsperrors[fxspindex])==r)
    {
     puline^=8;
     fpending=1;
     fxspindex++;
    }
   }

//   cprintf("ch=%d",*r);

   switch(ch=*r)
   {
       case     SNO:
                    sn=(*(r+1))+((*(r+2))<<8)+((*(r+3))<<16);
                    setsno(NULL,sn);
//																				cprintf("SNO");
                    break;


      case  TABSEQ:
//																			cprintf("TABSEQ fpend %d",fpending);
                   if(fstyles.data.underline)
                   {
                    puline&=~0x3;
                    if(ruline & 0x1) fpending=1;

                    if(lastch!=SPACE && lastch!=NBSPACE && 
                       lastch!=TABSEQ && lastch!=SPACESEQISDELIM)
                    {
                     firstlastspc=w;
                    }
                   }

                   if(fpending) flushstate();
																			

                   /* merge tabs */

																			// there is a problem. We don't know which tab stop we've tabbed to
																			// as a result we may not be using the correct leader
																			// all this is repeated in fxexpand()

                   if(fxinvisibles)
                   {
                    shift=r[1]+(r[2]<<8)+(r[3]<<16);
                    fontcharwidth(fontosfromuser(rfont),rxpt,rypt,fxcode(INVTAB,fontosfromuser(rfont)),&mw,&mh);
                    writemove((shift-mw)/2,0);
                    writecharconvert(INVTAB,fontosfromuser(rfont));
                    writemove((shift-mw)/2,0);
                   }
                   else
                   {
                    shift=0;
                    seentab=over=0;
                    while(1)
                    {
                    /* dprintf(0,"curr=%d",fxcurrtab); */
                     while(fxcurrtab<tabrulern)
                     {
                     /* dprintf(0,"loop=%d",fxcurrtab); */
                      if(tabruler[fxcurrtab].type==TABDATA)
                      {
                       if((tabruler[fxcurrtab].posn>>24)==TSUBLEAD)
                       {
                        if(seentab)
                        {
                        /* dprintf(0,"seentabx "); */
                         r-=TSLEN;
                         over=1;
                         break;
                        }
                        else
                        {	// can only concat onto leader set up by first style in line
																										// can only concat onto style leader if first TABDATA in ruler

																									if(!fxleaderdata)	// this is the first TABDATA in the ruler
																									{
																										XMEMCPYX(fxleader,fxbaseleader,LEADERLEN);
																										fxleaderlen=LEADERLEN;
																									}
																									else
																									if(fxleaderstyle)	// fxleaderlen has been set up by style
																									{
																										fxleaderlen=0;
																									}

                         XMEMCPYX(fxleader+fxleaderlen,&tabruler[fxcurrtab],LEADERLEN);
                         fxleaderchanged=1;
																									fxleaderlen+=LEADERLEN;
                         fxleader[fxleaderlen]=0;
                         fxleadercalc=1;
																									fxleaderdata=1;
																									fxleaderstyle=0;
//																									cprintf("set up leader %d len %d []%d",fxcurrtab,fxleaderlen,fxleader[0]);
                        }
                       }
                      }
                      else
																						{
																							fxleaderdata=1;

                       if(tabruler[fxcurrtab].type<=TCENTRE)
                       {
                       /* dprintf(0,"counttab "); */
																					 		fxleaderlen=0;
                        fxcurrtab++;
                        break;
                       }
																						}
                      fxcurrtab++;
                     }

                     if(over) break;
                     seentab=1;
                     shift+=r[1]+(r[2]<<8)+(r[3]<<16);
                     if(!((r+TSLEN)<rbrk && r[TSLEN]==TABSEQ)) break;
                     r+=TSLEN;
                    }

                    if(fxleadercalc)
                    {
                     fxleadercalc=0;
                     fxgetleaderwidth();
                    }

//					cprintf("leaderwidth %d leader2[]=%d",fxleaderwidth,fxleader2[0]);

                    if(fxleader2[0] && fxleaderwidth>0)
                    {
                     /* now fill shift worth of tab char and bracket it */
                     /* with 2 moves */

                     n=shift/fxleaderwidth;
                     shift-=n*fxleaderwidth;
                     writemove(shift,0);
//                     cprintf("actleader %d %d",n,fxleaderwidth);

                     while(n--)
                     {
                      llen=0;
                      while((c=fxleader2[llen])!=0)
                      {
                       if(fstyles.data.smlcaps)
                       {
                        if(fxislower(c) && !smlsize)
                        {
                         /* change from upper to lower */
                         pxpt=scale(fxpts,smallsize,0x10000);
                         pypt=scale(fypts,smallsize,0x10000);
                         smlsize=1;
                         fpending=1;
                        }
                        else
                        if(!fxislower(c) && smlsize)
                        {
                         pxpt=fxpts;
                         pypt=fypts;
                         smlsize=0;
                         fpending=1;
                        }
                        c=fxtoupper(c);
                        if(fpending) flushstate();
                       }

                       writecharconvert(c,fontosfromuser(rfont));
                       llen++;
                      }
                     }
                    }
                    else
                    {
                     writemove(shift,0);
                    }
                   }
                   lastch2=lastch;
                   lastch=ch; 
                   break;



     case SPACESEQ:

                   fspace=(*(r+1))+((*(r+2))<<8)+((*(r+3))<<16);
                   hspace=(*(r+4))+((*(r+5))<<8)+
                           ((*(r+6))<<16)+((*(r+7))<<24); 
                   vspace=(*(r+8))+((*(r+9))<<8)+
                           ((*(r+10))<<16)+((*(r+11))<<24); 

                   if(fstyles.data.underline)
                   {
                    if(fstyles.data.ulword)
                    {
                     if(fspace & SPACESEQDL)
                     {
                      if(ruline & 0x1)  
                      {
                       puline&=~0x3;
                       fpending=1;
                      }
                     }
                     else
                     {
                      /* don't change underlining */

                     }
                    }
                    else
                    {
                     /* don't change underlining */

                    }

                    if(lastch!=SPACE && lastch!=NBSPACE && 
                        lastch!=TABSEQ && lastch!=SPACESEQISDELIM)
                    {
                     firstlastspc=w;
                    }
                   }

                   if(fpending) flushstate();

                   if(fspace & SPACESEQEM)
                   {
                    hspace=scale(hspace,rypt,0x10000);
                    vspace=scale(vspace,rypt,0x10000);
                   }

                   setnewvshift(vspace);

                   if(fxinvisibles)
                   {
                    fontcharwidth(fontosfromuser(rfont),rxpt,rypt,fxcode(INVSPACESEQ,fontosfromuser(rfont)),&mw,&mh);
                    writemove((hspace-mw)/2,vspace/2);
                    writecharconvert(INVSPACESEQ,fontosfromuser(rfont));
                    writemove((hspace-mw)/2,vspace/2);
                   }
                   else
                   {
                    writemove(hspace,vspace);

                   }

                   lastch2=lastch;
                   if(fspace & SPACESEQDL) lastch=SPACESEQISDELIM;
                   else                    lastch=SPACESEQ; 

                   break;



      case   EOBOX: /* really this lot should force a termination */
      case  EOPAGE:
          case  CR:
          case  NL:
          case EOT:
                   if(fxinvisibles)
                   {
                    if(ch==CR)    ch=INVCR;
                    else
                    if(ch==NL)    ch=INVNL;
                    else
                    if(ch==EOT)   ch=INVEOT;
                    else
                    if(ch==EOBOX) ch=INVEOBOX;
                    else          ch=INVEOPAGE;
                    writecharconvert(ch,fontosfromuser(rfont));
                   }
                   break;

      case ACTDATE:
                   activedate();
                   break;

       case CHAPNO:
       case PAGENO:
                   pagenumber(&fxr->vec,ch==PAGENO);
                   break;

       case    EOB:
                   setupembeddedobject(r);
                   break;

       case MACSEQ:
                   macro(r,(fxr->vec.file)->merge);
                   break;

       case  UNC16:
                   printchar16((*(r+1))+((*(r+2))<<8));
                   break;

#ifdef NEVER
       case  GCODE:
                   break;

       case DCHYPH:
                   r++;
                   break;
#endif

       case DCHYPH:
                   if(fxinvisibles)
                   {
                    fontcharwidth(fontosfromuser(rfont),rxpt,rypt,fxcode(INVDCHYPH,fontosfromuser(rfont)),&mw,&mh);
                    writemove((-mw)/2,0);
                    writecharconvert(INVDCHYPH,fontosfromuser(rfont));
                    writemove((-mw)/2,0);
                   }
                   break;


           default:
                   if(ch>=32) printcharconvert(ch);
                   break;
   }

   r+=txcodelen(ch,fxr->vec.textsrc.sourcep);
  }
 }


 if(fxr->hpend) printcharconvert('-');

 if(fpending)
 {
  if(firstone) flushstate();
  else
  {
   if(fypts>fmaxpt)   fmaxpt=fypts;
   if(fheight>fmaxht) fmaxht=fheight;  /* was fheight=fheight */
   if(flead>fmaxld)   fmaxld=flead;
   if(fascent>fmaxas) fmaxas=fascent;
  }
 }


 if(ruline & (8+4+1))         ulend(1);
 if(FXCVNE(rbcol,bcol) && !vcolourtrans(fview,ffile,&rbcol)) bkend();
 fkend();

 *w++=0;
 *w=0;

 if(fxlinejustify)
 {
  fontcharwidth(ffontos,ffxpt,ffypt,SPACE,&fxlinespace,NULL);
 }


 if(fxdrop)
 {
  font_string fs;

  fs.s=fbuff;
  fs.x=XLIMIT;
  fs.y=YLIMIT;
  fs.term=FXMAXL;
  fs.split=-1;

  err=fxstrwidth(&fs,0,0,/*fxlineakern|*/FXSBBOX);

  fmaxht=fxsmaxht;
 }


 return(err);
}


static void fxsetjust(void)
{
 fxlinejustify=fstyles.data.justification && (fstyles.data.align==JUSTIFY);
 fxjustlettermin=fstyles.data.justlettermin;
 fxjustlettermax=fstyles.data.justlettermax;
 fxjustsingle=fstyles.data.justsingle;
 fxjustwordmin=fstyles.data.justwordmin*JUSTWORDSCALE;
 fxjustwordmax=fstyles.data.justwordmax*JUSTWORDSCALE;
}


void fxinitjust(int sn,filestr * file)
{
 findabsstylex(file,sn,&fstyles);
 fxsetjust();
}


void fxboxsetup(int angle)
{
 fxboxangle=angle;
}


static fxexpwritemove(int dx,int dy)
{
 if(dx)
 {
  *w++=FXHM;
  *w++=0; // padding
  *w++=(char)dx;
  *w++=(char)(dx>>8);
  *w++=(char)(dx>>16);
  *w++=(char)(dx>>24);
 }

	USE(dy);
}




os_error * fxexpand(vector * v,int flags,int len,bulletdatastr * bdata)
{
 os_error  * err;
 int         more;
 int         extab;
 int         hpend;
 char      * r;
 char      * rbrk;
 char      * wbrk;
 char      * fold;
 int         ch;
 sourcestr * sourcep;
 int         offset;
 int         i;
 int         sn;
 int         fxbdata;
 int         hspace;
 int         vspace;
 int         fspace;
 int         mw;
 int         mh;
	int         c;
	int         llen;
	int         shift;
	int         n;
	int         exleader;
	int         seentab;
	int         over;


 err=NULL;

 fxuni=txunicode;
 fpaintmode=0;
 fxinvisibles=fxspell=0;



 more      =flags & FXMORE;
 extab     =flags & FXTABS;
 hpend     =flags & FXHPEND;
 fxdrop    =flags & FXDROP;
 fxeobangle=flags & FXEOBA;
 fxnbsp    =flags & FXNBSP;
 fxbdata   =flags & FXBULLET;
 fxbaselinemode=(flags & FXBLMASK)>>FXBLSHIFT;
	exleader  =flags & FXLEADERF;


 sourcep=v->textsrc.sourcep;
 offset=v->textsrc.loffset;
 ffile=v->file;
 fview=NULL;
 fxcheckprefs(ffile);


// srcdata1=txptr(sourcep,oldoffset);
// srcgap=sourcep->goffset-oldoffset;

//	cprintf("flexp more %d len %d srclen %d oldlen %d oldoffset %d offset %d",more,len,sourcep->len,oldlen,oldoffset,offset);

 if(!more)
 {
  initialstate(sourcep,offset);
	 len=MIN(len,(sourcep->len-offset));			// don't go past end of text source

  fxcurrtab=0;
  fxleaderchanged=0;
  fxleadercalc=0;
		fxleaderdata=0;
		fxleaderstyle=0;

/*
 implicit in setsno() 
 fxleaderwidth=fstyles.data.leaderwidth;
 XMEMCPYX(fxleader,fstyles.data.leaderchar,LEADERLEN);
*/


  setsno(NULL,v->astyle);
  fxlineakern=fstyles.data.akern;
  fxbullettab=0;
  fxsetjust();

		if(exleader)		// otherwise done by flow code?
		{
   gettabruler(ffile,fstyles.data.tab);		// needed for exleader
   XMEMCPYX(fxbaseleader,fxleader,LEADERLEN);
		}

  fxfirsteob=-1;
  r=srcdata1;
 }
 else 
 {
  offset+=oldlen;
  len-=oldlen;
	 len=MIN(len,(sourcep->len-offset));			// don't go past end of text source
		if(len<=0) fterminated=1;       		 			// if len<=0 then offset is past the end of the buffer
  r=txptrlt(sourcep,offset);			       		// we use this for protection but we're not going to use r
 }


 if(fxbdata)
 {
  ffl[fxitem]=r-1;
  ffb[fxitem++]=w;
  renderbullet(bdata,v,extab);
/*   dprintf(7,"item %d ffl %x ffb %x",item,ffl[0],ffb[0]); */
 }


 rbrk=txptrlt(sourcep,offset+len);
 wbrk=fbuff+fxmaxl;

//	cprintf("offset+len %d",offset+len);

// cprintf("fterminated %d",fterminated);

 while(r<rbrk && !fterminated)
 {
   if(w>wbrk)
   {
    fold=fbuff;
    err=fxchunkl();
    if(err) break;
    wbrk=fbuff+fxmaxl;
    w=w-fold+fbuff;
   }

   if(fxitem>fxmaxi)
   {
    err=fxchunki();
    if(err) break;
   }


   ffl[fxitem]=r;
   ffb[fxitem++]=w;

//			cprintf("ffl %x ffb %x item %d",ffl[fxitem-1],ffb[fxitem-1],fxitem-1);

 /*  ffs[item++]=spcs; */


   switch(ch=*r)
   {
    case   GCODE:
                 fxitem--;  /* there is a problem with leaving this in        */
                          /* you are adding entries with an r value==srcgap */
                          /* fitem() etc. below will deduct srcgap          */
                          /* this is wrong, should be only for >srcgap      */
                 break;


    case     SNO:
                 sn=(*(r+1))+((*(r+2))<<8)+((*(r+3))<<16);
                 setsno(NULL,sn);
                 break;


    case  TABSEQ:
                 /*

                    assume that in expand code, this can have no effect,
                    no painting anyway

                  if(fstyles.data.underline)
                  {
                   if((fstyles.data.ulword) && ruline) {puline=0;fpending=1;}
                   else
                   if(ruline)                          {puline=0;fpending=1;}
                  }

                  */


                  if(fpending) flushstate();

                  if(extab)    /* if expanding tabs fill in with zeros */
                  {
                   for(i=0;i<FXHMLEN;i++)
                   {
                    *w++=0;
                   }
                  }
                  else
																		if(exleader)
																		{
                   shift=0;
                   seentab=over=0;
                   while(1)
                   {
                    while(fxcurrtab<tabrulern)
                    {
                     if(tabruler[fxcurrtab].type==TABDATA)
                     {
                      if((tabruler[fxcurrtab].posn>>24)==TSUBLEAD)
                      {
                       if(seentab)
                       {
                        r-=TSLEN;
                        over=1;
                        break;
                       }
																							else
                       {	// can only concat onto leader set up by first style in line
																									// can only concat onto style leader if first TABDATA in ruler

																								if(!fxleaderdata)	// this is the first TABDATA in the ruler
																								{
																									XMEMCPYX(fxleader,fxbaseleader,LEADERLEN);
																									fxleaderlen=LEADERLEN;
																								}
																								else
																								if(fxleaderstyle)	// fxleaderlen has been set up by style
																								{
																									fxleaderlen=0;
																								}

                        XMEMCPYX(fxleader+fxleaderlen,&tabruler[fxcurrtab],LEADERLEN);
                        fxleaderchanged=1;
																								fxleaderlen+=LEADERLEN;
                        fxleader[fxleaderlen]=0;
                        fxleadercalc=1;
																								fxleaderdata=1;
																								fxleaderstyle=0;
                       }
                      }
                     }
                     else
																					{
																						fxleaderdata=1;

                      if(tabruler[fxcurrtab].type<=TCENTRE)
                      {
																				 		fxleaderlen=0;
                       fxcurrtab++;
                       break;
                      }
																					}
                     fxcurrtab++;
                    }

                    if(over) break;
                    seentab=1;
                    shift+=r[1]+(r[2]<<8)+(r[3]<<16);
                    if(!((r+TSLEN)<rbrk && r[TSLEN]==TABSEQ)) break;
                    r+=TSLEN;
																			}

                   if(fxleadercalc)
                   {
                    fxleadercalc=0;
                    fxgetleaderwidth();
                   }

                   if(fxleader2[0] && fxleaderwidth>0)
                   {
                     /* now fill shift worth of tab char and bracket it */
                     /* with 2 moves */

                    n=shift/fxleaderwidth;
                    shift-=n*fxleaderwidth;
                    fxexpwritemove(shift,0);

                    while(n--)
                    {
                     llen=0;
                     while((c=fxleader2[llen])!=0)
                     {
                      if(fstyles.data.smlcaps)
                      {
                       if(fxislower(c) && !smlsize)
                       {
                         /* change from upper to lower */
                        pxpt=scale(fxpts,smallsize,0x10000);
                        pypt=scale(fypts,smallsize,0x10000);
                        smlsize=1;
                        fpending=1;
                       }
                       else
                       if(!fxislower(c) && smlsize)
                       {
                        pxpt=fxpts;
                        pypt=fypts;
                        smlsize=0;
                        fpending=1;
                       }
                       c=fxtoupper(c);
                       if(fpending) flushstate();
                      }

                      writecharconvert(c,fontosfromuser(rfont));
                      llen++;
                     }
                    }
																			}
																		}
																		else
                  {
                   *w++=FXHM;
                   *w++=0;  // padding
                   for(i=1;i<TSLEN;i++) *w++=r[i];
                   *w++=0;  // padding
                  }

                  lastch2=lastch;
                  lastch=ch;
                  break;


      case SPACESEQ:
                    if(fpending) flushstate();

                    fspace=(*(r+1))+((*(r+2))<<8)+((*(r+3))<<16);
                    hspace=(*(r+4))+((*(r+5))<<8)+
                           ((*(r+6))<<16)+((*(r+7))<<24); 
                    vspace=(*(r+8))+((*(r+9))<<8)+
                           ((*(r+10))<<16)+((*(r+11))<<24); 

                    if(fspace & SPACESEQEM)
                    {
                     hspace=scale(hspace,rypt,0x10000);
                     vspace=scale(vspace,rypt,0x10000);
                    }

                    setnewvshift(vspace);

                    if(!(fspace & SPACESEQNB))
                    {
                     fontcharwidth(fontosfromuser(rfont),rxpt,rypt,SPACE,&mw,&mh);
                     hspace-=mw;
                    }

                    if(hspace)
                    {
                     *w++=FXHM;
                     *w++=0; // padding
                     *w++=(char)hspace;
                     *w++=(char)(hspace>>8);
                     *w++=(char)(hspace>>16);
                     *w++=(char)(hspace>>24);
                    }

                    if(vspace)
                    {
                     *w++=FXVM;
                     *w++=0; // padding
                     *w++=(char)vspace;
                     *w++=(char)(vspace>>8);
                     *w++=(char)(vspace>>16);
                     *w++=(char)(vspace>>24);
                    }

                    if(!(fspace & SPACESEQNB))
                    {
                     *w++=SPACE;
                     if(fxuni) *w++=0;
                    }

                    lastch2=lastch;

                    if(fspace & SPACESEQDL) lastch=SPACESEQISDELIM;
                    else                    lastch=SPACESEQ; 
                    break;


      case   EOBOX:
      case  EOPAGE:
          case  CR:
          case  NL:
          case EOT:
                   fterminated=1;
                   break;

      case ACTDATE:
                   activedate();
                   break;

       case CHAPNO:
       case PAGENO:
                   pagenumber(v,ch==PAGENO);
                   break;

       case    EOB:
                   if(fxfirsteob<0) fxfirsteob=offset-oldoffset;
                   expandembeddedobject(v,r,1);
                   break;


       case MACSEQ:
                   macro(r,(v->file)->merge);
                   break;


       case  UNC16:
//																			cprintf("fxrender *r %x *r1 %x *r2 %x",*r,*(r+1),*(r+2));

                   printchar16((*(r+1))+((*(r+2))<<8));
                   break;


      /*  case SPACE:
                   spcs++; */

           default:
                   if(ch>=32)	printcharconvert(ch);
                   break;

   }

   r+=txcodelen(ch,sourcep);
 }

 if(hpend)
 {
  ffl[fxitem]=r;
  ffb[fxitem++]=w;
 /* ffs[item++]=spcs; */
  printcharconvert('-');
 }

 if(fpending)
 {
  if(firstone) flushstate();
  else
  {
   if(fypts>fmaxpt)   fmaxpt=fypts;
   if(fheight>fmaxht) fmaxht=fheight;
   if(flead>fmaxld)   fmaxld=flead;
   if(fascent>fmaxas) fmaxas=fascent;
  }
 }

 *w=0;
 *(w+1)=0;                // do it this way so fmaxlen gets the right value
 fmaxlen=w-fbuff;


 oldlen=r-srcdata1;         /* don't always read exactly len bytes */
 if(oldlen>srcgap) oldlen-=srcgapsize;    /* was >= */

//	cprintf("ex oldlen %d len %d r %x rbrk %x",oldlen,len,r,rbrk);

 if(fxlinejustify)
 {
  fontcharwidth(ffontos,ffxpt,ffypt,SPACE,&fxlinespace,NULL);
 }

 return(err);
}




// replace t1 with t2

os_error * fxmapout(vector * v,int len,int t1,int t2)
{
 sourcestr * s;
 char      * p;
 int         offset;
 int         slen;
 int         c1;
 int         c2;
 int         bits;
 int         i;


 s=v->textsrc.sourcep;
 offset=v->textsrc.loffset;
 p=fbuff;
 i=0;

 slen=0;
 while(slen<len)
 {
  c1=*txptr(s,offset+slen);

  bits=codex[c1];
  slen+=bits & CODELEN;
  if(bits & CODETERMINATOR) break;

  while(1)
  {
   c2=*p;
   if(fxuni) c2+=(*(p+1))<<8;

   if(i<(fxitem-1) && p>=ffb[i+1]) break;
   if(!c2) break;

   if(c2<32)
   {
    switch(c2)
    {
      case  FXFONTCODE:
                     p+=FXFCLEN;
                     break;

      case  FXCOLCODE2:
                     p+=FXCC2LEN;
                     break;

      case      FXHM:
                     p+=FXHMLEN;
                     break;

      case      FXVM:
                     p+=FXVMLEN;
                     break;

      case    FXTRANSFORM:
                     p+=FXTRANSLEN;
                     break;
    }
   }
   else
   if(c1==t1)
   {
    *p++=(char)t2;
    if(fxuni) *p++=(char)(t2>>8);
   }
   else
   {
    if(fxuni) p+=2;
    else      p++;
   }
  }

  i++;
  if(i>=fxitem) break;
 }

 return(NULL);
}






os_error * fxvalidfont(int osfont,int fxpts,int fypts,int fangle,int * fh,int * fchange)
{
// fxpts=scale(fxpts,cvdu.xdpi,72000);
//	fypts=scale(fypts,cvdu.ydpi,72000);

 fxpts=FXSCALEX(fxpts);
 fypts=FXSCALEY(fypts);

//	cprintf("fxmulx %x fxdivx %x fypts %x",fxmulx,fxdivx,fypts);

 return(validfont(osfont,fxpts,fypts,fangle,fh,fchange));
}

/******************************************************************************************/


static os_error * fxfont_paintext(char * s,int len,int options,int x,int y,fontrect * rectp,int * exts)
{
 int * lt;
 int * p;
 int   v;
 int   error;



 error=0;
 p=exts;
 lt=exts+len;
 while(p<lt)
 {
   
  error+=*p;
//   v=error/400;
  v=FXSCALEX(error);
//   error-=v*400;
  error-=FXINVSCALEX(v);

  *p++=v;
 }

 return(font_paintext(s,len,options,x,y,rectp,exts));
}



os_error * fxfont_paintextsymbol(int font,wchar_t * s,int len,int options,int x,int y,fontrect * rectp,int * exts)
{
	os_error * err;
	char     * temp;
	wchar_t  * r;
	wchar_t  * rlt;
	char     * w;
 int        code;

	if(fontcharset(font)==SYMBOL_CHARSET)
 {

//  cprintf("paint symbol");

		err=salloc((flex_ptr)&temp,len+1);
		if(!err)
		{
			r=s;
			rlt=r+len;
			w=temp;


			while(r<rlt)
			{
    code=code16winindex(*r++);

//				if(code==255) code=127;
    if(code>=0) *w++=(char)code;
    else        *w++=127;
			}

			*w=0;

   err=font_paintext(temp,w-temp,options,x,y,rectp,exts);

			sfree((flex_ptr)&temp);
		}
		return(err);
	}
	else
	{
//  cprintf("ansi print");

  return(font_paintext16(s,len,options,x,y,rectp,exts));
	}
}




static os_error * fxfont_paintext16(int font,wchar_t * s,int len,int options,int x,int y,fontrect * rectp,int * exts)
{
 int      * lt;
 int      * p;
 int        v;
 int        error;


// int   posn;
// int   lastposn;


  error=0;
  p=exts;
  lt=exts+len;
  while(p<lt)
  {
   
   error+=*p;
//   v=error/400;
   v=FXSCALEX(error);
//    v=(error*cvdu.xdpi)/72000;

//   error-=v*400;
   error-=FXINVSCALEX(v);
//   error-=(v*72000)/cvdu.xdpi;
   if(v<0) cprintf("-ve shift");
   *p++=v;
  }

// return(font_paintext16(s,len,options,x,y,rectp,exts));
   // posn+=*p;
   // v=posn/400-lastposn;
   // lastposn=posn/400;
   // posn+=*p;
   // v=posn/400-lastposn;
   // lastposn+=v;

	return(fxfont_paintextsymbol(font,s,len,options,x,y,rectp,exts));
}





static os_error * fxpaint9X(char * s,int x,int y,viewredrawstr * v)
{
 os_error      * err;
 char          * p;
 char          * q;
 int             ch;
 int             fh;
 int             fcol;
 int             font;
 int             xpts;
 int             ypts;
 font_string     fs;
	transformstr    tr;
	transformstr    ftr;
	transformstr    xtr;
	transformbitstr bits;
	int             angle;
	int             xscale;
	int             yscale;
 int             fdx;
 int             fdy;
 coordstr        cx;


//	cprintf("fxpaint9x");

 font_align(FA_BASELINE|FA_LEFT);

 fxsavescale();

 xpts=ffxpt;
 ypts=ffypt;
 font=ffontos;

 ftr=fxtr;
 if(v && !tr_isidentity(&v->tr))
 {
  tr_multiply(&tr,&ftr,&v->tr);
	}
	else
	{
  v=NULL;
		tr=ftr;
	}

 tr_getbits(&tr,&bits);
	angle=bits.angle;
 tr_setbits(&xtr,&bits,TR_ROTATE | TR_SKEW);


 if(v)
 {
 	xscale=bits.xscale;
 	yscale=bits.yscale;
  fxaddscale(xscale,yscale);
  tr_getbits(&v->tr,&bits);

  cx.x=x;
  cx.y=y;
  tr_transformset(&cx,1,&v->tr);
  x=cx.x;
  y=cx.y;
 }


 fxvalidfont(font,xpts,ypts,(angle*10)/0x10000,&fh,NULL);

 fcol=vfindcolour2(fview,ffile,&ffcol);

 err=font_setcolour(fh,PALTRANSPARENT,fcol,0);   // was fbcol

// cprintf("ffx %d ffy %d fxa %x",ffxpt,ffypt,fxangle);



 p=q=s;

 while(1)
 {
  ch=(*p)+((*(p+1))<<8);

  if(ch<32)
  {
   if(p>q)
   {
    fs.term=p-q;
    fs.s=q;
    fs.x=0;


    if(fxuni)
    {
     fontplacement(font,xpts,ypts,&fs,fxs,(fxlineakern?FP_KERNING:0)|FPWCS,fxlinedx,fxlineddx);

     fxfont_paintext16(font,(wchar_t*)fs.s,fs.term/2,0,x,y,NULL,fxs);
    }
    else
    {
     fontplacement(font,xpts,ypts,&fs,fxs,fxlineakern?FP_KERNING:0,fxlinedx,fxlineddx);

     fxfont_paintext(fs.s,fs.term,0,x,y,NULL,fxs);
    }

    fs.x=FXZSCALEX(fs.x);

    fdx=fs.x;
    fdy=0;
    tr_delta(&xtr,&fdx,&fdy);
    y+=fdy;
    x+=fdx;
   }

   if(ch==0) break;

   while((ch=(*p)+((*(p+1))<<8))<32 && ch!=0)
   {
    if(ch==FXHM)      // transform already done on these moves
    {
     fdx=((*(p+2))+((*(p+3))<<8)+((*(p+4))<<16)+((*(p+5))<<24));
     fdy=0;

     if(v) tr_delta(&v->tr,&fdx,&fdy);
     else  fdx=FXZSCALEX(fdx);

     x+=fdx;
     y+=fdy;
     p+=FXHMLEN;
    }
    else
    if(ch==FXVM)
    {
     fdx=0;
     fdy=((*(p+2))+((*(p+3))<<8)+((*(p+4))<<16)+((*(p+5))<<24));

     if(v) tr_delta(&v->tr,&fdx,&fdy);
     else  fdy=FXZSCALEY(fdy);

     x+=fdx;
     y+=fdy;
     p+=FXVMLEN;
    }
    else
    if(ch==FXTRANSFORM)
    {
     memcpy(&ftr.a,p+2,4*sizeof(int));
     
     if(v)
     {
      tr_multiply(&tr,&ftr,&v->tr);
     }
					else
					{
						tr=ftr;
					}

     tr_getbits(&tr,&bits);
	    angle=bits.angle;
					xscale=bits.xscale;
					yscale=bits.yscale;
     tr_setbits(&xtr,&bits,TR_ROTATE | TR_SKEW);
//   fxaddscale(xscale,yscale);

     fxvalidfont(font,xpts,ypts,(angle*10)/0x10000,&fh,NULL);
     font_setfont(fh);

     p+=FXTRANSLEN;
    }
    else
    if(ch==FXFONTCODE)
    {
     font=(*(p+2))+((*(p+3))<<8)+((*(p+4))<<16)+((*(p+5))<<24);
     xpts=(*(p+6))+((*(p+7))<<8)+((*(p+8))<<16)+((*(p+9))<<24);
     ypts=(*(p+10))+((*(p+11))<<8)+((*(p+12))<<16)+((*(p+13))<<24);
     font=fontosfromuser(font);
     fxvalidfont(font,xpts,ypts,(angle*10)/0x10000,&fh,NULL);
     font_setfont(fh);
     p+=FXFCLEN;
    }
    else
    if(ch==FXCOLCODE2)
    {
//     bcol=(*(p+2))+((*(p+3))<<8)+((*(p+4))<<16)+((*(p+5))<<24);
     fcol=(*(p+6))+((*(p+7))<<8)+((*(p+8))<<16)+((*(p+9))<<24);
     fcol=vfindcolour2(fview,ffile,(colourvalue*)&fcol);
     font_setcolour(0,PALTRANSPARENT,fcol,0); // was bcol
     p+=FXCC2LEN;
    }
    else
    {
     // dud code

     p++;
     if(fxuni) p++;
    }
   }
   q=p;
  }
  else
  {
   p++;
   if(fxuni) p++;
  }
 }

 fxloadscale();

 return(err);
}



/******************************************************************************************/



os_error * fxfont_paintexttr(char * s,int len,int options,int x,int y,fontrect * rectp,int * exts,transformstr * tr)
{
 int * lt;
 int * p;
 int   v;
 int   error;



 error=0;
 p=exts;
 lt=exts+len;
 while(p<lt)
 {
   
  error+=*p;
//   v=error/400;
  v=FXSCALEX(error);
//   error-=v*400;
  error-=FXINVSCALEX(v);

  *p++=v;
 }

 return(font_paintexttr(s,len,options,x,y,rectp,exts,(font_transform*)tr));
}




os_error * fxfont_paintext16tr(wchar_t * s,int len,int options,int x,int y,fontrect * rectp,int * exts,transformstr * tr)
{
 int * lt;
 int * p;
 int   v;
 int   error;

// int   posn;
// int   lastposn;


  error=0;
  p=exts;
  lt=exts+len;
  while(p<lt)
  {
   
   error+=*p;
//   v=error/400;
   v=FXSCALEX(error);
//    v=(error*cvdu.xdpi)/72000;

//   error-=v*400;
   error-=FXINVSCALEX(v);
//   error-=(v*72000)/cvdu.xdpi;
   if(v<0) cprintf("-ve shift");
   *p++=v;
  }


 return(font_paintext16tr(s,len,options,x,y,rectp,exts,(font_transform*)tr));
// return(font_paintext16(s,len,options,x,y,rectp,exts));
   // posn+=*p;
   // v=posn/400-lastposn;
   // lastposn=posn/400;
   // posn+=*p;
   // v=posn/400-lastposn;
   // lastposn+=v;
}





static os_error * fxpaint(char * s,int x,int y,viewredrawstr * v)
{
 os_error   * err;
 char       * p;
 char       * q;
 int          ch;
 int          fh;
 int          fcol;
 int          font;
 int          xpts;
 int          ypts;
 font_string  fs;
	transformstr tr;
	transformstr ftr;
 int          fdx;
 int          fdy;
 coordstr     cx;


 font_align(FA_BASELINE|FA_LEFT);


 xpts=ffxpt;
 ypts=ffypt;
 font=ffontos;

 ftr=fxtr;
 if(v) tr_multiply(&tr,&ftr,&v->tr);
 else  tr=ftr;



 fxvalidfont(font,xpts,ypts,0,&fh,NULL);

 fcol=vfindcolour2(fview,ffile,&ffcol);

 err=font_setcolour(fh,PALTRANSPARENT,fcol,0);   // was fbcol

// cprintf("ffx %d ffy %d",ffxpt,ffypt);



 p=q=s;

 while(1)
 {
  ch=(*p)+((*(p+1))<<8);

//  cprintf("paint ch %x",ch);

  if(ch<32)
  {
   if(p>q)
   {
    fs.term=p-q;
    fs.s=q;
    fs.x=0;


    if(fxuni)
    {
     fontplacement(font,xpts,ypts,&fs,fxs,(fxlineakern?FP_KERNING:0)|FPWCS,fxlinedx,fxlineddx);

     cx.x=x;
     cx.y=y;
     if(v) tr_transformset(&cx,1,&v->tr);

     fxfont_paintext16tr((wchar_t*)q,fs.term/2,0,cx.x,cx.y,NULL,fxs,&tr);
    }
    else
    {
     fontplacement(font,xpts,ypts,&fs,fxs,fxlineakern?FP_KERNING:0,fxlinedx,fxlineddx);

     cx.x=x;
     cx.y=y;
     if(v) tr_transformset(&cx,1,&v->tr);

     fxfont_paintexttr(q,fs.term,0,cx.x,cx.y,NULL,fxs,&tr);
    }

    fs.x=FXZSCALEX(fs.x);

    fdx=fs.x;
    fdy=0;
    tr_delta(&ftr,&fdx,&fdy);
    y+=fdy;
    x+=fdx;
   }

   if(ch==0) break;

   while((ch=(*p)+((*(p+1))<<8))<32 && ch!=0)
   {
    if(ch==FXHM)      // transform already done on these moves
    {
     x+=FXZSCALEX((*(p+2))+((*(p+3))<<8)+((*(p+4))<<16)+((*(p+5))<<24));
     p+=FXHMLEN;
    }
    else
    if(ch==FXVM)
    {
     y+=FXZSCALEY((*(p+2))+((*(p+3))<<8)+((*(p+4))<<16)+((*(p+5))<<24));
     p+=FXVMLEN;
    }
    else
    if(ch==FXTRANSFORM)
    {
     memcpy(&ftr.a,p+2,4*sizeof(int));
     
     if(v)
     {
      tr_multiply(&tr,&ftr,&v->tr);
     }

     p+=FXTRANSLEN;
    }
    else
    if(ch==FXFONTCODE)
    {
     font=(*(p+2))+((*(p+3))<<8)+((*(p+4))<<16)+((*(p+5))<<24);
     xpts=(*(p+6))+((*(p+7))<<8)+((*(p+8))<<16)+((*(p+9))<<24);
     ypts=(*(p+10))+((*(p+11))<<8)+((*(p+12))<<16)+((*(p+13))<<24);
     font=fontosfromuser(font);
     fxvalidfont(font,xpts,ypts,0,&fh,NULL);
     font_setfont(fh);
     p+=FXFCLEN;
    }
    else
    if(ch==FXCOLCODE2)
    {
//     bcol=(*(p+2))+((*(p+3))<<8)+((*(p+4))<<16)+((*(p+5))<<24);
     fcol=(*(p+6))+((*(p+7))<<8)+((*(p+8))<<16)+((*(p+9))<<24);
     fcol=vfindcolour2(fview,ffile,(colourvalue*)&fcol);
     font_setcolour(0,PALTRANSPARENT,fcol,0); // was bcol
     p+=FXCC2LEN;
    }
    else
    {
     // dud code

     p++;
     if(fxuni) p++;
    }
   }
   q=p;
  }
  else
  {
   p++;
   if(fxuni) p++;
  }
 }


 return(err);
}



/******************************************************************************************/



static os_error * fxrenderpaint(char * s,int x,int y,viewredrawstr * v)
{
 os_error * err;

 if(v->prjob && (((prjobstr*)(v->prjob))->bits & PSDIRECT))
 {
  err=ps_paint(s,x,y,fxuni,ffont,ffxpt,ffypt,ffcol,&fxtr,fxlineakern,fxlinedx,fxlineddx,v);
 }
 else
 {
  if(ISW9X) err=fxpaint9X(s,x,y,v);
		else				  err=fxpaint(s,x,y,v);
 }

 return(err);
}



// >> entry point from fxdraw code

os_error * fxpaintbase(char * s,int x,int y,viewredrawstr * v)
{
 os_error * err;

 err=NULL;

	fview=v->view;
	ffile=v->file;

 fontsetviewscale(NULL);

 err=fxrenderpaint(s,x,y,v);

 fontsetviewscale(fview);

 return(err);
}



/*

  There are problems here.
  If you use the font_transform matrix to shift text around, the font
  manager will cache unecessary copies of the font. In addition things
  will go wrong on mode changes.
  We therefore always have a transform matrix with e,f==0,0 and use
  the freedom to choose the origin to move the string around.
  We do use the transform to handle zooming of the window, this caches
  another copy of the font, however so do the alternatives of
  changing the font scale (like Ovation) or the font size (like Impression).

*/



void fxcalcdxs(int width,int ns,int nc)
{
// cprintf("calcdxs width %d ns %d",width,ns);

 fxlinedx=fxlinedy=fxlineddx=fxlineddy=0;
 if(width && (ns || (fxlinejustify && fxjustsingle)))
 {
  if(ns) fxlinedx=width/ns;
  else
  if(nc>1) fxlineddx=width/(nc-1);
     
  if(fxlinejustify && ns && ((nc-1)>ns))	// change 30/10/2008 forcing ns>0 and at least 2 non-space chars
  {																																						// decide that the last non-space in a line does not have a ddx after it
																																									// or else end of lines do not align
   if(width>0 && fxlinejustify)	
   {
    if(fxlinedx>(((fxjustwordmax-100)*fxlinespace)/100))
    {
//					cprintf("clause 1");
     fxlinedx=(((fxjustwordmax-100)*fxlinespace)/100);

					if(nc>ns) fxlineddx=(width-fxlinedx*ns)/((nc-1)-ns);
					else						fxlineddx=0;	// only spaces in line

     fxlinedx-=fxlineddx;

     if(fxlineddx>(fxjustlettermax*fxlinespace)/100)
     {
//						cprintf("clause 2");
      fxlineddx=(fxjustlettermax*fxlinespace)/100;
      fxlinedx=(width-fxlineddx*(nc-1))/ns;
     }
    }
   }
   else  /* width < 0 */
   {
    if(fxlinedx<(((fxjustwordmin-100)*fxlinespace)/100) && nc>ns)
    {
     fxlinedx=((fxjustwordmin-100)*fxlinespace)/100;
     if(nc>ns) fxlineddx=(width-fxlinedx*ns)/((nc-1)-ns);
					else						fxlineddx=0;
     fxlinedx-=fxlineddx;
    }
   }
  }
 }


//	 cprintf("dx=%d ddx=%d error %d",fxlinedx,fxlineddx,width-((fxlinedx+fxlineddx)*ns+(nc-1-ns)*fxlineddx));
}




// entry point>>

os_error * fxrender(viewredrawstr * v,fxrendstr * fxr)
{
 os_error   * err;
 int          flags;
 transformstr temp1;
 transformstr temp2;
 transformstr result;
 transformstr screentr;
 int          x;
 int          y;
 int          xc;
 int          yc;
 viewstr    * view;
 int          skip;



// cprintf("fxrender");

 ffile=v->file;
 fview=view=v->view;

 fontsetviewscale(fview);

 fxinvisibles=view->data.invisibles;
 fxspell=view->data.spell && (!v->isprinter);
 fpaintmode=1;
 fxuni=txunicode;
 fxmove=NULL;
 fxdrop=fxr->dropcap;
 fxeobangle=0;
 fxnbsp=1;
 skip=0;
 fxwidth=fxr->width;



 if(fxspell) spchkline(&fxr->vec,fxr->len,&fxsperrors,&fxmaxsp);
 initialstate(fxr->vec.textsrc.sourcep,fxr->vec.textsrc.offset);

 ulstart();
 bkstart();
 fkstart();
 embeddedobjectstart();   /* must match end below */
 fxcheckprefs(ffile);



 flags=0;              /* font_OSCOORDS; */
 bcol=fxr->backcol;

// if(bcol==-1 && (fontbits & 0x1) && !v->isprinter) flags|=font_BACKBLEND;

 fxleaderchanged=0;
 fxleadercalc=0;
	fxleaderdata=0;
	fxleaderstyle=0;
/*
 implicit in setsno() 
 fxleaderwidth=fstyles.data.leaderwidth;
 XMEMCPYX(fxleader,fstyles.data.leaderchar,LEADERLEN);
*/
 fxcurrtab=0;

 setsno(0,fxr->vec.astyle);


 fxlineakern=fstyles.data.akern;
 if(fxlineakern) flags|=font_AUTOKERN;
 fxbullettab=0;
 fxsetjust();

 gettabruler(ffile,fstyles.data.tab);
 XMEMCPYX(fxbaseleader,fxleader,LEADERLEN);

 if(fxinvisibles)
 {
  fxtotals(&fxr->vec,fxr->len,&fxspaces,&fxchars);
  fxcalcdxs(fxr->width,fxspaces,fxchars);
 }


 /* set up the transform for the font manager */
// tr_setscale(&screentr,view->data.zoom.div,view->data.zoom.mul,
//                       view->data.zoom.div,-view->data.zoom.mul);

 tr_setscale(&screentr,1,1,1,-1);
 tr_setshift(&temp1,fxr->x,fxr->y);
 tr_addscale(&temp1,1,1,-1,1);
 tr_multiply(&temp2,&temp1,&fxr->transform);

 tr_multiply(&fxtr,&temp2,&screentr);
 fxtrans=tr_type(&fxtr) & (~TR_SHIFT);

 fxtr.e=fxtr.f=0;

 
 err=fxrenderchunk(fxr);

 if(!err)
 {
  if(!err)
  {
   tr_setshift(&temp1,fxr->x,fxr->y+(fxdrop?fxsmaxld:fmaxld));
   tr_addscale(&temp1,1,1,-1,1);
   tr_multiply(&temp2,&temp1,&fxr->transform);

   x=temp2.e;
   y=temp2.f;

   tr_multiply(&result,&temp2,&screentr);

   result.e=0;
   result.f=0;

   doblank();

   xc=v->ox+osunits(v->xpo+x,view);
   yc=v->oy-osunits(v->ypo+y,view);
 
   xc*=400;
   yc*=400;

   fxcalcdxs(fxr->width,fxspaces,fxchars);

   bkcalc();
   ulcalc();
   fkcalc(&skip);

/*
   if((fxtrans & (TR_ROTATE|TR_SCALE)) && 
       (fxlinedx || fxlinedy || fxlineddx || fxlineddy))
   {
    tr_delta(&result,&fxlinedx,&fxlinedy);
    tr_delta(&result,&fxlineddx,&fxlineddy);
   }
*/
   transmoves(&fxtr); /* beware fbuff must not move */

   err=backgroundpaint(xc,yc,&result,v);
   if(!err) 
   {
    if(!skip)
    {
     err=fxrenderpaint(fbuff,xc,yc,v);
    }
   }

   if(!err) err=renderembeddedobject(v);
   if(!err) err=underline(xc,yc,&result,v,NULL);
  }
 }


 embeddedobjectend();      /* must match start above */
 if(skip) fpchange=1;
 else     fpchange=0; /* this is because if we've inserted moves */
                      /* we don't know if the font state is correct */

 return(err);
}


void fxtrash(void)
{
 oldlen=0;
 oldsource=0;
 fpfonth=-1;
 fpchange=1;
}





/* used to render sample of text */
/* box is area to fill           */
// entry point >>

os_error * fxsample(filestr * file,wimp_box * box,fxrendstr * fxr,xstylestr *s)
{
 os_error * err;
 int        flags;
 int        shift;
 int        xc;
 int        yc;


 
 fontsetviewscale(NULL);

 ffile=file;
 fview=NULL;


 fpaintmode=1;
 fxuni=txunicode;
 fxinvisibles=fxspell=0;
 fpchange=1;
 initialstate(fxr->vec.textsrc.sourcep,fxr->vec.textsrc.offset);
 ulstart();
 bkstart();

 flags=0;
 bcol=fxr->backcol;
// if(bcol==-1 && (fontbits & 0x1)) flags|=font_BACKBLEND;
 setsno(s,0);
 fxlineakern=fstyles.data.akern;
 fxsetjust();

 /* set up transform */
 tr_setidentity(&fxtr);
 fxtrans=0;


// cprintf("sample");


 err=fxrenderchunk(fxr);
 if(!err)
 {
  ulcalc();

  shift=bourunits(box->y1-box->y0)-fmaxht;
  shift>>=1;

  xc=bourunits(box->x0);
  yc=bourunits(box->y1)-shift-fmaxld;

/*
  font_align(FA_BASELINE|FA_LEFT);
  err=font_paint(fbuff,flags,xc,yc);
*/

  err=fxpaint(fbuff,xc,yc,NULL);

  underline(xc,yc,NULL,NULL,ffile);
 }

// fontdefscale();

 return(err);
}




/* given a length of fbuff return the length of the original */

int fchop(int bl,char * ffb[],char * base)
{
 int hi;
 int lo;
 int i;
 int code;


 hi=fxitem-1;
 lo=0;
 i=0;
 code=0;   /* compiler */

 while(hi>=lo)
 {
  i=((lo+hi)>>1);

  code=((ffb[i]-base)-bl);

  if(code>0)
  {
   hi=i-1;
  }
  else
  if(code<0)
  {
   lo=i+1;
  }
  else
   break;
 }

 if(i>0 && code>0) i--;
 else
 while(i<(fxitem-1) && (ffb[i+1]-base)<=bl) i++;

 return(i);
}


/* note that bl may be bigger than fmaxlen - check for this */

int fequivi(int bl,int * itemval)
{
 int i;

 i=fchop(bl,ffb,fbuff1);
 *itemval=i;

 i=ffl[i]-srcdata1;
 if(i>=srcgap) i-=srcgapsize;

//	cprintf("fequivi bl %d return i %d srcgap %d srcgapsize %d item %d",bl,i,srcgap,srcgapsize,*itemval);

 return(i);
}


/* given a length of original return length of flash buff code */

int fequivcode(int bl)
{
 if(bl>=srcgap) bl+=srcgapsize;

/* dprintf(8,"srcdata1 %x ffb[0] %x ffl[0] %x",srcdata1,ffb[0],ffl[0]);
 dprintf(9,"srcdata1 %x ffb[1] %x ffl[1] %x",srcdata1,ffb[1],ffl[1]); */

 return(ffb[fchop(bl,ffl,srcdata1)]-fbuff1);
}

/* how many spaces at this point in original */
/*
int fspace(int bl)
{
 if(bl>=srcgap) bl+=srcgapsize;
 return(ffs[fchop(bl,ffl,srcdata1)]);
}
*/

/* returns our offset for the next to last item */

int fnexttolast(int * itemp)
{
 int len;

 if(fxitem>0)
 {
  len=ffl[fxitem-1]-srcdata1;
  if(len>=srcgap) len-=srcgapsize;
  if(itemp) *itemp=fxitem-1;
 }
 else
 {
  len=0;
  *itemp=0;
 }

 return(len);
}


int fitem(int item)
{
 int len;
 len=ffl[item]-srcdata1;
 if(len>=srcgap) len-=srcgapsize;
 return(len);
}



/* returns the offset of the first spc in the line */

int getfirstspc(vector * s,int llen)
{
 int    c;
 int    offset;
 int    firstspc;
 int    slen;
 int    bits;

 offset=s->textsrc.loffset;
 firstspc=offset+llen;
 slen=0;

 while(slen<llen)
 {
  c=*txptr(s->textsrc.sourcep,offset+slen);
  bits=codex[c];

  if(c==SPACE)
  {
   firstspc=offset+slen;
   break;
  }

  if(bits & CODETERMINATOR) break;

  slen+=bits & CODELEN;
 }

 return(firstspc);
}




int striplen(sourcestr * s,int len,int offset)
{
 char   c;
 int    bits;
 int    slen;
 int    xslen;

 slen=0;
 xslen=0;

 while(slen<len)
 {
  c=*txptr(s,offset+slen);
  bits=codex[c];

  slen+=bits & CODELEN;

  if(c!=SPACE) xslen=slen;

  if(bits & CODETERMINATOR) break;
 }
 return(xslen);
}



os_error * fxtotals2(vector * v,int offset,int len,int * nsp,int * ncp)
{
 sourcestr * s;
 char        c;
 int         bits;
 int         slen;
 int         nc;
 int         ns;

 slen=0;
 nc=0;
 ns=0;
 s=v->textsrc.sourcep;

 while(slen<len)
 {
  c=*txptr(s,offset+slen);
  bits=codex[c];
  slen+=bits & CODELEN;

  if(c>=32) nc++;
  if(c==SPACE || c==NBSPACE) ns++;

  if(bits & CODETERMINATOR) break;
 }

 if(nsp) *nsp=ns;
 if(ncp) *ncp=nc;

 return(NULL);
}



os_error * fxtotals(vector * v,int len,int * nsp,int * ncp)
{
 return(fxtotals2(v,v->textsrc.loffset,len,nsp,ncp));
}




/* input click posn, font string set up */
/* output caret posn and offset         */

// in this version the length is not used

os_error * fxfsetcaret(font_string * fs,int dx,int ddx,int akern)
{
 os_error  * err;
 int         x;
 font_string tfs;
 int         len;
 char      * p;
 char      * q;
 char      * lt;
 int         ch;
 int         totlen;
 int         newflags;
 int         font;
 int         xpts;
 int         ypts;
 int         start;
 int         over;
	int         targetx;
	int         shiftx;

 err=NULL;

 newflags=FP_NEAREST;
 if(akern) newflags|=FP_KERNING;
 if(fxuni) newflags|=FPWCS;

 fs->term=fmaxlen;         // because we ignore the length
 font=ffontos;
 xpts=ffxpt;
 ypts=ffypt;


 p=q=fs->s;
 lt=p+fs->term;
 x=0;
 totlen=0;
 over=0;
 while(1)
 {
  if(p>=lt) ch=0;
  else      ch=(*p)+((*(p+1))<<8);

  if(ch<32)
  {
   if(p>q)
   {
    len=p-q;
    tfs.split=fs->split;
    tfs.term=len;
    tfs.x=targetx=fs->x-x;
    tfs.s=q;

    start=(q-fs->s);
    if(fxuni) start/=2;
    fontplacement(font,xpts,ypts,&tfs,fxs+start,newflags,dx,ddx);
    totlen+=tfs.term;
    x+=tfs.x;

// 			cprintf("len %d term %d tfs.x %d targetx %d",len,tfs.term,tfs.x,targetx);

    if(tfs.term<len) // we're through
    {

     break;
    }
   }

   if(ch==0) break;

   while((ch=(*p)+((*(p+1))<<8))<32 && ch!=0 && p<lt)
   {
    if(ch==FXHM)			// changed things so this code works	like fontplacement 30/1/2006
    {														// test is marking AAAA<tab>
					shiftx=(*(p+2))+((*(p+3))<<8)+((*(p+4))<<16)+((*(p+5))<<24);
     if((x+shiftx/2)>=fs->x)
     {
      over=1;
      break;
     }
					x+=shiftx;
     p+=FXHMLEN;
     totlen+=FXHMLEN;
    }
    else
    if(ch==FXVM)
    {
     p+=FXVMLEN;
     totlen+=FXVMLEN;
    }
    else
    if(ch==FXTRANSFORM)
    {
     p+=FXTRANSLEN;
     totlen+=FXTRANSLEN;
    }
    else
    if(ch==FXFONTCODE)
    {
     font=(*(p+2))+((*(p+3))<<8)+((*(p+4))<<16)+((*(p+5))<<24);
     xpts=(*(p+6))+((*(p+7))<<8)+((*(p+8))<<16)+((*(p+9))<<24);
     ypts=(*(p+10))+((*(p+11))<<8)+((*(p+12))<<16)+((*(p+13))<<24);
					font=fontosfromuser(font);

     p+=FXFCLEN;
     totlen+=FXFCLEN;
    }
    else
    if(ch==FXCOLCODE2)
    {
     p+=FXCC2LEN;
     totlen+=FXCC2LEN;
    }
   }
   q=p;
  }
  else
  {
   p++;
   if(fxuni) p++;
  }
  if(over) break;
 }

//	cprintf("totlen %d",totlen);

 fs->term=totlen;
 fs->x=x;
 fs->font=font;
 fs->xpts=xpts;
 fs->ypts=ypts;

 return(err);
}



static char * findsplit8(char * s,int len,int split,int inclusive)
{
 char * lt;
 char * last;
 int    ch;

 lt=s+len;
 last=s;

 while(s<lt || (inclusive && s<=lt))
 {
  if((ch=*s++)==split)
  {
   last=s-1;
  }
  else
  if(ch==FXHM)       s+=FXHMLEN-1;
  else
  if(ch==FXVM)       s+=FXVMLEN-1;
  else
  if(ch==FXFONTCODE) s+=FXFCLEN-1;
  else
  if(ch==FXCOLCODE2) s+=FXCC2LEN-1;
  else
  if(ch==FXTRANSFORM)s+=FXTRANSLEN-1;
 }

 return(last);
}


static char * findsplit16(char * s,int len,int split,int inclusive)
{
 char * lt;
 char * last;
 int    ch;

 lt=s+len;
 last=s;

 while(s<lt || (inclusive && s<=lt))
 {
  ch=*s++;
  ch+=(*s++)<<8;
  
  if(ch==split)
  {
   last=s-2;
  }
  else
  if(ch==FXHM)       s+=FXHMLEN-2;
  else
  if(ch==FXVM)       s+=FXVMLEN-2;
  else
  if(ch==FXFONTCODE) s+=FXFCLEN-2;
  else
  if(ch==FXCOLCODE2) s+=FXCC2LEN-2;
  else
  if(ch==FXTRANSFORM)s+=FXTRANSLEN-2;
 }

 return(last);
}


static char * findsplit(char * s,int len,int split,int inclusive)
{
 if(fxuni) return(findsplit16(s,len,split,inclusive));
 else      return(findsplit8(s,len,split,inclusive));
}








/* input click posn, font string set up */
/* output caret posn and offset         */


// FXSINCLUSIVE - when set include split chars beyond what will fit
// e.g. a line which ends with a space, but the space does not fit in the gap


os_error * fxstrwidth(font_string * fs,int dx,int ddx,int flags)
{
 os_error  * err;
 int         x;
 font_string tfs;
 int         len;
 char      * p;
 char      * q;
 char      * s;
 int         ch;
 int         totlen;
 char      * lt;
 int         newflags;
 int         i;
 int         hm;
 int         over;
 font_info   fi;
 int         fminy;
 int         fmaxy;
 int         font;
 int         xpts;
 int         ypts;
 int         start;
 int         end;
	int         fxinc;

 err=NULL;


// cprintf("fxstrwidth in");

 newflags=FP_EXTENT;
 if(flags & FXSAKERN) newflags|=FP_KERNING;
 if(fxuni) newflags|=FPWCS;
 
 // if(fs->term>fmaxlen) fs->term=fmaxlen;

 font=(flags & FXSFFONT)?fs->font:ffontos;
 xpts=(flags & FXSFFONT)?fs->xpts:ffxpt;
 ypts=(flags & FXSFFONT)?fs->ypts:ffypt;
 fxinc=(flags & FXSINCLUSIVE);

 if(fs->split>=0) fxinc=1;
 // code has to work like RISC OS version
 // consistency is the issue - Peter Newble July 2013
 // the split character does not have to be fitted into the width
 // enhanced justification shows up the problem



// there's a fiddle here fxs[] is used with one entry per input
// character position
// control sequences are turned into a number of characters	- same number as their length
// this means you can't assume fxs[] is always big enough from
// other uses of fxs[] in the document

// fs->term may be a huge number, so you can't use it to dimension space	here either


 over=0;
 p=q=fs->s;
 lt=p+fs->term;
 x=0;
 totlen=0;
 while(1)
 {
  if(p>=lt) ch=0;
  else
  {
   ch=*p;
   if(fxuni) ch+=(*(p+1))<<8;
  }

//		cprintf("ch =%d",ch);

  if(ch<32)
  {
   if(p>q)
   {
    len=p-q;

    tfs.split=fs->split;
    tfs.term=len;
    tfs.x=fs->x-x;
    tfs.s=q;

    start=q-fs->s;

    if(fxuni)
    {
     start/=2;
 			 fxchunkin((p-fs->s)/2);
				}
				else
				{
 			 fxchunkin((p-fs->s));
				}

//				cprintf("input len %d",len);

    fontplacement(font,xpts,ypts,&tfs,fxs+start,newflags,dx,ddx);

//				cprintf("output len %d",tfs.term);

    totlen+=tfs.term;
    x+=tfs.x;

    if(tfs.term<len)// we're through
    {
     if(fs->split>=0)
     {																// problem is that split char could reasonably be the char which failed to fit
																						// so we have to mess with inclusive search length for split
      s=findsplit(fs->s,totlen,fs->split,fxinc && (totlen<fs->term));
      start=(s-fs->s);
      end=totlen;
      if(fxuni)
      {
       start/=2;
       end/=2;
      }
      for(i=start;i<end;i++)  // was +1 another copy later.
      {
       x-=fxs[i];
      }
      totlen=s-fs->s;
     }
     break;
    }
   }

   if(ch==0) break;

   while((ch=(*p)+((*(p+1))<<8))<32 && ch!=0 && p<lt)
   {
    if(ch==FXHM)
    {
     hm=(*(p+2))+((*(p+3))<<8)+((*(p+4))<<16)+((*(p+5))<<24);
     if(fxuni)
     {
      memset(fxs+(p-fs->s)/2,0,sizeof(*fxs)*FXHMLEN/2);
      fxs[(p-fs->s)/2]=hm;
     }
     else
     {
      memset(fxs+(p-fs->s),0,sizeof(*fxs)*FXHMLEN);
      fxs[p-fs->s]=hm;
     }


     if((x+hm)>fs->x)
     {
//      cprintf("HM break");
      if(fs->split>=0)
      {
       s=findsplit(fs->s,totlen,fs->split,fxinc && (totlen<fs->term));
       start=(s-fs->s);
       end=totlen;
       if(fxuni)
       {
        start/=2;
        end/=2;
       }
       for(i=start;i<end;i++)
       {
        x-=fxs[i];
       }
       totlen=s-fs->s;
      }
      over=1;
      break;
     }
     else
     {
      x+=hm;
      p+=FXHMLEN;
      totlen+=FXHMLEN;
     }
    }
    else
    if(ch==FXVM)
    {
     if(fxuni)
     {
      memset(fxs+(p-fs->s)/2,0,sizeof(*fxs)*FXVMLEN/2);
     }
     else
     {
      memset(fxs+(p-fs->s),0,sizeof(*fxs)*FXVMLEN);
     }
     p+=FXVMLEN;
     totlen+=FXVMLEN;
    }
    else
    if(ch==FXFONTCODE)
    {
     if(fxuni)
     {
      memset(fxs+(p-fs->s)/2,0,sizeof(*fxs)*FXFCLEN/2);
     }
     else
     {
      memset(fxs+(p-fs->s),0,sizeof(*fxs)*FXFCLEN);
     }
     font=(*(p+2))+((*(p+3))<<8)+((*(p+4))<<16)+((*(p+5))<<24);
     font=fontosfromuser(font);
     xpts=(*(p+6))+((*(p+7))<<8)+((*(p+8))<<16)+((*(p+9))<<24);
     ypts=(*(p+10))+((*(p+11))<<8)+((*(p+12))<<16)+((*(p+13))<<24);
     p+=FXFCLEN;
     totlen+=FXFCLEN;
    }
    else
    if(ch==FXCOLCODE2)
    {
     if(fxuni)
     {
      memset(fxs+(p-fs->s)/2,0,sizeof(*fxs)*FXCC2LEN/2);
     }
     else
     {
      memset(fxs+(p-fs->s),0,sizeof(*fxs)*FXCC2LEN);
     }
     p+=FXCC2LEN;
     totlen+=FXCC2LEN;
    }
    else
    if(ch==FXTRANSFORM)
    {

     p+=FXTRANSLEN;
     totlen+=FXTRANSLEN;
    }
   }


   q=p;
   if(over) break;
  }
  else
  {
   p++;
   if(fxuni) p++;
  }
 }


//	cprintf("fxstrwidth totlen %d max %d",totlen,fmaxlen);

 fs->term=totlen;
 fs->x=x;
 fs->font=font;
 fs->xpts=xpts;
 fs->ypts=ypts;

 if(flags & FXSBBOX)
 {
  p=fs->s;
  lt=p+fs->term;

  font=(flags & FXSFFONT)?fs->font:ffontos;
  xpts=(flags & FXSFFONT)?fs->xpts:ffxpt;
  ypts=(flags & FXSFFONT)?fs->ypts:ffypt;

  fminy=fmaxy=0;

  while(p<lt)
  {
   ch=*p;
   if(fxuni) ch+=(*(p+1))<<8;

   if(ch<32)
   {
    if(ch==FXHM)
    {
     p+=FXHMLEN;
    }
    else
    if(ch==FXVM)
    {
     p+=FXVMLEN;
    }
    else
    if(ch==FXTRANSFORM)
    {
     p+=FXTRANSLEN;
    }
    else
    if(ch==FXFONTCODE)
    {
     font=(*(p+2))+((*(p+3))<<8)+((*(p+4))<<16)+((*(p+5))<<24);
     font=fontosfromuser(font);
     xpts=(*(p+6))+((*(p+7))<<8)+((*(p+8))<<16)+((*(p+9))<<24);
     ypts=(*(p+10))+((*(p+11))<<8)+((*(p+12))<<16)+((*(p+13))<<24);
     p+=FXFCLEN;
    }
    else
    if(ch==FXCOLCODE2)
    {
     p+=FXCC2LEN;
    }
   }
   else
   {
    fontcharbbox(font,xpts,ypts,ch,&fi);
    fmaxy=MAX(fmaxy,fi.maxy);
    fminy=MIN(fminy,fi.miny);
    p++;
    if(fxuni) p++;
   }
  }

  fxsmaxht=fmaxy-fminy+fxdropfix;
  fxfmaxld=fmaxy;
  fxsmaxld=fmaxy+fxdropfix;
  if(fxsmaxld>fxsmaxht) fxsmaxht=fxsmaxld;
  fxsmaxy=fmaxy;
  fxsminy=fminy;
 }


//  cprintf("fxstrwidth ex");

 return(err);
}





/* hasfont bit 1==fonts, bit 2==objects */

static int fsvshift;
static int fsbshift;
static int fspt;
static int fsld;
static int fsht;
static int fsas;


static void fontstatecheckheight(int force)
{
 int           bshift;
 int           pt;
 int           ld;
 int           ht;
 int           as;

 bshift=fsbshift+fsvshift;
 pt=fspt;
 ld=fsld;
 ht=fsht;
 as=fsas;


 if(bshift>0)
 {
  ld+=bshift;
  ht+=bshift;
  as+=bshift;
 }
 else
 if(bshift<0)
 {
  ht-=bshift;
 }

 if(force)
 {
  fmaxpt=pt;
  fmaxld=ld;
  fmaxht=ht;
  fmaxas=as;
 }
 else
 {
  if(pt>fmaxpt) fmaxpt=pt;
  if(ld>fmaxld) fmaxld=ld;
  if(as>fmaxas) fmaxas=as;
  if(ht>fmaxht) fmaxht=ht;
 }
}


static os_error * fontstatecode(int sn,filestr * file,int force)
{
 absstylestr * s;

 findabsstylep(file,sn,&s);
 fspt=s->style.data.ypts;
 fsld=s->style.data.lead;
 fsht=s->style.data.height;
 fsas=s->style.data.ascent;

 fsbshift=s->style.data.baseshift;
 
 fontstatecheckheight(force);

 return(NULL);
}



/* NB state of eob angles still in force */

os_error * fontstate(vector * v,int offset,int len,int * style,int * hasfont,
                                                    int flag,int * ecode)
{
 os_error * err;
 int        c;
 int        bits;
 int        maxoffset;
 int        sn;
 int        pr;
 char     * p;
 int        pendingsn;
 int        fspace;
 int        vspace;


 err=NULL;
 *hasfont=0;
 maxoffset=offset+len;
 sn=*style;
 pr=0;
 c=-1;
 pendingsn=0;

 fsvshift=0;
 fsbshift=0;

 fontstatecode(sn,v->file,1);

 while(offset<maxoffset)
 {
  p=txptr(v->textsrc.sourcep,offset);
  c=*p;
  bits=codex[c];

  if(pendingsn && c!=SNO)
  {
   fontstatecode(sn,v->file,!pr);
   pendingsn=0;
   *hasfont|=1;
  }

  switch(c)
  {

   case  SNO:
             sn=p[1]+(p[2]<<8)+(p[3]<<16);
             pendingsn=sn;
             *hasfont|=1;
             break;

   case  EOB:
             *hasfont|=2;
             pr=1;
             expandembeddedobject(v,p,0);
             break;

 case SPACESEQ:
               pr=1;

               fspace=(*(p+1))+((*(p+2))<<8)+((*(p+3))<<16);
               vspace=(*(p+8))+((*(p+9))<<8)+
                           ((*(p+10))<<16)+((*(p+11))<<24); 

               if(fspace & SPACESEQEM)
               {
                vspace=scale(vspace,rypt,0x10000);
               }

               fsvshift+=vspace;

               fontstatecheckheight(0);

               break;

 case TABSEQ:
 case MACSEQ:
 case  UNC16:
             pr=1;
             break;

           default:
             if(bits & CODETERMINATOR)
             {
              offset=maxoffset;
             }
             else 
             {
              pr=1;
             }
             break;
  }

  offset+=bits & CODELEN;
 }

 if(pendingsn)
 {
  fontstatecode(sn,v->file,!pr);
  pendingsn=0;
  *hasfont|=1;
 }

 *style=sn;
 *ecode=c;

 return(err);

 USE(flag);
}




os_error * firstfont(vector * v,int flag)
{
 os_error * err;
 int        c;
 int        bits;
 int        offset;
 char     * p;
 int        sn;

 err=NULL;
 offset=v->textsrc.loffset;


 fsvshift=0;
 fsbshift=0;


 fontstatecode(v->astyle,v->file,1);

 while(1)
 {
  p=txptr(v->textsrc.sourcep,offset);
  c=*p;
  bits=codex[c];
 
  if(c==SNO)
  {
   sn=p[1]+(p[2]<<8)+(p[3]<<16);
   fontstatecode(sn,v->file,1);
   offset+=bits & CODELEN;
  }
  else break;
 }

 return(err);

 USE(flag);
}





/* find the style number at the caret                                   */
/* scan from the start of the line unpacking fonts along the way */

os_error * getstylev(vector * s,int inclusive,int * sn)
{
 os_error * err;
 char     * c;
 int        end;
 int        offset;
 char     * cs=NULL;
 int        ch;
 int        bits;
 vlstr    * vl;
 int        voffset;

 err=NULL;
 end=s->textsrc.offset;
 offset=s->textsrc.loffset;
 *sn=s->astyle;

 /* need this because caret can be at start of line before a style code */

 if(!inclusive && end==offset && s->textsrc.voffset)
 {
  voffset=s->textsrc.voffset;
  while(voffset)
  {
   voffset-=sizeof(vlstr);
   vl=vlptr(s->textsrc.vsourcep,voffset);
   if(!vl->line.xl)
   {
    *sn=vl->line.style;
    offset-=vl->line.len;
    break;
   }
  }
 }

 while(offset<end || (offset<=end && inclusive))
 {
  c=txptr(s->textsrc.sourcep,offset);
  ch=*c;

  bits=codex[ch];
  if(ch==SNO) cs=c;
  offset+=bits & CODELEN;
  if(bits & CODETERMINATOR) break;
 }

 if(cs) *sn=(*(cs+1))+((*(cs+2))<<8)+((*(cs+3))<<16);

 return(err);      
}



os_error * getcaretstyle(vector * s,absstylestr * st)
{
 os_error * err;
 int        sn;

 err=getstylev(s,0,&sn);
 if(!err) err=findabsstyle(s->file,sn,st);

 return(err); 
}



os_error * getcaretstylex(vector * s,absstylestr * st)
{
 os_error * err;

 err=txlock(&s->textsrc,s->file);
 if(!err)
 {
  err=getcaretstyle(s,st);

  txunlock(&s->textsrc,s->file);
 }

 return(err);
}




os_error * getcaretstyleinc(vector * s,absstylestr * st)
{
 os_error * err;
 int        sn;

 err=getstylev(s,1,&sn);
 if(!err) err=findabsstyle(s->file,sn,st);

 return(err); 
}




/* called when file is closed */

static os_error * fxclose(int eventn,int user,filestr * file,int data1)
{
 if(file==filepref) filepref=NULL;

 return(NULL);

 USE(eventn);
 USE(user);
 USE(data1);
}




static os_error * fxpref(int eventn,int user,viewstr * view,int data1)
{
 if(view->file==filepref) filepref=NULL;

 return(NULL);

 USE(eventn);
 USE(user);
 USE(data1);
}








os_error * fxinit(void)
{
 os_error * err;

 fxuni=txunicode;

 err=salloc((flex_ptr)&fxsperrors,sizeof(int)*FXMAXSPERR);
 fxmaxsp=FXMAXSPERR-4;

 if(!err) err=fxbuffinit();
 if(!err) err=ulinit();
 if(!err) err=embeddedobjectinit();
 if(!err) err=bkinit();
 if(!err) err=fkinit();
 if(!err) err=addevent(EVENT_FCLOSE,(eventfn)fxclose,0);
 if(!err) err=addevent(EVENT_PREFERENCES,(eventfn)fxpref,0);

 return(err);
}

