/*->c.text */


#include "stdafx.h"

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <locale.h>
#include <math.h>

#include "os.h"
#include "wimp.h"
#include "wimpt.h"
#include "werr.h"
#include "wos.h"
#include "flex.h"
#include "bbc.h"
#include "font.h"
#include "transform.h"
#include "xprocess.h"
#include "avl.h"

#include "err.h"
#include "xmath.h"
#include "fsx.h"
#include "xext.h"
#include "poll.h"
#include "alloc.h"
#include "trans.h"
#include "colour.h"
#include "etc.h"
#include "bf.h"
#include "sp.h"
#include "deb.h"
#include "bits.h"
#include "imlib.h"


#include "constants.h"
#include "str.h"
#include "reslink.h"
#include "obj.h"
#include "object.h"
#include "pref.h"

#include "geometry.h"

#include "viewr.h"
#include "view.h"
#include "file.h"
#include "chain.h"
#include "posn.h"

#include "select.h"

#include "editpath.h"
#include "objectdb.h"
#include "undo.h"
#include "units.h"

#include "xcolour.h"
#include "border.h"
#include "xredraw.h"
#include "curve.h"
#include "chain.h"
#include "mpage.h"
#include "fillstub.h"
#include "prstr.h"
#include "xprint.h"

#include "pxstr.h"
#include "pict.h"
#include "impex.h"

#include "frameflow.h"
#include "section.h"


#include "txstr.h"
#include "tx.h"
#include "sx.h"
#include "txprivate.h"
#include "fx.h"
#include "vl.h"
#include "vi.h"
#include "fl.h"
#include "fl2.h"
#include "style.h"
#include "ustyle.h"
#include "caret.h"
#include "vec.h"
#include "act.h"
#include "txdd.h"
#include "texttool.h"
#include "codes.h"
#include "hp.h"
#include "blank.h"
#include "link.h"
#include "spell.h"
#include "fmap.h"
#include "fox.h"
#include "mx.h"
#include "dbtext.h"
#include "dbstyle.h"
#include "txchoices.h"
#include "stylemap.h"
#include "styleif.h"
#include "index.h"
#include "txds.h"
#include "textr.h"
#include "bms.h"
#include "tabs.h"
#include "textunicode.h"
#include "postscript.h"

#include "text.h"






#define UTTRAN     0x2000
#define UTFLOW     0x2001
#define UTUPDATE   0x2002
#define UTRECREATE 0x2003
#define UTDELETE   0x2004
#define UTSHAPE    0x2005
#define UTBORDER   0x2006
#define UTMOVE     0x2007



/* zeroing vlines has consequences for flow code         */
/* in effect creating lines that can never be seen by it */

void zerocolumns(textboxstr * textp,int u,int vbox)
{
 int      usize;
 texsub * texup;
 int      columns;
 int      i;

 columns=textp->data.columns;

 if(textp->data.header || textp->data.footer) 
 {
  usize=sizeof(textboxstr)+3*sizeof(texsrc)+sizeof(texhdr);
  if(u<0)
  {
   columns+=2;
  }
  else
  if(u==0) 
  {
   usize+=2*sizeof(texsub);
  }
  else
  {
   columns=1;
   if(u==2) usize+=sizeof(texsub);
  }
 }
 else 
 {
  usize=sizeof(textboxstr)+sizeof(texsrc);
 }

 texup=(texsub*)(((char*)textp)+usize);

 for(i=0;i<columns;i++)
 {
  texup->bytes=0;
  texup->vlines=0;
  if(vbox) texup->vbox=0;
  texup++;
 }
}



os_error * newtextbuffers(int * txsource,int * vlsource,filestr * file)
{
 os_error   * err;
 char         temp[8];
 sourcestr  * sourcep;

          err=txsourcenew(txsource,file);
 if(!err) err=vsourcenew(vlsource,file);

 err=writedefltstyle(temp,file);
 temp[SNLEN]=EOT;
 if(!err)
 {
  fob_change(*txsource,file,sizeof(sourcestr)+SNLEN+1,(fobjptr)&sourcep);
  sourcep->len=sourcep->maxlen=sourcep->goffset=SNLEN+1;
  XMEMCPYX(sourcep->data,temp,SNLEN+1);
 }

 return(err);
}


os_error * newtextbuffer(int textk,filestr * file,int main)
{
 os_error   * err;
 int          txsource;
 int          vlsource=0;
 textboxstr * textp;
 textsrcstr   textsrc;
 char         temp[8];
 texsrc     * texsp;
 int          header;
 int          footer;
 int          u;

 textp=(textboxstr*)fob_find(textk,file);
 header=textp->data.header;
 footer=textp->data.footer;

 err=NULL;

 for(u=0;u<3;u++)
 {
  if((u==0 && main) || (u==1 && header) || (u==2 && footer))
  {
            err=txsourcenew(&txsource,file);
   if(!err) err=vsourcenew(&vlsource,file);
   if(err) break;

   textp=(textboxstr*)fob_find(textk,file);

   texsp=(texsrc*)(((char*)textp)+sizeof(textboxstr));

   texsp[u].source=txsource;
   texsp[u].vsource=vlsource;

   zerocolumns(textp,u,0);

   textsrc.text=textk;
   textsrc.u=u;

   err=txlock(&textsrc,file);
   if(!err)
   {
    textsrc.offset=0;

    err=writedefltstyle(temp,file);
    temp[SNLEN]=EOT;
    if(!err)
    {
     err=txsourceinsert(temp,EOTLEN+SNLEN,&textsrc,file);
    }
  
    txsourceclose(&textsrc,file);
    vsourceclose(&textsrc,file);

    txunlock(&textsrc,file);
   }
  }
 }
 return(err);
}



#define DEFINSET  MMSIZE
#define DEFOUTSET MMSIZE


unpackedtextdatastr deflttextdata=
{

 1,           /* columns   */
 0,           /* header    */
 DEFINSET,    /* inset     */
 0,           /* changei   */

 0,           /* valign    */
 0,           /* repeat    */
 0,           /* footer    */
 0,           /* radius    */

 OURWHITE,

 0,           /* column mode   */
 0,           /* column guides */
 MMSIZE,      /* column guide width  */
 14173,       /* column width  */
 OURBLACK,    /* column guide colour */

 FILLSTR,     /* fill                */

 0,           /* lock                */
 0,           /* spread              */

};



textflowstr deflttextflow=
{
 DEFOUTSET,
 FRFBOTH,
 FROFRAME,
 0,           /* changeo */
};



void getdeflttextdata(unpackedtextdatastr * textdata)
{
 *textdata=deflttextdata;
}



static void packtextdatas(textboxstr * textp,unpackedtextdatastr * s)
{
 textdatastr * d;
 texhdr      * texhp;

 d=&textp->data;

 d->columns=s->columns;
 d->header=(s->header!=0);
 d->footer=(s->footer!=0);
 d->i=s->inset;
 d->changei=s->changei;
 d->valign=s->valign;
 d->repeat=s->repeat;
 d->radius=s->radius;
 d->colour=s->colour;
 d->columndata=s->columndata;
 d->fill=s->fill;


 if(s->header || s->footer)
 {
  texhp=(texhdr*)(((char*)textp)+sizeof(textboxstr)+3*sizeof(texsrc));
  texhp->footer=s->footer;
  texhp->header=s->header;
 }
}



void packtextdata(textboxstr * textp,unpackedtextdatastr * s)
{
 textp->flags.locked=s->lock;
 textp->flags.spread=s->spread;
 packtextdatas(textp,s);
}



void unpacktextdata(unpackedtextdatastr * d,textboxstr * textp)
{
 textdatastr * s;
 texhdr      * texhp;

 s=&textp->data;

 d->columns=s->columns;
 d->inset=s->i;
 d->changei=s->changei;
 d->valign=s->valign;
 d->repeat=s->repeat;
 d->radius=s->radius;
 d->colour=s->colour;
 d->columndata=s->columndata;
 d->fill=s->fill;

 d->lock=textp->flags.locked;
 d->spread=textp->flags.spread;

 d->footer=d->header=0;

 if(s->header || s->footer)
 {
  texhp=(texhdr*)(((char*)textp)+sizeof(textboxstr)+3*sizeof(texsrc));
  d->footer=texhp->footer;
  d->header=texhp->header;
 }
}




 /* getbordersize(textp->frame,file,&borderwidth);
  i+=borderwidth; */


#ifdef NEVER
   tr_setshift(&itr,/* fcurve.box.x */-xcurve.box.x,
                    /* fcurve.box.y */-xcurve.box.y);
#endif



os_error * txboundingcurves(textboxstr ** textpp,filestr * file,int flags)
{
 os_error         * err;
 transformbitstr    b;
 transformstr       tr;
 transformstr       itr;
 int                textk;
 curvestr           fcurve;
 curvestr           icurve;
 curvestr           ocurve;
 curvestr           xcurve;
 curvestr           newi;
 curvestr           newo;
 int                i;
 int                o;
 textboxstr      *  textp;
 int                borderwidth[4];

 err=NULL;


 if(flags & (BCINNER|BCOUTER))
 {
  textp=*textpp;
  textk=textp->key;

  fcurve=textp->fcurve;
  icurve=textp->icurve;
  ocurve=textp->ocurve;

  o=textp->textflow.o;

  tr_getbits(&textp->transform,&b);
  tr_setbits(&tr,&b,TR_SCALE /*|TR_SKEW*/);

  i=textp->data.i;

  /* this is odd because a skew frame which is a box will get an outer */
  /* curve which is a path                                             */

  copycurve(&xcurve,file,&fcurve,file);
  transformcurve(&tr,&xcurve,file);
  tr_inverse(&tr,&itr);

  if(flags & BCINNER)
  {                                                                                parallelcurve(file,&xcurve,&newi,-i);
   if(flags & BCDEL) deletecurve(&icurve,file);

   transformcurve(&itr,&newi,file);

   err=fob_mod(textk,file,(fobjptr)&textp);
   textp->icurve=newi;
  }

  if(flags & BCOUTER)
  {
   textp=(textboxstr*)fob_find(textk,file);
   getbordersize(textp->frame,file,borderwidth,&textp->fcurve);

   parallelcurve2(file,&xcurve,&newo,o,borderwidth);
   if(flags & BCDEL) deletecurve(&ocurve,file);
   transformcurve(&itr,&newo,file);

   err=fob_mod(textk,file,(fobjptr)&textp);
   textp->ocurve=newo;
  }

  deletecurve(&xcurve,file);

  *textpp=(textboxstr*)fob_find(textk,file);
 }

 return(err);
}





/* simple low level text link */

os_error * textlink(int box,int nextbox,filestr * file)
{
 textboxstr * textp;
 int          source;
 int          vsource;
 int          osource;
 int          ovsource;
 texsrc     * texsp;

 textp=(textboxstr*)fob_find(box,file);
 textp->fchain.next=nextbox;

 texsp=(texsrc*)(((char*)textp)+sizeof(textboxstr));
 source=texsp->source;
 vsource=texsp->vsource;

 textp=(textboxstr*)fob_find(nextbox,file);
 textp->fchain.prev=box;
 texsp=(texsrc*)(((char*)textp)+sizeof(textboxstr));

 osource=texsp->source;
 ovsource=texsp->vsource;

 texsp->source=source;
 texsp->vsource=vsource;

 if(osource!=source)   txsourcedel(osource,file,1);
 if(ovsource!=vsource) vsourcedel(ovsource,file);

 return(NULL);
}








os_error * createtexts1(objectloc * loc,curvestr * c,
             unpackedtextdatastr * data,textflowstr * flow,
                      transformstr * tr,int frame,curvestr * ic,curvestr * oc)
{
 os_error    * err;
 int           textk;
 textboxstr  * textp;
 curvestr      fcurve;
 curvestr      icurve;
 curvestr      ocurve;
 filestr     * file;
 int           size;
 int           bits;


 /* note size is linked to number of columns in default */

 if(data->header || data->footer)
 {
  size=sizeof(textboxstr)+sizeof(texhdr)+3*sizeof(texsrc)+
                                           (data->columns+2)*sizeof(texsub);
 }
 else
 {
  size=sizeof(textboxstr)+sizeof(texsrc)+data->columns*sizeof(texsub);
 }

 file=loc->file;

 err=fob_create(size,file,OTEXTBOX,(fobjptr)&textp);
 if(!err)
 {
  textk=textp->key;

  packtextdata(textp,data);
  textp->textflow=*flow;
  textp->transform=*tr;
  textp->frame=frame;

  copycurve(&fcurve,file,c,file);




  bits=0;
  if(ic)
  {
   copycurve(&icurve,file,ic,file);
  }
  else bits|=BCINNER;

  if(oc)
  {
   copycurve(&ocurve,file,oc,file);
  }
  else bits|=BCOUTER;


  if(loc->copymode & LOCNEW)
  {
   err=newtextbuffer(textk,file,1);
  }

  fob_mod(textk,file,(fobjptr)&textp);
  textp->fcurve=fcurve;
  if(ic) 
  {
   textp->icurve=icurve;
   textp->data.changei=1;
  }
  if(oc)
  {
   textp->ocurve=ocurve;
   textp->textflow.changeo=1;
  }

  settexttransform(textp);       /* uses fcurve */

  setcurveradius(&textp->fcurve,textp->data.radius,&textp->transform);
  txboundingcurves(&textp,file,bits);

  getframemaxbox((sobjectstr **)&textp,textp->frame,file,&textp->transform);

  insafter(textk,loc->after,loc->parent,loc->chain,file);

  loc->object=textk;

  textp=(textboxstr*)fob_find(textk,file);

  if(loc->copymode & LOCNEW)
  {
   frameflow((sobjectstr **)&textp,file);
   frfladdb((sobjectstr **)&textp,file,1);
  }
  else
  if(!(loc->copymode & LOCNVBOX))
  {
   createvboxes(textk,file);
  }



  vxadd((sobjectstr **)&textp,file);
 }
 return(err);
}



os_error * createtexts(objectloc * loc,curvestr * c,
                       unpackedtextdatastr * data,textflowstr * flow)
{
 transformstr tr;
/* curvestr     cx; */

/* if(c->type==CBOX)
 {
  tr_setscale(&tr,0x10000,c->box.w,0x10000,c->box.h);
  tr.e=c->box.x;
  tr.f=c->box.y;
  nullcurve(&cx);
  cx.type=CBOX;
  cx.box.w=cx.box.h=0x10000;
  c=&cx;
 }  
 else */
 {
  tr_setidentity(&tr);
 }

 return(createtexts1(loc,c,data,flow,&tr,0,NULL,NULL));
}


static os_error * createtext(objectloc * loc,curvestr * c)
{
 os_error * err;

 loc->copymode|=LOCNEW;

 err=createtexts(loc,c,&deflttextdata,&deflttextflow);
 if(!err)
 {
  undowritefn(loc->file,UTDELETE,&loc->object,sizeof(int));
 }

 return(err);
}


/*****************************************************************************/

static transformstr xtransform;

static int xtrf(transformstr * r,transformstr * t,
                                    curvestr * c,transformstr * ct)
{
 tr_multiply(r,t,&xtransform);

 return(0);

 USE(c);
 USE(ct);
}




typedef struct txmovestr
{
 int            text;
 int            spage;
 int            dpage;
 int            parent;
 int            after;
 transformstr   tr;
} txmovestr;




static os_error * untextmove(filestr * file)
{
 txmovestr    old;
 txmovestr    xnew;
 textboxstr * textp;
 int          cbits;

 undoread(file,&xnew,sizeof(txmovestr));

 old=xnew;
 old.spage=xnew.dpage;
 old.dpage=xnew.spage;

 textp=(textboxstr*)fob_find(old.text,file);

 old.tr=textp->transform;
 old.after=textp->chain.prev;
 old.parent=parentof((chainobject*)textp,file);

 undowritefn(file,UTMOVE,&old,sizeof(txmovestr));

 textp=(textboxstr*)fob_find(xnew.text,file);

 vxaddn((sobjectstr**)&textp,file,xnew.spage);
 frameflow((sobjectstr **)&textp,file);

 textp->transform=xnew.tr;
 settexttransform(textp);

 unlinkobject(old.text,0,file);
 insafter(xnew.text,xnew.after,xnew.parent,0,file);

 textp=(textboxstr*)fob_find(xnew.text,file);
 setcurveradius(&textp->fcurve,textp->data.radius,&textp->transform);

 cbits=BCDEL;
 if(!textp->data.changei)     cbits|=BCINNER;
 if(!textp->textflow.changeo) cbits|=BCOUTER;
 txboundingcurves(&textp,file,cbits);

 getframemaxbox((sobjectstr **)&textp,textp->frame,file,&textp->transform);

 frameflow((sobjectstr **)&textp,file);
 vxaddn((sobjectstr **)&textp,file,xnew.dpage);

 return(NULL);
}



static os_error * textcopym(objectloc * src,objectloc * dest,transformstr * tr)
{
 textboxstr * textp;
 filestr    * sfile;
 int          object;
 int          trmode;
 txmovestr    old;

 sfile=src->file;
 object=src->object;

 textp=(textboxstr*)fob_find(object,sfile);
 vxaddn((sobjectstr**)&textp,sfile,src->page);

 frameflow((sobjectstr **)&textp,sfile);

 if(dest->copymode & LOCUNDO)
 {
  old.text=object;
  old.spage=dest->page;
  old.dpage=src->page;
  old.tr=textp->transform;
  old.after=textp->chain.prev;
  old.parent=parentof((chainobject*)textp,sfile);

  undowritefn(sfile,UTMOVE,&old,sizeof(txmovestr));
 }


 unlinkobject(object,0,sfile);
 dest->object=object;
 insafter(object,dest->after,dest->parent,0,sfile);

 textp=(textboxstr*)fob_find(object,sfile);
 xtransform=*tr;

 trmode=TRNOUPDATE|TRNOREFLOWS|TRNOUNDO;

 transtext(textp,sfile,xtrf,trmode);

 textp=(textboxstr*)fob_find(object,sfile);
 vxaddn((sobjectstr**)&textp,sfile,dest->page);

 return(NULL);
}




/* 

   Note
   Repeating master frames have a previous box and can still be
   the first thing created on document page. i.e. the right hand
   page is created first

*/

os_error * textcopyc(objectloc * src,objectloc * dest,transformstr * tr)
{
 os_error    * err;
 int           textk;
 textboxstr  * dtextp=NULL;
 filestr     * sfile;
 filestr     * dfile;
 textboxstr  * srctext;
 textboxstr  * desttext;
 int           size;
 int           i;
 int           header;
 int           footer;
 texsrc      * texsp;
 texsrc      * dtexsp;
 texsub      * texup;
 texsub      * dtexup;
 texhdr      * texhp=NULL;
 texhdr      * dtexhp=NULL;
 int           texsize;  /* in bytes        */
 int           subsize;  /* in texsub units */
 sectionmapstr map;
 int           newchain;
 int           msource;
 int           mvsource;


 err=NULL;

/* dprintf(4,"textcopy"); */



 sfile=src->file;
 dfile=dest->file;
 newchain=0;

 err=fob_static((fobjptr)&srctext,src->object,sfile);
 if(!err)
 {
  err=fob_static((fobjptr)&desttext,src->object,sfile);
  if(!err)
  {
   header=srctext->data.header;
   footer=srctext->data.footer;

   if(header || footer)
   {
    texsize=3*sizeof(texsrc)+sizeof(texhdr);
    subsize=srctext->data.columns+2;
   }
   else
   {
    texsize=sizeof(texsrc);
    subsize=srctext->data.columns;
   }
   size=sizeof(textboxstr)+texsize+subsize*sizeof(texsub);


            err=copycurve(&desttext->fcurve,dfile,&srctext->fcurve,sfile);
   if(!err) err=copycurve(&desttext->icurve,dfile,&srctext->icurve,sfile);
   if(!err) err=copycurve(&desttext->ocurve,dfile,&srctext->ocurve,sfile);

   if(!err) err=copyborderm(&desttext->frame,dfile,
                             srctext->frame,sfile,dest->copymode);
   if(!err) err=copyfillm(&desttext->data.fill,dfile,
                          &srctext->data.fill,sfile,dest->copymode);

   if(!err) err=mapcolour(sfile,dfile,&desttext->data.colour,dest->copymode);
   if(!err) err=mapcolour(sfile,dfile,&desttext->data.columndata.colour,
                                                             dest->copymode);

   if(!err) err=fob_create(size,dfile,OTEXTBOX,(fobjptr)&dtextp);
   textk=dtextp->key;

   texsp=(texsrc*)(((char*)desttext)+sizeof(textboxstr));
   texup=(texsub*)(((char*)desttext)+sizeof(textboxstr)+texsize);

   for(i=0;i<3;i++)
   {
    if(i==0 || (i==1 && header) || (i==2 && footer))
    {
     if(!srctext->data.repeat || i>0 || dest->branch) 
     {

      if(!srctext->fchain.prev || i>0)
      {

       if(!err) err=txcopysourcedata(texsp[i].source,&texsp[i].source,
                                    texsp[i].vsource,&texsp[i].vsource,
                                    sfile,dfile,dest->copymode);

       if(!err) err=txcopyeobs(sfile,dfile,tr,
                               textk,dest->page,dest->section,texsp[i].source,
                               0,-1,dest->copymode);

      }
      else
      {
       texsp[i].source=texsp[i].vsource=0;
      }

     }
     else
    /* if(dest->copymode & LOCNEW) */
     {
      /* we must be making a copy of a master frame           */
      /* sfile has to equal dfile                             */ 
      /* has to be master branch to doc branch                */
      /* we assert that doc to master copies can never happen */

      msource =texsp[0].source;
      mvsource=texsp[0].vsource;

      if(!src->branch && !dest->branch && !(dest->copymode & LOCOLDMASTER))
      {
       /* find msource in dest */
       mapmaster(src,dest,srctext->master,&desttext->master);
       dtextp=(textboxstr*)fob_find(desttext->master,dfile);
       dtexsp=(texsrc*)(((char*)dtextp)+sizeof(textboxstr));
       msource =dtexsp[0].source;
       mvsource=dtexsp[0].vsource;
       sectionfindmap(msource,&map,dest->section,dfile);
      }
      else
      {
       sectionfindmap(msource,&map,src->section,sfile);
      }

      /* first of these had better be true     */
      /* second is only valid if first is true */

 /*  dprintf(5,"sectionmap ms=%d ds=%d",map.msource,map.dsource); */

      if(!map.msource || !map.dsource)
      {
       map.msource =msource;
       map.mvsource=mvsource;

       if(!err) err=txcopysourcedata(texsp[i].source,&texsp[i].source,
                                    texsp[i].vsource,&texsp[i].vsource,
                                    sfile,dfile,dest->copymode);

       txcopyeobs(sfile,dfile,tr,
                 textk,dest->page,dest->section,texsp[i].source,
                 0,-1,dest->copymode);

       map.dsource =texsp[0].source;
       map.dvsource=texsp[0].vsource;

       if(!src->branch && !dest->branch && !(dest->copymode & LOCOLDMASTER))
       {
        sectionaddmap(&map,dest->section,dfile,-1);
       }
       else
       {
        sectionaddmap(&map,src->section,dfile,-1);
       }

       newchain=1;
      }
      else
      {
       texsp[0].source=map.dsource;
       texsp[0].vsource=map.dvsource;
      }
     }
    }
    if(err) break;
   }

   if(!err)
   {
    if(dest->copymode & LOCFLOWDATA)
    {
     for(i=0;i<subsize;i++)
     {
      err=vboxcopy(texup[i].vbox,&texup[i].vbox,sfile,dfile);
     }
    }
    else
    {
     for(i=0;i<subsize;i++)
     {
      texup[i].vbox=0;
     }
    }
   }

   if(!err)
   {
    dtextp=(textboxstr*)fob_find(textk,dfile);
    dtextp->fcurve=desttext->fcurve;
    dtextp->icurve=desttext->icurve;
    dtextp->ocurve=desttext->ocurve;
    dtextp->frame=desttext->frame;
    dtextp->data=desttext->data;
    dtextp->textflow=desttext->textflow;

    if(header || footer)
    {
     dtexhp=(texhdr*)(((char*)dtextp)+sizeof(textboxstr)+3*sizeof(texsrc));
     texhp=(texhdr*)(((char*)desttext)+sizeof(textboxstr)+3*sizeof(texsrc));
     *dtexhp=*texhp;
     dtexhp->headerdata=(src->branch && !dest->branch);
     dtexhp->footerdata=(src->branch && !dest->branch);
    }

    dtexsp=(texsrc*)(((char*)dtextp)+sizeof(textboxstr));

    for(i=0;i<3;i++)
    {
     if(i==0 || (i==1 && header) || (i==2 && footer))
     {
      dtexsp[i]=texsp[i];
     }
    }

    dtexup=(texsub*)(((char*)dtextp)+sizeof(textboxstr)+texsize);

    if(header || footer)
    {
     dtexup[0].bytes=texup[0].bytes;
     dtexup[0].vlines=texup[0].vlines;
     dtexup[0].vdelta=texup[0].vdelta; /* DP 159 */
     dtexup[1].bytes=texup[1].bytes;
     dtexup[1].vlines=texup[1].vlines;
     dtexup[1].vdelta=texup[1].vdelta; /* DP 159 */
    }

    if((dest->copymode & LOCNEW) || !srctext->data.repeat || newchain)
    {
     if(header||footer) i=2;
     else               i=0;

     while(i<subsize)
     {
      dtexup[i].bytes=texup[i].bytes;
      dtexup[i].vlines=texup[i].vlines;
      dtexup[i].vdelta=texup[i].vdelta; /* DP 159 */
      i++;
     }
    }
   /* else
    {
     zerocolumns(dtextp,0,0);
    } */

    for(i=0;i<subsize;i++)
    {
     dtexup[i].vbox=texup[i].vbox;
    }

   /* memset(&dtextp->flags,0,sizeof(flagstr)); */
    dtextp->flags.locked=desttext->flags.locked;
    dtextp->flags.spread=desttext->flags.spread;

    if(src->branch && !dest->branch) 
    {
     dtextp->master=srctext->key;
     dtextp->flags.masterdata=1;
    }


    if(dest->copymode & LOCOLDMASTER) 
    {
     dtextp->master=srctext->master;
     dtextp->flags.masterdata=1;
     /* why should masterdata and headerdata ever be treated differently?*/
     if(header || footer) /* DP 356 */
     {
      dtexhp->headerdata=1;
      dtexhp->footerdata=1;
     }
    }
    else
    if(!src->branch && !dest->branch)
    {
     if(srctext->master)
     {
      if((dest->copymode & LOCKEEPMASTER))
      { 
       dtextp->flags.local=desttext->flags.local;
       mapmaster(src,dest,srctext->master,&desttext->master);
       dtextp=(textboxstr*)fob_find(textk,dfile);
       dtextp->master=desttext->master;
       dtextp->flags.local=desttext->flags.local;
       dtextp->flags.masterdata=desttext->flags.masterdata;
       if(header || footer) /* DP 356 */
       {
        dtexhp->headerdata=texhp->headerdata;
        dtexhp->footerdata=texhp->footerdata;
       }
      }
     }
     else
     {
      dtextp->fchain.prev=desttext->fchain.prev;
      dtextp->fchain.next=desttext->fchain.next;
     }

     dtextp->flags.full=desttext->flags.full;
    }


    tr_multiply(&dtextp->transform,&desttext->transform,tr);
    tr_multiply(&dtextp->data.transform,&desttext->data.transform,tr);

    getframemaxbox((sobjectstr **)&dtextp,dtextp->frame,dfile,
                                                       &dtextp->transform);

    insafter(textk,dest->after,dest->parent,dest->chain,dfile);

    dest->object=textk;

    frfladdb((sobjectstr**)&dtextp,dfile,1);

    if(!(dest->copymode & LOCNOFLOW)) frameflow((sobjectstr **)&dtextp,dfile);

    vxadd((sobjectstr **)&dtextp,dfile);
   }

   fob_free((fobjptr)&desttext,sfile);
  }
  fob_free((fobjptr)&srctext,sfile);
 }

 return(err);
}




os_error * textcopy(objectloc * src,objectloc * dest,transformstr * tr)
{
 if(dest->copymode & LOCMOVE) return(textcopym(src,dest,tr));
 else                         return(textcopyc(src,dest,tr));
}


/*****************************************************************************/

static os_error * textreflowmessage(textboxstr * textp,
                                                 filestr * file,int flags)
{
 os_error  * err;
 vector      v;
 int         textk;
 flowstr     flop;
 int         header;
 int         footer;
 int         u;
 int         firstbox;
 sourcestr * sourcep;
 texsrc    * texsp;
 int         size;

 err=NULL;

 textk=textp->key;
 header=textp->data.header;
 footer=textp->data.footer;
 firstbox=!textp->fchain.prev;

/* dprintf(0,"text reflow flags=%x text=%d",flags,textk); */

 if(flags & TXREFLOWVBOX)   err=createvboxes(textk,file);
 if(flags & TXREFLOWONEBOX) firstbox=1;


 if((flags & TXREFLOWMASK)!=FLNONE)
 {
  for(u=0;u<3;u++)
  {
   if(u==0 || (header && u==1) || (footer && u==2))
   {
    textp=(textboxstr*)fob_find(textk,file);
    if(flags & TXREFLOWZERO) zerocolumns(textp,u,0);

    if(u!=0 || firstbox)
    {
     texsp=(texsrc*)(((char*)textp)+sizeof(textboxstr));
     sourcep=(sourcestr*)fob_find(texsp[u].source,file);
     size=boxcontents(textp,u,NULL,NULL);

   /* dprintf(0,"h=%d f=%d u=%d textk=%d",header,footer,u,textk); */

     setvectorfrombox(&v,u,textk,file);

     flop.opcode=FWAIT;
     flop.data.type=flags & TXREFLOWMASK;
     flop.data.offset=0;
     flop.data.length=0;
     flop.data.delta=0;

     if(flop.data.type==FLDELTA) 
     {
      if(flags & TXREFLOWONEBOX) 
      {
       flop.data.delta=size;
       flop.data.offset=v.boffset;
      }
      else
      {
       flop.data.delta=sourcep->len;
      }
     }
     else
     {
      if(flags & TXREFLOWONEBOX)
      {
       flop.data.length=size;
       flop.data.offset=v.boffset;
      }
      else
      {
       flop.data.length=sourcep->len;
      }
     }

     flow(&v,&flop);
    }
   }
  }
 }

 return(err);
}


static os_error * textdoreflow(textboxstr * textp,filestr * file)
{
// cprintf("text doreflow =%d",textp->key);

 return(textreflowmessage(textp,file,TXREFLOWVBOX|TXREFLOWONEBOX|FLQUICK));
}


/*****************************************************************************/


os_error * textfrompictlo(textboxstr * textp,filestr * file)
{
 os_error   * err;
 int          textk;
 int          size;
 texsub     * texup;
 int          usize;
 texsrc     * texsp;
 pictdatastr  pictdata;

 err=NULL;

 textk=textp->key;

 pictdata=((pictboxstr*)textp)->data;

 size=sizeof(textboxstr)+sizeof(texsrc)+deflttextdata.columns*sizeof(texsub);
 fob_change(textk,file,size,(fobjptr)&textp);

 textp->type=OTEXTBOX;
 packtextdatas(textp,&deflttextdata);

 textp->data.colour=pictdata.colour;
 textp->data.fill=pictdata.fill;
 textp->data.radius=pictdata.radius;

 textp->flags.version=0;

 texsp=(texsrc*)(((char*)textp)+sizeof(textboxstr));
 texsp->source=texsp->vsource=0;

 usize=sizeof(textboxstr)+sizeof(texsrc);
 texup=(texsub*)(((char*)textp)+usize);
 texup->bytes=0;
 texup->vlines=0;
 texup->vbox=0;
 texup->vdelta=0;

 textp->fchain.next=textp->fchain.prev=0;

 textp->flags.version=0;

 settexttransform(textp);

 textp=(textboxstr*)fob_find(textk,file);

 /* need to think about keeping inner/outer curves from pictures */

 textp->textflow.changeo=0;
 if(textp->textflow.omode==FROUSER) textp->textflow.omode=FROFRAME;

 return(err);
}



os_error * textfrompict(textboxstr * textp,filestr * file)
{
 os_error * err;
 int        text;

 text=textp->key;

 err=textfrompictlo(textp,file);

 err=newtextbuffer(text,file,1);

 textp=(textboxstr*)fob_find(text,file);

 txboundingcurves(&textp,file,BCDEL|BCINNER|BCOUTER);

 getframemaxbox((sobjectstr **)&textp,textp->frame,file,&textp->transform);

 frameflow((sobjectstr **)&textp,file);
 frfladdb((sobjectstr **)&textp,file,1);
 vxadd((sobjectstr **)&textp,file);

 return(err);
}

#ifdef NEVER
os_error * textscrapdata(int object,filestr * file)
{
 textboxstr * textp;
 int          i;
 texsrc     * texsp;
 int          header;
 int          footer;

 fob_lock((fobjptr)&textp,object,file);

 header=textp->data.header;
 footer=textp->data.footer;

 for(i=0;i<3;i++)
 {
  if(i==0 || (i==1 && header) || (i==2 && footer))
  {
   texsp=(texsrc*)(((char*)textp)+sizeof(textboxstr));
   txsourcedel(texsp[i].source,file,1);
   texsp=(texsrc*)(((char*)textp)+sizeof(textboxstr));
   vsourcedel(texsp[i].vsource,file);
  }
 }

 fob_unlock((fobjptr)&textp,file);

 return(NULL);
}
#endif



typedef struct txsavestr
{
 texsrc          texs[3];

 unsigned int    header;
 unsigned int    footer;

 unsigned int    changei:1;
 unsigned int    changeo:1;
 unsigned int    valign:4;
 unsigned int    columns:5;

 unsigned int    i:25;      /* inset              */

 columnstr       columndata;

 curvestr        icurve;
 curvestr        ocurve;
} txsavestr;



os_error * txsavedata(int text,filestr * file)
{
 os_error   * err;
 txsavestr    txsave;
 textboxstr * textp;
 texsrc     * texsp;
 texhdr     * texhp;
 int          i;
 int          usize;
 int          n;
 texsub       txsub[MAXCOLUMNS+2];
 texsub     * texup;

 memset(&txsave,0,sizeof(txsavestr));

 textp=(textboxstr*)fob_find(text,file);

 txsave.columns=textp->data.columns;
 n=txsave.columns;
 usize=sizeof(textboxstr)+sizeof(texsrc);

 if(textp->data.header || textp->data.footer)
 {
  texhp=(texhdr*)(((char*)textp)+sizeof(textboxstr)+3*sizeof(texsrc));
  txsave.header=texhp->header;
  txsave.footer=texhp->footer;
  usize+=2*sizeof(texsrc)+sizeof(texhdr);
  n+=2;
 }

 txsave.changei=textp->data.changei;
 txsave.changeo=textp->textflow.changeo;
 txsave.valign=textp->data.valign;
 txsave.i=textp->data.i;
 txsave.columndata=textp->data.columndata;

 txsave.icurve=textp->icurve;
 txsave.ocurve=textp->ocurve;

 nullcurve(&textp->icurve);
 nullcurve(&textp->ocurve);

 texsp=(texsrc*)(((char*)textp)+sizeof(textboxstr));

 for(i=0;i<3;i++)
 {
  if(i==0 || (i==1 && txsave.header) || (i==2 && txsave.footer))
  {
   txsave.texs[i]=texsp[i];
  }
  else
  {
   memset(&txsave.texs[i],0,sizeof(texsrc));
  }
 }

 texup=(texsub*)(((char*)textp)+usize);

 XMEMCPYX(txsub,texup,n*sizeof(texsub));

 if(!txsave.changei) deletecurve(&txsave.icurve,file);
 if(!txsave.changeo) deletecurve(&txsave.ocurve,file);

 trashvboxes(text,file);

 err=undowrite(file,&txsave,sizeof(txsavestr));
 if(!err) undowrite(file,txsub,n*sizeof(texsub));

 return(err);
}



os_error * txloaddata(int text,filestr * file)
{
 os_error   * err;
 txsavestr    txsave;
 textboxstr * textp;
 texsrc     * texsp;
 texhdr     * texhp;
 int          bits;
 int          i;
 int          usize;
 int          n;
 texsub       txsub[MAXCOLUMNS+2];
 texsub     * texup;

 err=undoread(file,&txsave,sizeof(txsavestr));

 if(!err)
 {
  n=txsave.columns;
  usize=sizeof(textboxstr)+sizeof(texsrc);

  if(txsave.header || txsave.footer)
  {
   usize+=2*sizeof(texsrc)+sizeof(texhdr);
   n+=2;
  }

  undoread(file,txsub,n*sizeof(texsub));

  fob_change(text,file,usize+n*sizeof(texsub),(fobjptr)&textp);

  textp->data.columns=txsave.columns;
  textp->data.header=txsave.header!=0;
  textp->data.footer=txsave.footer!=0;
  textp->data.changei=txsave.changei;
  textp->textflow.changeo=txsave.changeo;
  textp->data.valign=txsave.valign;
  textp->data.i=txsave.i;
  textp->data.columndata=txsave.columndata;

  textp->icurve=txsave.icurve;
  textp->ocurve=txsave.ocurve;

  if(txsave.header || txsave.footer)
  {
   texhp=(texhdr*)(((char*)textp)+sizeof(textboxstr)+3*sizeof(texsrc));
   texhp->header=txsave.header;
   texhp->footer=txsave.footer;
  }

  texsp=(texsrc*)(((char*)textp)+sizeof(textboxstr));

  for(i=0;i<3;i++)
  {
   if(i==0 || (i==1 && txsave.header) || (i==2 && txsave.footer))
   {
    texsp[i]=txsave.texs[i];
   }
  }

  texup=(texsub*)(((char*)textp)+usize);

  for(i=0;i<n;i++) txsub[i].vbox=0;

  XMEMCPYX(texup,txsub,n*sizeof(texsub));

  settexttransform(textp);

  bits=0;
  if(!txsave.changeo) bits|=BCOUTER;
  if(!txsave.changei) bits|=BCINNER;

  txboundingcurves(&textp,file,bits);

  getframemaxbox((sobjectstr **)&textp,textp->frame,file,&textp->transform);

  frameflow((sobjectstr **)&textp,file);

  createvboxes(text,file);

 }

 return(err);
}



os_error * txscrapdata(filestr * file)
{
 os_error   * err;
 txsavestr    txsave;
 texsub       txsub[MAXCOLUMNS+2];
 int          i;
 int          n;


 err=undoread(file,&txsave,sizeof(txsavestr));

 n=txsave.columns;

 if(txsave.header || txsave.footer)
 {
  n+=2;
 }

 undoread(file,txsub,n*sizeof(texsub));

 if(!err)
 {
  for(i=0;i<3;i++)
  {
   txsourcedel(txsave.texs[i].source,file,1);
   vsourcedel(txsave.texs[i].vsource,file);
  }

  if(txsave.changei) deletecurve(&txsave.icurve,file);
  if(txsave.changeo) deletecurve(&txsave.ocurve,file);
 }

 return(err);
}



os_error * makepictframe(int text,filestr * file,int section,int * claim)
{
 os_error * err;

 err=NULL;

 if(!txconvertable(text,section,file))
 {
  if(act.valid && file==act.file && act.textsrc.text==text) clearactive();

  *claim=0;
 }

 return(err);
}

/*****************************************************************************/


static int findtext(posnstr * posn,textboxstr * textp,int * before,int last)
{
 os_error    * err;
 int           childk;
 chainobject * childp;
 int           lines;
 int           bytes;
 vlstr       * vline;
 int           maxoffset;
 textsrcstr    texsrc;
 char        * p;
 int           c;
 int           bits;
 int           header;
 int           footer;


 texsrc.text=textp->key;
 header=textp->data.header;
 footer=textp->data.footer;


 if(insidebox(posn->x,posn->y,&textp->box))
 {
  if(insidecurve(posn->x,posn->y,&textp->fcurve,&textp->transform,posn->file))
                                                              last=texsrc.text;
 }



 if(last==texsrc.text)
 {
  for(texsrc.u=0;texsrc.u<3;texsrc.u++)
  {
   if((texsrc.u==0) || (texsrc.u==1 && header) || (texsrc.u==2 && footer))
   {
    if(texsrc.u==0)
    {
     settextoffset(posn->file,textp,&texsrc.voffset,&texsrc.offset);
    }
    else
    {
     texsrc.voffset=texsrc.offset=0;
    }

    boxcontents(textp,texsrc.u,&bytes,&lines);

    if(lines && bytes)
    {
     err=txlock(&texsrc,posn->file);
     if(!err)
     {
      if((texsrc.voffset+lines)>texsrc.vsourcep->len)
                         lines=texsrc.vsourcep->len-texsrc.voffset;

      while(lines)
      {
       lines-=sizeof(vlstr);
       vline=vlptr(texsrc.vsourcep,texsrc.voffset);
							if(!vline) break;

       if(!vline->line.xl)
       {
        if(vline->line.object)
        {
         maxoffset=texsrc.offset+vline->line.len;

         while(texsrc.offset<maxoffset)
         {
          p=txptr(texsrc.sourcep,texsrc.offset);
          c=*p;
          bits=codex[c];

          if(c==EOB)
          {
           childk=(*(p+1))+((*(p+2))<<8)+((*(p+3))<<16)+((*(p+4))<<24);
           childp=(chainobject*)fob_find(childk,posn->file);
           last=objectfind(posn,(objhdrstr*)childp,before,last);
          }
   
          texsrc.offset+=bits & CODELEN;
         }
        }
        else
        {
         texsrc.offset+=vline->line.len;
        }
       }
       texsrc.voffset+=sizeof(vlstr);
      }

      txunlock(&texsrc,posn->file);
     }
    }
   }
  }

  childk=textp->chain.child;
  while(childk)
  {
   childp=(chainobject*)fob_find(childk,posn->file);
   childk=childp->chain.next;
   last=objectfind(posn,(objhdrstr*)childp,before,last);
  }
 }

 return(last);
}




static int selecttext(textboxstr * textp,posnstr * posn,int type)
{
 int           textk;
 int           parent;
 filestr     * file;
 int           xtype;

 textk=textp->key;
 file=posn->file;

 if(type==SELECTOBJECT || type==SELECT1)
 {
  xtype=type;
  parent=parentof((chainobject*)textp,file);
  if(parent) type=objectselect((objhdrstr*)fob_find(parent,file),posn,SELECT1);
  if(xtype!=SELECT1) addselection(textk,file,type);
 }
 else
 if(type==DESELECTOBJECT)
 {
  remselection(textk,file,type);
 }

 return(type);
}




/* writes data that can be changed by a transform */

static os_error * writetransdata(textboxstr * textp,filestr * file)
{
 os_error     * err;

          err=undowrite(file,&textp->transform,sizeof(transformstr));
/* if(!err) err=undowrite(file,&textp->data.transform,sizeof(transformstr));
 if(!err) err=undowritecurve(file,&textp->fcurve);
 if(!err) err=undowritecurve(file,&textp->icurve);
 if(!err) err=undowritecurve(file,&textp->ocurve); */

 return(err);
}


/* reads data that can be changed by a transform */

static os_error * readtransdata(textboxstr * textp,filestr * file)
{
 os_error     * err;

          err=undoread(file,&textp->transform,sizeof(transformstr));
/* if(!err) err=undoread(file,&textp->data.transform,sizeof(transformstr));
 if(!err) err=undoreadcurve(file,&textp->fcurve);
 if(!err) err=undoreadcurve(file,&textp->icurve);
 if(!err) err=undoreadcurve(file,&textp->ocurve); */

 return(err);
}



/* tagged to UTTRAN */

static os_error * untranstext(filestr * file)
{
 os_error     * err;
 int            text;
 textboxstr   * textp;
 int            cbits;

 err=undoread(file,&text,sizeof(int));

 textp=(textboxstr*)fob_find(text,file);

 if(textp)
 {
  vxadd((sobjectstr **)&textp,file);
  frameflow((sobjectstr **)&textp,file);
  frfladdb((sobjectstr **)&textp,file,1);

           err=undowritefn(file,UTTRAN,&text,sizeof(int));
  if(!err) err=writetransdata(textp,file);
  if(!err) err=readtransdata(textp,file);

  settexttransform(textp);

  setcurveradius(&textp->fcurve,textp->data.radius,&textp->transform);

  cbits=BCDEL;
  if(!textp->data.changei)     cbits|=BCINNER;
  if(!textp->textflow.changeo) cbits|=BCOUTER;

  txboundingcurves(&textp,file,cbits);

  getframemaxbox((sobjectstr **)&textp,textp->frame,file,&textp->transform);

  frameflow((sobjectstr **)&textp,file);
  vxadd((sobjectstr **)&textp,file);
 }

 return(err);
}




void settexttransform(textboxstr * textp)
{
 transformbitstr b;
 transformstr    r2;
 transformstr    r3;
 int             y;

 tr_getbits(&textp->transform,&b);
 tr_setbits(&r2,&b,TR_SHIFT | TR_ROTATE);

 tr_setshift(&r3,scale(textp->fcurve.box.x,b.xscale-0x10000,0x10000),
                 scale(textp->fcurve.box.y,b.yscale-0x10000,0x10000));

 if(b.skewxy)
 {
  y=scale(textp->fcurve.box.y,b.yscale,0x10000);
  if(b.skewxy<0) y+=scale(textp->fcurve.box.h,b.yscale,0x10000);

  r3.e+=scale(y,b.skewxy,0x10000);
 }

 tr_multiply(&textp->data.transform,&r3,&r2);
}




static transformstr gtrans;
static int          gangle;

static int gtrf(transformstr * r,transformstr * t,
                                    curvestr * c,transformstr * ct)
{
 tr_multiply(r,t,&gtrans);
 return(0);
 USE(c);
 USE(ct);
}



static os_error * textembededtrans(int text,filestr * file,transformfn trf,int flags)
{
 os_error    * err;
 int           lines;
 int           bytes;
 vlstr       * vline;
 int           maxoffset;
 textsrcstr    texs;
 textboxstr  * textp;
 texsrc      * texsp;
 char        * p;
 int           c;
 int           bits;
 int           extent;
 int           object;
 int           source;
 int           vsource;
 int           u;
 int           header;
 int           footer;
	int           angle;

 err=NULL;


 texs.text=text;


 for(u=0;u<3;u++)
 {
  textp=(textboxstr*)fob_find(text,file);
  header=textp->data.header;
  footer=textp->data.footer;

  if(u==0 || (u==1 && header) || (u==2 && footer))
  {
   texs.u=u;

   texsp=(texsrc*)(((char*)textp)+sizeof(textboxstr));
   source=texsp[u].source;
   vsource=texsp[u].vsource;
   bytes=sourcesize(source,file);
   lines=vsourcesize(vsource,file);
   texs.voffset=texs.offset=0;

   settextoffset(file,textp,&texs.voffset,&texs.offset);
   boxcontents(textp,0,&bytes,&lines);

   if(lines && bytes)
   {
    err=txlock(&texs,file);
    if(!err)
    {
     if((texs.voffset+lines)>texs.vsourcep->len) lines=texs.vsourcep->len-texs.voffset;

     extent=texs.sourcep->len;
   
     while(lines>0)
     {
      lines-=sizeof(vlstr);
      vline=vlptr(texs.vsourcep,texs.voffset);

      if(texs.offset>extent) break;

      if(!vline->line.xl)
      {
       if(vline->line.object)
       {
        maxoffset=texs.offset+vline->line.len;
        if(maxoffset>extent) maxoffset=extent;

        while(texs.offset<maxoffset)
        {
         p=txptr(texs.sourcep,texs.offset);
         c=*p;
         bits=codex[c];

         if(c==EOB)
         {
          object=(*(p+1))+((*(p+2))<<8)+((*(p+3))<<16)+((*(p+4))<<24);

          if(gangle)
          {
           angle=(*(p+11))+((*(p+12))<<8)+((*(p+13))<<16)+((*(p+14))<<24);
											angle+=gangle;

											cprintf("angle %d gangle %d",angle,gangle);

           *(p+11)=(char)angle;
           *(p+12)=(char)(angle>>8);
           *(p+13)=(char)(angle>>16);
           *(p+14)=(char)(angle>>24);
										}

          err=objecttransform((objhdrstr*)fob_find(object,file),file,trf,flags);
          if(err) break;
         }
   
         texs.offset+=bits & CODELEN;
        }
       }
       else
       {
        texs.offset+=vline->line.len;
       }
      }

      texs.voffset+=sizeof(vlstr);
      if(err) break;
     }

     txunlock(&texs,file);
    }
   }
  }
	}
 return(err);
}








os_error * transtext(textboxstr * textp,filestr * file,
                                      transformfn trf,int flags)
{
 os_error      * err;
 transformstr    r1;
	transformstr    inv;
 int             text;
 int             cbits;
 transformbitstr gbits;
 int             code;


 err=NULL;

 text=textp->key;

 if(!(flags & TRNOUPDATE))  vxadd((sobjectstr **)&textp,file);
 if(!(flags & TRNOREFLOW))  
 {
  frfladdb((sobjectstr **)&textp,file,1);
 }
 if(!(flags & TRNOREFLOWS)) frameflow((sobjectstr **)&textp,file);

 if(!(flags & TRNOUNDO))
 {
           err=undowritefn(file,UTTRAN,&textp->key,sizeof(int));
  if(!err) err=writetransdata(textp,file);
 }

 code=trf(&r1,&textp->transform,&textp->fcurve,&textp->transform); 
 tr_inverse(&textp->transform,&inv);
 tr_multiply(&gtrans,&inv,&r1);
 textp->transform=r1;

	if(code & TR_ROTATE)
	{
 	tr_getbits(&gtrans,&gbits);
 	gangle=gbits.angle;
	}
 else
	{
		gangle=0;
	}

 settexttransform(textp);

 getframemaxbox((sobjectstr **)&textp,textp->frame,file,&textp->transform);
 setcurveradius(&textp->fcurve,textp->data.radius,&textp->transform);

 cbits=BCDEL;
 if(!textp->data.changei)     cbits|=BCINNER;
 if(!textp->textflow.changeo) cbits|=BCOUTER;

 txboundingcurves(&textp,file,cbits);

 if(!(flags & TRNOREFLOWD)) frameflow((sobjectstr **)&textp,file);
 if(!(flags & TRNOUPDATE))  vxadd((sobjectstr **)&textp,file);


// problem of frames embedded objects > 1 deep - move parent, child
// of child remains unmoved
// however removing the constraints leads to memory errors
// the constraints are probably fair game, limiting code to fl.cpp calls
// when an embedded object is moved in a line

																
 if((flags & TRNOREFLOW) && (flags & TRNOREFLOWS) &&
    (flags & TRNOREFLOWD) && (flags & TRNOUPDATE) &&
    (flags & TRNOUNDO)) textembededtrans(textp->key,file,gtrf,flags);


 return(err);
}


/*****************************************************************************/
/* set flow mode for text box */


static os_error * setflow(filestr * file,int text,
                          textflowstr * textflow,textflowstr * oldflow)
{
 os_error   * err;
 int          changeo;
 textboxstr * textp;


 err=NULL;

 if(textflow->omode==FROUSER) textflow->omode=FROFRAME;

 fob_mod(text,file,(fobjptr)&textp);
 textp->textflow=*textflow;

 frameflow((sobjectstr **)&textp,file);

 if(textflow->omode!=oldflow->omode)
 {
  if(textflow->omode==FROFRAME)
  {
   err=txboundingcurves(&textp,file,BCOUTER|BCDEL);
  }
  else
  if(textflow->omode==FRONONE)
  {
   err=deletecurve(&textp->ocurve,file);
  }
 }
 else
 {
  changeo=(oldflow->changeo!=textflow->changeo) || (oldflow->o!=textflow->o);

  if(changeo && !textflow->changeo)
  {
   err=txboundingcurves(&textp,file,BCOUTER|BCDEL);
  }
 }

 frameflow((sobjectstr **)&textp,file);

 return(err);
}


/* tagged to UTFLOW */

static os_error * untextsetflow(filestr * file)
{
 os_error     * err;
 int            text;
 textboxstr   * textp;
 textflowstr    textflow;
 textflowstr    oldflow;

 err=undoread(file,&text,sizeof(int));

 textp=(textboxstr*)fob_find(text,file);

 if(textp)
 {
  oldflow=textp->textflow;

           err=undowritefn(file,UTFLOW,&text,sizeof(int));
  if(!err) err=undowrite(file,&oldflow,sizeof(textflowstr));
  if(!err) err=undoread(file,&textflow,sizeof(textflowstr));
  if(!err) err=setflow(file,text,&textflow,&oldflow);
 }
 return(err);
}


static os_error * textflowvalues(textboxstr * textp,filestr * file,
                                             objectflowstr * flow,int read)
{
 os_error    * err;
 int           text;
 textflowstr   oldflow;

 if(read)
 {
  flow->flow=textp->textflow;
  flow->tr=textp->transform;
  err=NULL;
 }
 else
 {
  text=textp->key;
  oldflow=textp->textflow;

           err=undowritefn(file,UTFLOW,&text,sizeof(int));
  if(!err) err=undowrite(file,&oldflow,sizeof(textflowstr));
  if(!err) err=setflow(file,text,&flow->flow,&oldflow);
 }

 return(err);
}





static os_error * textembeded(textboxstr * textp,sobjectstr * fix,
                                  filestr * file,int * hit)
{
 os_error    * err;
 int           object;
 int           lines;
 int           bytes;
 vlstr       * vline;
 int           maxoffset;
 vector        v;
 char        * p;
 int           c;
 int           bits;
 int           len;
 flowstr       flop;
 int           header;
 int           footer;
 int           u;


 err=NULL;

 *hit=0;

 header=textp->data.header;
 footer=textp->data.footer;

 for(u=0;u<3;u++)
 {
  if((u==0) || (u==1 && header) || (u==2 && footer))
  {
   boxcontents(textp,u,&bytes,&lines);
   setvectorfrombox(&v,u,textp->key,file);

   err=txlock(&v.textsrc,file);
   if(!err)
   {
    if(lines && bytes)
    {
     if((v.textsrc.voffset+lines)>v.textsrc.vsourcep->len)
                         lines=v.textsrc.vsourcep->len-v.textsrc.voffset;

     while(lines)
     {
      lines-=sizeof(vlstr);

      vline=vlptr(v.textsrc.vsourcep,v.textsrc.voffset);

      if(!vline->line.xl)
      {
       if(vline->line.object)
       {
        len=vline->line.len;
        maxoffset=v.textsrc.loffset+len;
        v.textsrc.offset=v.textsrc.loffset;

        while(v.textsrc.offset<maxoffset)
        {
         p=txptr(v.textsrc.sourcep,v.textsrc.offset);
         c=*p;
         bits=codex[c];

         if(c==EOB)
         {
          object=(*(p+1))+((*(p+2))<<8)+((*(p+3))<<16)+((*(p+4))<<24);
          if(object==fix->key)
          {
           flop.opcode=FWAIT|FLPREV;
           flop.data.type=FLDIRTY;
           flop.data.offset=v.textsrc.loffset;
           flop.data.length=len;
           flop.data.delta=0;

           flow(&v,&flop);
           *hit=1;
           break;
          }
         }
         v.textsrc.offset+=bits & CODELEN;
        }

        if(*hit) break;
       }
      }
     /* v.textsrc.loffset+=len;
      v.textsrc.voffset+=sizeof(vlstr); */

      nextvline(&v);
     }
    }
    txunlock(&v.textsrc,file);
   }
  }

  if(*hit) break;
 }

 return(err);
}




static os_error * textcheckforreflow(textboxstr * textp,sobjectstr * fix,
                                          filestr * file,int * end)
{
 os_error   * err;
 sobjectstr * childp;
 int          child;


 err=NULL;

 if(fix->key==textp->key)
 {
  *end=1;
 }
 else
 {
  /* if sob fix is embedded in this textframe             */
  /* then quit now, and generate a d reflow for the object */

  if((*end)==2) textembeded(textp,fix,file,end);

  if(!(*end))
  {
   /* handle consequences for this object, then apply to children */

   /* in brief, if this object, cuts the fixed object, add to reflow list */


/*   dprintf(0,"frfladd %d",textp->key); */

   if(boxoverlap(&textp->box,&fix->box))
   {
/*    dprintf(0,"frfladd hit"); */
    err=frfladd((sobjectstr **)&textp,file);
   }


   child=textp->chain.child;
   while(child)
   {
    childp=(sobjectstr*)fob_find(child,file);
    if(childp)
    {
     child=childp->chain.next;
     err=objectsetflow((objhdrstr*)childp,(objhdrstr*)fix,file,end);
     if(err) break;
     if(*end) break;
    }
    else break;
   }
  }
 }
 return(err);
}



/*****************************************************************************/

/* just scrap object and all linked objects */

os_error * textscrap(int object,filestr * file,int flags)
{
 os_error   * err;
 textboxstr * tbox;
 texsrc     * texsp;
 int          i;
 int          header;
 int          footer;
 textboxstr * textp;


/* dprintf(0,"text scrap %d",object); */

 textp=(textboxstr*)fob_find(object,file);
 if(textp)
 {
  frameflowdelete((sobjectstr **)&textp,file);
  vxadd((sobjectstr **)&textp,file);
 }

 err=fob_static((fobjptr)&tbox,object,file);
 if(!err)
 {
  if(flags & DELETEUNLINK) unlinkobject(object,0,file);

           err=deletecurve(&tbox->fcurve,file);
  if(!err) err=deletecurve(&tbox->icurve,file);
  if(!err) err=deletecurve(&tbox->ocurve,file);
  if(!err) err=deleteborder(tbox->frame,file);
  if(!err) err=deletefill(&tbox->data.fill,file);

  header=tbox->data.header;
  footer=tbox->data.footer;
  texsp=(texsrc*)(((char*)tbox)+sizeof(textboxstr));

  for(i=0;i<3;i++)
  {
   if((i==0 && !tbox->data.repeat && !tbox->fchain.prev) ||
                                        (i==1 && header) || (i==2 && footer))
   {
    if(!err) err=txsourcedel(texsp[i].source,file,1);
    if(!err) err=vsourcedel(texsp[i].vsource,file);
   }
  }

  trashvboxes(object,file);

  fob_delete(object,file);

  fob_free((fobjptr)&tbox,file);
 }

 return(err);
}



/* undoable delete */

static os_error * utdeletesub(int object,filestr * file)
{
 os_error   * err;
 textboxstr * textp;
 int          parent;
 int          after;

 err=NULL;

 textp=(textboxstr*)fob_find(object,file);
 if(textp)
 {
  frameflowdelete((sobjectstr **)&textp,file);
  vxadd((sobjectstr **)&textp,file);

  /* flow links, embedded objects, vsource can be recreated anyway !!! */

  parent=textp->chain.parent;
  after=textp->chain.prev;

  unlinkobject(object,0,file);

  undowritefn(file,UTRECREATE,&object,sizeof(int));
  undowrite(file,&parent,sizeof(int));
  undowrite(file,&after,sizeof(int));
 }

 return(err);
}




/* tagged to UTRECREATE */

static os_error * utrecreate(filestr * file)
{
 textboxstr * textp;
 int          object;
 int          parent;
 int          after;

 undoread(file,&object,sizeof(int));
 undoread(file,&parent,sizeof(int));
 undoread(file,&after,sizeof(int));

 insafter(object,after,parent,0,file);

 undowritefn(file,UTDELETE,&object,sizeof(int));

 textp=(textboxstr*)fob_find(object,file);
 frameflow((sobjectstr **)&textp,file);
 vxadd((sobjectstr **)&textp,file);

 return(NULL);
}


/* scrap function for UTRECREATE */

static os_error * uttrash(filestr * file)
{
 int object;
 undoread(file,&object,sizeof(int));
 return(textscrap(object,file,0));
}


/* tagged to UTDELETE */

static os_error *  utdelete(filestr * file)
{
 int object;
 undoread(file,&object,sizeof(int));
 utdeletesub(object,file);
 return(NULL);
}


static os_error * textdelete(textboxstr * textp,int dm,filestr * file)
{
 int text;

 text=textp->key;

 bmtextdel(text,file);

 if(dm & DELETESCRAP) return(textscrap(text,file,dm));
 else                 return(utdeletesub(text,file));
}


/*****************************************************************************/


typedef struct txusrcstr
{
 int source[2];
 int vsource[2];
} txusrcstr;



static os_error * textupdate(int textk,filestr * file,
                                    unpackedtextdatastr * pd,int undo)
{
 os_error   * err;
 textboxstr * textp;
 int          newsize;
 textdatastr  oldpd;
 int          reflow;
 int          source[3];
 int          vsource[3];
 texsub     * texup;
 texsrc     * texsp;
 int          i;
 int          ousize;
 int          nusize;
 int          hsize;
 int          cbits;
 txusrcstr    oldtxusrc;
 txusrcstr    newtxusrc;


 err=NULL;

 textp=(textboxstr*)fob_find(textk,file);
 oldpd=textp->data;

 memset(&oldtxusrc,0,sizeof(txusrcstr));

 if(pd->columns!=(int)oldpd.columns || (pd->header!=(int)oldpd.header) ||
                                  (pd->footer!=(int)oldpd.footer))
 {
  if(oldpd.header || oldpd.footer) ousize=3;
  else                             ousize=1;

  texsp=(texsrc*)(((char*)textp)+sizeof(textboxstr));

  memset(source,0,3*sizeof(int));
  memset(vsource,0,3*sizeof(int));

  for(i=0;i<ousize;i++)
  {
   source[i]=texsp->source;
   vsource[i]=texsp->vsource;
   texsp++;
  }

  trashvboxes(textk,file);

  newsize=sizeof(textboxstr);
  if(pd->header || pd->footer)
  {
   nusize=3;
   hsize=1;
   newsize+=sizeof(texhdr)+3*sizeof(texsrc)+(pd->columns+2)*sizeof(texsub);
  }
  else
  {
   nusize=1;
   hsize=0;
   newsize+=sizeof(texsrc)+pd->columns*sizeof(texsub);
  }

  fob_change(textk,file,newsize,(fobjptr)&textp);

  if(undo)
  {
   undoread(file,&newtxusrc,sizeof(txusrcstr));

// 	 cprintf("uread %d %d %d %d",newtxusrc.source[0],newtxusrc.source[1],newtxusrc.vsource[0],newtxusrc.vsource[1]);

   if(pd->header && !oldpd.header)
   {
    source[1]=newtxusrc.source[0];
    vsource[1]=newtxusrc.vsource[0];
   }

   if(pd->footer && !oldpd.footer)
   {
    source[2]=newtxusrc.source[1];
    vsource[2]=newtxusrc.vsource[1];
   }
  }
  else
  {
   if(pd->header && !oldpd.header) newtextbuffers(source+1,vsource+1,file);
   if(pd->footer && !oldpd.footer) newtextbuffers(source+2,vsource+2,file);
  }


  if(!pd->header && oldpd.header)
  {
   oldtxusrc.source[0]=source[1];
   source[1]=0;
   oldtxusrc.vsource[0]=vsource[1];
   vsource[1]=0;
  }


  if(!pd->footer && oldpd.footer)
  {
   oldtxusrc.source[1]=source[2];
   source[2]=0;
   oldtxusrc.vsource[1]=vsource[2];
   vsource[2]=0;
  }


/*  dprintf(0,"nusize=%d",nusize); */

  fob_mod(textk,file,(fobjptr)&textp);

  texsp=(texsrc*)(((char*)textp)+sizeof(textboxstr));
  for(i=0;i<nusize;i++)
  {
   texsp->source=source[i];
   texsp->vsource=vsource[i];
 /*  dprintf(0,"i=%d s=%d v=%d",i,source[i],vsource[i]); */
   texsp++;
  }

  texup=(texsub*)(((char*)textp)+sizeof(textboxstr)+nusize*sizeof(texsrc)+
                                                    hsize*sizeof(texhdr));

  memset(texup,0,sizeof(texsub)*(pd->columns+(hsize?2:0)));
 }
	else
	{
		if(undo)
		{
   undoread(file,&newtxusrc,sizeof(txusrcstr));
// 	 cprintf("uread %d %d %d %d",newtxusrc.source[0],newtxusrc.source[1],newtxusrc.vsource[0],newtxusrc.vsource[1]);
		}
	}


 undowrite(file,&oldtxusrc,sizeof(txusrcstr));
//	cprintf("uwrite %d %d %d %d",oldtxusrc.source[0],oldtxusrc.source[1],oldtxusrc.vsource[0],oldtxusrc.vsource[1]);

 textp=(textboxstr*)fob_find(textk,file);
 packtextdata(textp,pd);

 reflow=(pd->radius!=oldpd.radius)    || 
        (pd->header!=(int)oldpd.header)    ||
        (pd->footer!=(int)oldpd.footer)    ||
        (pd->inset!=(int)oldpd.i)          ||
        (pd->columns!=(int)oldpd.columns)  ||
        (pd->columndata.width!=oldpd.columndata.width) ||
        (pd->changei!=(int)oldpd.changei)  ||
        (pd->valign!=(int)oldpd.valign);         /* && has eobs */

 cbits=BCDEL;

 if(pd->radius!=oldpd.radius)
 {
  if(!textp->textflow.changeo) cbits|=BCOUTER;
  setcurveradius(&textp->fcurve,pd->radius,&textp->transform);
  frameflow((sobjectstr **)&textp,file);
 }

 if(reflow && !pd->changei) cbits|=BCINNER;

/* dprintf(12,"reflow=%d changei=%d cbits=%d",reflow,pd->changei,cbits); */

 txboundingcurves(&textp,file,cbits);

 if(reflow) 
 {
  frfladdb((sobjectstr **)&textp,file,1);
 }

 vxadd((sobjectstr **)&textp,file);


/*
 texsp=(texsrc*)(((char*)textp)+sizeof(textboxstr));
 for(i=0;i<nusize;i++)
 {
  dprintf(0,"i=%d s=%d v=%d",i,texsp->source,texsp->vsource);
  texsp++;
 }
*/


 return(err);
}



/* tagged to UTUPDATE */

static os_error * unupdatetext(filestr * file)
{
 os_error            * err;
 int                   text;
 textboxstr          * textp;
 unpackedtextdatastr   pd;

 err=undoread(file,&text,sizeof(int));

 textp=(textboxstr*)fob_find(text,file);
 if(textp)
 {
  unpacktextdata(&pd,textp);

           err=undowritefn(file,UTUPDATE,&text,sizeof(int));
  if(!err) err=undowrite(file,&pd,sizeof(unpackedtextdatastr));
  if(!err) err=undoread(file,&pd,sizeof(unpackedtextdatastr));
  if(!err) err=textupdate(text,file,&pd,1);
 }
 return(err);
}



static os_error * unupdatescrap(filestr * file)
{
	os_error            * err;
 unpackedtextdatastr   pd;
 txusrcstr             txusrc;
 int                   i;
	int                   text;

 err=undoread(file,&text,sizeof(int));

 if(!err) err=undoread(file,&pd,sizeof(unpackedtextdatastr));
 if(!err) err=undoread(file,&txusrc,sizeof(txusrcstr));
//	cprintf("uscrap %d %d %d %d",txusrc.source[0],txusrc.source[1],txusrc.vsource[0],txusrc.vsource[1]);

 for(i=0;i<2;i++)
 {
  txsourcedel(txusrc.source[i],file,1);
  vsourcedel(txusrc.vsource[i],file);
 }

 return(err);
}





static int cmpcolumndata(columnstr * c1,columnstr * c2)
{
 return(c1->mode!=c2->mode ||
        c1->guides!=c2->guides ||
        c1->guidewidth!=c2->guidewidth ||
        c1->width!=c2->width ||
        cmpcolourval(&c1->colour,&c2->colour));
}



static void filltextdata(unpackedtextdatastr * od,
                         unpackedtextdatastr * pd,textchangebits * bits)
{
 if(bits->xcolumns)    od->columns=pd->columns;
 if(bits->xheader)     od->header=pd->header;
 if(bits->xinset)      od->inset=pd->inset;
 if(bits->xchangei)    od->changei=pd->changei;
 if(bits->xvalign)     
 {
  od->valign&=~0x3;
  od->valign|=(pd->valign & 0x3);
 }
 if(bits->xfirstline)
 {
  od->valign&=~0xC;
  od->valign|=(pd->valign & 0xC);
 }
 if(bits->xrepeat)     od->repeat=pd->repeat;
 if(bits->xfooter)     od->footer=pd->footer;
 if(bits->xradius)     od->radius=pd->radius;
 if(bits->xcolour)     od->colour=pd->colour;
 if(bits->xcolumndata) od->columndata=pd->columndata;
 if(bits->xfill)       od->fill=pd->fill;
 if(bits->xlock)       od->lock=pd->lock;
 if(bits->xspread)     od->spread=pd->spread;

}



os_error * textchanges(int text,filestr * file,
                              unpackedtextdatastr * pd,textchangebits * bits)
{
 textboxstr  * textp;
 textdatastr * s;
 texhdr      * texhp;
 int           header;
 int           footer;

 textp=(textboxstr*)fob_find(text,file);
 s=&textp->data;

 bits->xcolumns=((int)s->columns!=pd->columns);
 bits->xinset=((int)s->i!=pd->inset);
 bits->xchangei=((int)s->changei!=pd->changei);
 bits->xvalign=((int)s->valign & 0x3)!=(pd->valign & 0x3);
 bits->xfirstline=((int)s->valign & 0xC)!=(pd->valign & 0xC);
 bits->xrepeat=((int)s->repeat!=pd->repeat);
 bits->xradius=(s->radius!=pd->radius);
 bits->xcolour=(cmpcolourval(&s->colour,&pd->colour)!=0);
 bits->xcolumndata=cmpcolumndata(&s->columndata,&pd->columndata);
 bits->xfill=(s->fill.fill!=pd->fill.fill);
 bits->xlock=((int)textp->flags.locked!=pd->lock);
 bits->xspread=((int)textp->flags.spread!=pd->spread);

 header=footer=0;
 if(s->header || s->footer)
 {
  texhp=(texhdr*)(((char*)textp)+sizeof(textboxstr)+3*sizeof(texsrc));
  footer=texhp->footer;
  header=texhp->header;
 }

 bits->xheader=(header!=pd->header);
 bits->xfooter=(footer!=pd->footer);

 return(NULL);
}




os_error * textboxupdate(unpackedtextdatastr * pd,textchangebits * bits,
                                         int text,filestr * file)
{
 os_error            * err;
 textboxstr          * textp;
 unpackedtextdatastr   od;

 textp=(textboxstr*)fob_find(text,file);
 unpacktextdata(&od,textp);

          err=undowritefn(file,UTUPDATE,&text,sizeof(int));
 if(!err) err=undowrite(file,&od,sizeof(unpackedtextdatastr));
              filltextdata(&od,pd,bits);
 if(!err) err=textupdate(text,file,&od,0);
 return(err);
}



static os_error * textsetfill(textboxstr * textp,filestr * file,fillstr * fill)
{
 textp->data.fill=*fill;
 return(vxadd((sobjectstr **)&textp,file));
}




os_error * textchangecolumns(int textk,int columns,filestr * file)
{
 textboxstr          * textp;
 unpackedtextdatastr   pd;

 textp=(textboxstr*)fob_find(textk,file);
 unpacktextdata(&pd,textp);
 pd.columns=columns;

 return(textupdate(textk,file,&pd,0));
}



os_error * textchangebox(int text,boxstr * box,columnstr * cd,
                         int columns,int header,int footer,filestr * file)
{
 os_error            * err;
 textboxstr          * textp;
 unpackedtextdatastr   pd;
 textchangebits        bits;
 boxbitstr             ob;
 boxbitstr             nb;


 pd.columns=columns;
 pd.header=header;
 pd.footer=footer;
 pd.columndata=*cd;

 memset(&bits,0,sizeof(textchangebits));

 bits.xcolumns=1;
 bits.xheader=1;
 bits.xfooter=1;
 bits.xcolumndata=1;

 textboxupdate(&pd,&bits,text,file);

 textp=(textboxstr*)fob_find(text,file);

 getboxbits(&textp->fcurve.box,&textp->transform,&ob);

 nb=ob;
 nb.orgx=box->x;
 nb.orgy=box->y;
 nb.width=box->w;
 nb.height=box->h;

 setboxtrans(&ob,&nb);

 err=transtext(textp,file,boxtrans,0);

 return(err);
}


static os_error * masterobject(textboxstr * textp,filestr * file,int * master,
                                                          objectbitstr * bits)
{
 texhdr     * texhp;

 *master=textp->master;
 memset(bits,0,sizeof(objectbitstr));

 bits->local=textp->flags.local;
 bits->locked=textp->flags.locked;

 bits->nodelete=(textp->fchain.next!=NULL)||(textp->fchain.prev!=NULL)||
                (textp->data.repeat!=0);

 bits->canmakelocal=!bits->nodelete;
 bits->nocopy=bits->nodelete;
 bits->nogroup=bits->nodelete;

 bits->nosectionmove=bits->nodelete;

 bits->nopagemove=(textp->data.repeat!=0);

 if(textp->data.repeat) 
 {
  bits->localdata=(boxcontents(textp,0,NULL,NULL)!=0);
 }
 else
 {
  bits->localdata=!textp->flags.masterdata;
 }

 if(!bits->localdata) 
 {
  if(textp->data.header || textp->data.footer)
  {
   texhp=(texhdr*)(((char*)textp)+sizeof(textboxstr)+3*sizeof(texsrc));
   if(textp->data.header) bits->localdata=!texhp->headerdata;
   if(!bits->localdata)
   {
    if(textp->data.footer) bits->localdata=!texhp->footerdata;
   }
  }
 }

 return(NULL);
 USE(file);
}



/*****************************************************************************/

static int imptext;
static int imptype;
static int impdirectload;
static int imppix;
static int imppath;

static os_error * textloadtype(char * name,int ftype,posnstr * posn,int * method)
{
 os_error * err;
 int        flags;
 filestr  * file;
 vector     v;

 cprintf("text load type %x",ftype);

 file=posn->file;
 impdirectload=0;
 imppix=imppath=0;

 err=NULL;

 if(posn->alt && !posn->ctrl && !posn->shift)
 {
  if(!*method)
  {
   imppath=1;					// file pathname
   *method=1;
  }
  else
  {
   *method=0;
   err=geterror(ETXE7);
  }
 }
 else
 {
  *method=0;
//  flags=impexdata(ftype);
  flags=impexdatatrans(ftype,name);

			cprintf("flags & IMPXLOAD %d flags & IMPXTEXT %d",(flags & IMPXLOAD),(flags & IMPXTEXT));

  if(flags & IMPXLOAD)
  {
   if((flags & IMPXTEXT)) *method=1;
   else
   if((flags & IMPXPICT))
   {
    /* if this is an empty text box and has no links etc etc */

             err=txconvertable(posn->object,posn->section,file);
    if(!err) err=modfile(file,posn->section);
    if(!err)
    {
     imppix=1;
     posn->otype=OPICTBOX;
     err=objectloadtype(name,ftype,posn,method);
    }
    else
    {
     err=posn2vector(posn,&v,NULL);
     if(!err)
     {
      if(v.valid)
      {
       err=txeditable(posn->object,posn->section,v.textsrc.u,file);
       if(!err)
       {
        impdirectload=1;
        *method=1;
       }
      }
     }
    }
   }
  }
 }

 if(!err && (*method)>0) err=modfile(file,posn->section);

 return(err);
}



static os_error * textloadpost(posnstr * posn,int flags)
{
 os_error    * err;
 vector        v;
 filestr     * file;
 int           object;
 int           yshift;
 int           after;
 int           sn;

 cprintf("text load post");

 file=posn->file;

 if(imppath)
 {
  err=NULL;
 }
 else
 if(imppix)
 {
  posn->otype=OPICTBOX;
  err=objectloadpost(posn,flags);
 }
 else
 {
  err=importloadpost(imptype,imptext,file);
  if(!err)
  {
   if(flags & OBDIRECTLOAD) setvectorfrombox(&v,0,posn->object,file);
   else
   if(flags & OBCARETLOAD)
   {
    if(act.valid && act.textsrc.text==posn->object) v=act;
    else         setvectorfrombox(&v,0,posn->object,file);
   }
   else
   {
    err=posn2vector(posn,&v,NULL);
   }

   if(impdirectload) /* direct load of picture */
   {
//				cprintf("pict direct load");
    err=pictdirectload(posn,imptext,&object,&yshift);
    if(!err) err=txembedobject(&v,object,yshift);
   }
   else
   if(imptext)
   {
//    cprintf("text load direct %d caret %d",(flags & OBDIRECTLOAD),(flags & OBCARETLOAD));
    if(v.valid)
    {
     err=modfile(act.file,act.section);
     if(!err)
     {
      err=undostart(file);
      if(!err)
      {
       stylependflush(&sn,&after);
       if(after) sn=0;

       if(act.valid && act.file==file)
       {
//        if((flags & OBCARETLOAD))
        {
         if(txovertype) deleteselectedlo();
         v=act;
        }
       
        clearactive();
       }

       err=txinsrc(&v,imptext,sn);
       stylependflushpost(sn,after);

       undoend(file);
      }
     }
    }
    fob_delete(imptext,file);
   }
  }
 }

 return(err);
}


static os_error * textload(char * name,int ftype,int xvolatile,posnstr * posn)
{
 os_error     * err;
 vector         v;
 filestr      * file;
 char           path[FILENAMELEN];

 if(imppath)
 {
  err=posn2vector(posn,&v,NULL);
  if(!err && v.valid)
  {
   file=posn->file;
   err=undostart(file);
   if(!err)
   {
    makeactive(&v);
    xzstrncpy(path,name,sizeof(path));
    actinstext(path,strlen(path),sizeof(path));
    undoend(file);
   }
  }
 }
 else
 if(imppix)
 {
  posn->otype=OPICTBOX;
  err=objectload(name,ftype,xvolatile,posn);
 }
 else
 {
		cprintf("import load %s",name);

  err=importload(name,ftype,xvolatile,&imptext,posn->file);
  if(!err)
  {
			cprintf("import load OK %x",ftype);
   if(impdirectload)
			{
				picturestr * picturep;

		  picturep=(picturestr*)fob_find(imptext,posn->file);
    ftype=picturep->ftype;
			}

   imptype=ftype;
  }
 }
 return(err);
}


/***************************************************************************/



static os_error * remapstyles(textboxstr * textp,filestr * file)
{
 os_error * err;
 vector     v;
 int        textk;
 int        header;
 int        footer;

 err=NULL;

 header=textp->data.header;
 footer=textp->data.footer;

 textk=textp->key;

 if(!textp->fchain.prev) /* first box in chain */
 {
  setvectorfrombox(&v,0,textk,file);
  err=remapvector(&v);
 }

 if(header)
 {
  setvectorfrombox(&v,1,textk,file);
  err=remapvector(&v);
 }

 if(footer)
 {
  setvectorfrombox(&v,2,textk,file);
  err=remapvector(&v);
 }

 return(err);
}





/* called on a text box in a new page */
/* if on the master page, this box links to a box on the previous master */
/* page, then IF there is a previous master page...                      */




static os_error * relink(textboxstr * textp,linkstr * link,filestr * file)
{
 os_error    * err;
 int           textk;
 pagestr     * pagep;
 int           pchild;
 int           master;
 int           message;
 int           mfnext;
 int           mfprev;
 int           repeat;
 int           mpage;
 int           linkprev;
 int           linkcurr;
 int           linknext;
 int           dprev2;
 texsrc      * texsp;
 int           msource;
 sectionmapstr map;
 int           source;
 int           vsource;
 int           fprev;
 int           fcurr;


 err=NULL;

 textk=textp->key;
 master=textp->master;
 {
   texsp=(texsrc*)(((char*)textp)+sizeof(textboxstr));
   msource=texsp[0].source;
//   cprintf("relink source %x master %x",msource,master);
 
 }
 if(master)
 {
  textp=(textboxstr*)fob_find(master,file);
  if(textp->type==OTEXTBOX)
  {
   mfprev=textp->fchain.prev;
   mfnext=textp->fchain.next;

//   cprintf("mfprev %d mfnext %d",mfprev,mfnext);


   texsp=(texsrc*)(((char*)textp)+sizeof(textboxstr));
   msource=texsp[0].source;
 
   repeat=textp->data.repeat;
   linkprev=linkcurr=linknext=0;

   if(repeat)
   {
    sectionfindmap(msource,&map,link->msection,file);

    if(mfnext)
    {
     textp=(textboxstr*)fob_find(mfnext,file);
     mpage=pageof((chainobject*)textp,file);
     if(mpage!=link->mpage) linknext=1;   /* was ==link->mnext */
    }
    else
    {
     linknext=1;
     if(link->mpage!=link->mnext && link->mnext)  /* double sided */
     {

      /* need to know which page next frame is on */
      fcurr=textk;
      fprev=mfprev;
      while(fprev)
      {
       fcurr=fprev;
       textp=(textboxstr*)fob_find(fcurr,file);
       fprev=textp->fchain.prev;
      }

      mpage=pageof((chainobject*)textp,file);
      if(mpage==link->mpage)
      {
       linknext=2;
      }
     }
    }

    if(mfprev)
    {
     textp=(textboxstr*)fob_find(mfprev,file);
     mpage=pageof((chainobject*)textp,file);
     if(mpage==link->mprev) linkprev=1;
     else                   linkcurr=1;
    }
    else
    if(mfnext)
    {
     while(mfnext)
     {
      textp=(textboxstr*)fob_find(mfnext,file);
      mfnext=textp->fchain.next;
     }
     mfprev=textp->key;
     linkprev=1;
    }
    else
    {
     mfprev=master;
     linkprev=1;
    }

//    cprintf("linkprev %d linkcurr %d",linkprev,linkcurr);

    message=OM_FINDMASTER;
    master=mfprev;

    if(linkprev)
    {
     if(!link->dprev) linkprev=0;
     else
     {
      pagep=(pagestr*)fob_find(link->dprev,file);
      dprev2=pagep->chain.prev;
   
      objectchainmessage(pagep->chain.child,file,&message,&master);
      if(message)
      {
       if(!dprev2) linkprev=0;
       else
       {
        message=OM_FINDMASTER;
        master=mfprev;
        pagep=(pagestr*)fob_find(dprev2,file); 
        objectchainmessage(pagep->chain.child,file,&message,&master);
       }
      }
     }
    }
    else
    if(linkcurr)
    {
     pagep=(pagestr*)fob_find(link->dpage,file);
     objectchainmessage(pagep->chain.child,file,&message,&master);
    }

    /* if the message is ack'd, then master is the previous flow box in the */
    /* document.                                                            */

    if(!message && (linkprev || linkcurr))
    {
     textp=(textboxstr*)fob_find(master,file);
     textp->fchain.next=textk;
     textp=(textboxstr*)fob_find(textk,file);
     textp->fchain.prev=master;

    }
    else
    {
     textp=(textboxstr*)fob_find(textk,file);
     textp->fchain.prev=0;
    }


    if(linknext)
    {
     if(!link->dnext) textp->fchain.next=0;
     else
     if(linknext==2)
     {
      pagep=(pagestr*)fob_find(link->dnext,file);
      if(!pagep->chain.next) textp->fchain.next=0;
     }
    }


    texsp=(texsrc*)(((char*)textp)+sizeof(textboxstr));
    texsp[0].source=map.dsource;
    texsp[0].vsource=map.dvsource;

    cprintf("map dsource %x vsource %x",map.dsource,map.dvsource);
   }
   else
   {
    /* find the frame on this page that has the same master frame */
    /* as the frames this frame links to                          */

    cprintf("not repeat mfprev %x",mfprev);

    if(mfprev)
    {
     master=mfprev;

     message=OM_FINDMASTER;
     pagep=(pagestr*)fob_find(link->dpage,file);
     pchild=pagep->chain.child;

     objectchainmessage(pchild,file,&message,&master);
     if(!message)
     {
//      cprintf("found master");


      fob_mod(master,file,(fobjptr)&textp);
      textp->fchain.next=textk;
      fob_mod(textk,file,(fobjptr)&textp);
      textp->fchain.prev=master;
      if(!mfnext) textp->fchain.next=0;

      while(1)
      {
       textp=(textboxstr*)fob_find(mfprev,file);
       if(!textp->fchain.prev) break;
       mfprev=textp->fchain.prev;
      }

      master=mfprev;
      message=OM_FINDMASTER;
      objectchainmessage(pchild,file,&message,&master);

      if(!message)
      {
//       cprintf("found master2");

       textp=(textboxstr*)fob_find(master,file);

       texsp=(texsrc*)(((char*)textp)+sizeof(textboxstr));
       source=texsp[0].source;
       vsource=texsp[0].vsource;

       fob_mod(textk,file,(fobjptr)&textp);

       texsp=(texsrc*)(((char*)textp)+sizeof(textboxstr));
       texsp[0].source=source;
       texsp[0].vsource=vsource;

//       cprintf("relink no repeat source %x",source);
      }
     }
    }
    else
    {
     fob_mod(textk,file,(fobjptr)&textp);
     textp->fchain.prev=0;
     if(!mfnext) textp->fchain.next=0;
    }
   }
  }
 }

 return(err);
}




/*****************************************************************************/


#define DMAPCHUNK  0x1000
#define DMAPCHUNK2 (sizeof(int)*0x80)

static char * dmap;
static int    dmaplen;
static int    drootp;
static int  * dmap2;
static int    dmapn2;


typedef struct dmapstr
{
 int          parent;
 int          sibls[2];
 int          balance;
 int          link;        /* key in source file */
 int          text;        /* key in dest file   */

} dmapstr;



static int dmcmp1(void * key1,void * key2)
{
 return((int)key1-(*((int*)key2)));
}


static int dmcmp2(void * key1,void * key2)
{
 return((*((int*)key1))-(*((int*)key2)));
}



static int dsearchmap(int link)
{
 int offset;

 offset=avlfind((void*)link,drootp,dmap,dmcmp1);

 if(offset>=0)
 {
  return(((dmapstr*)(dmap+offset))->text);
 }
 else
 {
  return(0);
 }
}



static os_error * daddtomap(int link,int text)
{
 os_error * err;
 dmapstr  * s;

 err=flex_chunk((flex_ptr)&dmap,dmaplen+sizeof(dmapstr),DMAPCHUNK);
 if(!err)
 {
  s=(dmapstr*)(dmap+dmaplen);
  s->link=link;
  s->text=text;
  avlsearch(dmaplen,&drootp,dmap,dmcmp2);
  dmaplen+=sizeof(dmapstr);
 }

 return(err);
}


static os_error * dmapinit(void)
{
 os_error * err;

 err=flex_alloc((flex_ptr)&dmap,DMAPCHUNK);
 if(!err)
 {
  dmaplen=0;
  drootp=-1;
  dmapn2=0;

  err=flex_alloc((flex_ptr)&dmap2,DMAPCHUNK2);
  if(err)
  {
   flex_free((flex_ptr)&dmap);
  }
 }

 return(err);
}



static os_error * dmapfinit(filestr * file)
{
 os_error   * err;
 int          i;
 textboxstr * textp;
 texsrc     * texsp;
 int          text;
 int          source;
 int          vsource;


 for(i=0;i<dmapn2;i++)
 {
  textp=(textboxstr*)fob_find(dmap2[i],file);
  if(textp)
  {
   texsp=(texsrc*)(((char*)textp)+sizeof(textboxstr));

   text=textp->fchain.next;
   source=texsp[0].source;
   vsource=texsp[0].vsource;

   while(text)
   {
    textp=(textboxstr*)fob_find(text,file);
    if(!textp) break;
    texsp=(texsrc*)(((char*)textp)+sizeof(textboxstr));
    texsp[0].source=source;
    texsp[0].vsource=vsource;
    text=textp->fchain.next;
   }
  }
 }

          err=flex_free((flex_ptr)&dmap);
 if(!err) err=flex_free((flex_ptr)&dmap2);

 return(err);
}




static os_error * txdrlink(int eventn,int user,filestr * file,int data)
{
 if(data==0) return(dmapinit());
 else        return(dmapfinit(file));

 USE(eventn);
 USE(user);
}






static os_error * makedlink(textboxstr * textp,filestr * sfile,filestr * file)
{
 os_error   * err;
 textboxstr * stextp;
 textboxstr * dtextp;
 int          text;
 int          link;
 int          dtext;
 int          prev;
 int          next;


 err=NULL;

 if(!textp->data.repeat && !textp->master)
 {
  text=textp->key;
  next=textp->fchain.next;
  prev=textp->fchain.prev;

  if(next || prev)
  {
   if(!prev && next)
   {
    err=flex_chunk((flex_ptr)&dmap2,(dmapn2+1)*sizeof(int),DMAPCHUNK2);
    if(!err)
    {
     dmap2[dmapn2++]=text;
    }
   }

   if(prev)
   {
    stextp=(textboxstr*)fob_find(prev,sfile);
    link=stextp->fchain.next;
   }
   else
   {
    stextp=(textboxstr*)fob_find(next,sfile);
    link=stextp->fchain.prev;
   }

   daddtomap(link,text);

   if(prev)
   {
    dtext=dsearchmap(prev);

    if(dtext)
    {
     dtextp=(textboxstr*)fob_find(dtext,file);

     dtextp->fchain.next=text;
     textp=(textboxstr*)fob_find(text,file);
     textp->fchain.prev=dtext;
    }
   }

   if(next)
   {
    dtext=dsearchmap(next);

    if(dtext)
    {
     dtextp=(textboxstr*)fob_find(dtext,file);

     dtextp->fchain.prev=text;
     textp=(textboxstr*)fob_find(text,file);
     textp->fchain.next=dtext;
    }
   }
  }
 }

 return(err);
}



/*****************************************************************************/



static os_error * relinkom(textboxstr * textp,linkstr * link,filestr * file)
{
 os_error    * err;
 int           textk;
 pagestr     * pagep;
 int           master;
 int           message;
 int           mfnext;
 int           mfprev;
 int           repeat;
 int           mpage;
 int           linkprev;
 int           linkcurr;
 int           linknext;
 int           dnext2;
 int           mmfnext;
 int           source;
 int           vsource;
 texsrc      * texsp;


 err=NULL;

 textk=textp->key;
 master=textp->master;
 master=findoldmaster(master,file,0);


 if(master)
 {
  textp=(textboxstr*)fob_find(master,file);
  if(textp->type==OTEXTBOX)
  {
   mfprev=textp->fchain.prev;
   mfnext=textp->fchain.next;
   repeat=textp->data.repeat;
   linkprev=linkcurr=linknext=0;

   if(repeat)
   {
    if(mfprev)
    {
     textp=(textboxstr*)fob_find(mfprev,file);
     mpage=pageof((chainobject*)textp,file);
     if(mpage==link->mprev) linkprev=1;
    }
    else linkprev=1;

    if(mfnext)
    {
     textp=(textboxstr*)fob_find(mfnext,file);   // was mfprev
     mpage=pageof((chainobject*)textp,file);
     if(mpage==link->mnext) linknext=1;
     else                   linkcurr=1;
    }
    else
    if(mfprev)
    {
     while(mfprev)
     {
      textp=(textboxstr*)fob_find(mfprev,file);
      mfprev=textp->fchain.prev;
     }
     mfnext=textp->key;
     linknext=1;
    }
    else
    {
     mfnext=master;
     linknext=1;
    }

    mmfnext=mfnext;
    if(mfnext)
    {
     textp=(textboxstr*)fob_find(mfnext,file);
     mmfnext=textp->master;
    }

    message=OM_FINDMASTER;
    master=mmfnext;

    if(linknext)
    {
     if(!link->dnext) linknext=0;
     else
     {
      pagep=(pagestr*)fob_find(link->dnext,file);
      dnext2=pagep->chain.next;

      objectchainmessage(pagep->chain.child,file,&message,&master);
      if(message)
      {
       if(!dnext2) linknext=0;
       else
       {
        message=OM_FINDMASTER;
        master=mmfnext;
        pagep=(pagestr*)fob_find(dnext2,file); 
        objectchainmessage(pagep->chain.child,file,&message,&master);
       }
      }
     }
    }
    else
    if(linkcurr)
    {
     pagep=(pagestr*)fob_find(link->dpage,file);
     objectchainmessage(pagep->chain.child,file,&message,&master);
    }

    /* if the message is ack'd, then master is the next flow box in the */
    /* document.                                                            */

    if(!message && (linknext || linkcurr))
    {
     textp=(textboxstr*)fob_find(master,file);
     textp->fchain.prev=textk;
     textp=(textboxstr*)fob_find(textk,file);
     textp->fchain.next=master;
    }
    else
    {
     textp=(textboxstr*)fob_find(textk,file);
     textp->fchain.next=0;
    }
   
    if(linkprev && !link->dprev) textp->fchain.prev=0;



#ifdef NEVER
    dprintf(0,"dpage=%d dprev=%d dnext=%d prev=%d next=%d",
                   link->dpage,link->dprev,link->dnext,
                            textp->fchain.prev,textp->fchain.next);

    {
     textboxstr * xtextp;
     int          next;

     next=textp->fchain.next;

     if(next)
     {
      xtextp=fob_find(next,file);
      dprintf(0,"next=%d prev=%d",next,xtextp->fchain.prev);

     }
     else dprintf(0,"no next");

    }
#endif



   }
   else
   {
    /* find the frame on this page that has the same master frame */
    /* as the frames this frame links to                          */

    if(mfprev)
    {
     textp=(textboxstr*)fob_find(mfprev,file);
     master=textp->master;

     message=OM_FINDMASTER;
     pagep=(pagestr*)fob_find(link->dpage,file);

     objectchainmessage(pagep->chain.child,file,&message,&master);
     if(!message)
     {
      fob_mod(master,file,(fobjptr)&textp);
      textp->fchain.next=textk;
      texsp=(texsrc*)(((char*)textp)+sizeof(textboxstr));
      source=texsp[0].source;
      vsource=texsp[0].vsource;

      fob_mod(textk,file,(fobjptr)&textp);
      textp->fchain.prev=master;
      if(!mfnext) textp->fchain.next=0;
      texsp=(texsrc*)(((char*)textp)+sizeof(textboxstr));
      texsp[0].source=source;
      texsp[0].vsource=vsource;
     }
    }
    else
    {
     fob_mod(textk,file,(fobjptr)&textp);
     textp->fchain.prev=0;
     if(!mfnext) textp->fchain.next=0;
    }
   }
  }
 }

 return(err);
}



/****************************************************************************/

/* this is a frame in the dpage branch */
/* if it is the first frame in a chain */
/* then follow the chain               */
/* for each frame in it set up sources */


static int dbleindexobject(int stext,mlinkstr * link,
                                        filestr * sfile,filestr * dfile)
{
 int hand;
 int spage;
 int textindex;


 for(hand=0;hand<2;hand++)
 {
  spage=link->spage[hand];
  if(spage)
  {
   textindex=objectindex(stext,spage,sfile);
   if(textindex>=0) return(objectfindindex(textindex,link->dpage[hand],dfile));
  }
 }

 return(0);
}


static os_error * mrelink(textboxstr * textp,mlinkstr * link,filestr * dfile)
{
 os_error * err;
 filestr  * sfile;
 int        textindex;
 int        dtext;
 int        nextdtext;
 int        stext;
 int        source;
 int        vsource;
 texsrc   * texsp; 

 err=NULL;

 dtext=textp->key;
 texsp=(texsrc*)(((char*)textp)+sizeof(textboxstr));
 source=texsp[0].source;
 vsource=texsp[0].vsource;


 sfile=link->sfile;

 textindex=objectindex(dtext,link->dpage[link->hand],dfile);
 stext=objectfindindex(textindex,link->spage[link->hand],sfile);

 textp=(textboxstr*)fob_find(stext,sfile);

 if(!textp->fchain.prev)
 {
  while(1)
  {
   textp=(textboxstr*)fob_find(stext,sfile);
   stext=textp->fchain.next;
   if(!stext) break;

   nextdtext=dbleindexobject(stext,link,sfile,dfile);

   if(!nextdtext) break;

   textp=(textboxstr*)fob_find(dtext,dfile);
   textp->fchain.next=nextdtext;

   textp=(textboxstr*)fob_find(nextdtext,dfile);
   textp->fchain.prev=dtext;

   texsp=(texsrc*)(((char*)textp)+sizeof(textboxstr));
   texsp[0].source=source;
   texsp[0].vsource=vsource;

   dtext=nextdtext;
  }
 }

 return(err);
}




/* called on frames on first of pair of master pages  */
/* when double sided->single                          */

static os_error * mbreaklink(textboxstr * textp,linkstr * link,filestr * file)
{
 int        text;
 int        fnext;
 int        page;

 text=textp->key;
 fnext=textp->fchain.next;
 if(fnext && textp->data.repeat)
 {
  page=pageof((chainobject*)(fob_find(fnext,file)),file);
  if(link->mpage!=page)
  {
   textp=(textboxstr*)fob_find(text,file);
   textp->fchain.next=0;
  }
 }

 return(NULL);
}



/* called on frames on second of pair of master pages  */
/* when single sided-> double                          */

static os_error * mremakelink(textboxstr * textp,linkstr * link,filestr *file)
{
 int        text;

 text=textp->key;

 if(textp->fchain.prev && textp->data.repeat)
 {
  textp=(textboxstr*)fob_find(textp->fchain.prev,file);
  textp->fchain.next=text;
 }

 return(NULL);
 USE(link);
}                                        




/*****************************************************************************/


static os_error * ubtrash(filestr * file)
{
 os_error     * err;
 int            object;
 int            border;

          err=undoread(file,&object,sizeof(int));
 if(!err)
 {
  err=undoread(file,&border,sizeof(int));
  if(!err)
  {
   deleteborder(border,file);
  }
 }
 return(err);
}


#ifdef NEVER

/* boxbitstr    ob;
 boxbitstr    nb; */

/* getboxbits(&textp->fcurve.box,&textp->transform,&ob); */

/* nb=ob; */

/*
  nb.width+=2*(newwidth-oldwidth);
  nb.height+=2*(newwidth-oldwidth);

  if(!bits)
  {
   setboxtrans(&ob,&nb);
   err=transtext(textp,file,boxtrans,bits);
  }
 */



#endif


static os_error * changeborder(int newborder,int text,filestr * file,int bits)
{
 os_error   * err;
 int          oldborder;
 int          oldwidth[4];
 int          newwidth[4];
 textboxstr * textp;


 err=NULL;

 textp=(textboxstr*)fob_find(text,file);

 oldborder=textp->frame;

 getbordersize(oldborder,file,oldwidth,&textp->fcurve);
 getbordersize(newborder,file,newwidth,&textp->fcurve);

 fob_mod(text,file,(fobjptr)&textp);
 textp->frame=newborder;
 vxadd((sobjectstr **)&textp,file);

 if(bordercmp(newwidth,oldwidth))
 {
  frameflow((sobjectstr **)&textp,file);

  if(!textp->textflow.changeo) txboundingcurves(&textp,file,BCDEL|BCOUTER);

  getframemaxbox((sobjectstr **)&textp,textp->frame,file,&textp->transform);

  frameflow((sobjectstr **)&textp,file);
  vxadd((sobjectstr **)&textp,file);

  changesize((chainobject*)textp,file);
 }

 undowritefn(file,UTBORDER,&text,sizeof(int));
 undowrite(file,&oldborder,sizeof(int));

 return(err);

 USE(bits);
}



static os_error * unborder(filestr * file)
{
 os_error     * err;
 int            object;
 int            newborder;

 err=undoread(file,&object,sizeof(int));
 if(!err)
 {
  err=undoread(file,&newborder,sizeof(int));
  if(!err)
  {
   err=changeborder(newborder,object,file,1);
  }
 }

 return(err);
}




/* add frame                    */
/* get old width                */
/* stash old frame              */
/* create new frame             */
/* get new width                */
/* sort out changing frame size */
/* add refresh+redraw           */

static os_error * textnewborder(textboxstr * textp,filestr * file,
                                int * message,modifyborderdatastr * borderp)
{
 os_error * err;
 int        newborder;
 int        text;

 err=NULL;

 text=textp->key;

 if(!textp->master || textp->flags.local)
 {
  createborder(borderp,file,&newborder,textp->frame);
  changeborder(newborder,text,file,0);
 }

 return(err);

 USE(message);
}



static os_error * textbordertype(textboxstr * textp,filestr * file,
                                 int * message,int * border)
{
 *border=textp->frame;
 *message=0;

 return(NULL);

 USE(file);
}


/****************************************************************************/

static os_error * texteditpath(textboxstr * textp,filestr * file,
                                                   int * message,epstr * ep)
{
 os_error      * err;

 err=NULL;

 ep->curve[EP_INNER]=textp->icurve;
 ep->curve[EP_FRAME]=textp->fcurve;
 ep->curve[EP_OUTER]=textp->ocurve;

 if(editpathcanedit(ep->curve))
 {
  *message=0;

  ep->tr[EP_INNER]=textp->transform;
  ep->tr[EP_FRAME]=textp->transform;
  ep->tr[EP_OUTER]=textp->transform;

  ep->colour.cv=textp->data.colour;
  ep->coltype=EPC_CVG;

  textp->flags.invisible=ep->invisible;

  if(ep->invisible) vxadd((sobjectstr **)&textp,file);
 }

 return(err);
}



static os_error * textchangepath(textboxstr * textp,filestr * file,
                                                   int * message,epstr * ep)
{
 os_error * err;
 int        outer;
 int        inner;
 int        flags;
 int        changei;
 int        changef;
 int        changeo;

 err=NULL;

 *message=0;

 changei=inner=ep->change[EP_INNER] & 0x1;
 changef=ep->change[EP_FRAME] & 0x1;
 changeo=outer=ep->change[EP_OUTER] & 0x1;

 textp->data.changei|=inner;
 textp->textflow.changeo|=outer;

 flags=BCDEL;

 if(changef)
 {
  if(!textp->data.changei) 
  {
   flags|=BCINNER;
   inner=1;
  }

  if(!textp->textflow.changeo)
  {
   flags|=BCOUTER;
   outer=1;
  }
 }

 if(changeo) textp->ocurve=ep->curve[EP_OUTER];

 if(changef) 
 {
  textp->fcurve=ep->curve[EP_FRAME];
  settexttransform(textp);
 }

 if(changei) textp->icurve=ep->curve[EP_INNER];

 /* refresh twice, depending on if box is getting bigger or smaller */

 if(!ep->invisible) vxadd((sobjectstr **)&textp,file);
 if(outer)          frameflow((sobjectstr **)&textp,file);

 txboundingcurves(&textp,file,flags);
 if(flags & BCOUTER) ep->curve[EP_OUTER]=textp->ocurve;
 if(flags & BCINNER) ep->curve[EP_INNER]=textp->icurve;

 getframemaxbox((sobjectstr **)&textp,textp->frame,file,&textp->transform);

 textp->flags.invisible=ep->invisible;

 if(!ep->invisible) vxadd((sobjectstr **)&textp,file);
 if(outer)          frameflow((sobjectstr **)&textp,file);
 if(inner)          
 {
  frfladdb((sobjectstr **)&textp,file,1);
 }

 if(ep->quit) changesize((chainobject*)textp,file);

 return(err);
}



/****************************************************************************/


static void textsnapbox(textboxstr * textp,snapfn snapbox)
{
 transformbitstr bits;
 int             i;
 int             header;
 int             footer;
 columnstr       columndata;
 boxstr          box;
 int             gwidth;
 int             cwidth;
 int             columns;
 texhdr        * texhp;


 header=textp->data.header;
 footer=textp->data.footer;
 columns=textp->data.columns;


 if(!header && !footer && columns<2)
 {
  snapbox(textp->key,&textp->transform,&textp->fcurve.box);
 }
 else
 {
  tr_getbits(&textp->transform,&bits);

  columndata=textp->data.columndata;

  columndata.width=scale(columndata.width,0x10000,bits.xscale);
  columndata.guidewidth=scale(columndata.guidewidth,0x10000,bits.xscale);

  if(header || footer)
  {
   texhp=(texhdr*)(((char*)textp)+sizeof(textboxstr)+3*sizeof(texsrc));
   header=scale(texhp->header,0x10000,bits.yscale);
   footer=scale(texhp->footer,0x10000,bits.yscale);

   if(header)
   {
    box=textp->fcurve.box;
    box.h=header;
    snapbox(textp->key,&textp->transform,&box);
   }

   if(footer)
   {
    box=textp->fcurve.box;
    box.y=box.y+box.h-footer;
    box.h=footer;
    snapbox(textp->key,&textp->transform,&box);
   }
  }

  box=textp->fcurve.box;
  box.y+=header;
  box.h-=header+footer;

  gwidth=guttersize(&columndata,columns,box.w);
  cwidth=(box.w-(columns-1)*gwidth)/columns;

  box.w=cwidth;

  for(i=0;i<columns;i++)
  {
   snapbox(textp->key,&textp->transform,&box);
   box.x+=(gwidth+cwidth);

   if(i==(columns-1))
   {
    box.w=textp->fcurve.box.w+textp->fcurve.box.x-box.x;
   }
  }
 }
}




/*****************************************************************************/


// all this is scanning for embedded pictures with fonts in
// it is not caching fonts used in text
// that is done by the cruder way of caching all fonts in document
// using code in c.fox (cachefonts)


#define SMAPCHUNK 0x100


static void * shandle;


static os_error * txprcache0(int eventn,int user,viewstr * view,void * data)
{
	cprintf("xset init");
 return(xsetinit(&shandle,SMAPCHUNK));
 USE(eventn);
 USE(user);
 USE(view);
 USE(data);
}



static os_error * txprcache1(int eventn,int user,viewstr * view,void * data)
{
	cprintf("xset finit");
 return(xsetfinit(&shandle));
 USE(eventn);
 USE(user);
 USE(view);
 USE(data);
}






static os_error * textembededmessage(int text,filestr * file,
                                                  int * message,void * data)
{
 os_error      * err;


 vlstr           vline;
	vlstr           xline;
 textsrcstr      texs;
 textboxstr    * textp;

 char          * p;
 int             c;
 int             bits;
 int             mess;
 int             extent;
 int             object;
 int             source;
 texsrc        * texsp;
 int             u;
 int             header;
 int             footer;
	vector          v;
 bulletdatastr   bulletdata;
 bulletdatastr * bdata;
	int             offset;
	int             scanchain;

 err=NULL;


 if((mess=*message)!=0)
 {
  if(mess==OM_PRCACHE)
  {
			cprintf("OM_PRCACHE");

   for(u=0;u<3;u++)
   {
    textp=(textboxstr*)fob_find(text,file);
    header=textp->data.header;
    footer=textp->data.footer;

    if(u==0 || (u==1 && header) || (u==2 && footer))
    {
     if((u==0 && textp->data.repeat) || u>0)
     {
      /* we make life easy for repeating chains, otherwise */
      /* e.g. 80 pages of 24 labels, things get too slow   */
      /* PRCACHE may not go to the first box in a chain    */
      /* so need to use map to count when chains hit       */

      texsp=(texsrc*)(((char*)textp)+sizeof(textboxstr));
      source=texsp[u].source;

      if(u==0 && textp->data.repeat)											// added u==0	9/1/2006
      {
							cprintf("xset check %d %d result %d",source,shandle,xsetsearch(source,shandle));
       if(xsetsearch(source,shandle)==0) continue; /* !!! */
							cprintf("xset add");
       xsetadd(source,&shandle);
      }

						vsetupfirstbox(&v,text,u,file);
						scanchain=(u==0);
     }
     else
     {
						scanchain=0;
						setvectorfrombox(&v,u,text,file);
     }

// have to scan all vlines in correct context, page numbers etc., fxexpand(), then cache

					err=txlock(&v.textsrc,v.file);
					if(!err)
					{
 					if(v.textsrc.voffset<v.textsrc.vsourcep->len)
						{
       while(1)
 				 	{
 				 		bdata=NULL;

        getvline(&vline,v.textsrc.vsourcep,v.textsrc.voffset);

        if((v.textsrc.voffset+(int)sizeof(vlstr))<v.textsrc.vsourcep->len)
        {
         getvline(&xline,v.textsrc.vsourcep,v.textsrc.voffset+sizeof(vlstr));

         if(xline.line.xl && xline.ext.type==VLBULLET)
         {
          expandbulletdata(&xline,&bulletdata);
          bdata=&bulletdata;
         }
        }

			  		 err=fxexpand(&v,(vline.line.eol==ISDROP?FXDROP:0)|FXNBSP|(bdata?FXBULLET:0)|FXLEADERF,
                                                                   vline.line.len,bdata);

			 				if(!err)
			 				{
			 					ps_cacheline(fbuff,fxuni,ffont);

 		 					if(vline.line.object)
 		 					{
          offset=v.textsrc.loffset;
          while(offset<(int)(v.textsrc.loffset+vline.line.len))
          {
           c=*(p=txptr(v.textsrc.sourcep,offset));

           if(c==EOB)
           {
            object=(*(p+1))+((*(p+2))<<8)+((*(p+3))<<16)+((*(p+4))<<24);
            err=objectmessage2(object,file,message,data);
            if(err || !(*message)) break;
           }
 
           offset+=codex[c] & CODELEN;
          }
		 	 				}
				 			}
				 
        if(err || !(*message)) break;
        if(!nextvlinev(&v,0)) break;
	 						if(!scanchain && v.textsrc.text!=text) break;
	 		 		}
						}
				 	txunlock(&v.textsrc,v.file);
					}
    }
   }
  }
  else
  if(mess==OM_FUNCTION2 || mess==OM_REFLOW2 || mess==OM_COMPATABILITY || 1)
  {
   /* for these we pass the message to all embeded objects */
   /* not just those visible */

   texs.text=text;
   texs.u=0;

   for(u=0;u<3;u++)																							// added for OM_COMPAT...
   {
    textp=(textboxstr*)fob_find(text,file);
    header=textp->data.header;
    footer=textp->data.footer;

    if((u==0 && !textp->fchain.prev) || (u==1 && header) || (u==2 && footer))
    {
     texs.u=u;

     texs.voffset=texs.offset=0;

     err=txlock(&texs,file);
     if(!err)
     {
      extent=texs.sourcep->len;

      while(texs.offset<extent)
      {
       p=txptr(texs.sourcep,texs.offset);
       c=*p;
       bits=codex[c];

       if(c==EOB)
       {
        object=(*(p+1))+((*(p+2))<<8)+((*(p+3))<<16)+((*(p+4))<<24);
        err=objectmessage2(object,file,message,data);
        if(err || !(*message)) break;
       }
   
       texs.offset+=bits & CODELEN;
      }
      txunlock(&texs,file);
					}
    }
   }
  }
 }

 return(err);
}






static os_error * textmessage(textboxstr * textp,filestr * file,
                                                  int * message,void * data)
{
 os_error * err;
 int        child;
 omessagefn fn;
 snapfn     snapbox;
 int        notembeded;
 int        text;


 err=NULL;
 notembeded=0;
 child=textp->chain.child;
 text=textp->key;

 switch(*message)
 {

  case  OM_EDITCHANGE:
                      return(textchangepath(textp,file,message,(epstr*)data));
                      break;

  case    OM_EDITPATH:
                      return(texteditpath(textp,file,message,(epstr*)data));
                      break;


  case OM_REMAPSTYLES:
                      remapstyles(textp,file);
                      break;


  case    OM_FUNCTION:
                      fn=((omessagefn)data);
                      return(fn((objhdrstr*)textp,file,message));
                      break;

  case   OM_FUNCTION2:
                      fn=((omessagefn)data);
                      err=fn((objhdrstr*)textp,file,message);
                      break;


  case  OM_FINDMASTER:
                      if((*((int*)data))==textp->master)
                      {
                       *((int*)data)=textp->key;
                       *message=0;
                      }
                      notembeded=1;  // added 18/9/2005 problem is that relinking sends this message but some frames may not have had sources set up, leads to crash
                      break;

  case      OM_RELINK:
                      relink(textp,(linkstr*)data,file);
                      notembeded=1;
                      break;

  case    OM_RELINKOM:
                      relinkom(textp,(linkstr*)data,file);
                      notembeded=1;
                      break;

  case     OM_MRELINK:
                      mrelink(textp,(mlinkstr*)data,file);
                      notembeded=1;
                      break;

  case  OM_MBREAKLINK:
                      mbreaklink(textp,(linkstr*)data,file);
                      notembeded=1;
                      break;

  case OM_MREMAKELINK:
                      mremakelink(textp,(linkstr*)data,file);
                      notembeded=1;
                      break;

  case       OM_DLINK:
                      makedlink(textp,(filestr*)data,file);
                      notembeded=1;
                      break;



  case      OM_REFLOW:
                      notembeded=1;
  case     OM_REFLOW2:
                      textreflowmessage(textp,file,(int)data);
                      break;


  case   OM_NEWBORDER:
                      return(textnewborder(textp,file,message,
                                                (modifyborderdatastr*)data));
                      break;

  case  OM_BORDERTYPE:
                      return(textbordertype(textp,file,message,(int*)data));
                      break;

   case     OM_DSNAME:
   case     OM_DSSECT:
   case     OM_DSSAVE:
                      return(txdsmessage(textp,message,file,(buffer*)data));
                      break;

   case      OM_DSLOC:
                      return(txdsloc(textp,message,file,data));
                      break;

   case   OM_DELEMBED:
                      return(txdelembed(textp,file,(int)data));
                      break;

/* case    OM_PICTBOX:
                      return(makepictframe(textp,message,file,data));
                      break; */

 case OM_PAGENOREFLOW:
                      /* dprintf(0,"pagenoreflow %d",text); */
                      pagereflowmessage(textp,(int)data,file);
                      break;

 case      OM_SNAPBOX:
                      snapbox=((snapfn)data);
                      textsnapbox(textp,snapbox);
                      return(NULL);
                      break;

  case       OM_PLINK:
                      notembeded=1;
                      lxplink(textp,message,(plinkdatastr*)data,file);
                      break;


   case    OM_SETFILL:
                      notembeded=1;
                      textsetfill(textp,file,(fillstr*)data);
                      break;

   case    OM_GETFILL:
                      *((fillstr*)data)=textp->data.fill;
                      *message=0;
                      break;

   case OM_GETCOLOUR:
                     if(*((int*)data)==SELECTION_FILLCOLOUR)
                     {
                      *message=0;
                      *((colourvalue*)data)=textp->data.colour;
                     }
                     else 
                     {
                      bordergetcolour(textp->frame,message,data,file);
                     }
                     break;

   case OM_SETCOLOUR:
                     if(*((int*)data)==SELECTION_FILLCOLOUR)
                     {
                      textp->data.colour=*((colourvalue*)(((int*)data)+1));
                      vxadd((sobjectstr **)&textp,file);
                     }
                     else 
                     {
                      vxadd((sobjectstr **)&textp,file);
                      bordersetcolour(textp->frame,data,file);
                     }
                     break;



			case	OM_COMPATABILITY:
																					err=txcompatability(file,text,(filestr*)data,message);
																					break;

 }


 if(*message)
 {
  if(!err && !notembeded)
  {
   err=textembededmessage(text,file,message,data);
  }

  if(!err) err=objectchainmessage(child,file,message,data);
 }

 return(err);
}




static os_error * text(textboxstr * textp,filestr * file,
                                             viewstr* view,objectdbstr * cont)
{
 switch(cont->type)
 {
  case  ODB_OBJECTNAMEPLURAL:
                             tsprintf(ODBCONLEN,cont->name,"{TX00}"); 
                                               /* text frames */
                             break;

  case ODB_OBJECTNAMEPLURALC:
                             tsprintf(ODBCONLEN,cont->name,"{TX01}");
                                               /* Text frames */
                             break;
                                                                                        case ODB_OBJECTNAME:
                            tsprintf(ODBCONLEN,cont->name,"{TX02}");
                                               /* Text frame */
                            break;

            case ODB_MODIFY:
                            opentextbox(textp,file,view);
                            break;
 }

 USE(textp);

 return(NULL);
}




/*****************************************************************************/


/* tagged to UTSHAPE */

static os_error * ustrash(filestr * file)
{
 os_error     * err;
 int            object;
 curvestr       fcurve;

          err=undoread(file,&object,sizeof(int));
 if(!err) err=undoread(file,&fcurve,sizeof(curvestr));

 err=deletecurve(&fcurve,file);

 return(err);
}


static os_error * unshape(filestr * file)
{
 os_error     * err;
 int            object;
 textboxstr   * textp;
 curvestr       fcurve;
 curvestr       ocurve;

          err=undoread(file,&object,sizeof(int));
 if(!err) err=undoread(file,&fcurve,sizeof(curvestr));


 textp=(textboxstr*)fob_find(object,file);
 if(textp)
 {
  fob_mod(object,file,(fobjptr)&textp);

  vxadd((sobjectstr **)&textp,file);
  frameflow((sobjectstr **)&textp,file);
  frfladdb((sobjectstr **)&textp,file,1);

  ocurve=textp->fcurve;
  textp->fcurve=fcurve;

  setcurveradius(&textp->fcurve,textp->data.radius,&textp->transform);
  txboundingcurves(&textp,file,BCINNER|BCOUTER|BCDEL);
  getframemaxbox((sobjectstr **)&textp,textp->frame,file,&textp->transform);

  vxadd((sobjectstr **)&textp,file);
  frameflow((sobjectstr **)&textp,file);

  deletecurve(&ocurve,file);
 }

 return(err);
}





static os_error * shapeobject(textboxstr * textp,int shape,
                                              int data,filestr * file)
{
 int      object;
 curvestr fcurve;

 object=textp->key;
 fcurve=textp->fcurve;

 vxadd((sobjectstr **)&textp,file);
 frameflow((sobjectstr **)&textp,file);
 frfladdb((sobjectstr **)&textp,file,1);

 undowritefn(file,UTSHAPE,&object,sizeof(int));
 undowrite(file,&fcurve,sizeof(curvestr));

 makecurve(&fcurve,shape,data,file);

 fob_mod(object,file,(fobjptr)&textp);
 textp->fcurve=fcurve;

 setcurveradius(&textp->fcurve,textp->data.radius,&textp->transform);
 txboundingcurves(&textp,file,BCINNER|BCOUTER|BCDEL);
 getframemaxbox((sobjectstr **)&textp,textp->frame,file,&textp->transform);

 vxadd((sobjectstr **)&textp,file);
 frameflow((sobjectstr **)&textp,file);

 return(NULL);
}



static os_error * oreaddata(int action,textboxstr * textp,
                                             filestr * file,void * data)

{

 switch(action)
 {

  case SELECTINFO:
                  ((outlineinfostr*)data)->fcurve=textp->fcurve;
                  ((outlineinfostr*)data)->tr=textp->transform;
                  ((outlineinfostr*)data)->frame=textp->frame;
                  break;

  case  OREADFILL:
                  *((colourvalue*)data)=textp->data.colour;
                  break;

 }

 return(NULL);
 USE(file);
}



/****************************************************************************/



static objectstr textobject=
{
 OTEXTBOX,                            /* type */
 NULL,                                /* new  */
 (objectcopyfn)textcopy,              /* copy */
 (objectredrawfn)redrawtext,          /* redraw */
 (objectcreatefn)createtext,          /* create */
 (objectfindfn)findtext,              /* find   */
 (objectselectfn)selecttext,          /* select */
 (objecttransformfn)transtext,        /* transform */
 (objectloadtypefn)textloadtype,      /* load type */
 (objectloadfn)textload,              /* load */
 (objectloadpostfn)textloadpost,      /* load post */
 (objectmessagefn)textmessage,        /* message */
 (objectdbfn)text,                    /* object db's */
 (objectflowfn)textflowvalues,        /* access text flow info */
 (objectdeletefn)textdelete,          /* delete */
 (objectreflowfn)textdoreflow,        /* text reflow */
 (objectsetflowfn)textcheckforreflow, /* need to reflow? */
 (objectmasterfn)masterobject,        /* master object?  */
 (objectlocalfn)textlocalobject,      /* local object    */
 (objectshapefn)shapeobject,          /* change shape    */
 (objectreadfn)oreaddata,             /* read data */
 NULL,                                /* x12 */

};


#define UNDOS 8


static undofnstr undos[UNDOS]=
{
 untranstext,   NULL,             UTTRAN,     "{UTRANS}",
 untextsetflow, NULL,             UTFLOW,     "{UFLOW}",
 unupdatetext,  unupdatescrap,    UTUPDATE,   "{UMODIFY}",
 utrecreate,    uttrash,          UTRECREATE, NULL,
 utdelete,      NULL,             UTDELETE,   NULL,
 unshape,       ustrash,          UTSHAPE,    NULL,
 unborder,      ubtrash,          UTBORDER,   NULL,
 untextmove,    NULL,             UTMOVE,     NULL,
};



static os_error * newtextinfo(filestr * file,int user,filestr * sfile)
{
 os_error * err;

          err=newfmap(file);     /* before styles */
 if(!err) err=newstylemap(file,user);
 if(!err)
 {
  if(sfile) err=copydcmap(sfile,file);
  else      err=newdcmap(file);
 }
 if(!err) err=newindex(file);

 return(err);
}




static os_error * copytextinfo(filestr * sfile,filestr * dfile)
{
 os_error      * err;


          err=newfmap(dfile);                      /* before styles */
 if(!err) err=newstylemap(dfile,0);
 if(!err) err=copyuserstyles(sfile,dfile);
 if(!err) err=copydcmap(sfile,dfile);
 if(!err) err=copyindex(sfile,dfile);

 return(err);
}






/* NB s==source d==dest. */

static os_error * txmkstyle(int eventn,int user,filestr * dfile,
                                                    filestr * sfile)
{
 os_error      * err;

 err=copytextinfo(sfile,dfile);

 return(err);

 USE(eventn);
 USE(user);
}





static os_error * txnewevent(int eventn,int user,filestr * file,
                                                 filestr * deffile)
{
 if(deffile) return(copytextinfo(deffile,file));
 else        return(newtextinfo(file,1,NULL));

 USE(eventn);
 USE(user);
}




static os_error * txbareevent(int eventn,int user,filestr * file,
                                                             void * data)
{
 return(newtextinfo(file,1,deffile));
 USE(eventn);
 USE(data);
 USE(user);
}



static os_error * txdocinit2(int eventn,int user,filestr * file,
                                                            void * data)
{
 int          text;
 textboxstr * textp;

 if((text=xprototype(OTEXTBOX))!=0)
 {
  textp=(textboxstr*)fob_find(text,deffile);

  deflttextflow=textp->textflow;
  deflttextflow.changeo=0;

  unpacktextdata(&deflttextdata,textp);
  deflttextdata.fill.fill=FILLSTR;
  deflttextdata.changei=0;
  deflttextdata.repeat=0;

 }

 return(remevent(EVENT_DOCINIT2,(eventfn)txdocinit2,0));

 USE(eventn);
 USE(data);
 USE(user);
 USE(file);
}





os_error * textinit(void)
{
 os_error * err;

 cprintf("**************text init");

 codeinit();

          err=fontinit();
 if(!err) err=undoaddblock(undos,UNDOS);
 if(!err) err=objectregister(&textobject);
 if(!err) err=texttoolinit();
 if(!err) err=flowinit();
 if(!err) err=spellinit();
 if(!err) err=inithp();
 if(!err) err=linkinit();
 if(!err) err=styleinit();
 if(!err) err=txmxinit();
 if(!err) err=txchoicesinit();
 if(!err) err=txdsinit();
 if(!err) err=dbstyleinit();
 if(!err) err=fullinit();
 if(!err) err=addevent(EVENT_MKSTYLE1,(eventfn)txmkstyle,0);
 if(!err) err=addevent(EVENT_NEWDOC1,(eventfn)txnewevent,0);
 if(!err) err=addevent(EVENT_BAREDOC1,(eventfn)txbareevent,0);
 if(!err) err=addevent(EVENT_DOCINIT2,(eventfn)txdocinit2,0);
 if(!err) err=addevent(EVENT_PRCACHE0,(eventfn)txprcache0,0);
 if(!err) err=addevent(EVENT_PRCACHE1,(eventfn)txprcache1,0);
 if(!err) err=addevent(EVENT_DRELINK,(eventfn)txdrlink,0);
 if(!err) err=addevent(EVENT_TESTCOMPATABILITY,(eventfn)txcompat,0);

 return(err);
}
