/*->c.Drawrebind */



#include "stdafx.h"

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <math.h>

#include "os.h"
#include "bbc.h"
#include "sprite.h"
#include "font.h"
#include "wimp.h"

#include "transform.h"
#include "xprocess.h"
#include "xmath.h"



#define DRAWFILE_INTERNAL
#include "DrawFile1.h"
#include "DrawLevel0.h"
#include "DrawLevel1.h"
#include "DrawFile2.h"
#include "DrawErrors.h"

#include "Drawrebind.h"


static void bind_objects(draw_objptr hdrptr,
                                          draw_objptr limit,Draw_bboxtyp *box)
{
 int first;

 first=1;

 for(;hdrptr.bytep<limit.bytep;hdrptr.bytep+=hdrptr.objhdrp->size)
 { 
  if(hdrptr.objhdrp->tag==draw_OBJGROUP)
  {
   draw_objptr  objptr;
   draw_objptr  objlim;
   Draw_bboxtyp obox;

   objptr.bytep=hdrptr.bytep+sizeof(draw_groustr);
   objlim.bytep=hdrptr.bytep+hdrptr.objhdrp->size;

   bind_objects(objptr,objlim,&obox);

   hdrptr.objhdrp->bbox=obox;
  }

  if(hdrptr.objhdrp->tag!=draw_OBJFONTLIST)
  {
   if(first)
   {
    *box=hdrptr.objhdrp->bbox;
    first=0;
   }
   else dr_unifyBoxes(box,&hdrptr.objhdrp->bbox);
  }
 }
}




void Draw_rebind_fulldiag(Draw_diag * diag)
{
 draw_objptr    hdrptr;
 draw_objptr    fileHeader;
 Draw_bboxtyp * box;
 draw_objptr    limit;

 fileHeader.bytep=diag->data;
 box=&fileHeader.filehdrp->bbox;

 box->x0=box->y0=0;
 box->x1=box->y1=0;

 limit.bytep=diag->data+diag->length;
 hdrptr.bytep=diag->data+sizeof(draw_fileheader);

 bind_objects(hdrptr,limit,box);
}



void Draw_rebind_check(Draw_diag * diag)
{
 draw_objptr    fileHeader;

 fileHeader.bytep=diag->data;

 if(!memcmp(fileHeader.filehdrp->progident,"ArtWorks    ",12)) 
                                           Draw_rebind_fulldiag(diag);
}



/*
 Function    : Draw_rebind_diag
 Purpose     : rebind the diagram header
 Parameters  : diagram structure
 Returns     : void
*/

void Draw_rebind_diag(Draw_diag  * diag)
{
 draw_objptr    hdrptr;
 draw_objptr    fileHeader;
 Draw_bboxtyp * box;
 char         * limit;

 fileHeader.bytep=diag->data;
 box=&fileHeader.filehdrp->bbox;

 box->x0=box->y0=0;
 box->x1=box->y1=0;

 limit=diag->data+diag->length;

  /* Get first box */

 for(hdrptr.bytep=diag->data+sizeof(draw_fileheader);
         hdrptr.bytep<limit;hdrptr.bytep += hdrptr.objhdrp->size)
 {
  if(hdrptr.objhdrp->tag!=draw_OBJFONTLIST)
  {
   *box=hdrptr.objhdrp->bbox;
   break;
  }
 }

  /* Unify other boxes with current one */
 for(hdrptr.bytep+=hdrptr.objhdrp->size;
       hdrptr.bytep<limit;hdrptr.bytep+=hdrptr.objhdrp->size)
 {
  if(hdrptr.objhdrp->tag!=draw_OBJFONTLIST)
                 dr_unifyBoxes(box, &hdrptr.objhdrp->bbox);
 }
}




/*
 Function    : Draw_queryBox
 Purpose     : find the bounding box of the diagram
 Parameters  : diagram structure
               pointer to box structure
               flag: screen units wanted?
 Returns     : void
 Description : Find the bounding box of the file. If the flag 'screenUnits' is
               TRUE, this is returned in screen units, otherwise in draw units.
*/


void Draw_queryBox(Draw_diag diag, Draw_box *box, BOOL screenUnits)
{
  Draw_objectType object;

  object.bytep = diag.data;
  if (screenUnits)
  {
    Draw_convertBox((Draw_box*)&object.fileHeader->bbox, box, TRUE);
  }
  else
  { /* Fiddle type and copy box */
    *box = *((Draw_box*)(&object.fileHeader->bbox));
  }
}


/*
 Function    : Draw_convertBox
 Purpose     : convert a box to/from screen coordinates
 Parameters  : pointer to box to convert
               pointer to box for result
               flag: to screen units?
 Returns     : void
 Description : from and to may point to the same box. If toScreen is TRUE, the
               box is taken as being in Draw units, else it is in screen units.
*/

void Draw_convertBox(Draw_box *from, Draw_box *to, BOOL toScreen)
{
  if (toScreen)
  { to->x0 = Draw_drawToScreen(from->x0);
    to->y0 = Draw_drawToScreen(from->y0);
    to->x1 = Draw_drawToScreen(from->x1);
    to->y1 = Draw_drawToScreen(from->y1);
  }
  else
  { to->x0 = Draw_screenToDraw(from->x0);
    to->y0 = Draw_screenToDraw(from->y0);
    to->x1 = Draw_screenToDraw(from->x1);
    to->y1 = Draw_screenToDraw(from->y1);
  }
}



