
#include <stdafx.h>


#include <stdlib.h>



#include "os.h"


#include "fsx.h"
#include "flex.h"
#include "wimp.h"
#include "etc.h"
#include "sprite.h"
#include "wos.h"
#include	"poll.h"
#include "userdraw.h"
#include "comctls.h"
#include "fs_dirutils.h"


#define MAX_DRIVE _MAX_DRIVE


// think C:/    is the name of the root directory
//       C:/bob is the name of directory bob
// the latter does not end in / whilst the former does
// this matters when you're cating things onto the name



// can be c:/
//		  //MYPC
//  or a path item

char * getpathitem(char * source,char * item,int maxsize)
{
 char * p;
 int    ch;


 ch=*source;
 if(ch=='\\' && *(source+1)=='\\')
 {
  *item++='\\';
  *item++='\\';
  source+=2;
 }
 else
 if(isalpha(ch) && *(source+1)==':' && *(source+2)=='\\')
 {
  *item++=(char)ch;
  *item++=*(source+1);
//  *item++=*(source+2);
  *item++=0;
  return(source+3);
 }

 p=source;
 while(1)
 {
  ch=*p++;

  if(ch==0)
  {
   p--;
   if(p==source) p=NULL;
   *item=0;
   break;
  }
  else
  if(ch=='\\' || ch=='/')
  {
   *item=0;
   break;
  }
  else
  {
   *item++=(char)ch;
  }
 }

 return(p);

 USE(maxsize);
}


os_error * getdrive(char * path,char * drive)
{
 getpathitem(path,drive,MAX_DRIVE);
 strcat(drive,"\\");
 return(NULL);
}


os_error * parsepath(char * path,int * maxlevel)
{
 os_error * err;
 char     * p;
 int        ch;
 int        level;
 int        lastch;
 int        good;

 err=NULL;

 level=0;

 p=path;

 ch=*p++;
 good=0;
 ch=*p++;
 if((isalpha(ch) && *p==':' && *(p+1)=='\\' )) {p+=2;good=1;}
 if(ch=='\\' && *p=='\\') {p++;good=1;}


 if(good)
 {
  while(1)
  {
   lastch=ch;
   ch=*p++;

   if(ch==0)
   {

    break;
   }
   else
   if(lastch=='\\' || lastch=='/')
   {
    level++;
   }
  }
 }

 if(maxlevel) *maxlevel=level;

 return(err);
}


// return pointer to first char of maxlevel sub path

char * pathleveln(char * path,int maxlevel)
{
 char     * p;
 int        ch;
 int        lastch;
 int        level;
 int        good;

 level=0;

 p=path;

 if(maxlevel==0) return(p);

 good=0;
 ch=*p++;
 if((isalpha(ch) && *p==':' && *(p+1)=='\\' )) {p+=2;good=1;}
 if(ch=='\\' && *p=='\\') {p++;good=1;}

 if(good)
 {
  while(1)
  {
   lastch=ch;
   ch=*p++;

   if(ch==0)
   {

    break;
   }
   else
   if(lastch=='\\' || lastch=='/')
   {
    level++;
    if(level>=maxlevel)
    {
     p--;
     break;
    }
   }
  }
 }
 return(p);
}






#define DIRCHUNK (64*sizeof(fstat2))
#define DIRSTRINGCHUNK (0x800)

os_error * getdirectory2(int * dirstringn,int * stringsize,char ** dirstring,fstat2 ** dirstat2,char * path,char * wild,int flags)
{
 os_error * err;
 int        offset;
 int        n;
 int        eof;
 fxstat     fs;
 int        len;

 err=flex_alloc((flex_ptr)dirstat2,DIRCHUNK);
 if(!err)
 {
  err=flex_alloc((flex_ptr)dirstring,DIRSTRINGCHUNK);
  if(!err)
  {
   n=0;
   offset=0;
   fs_startscan();
   while(1)
   {
    err=fs_nextitem(path,&fs,wild,&eof);
    if(err) break;
    if(eof) break;

    if(flags & GETDIRHIDDEN)
    {
     if(fs_hidden(fs.f.acc)) continue;
    }

    if(flags & GETDIRSYSTEM)
    {
     if(fs_system(fs.f.acc)) continue;
    }

    if(flags & GETDIRREADONLY)
    {
     if(fs_readonly(fs.f.acc)) continue;
    }

    if(flags & GETDIRDIR)
    {
     if(fs.f.object!=2) continue;
    }

    err=flex_chunk((flex_ptr)dirstat2,(n+1)*sizeof(fstat2),DIRCHUNK);
    if(err) break;

    len=strlen(fs.name)+1;
    err=flex_chunk((flex_ptr)dirstring,offset+len,DIRSTRINGCHUNK);
    if(err) break;

    (*dirstat2)[n].f=fs.f;
    (*dirstat2)[n].name=offset;
    (*dirstat2)[n].flags=0;
    strcpy((*dirstring)+offset,fs.name);

    offset+=len;
    n++;
   }

   if(dirstringn) *dirstringn=n;
   if(stringsize) *stringsize=offset;
   fs_endscan();
  }
  else
  {
   flex_free((flex_ptr)dirstat2);
  }
 }

 return(err);
}


os_error * getdirectory(int * dirstringn,char ** dirstring,fstat2 ** dirstat2,char * path,char * wild,int flags)
{
 return(getdirectory2(dirstringn,NULL,dirstring,dirstat2,path,wild,flags));
}



static char * astring;

static int acmpfn(const void * p1,const void * p2)
{
 return(_stricmp(((fstat2*)p1)->name+astring,((fstat2*)p2)->name+astring));
}

 
void sortdirectory(int dirstringn,char * dirstring,fstat2 * dirstat2)
{
 astring=dirstring;
 qsort(dirstat2,dirstringn,sizeof(fstat2),acmpfn);
}



os_error * freedirectory(char ** dirstring,fstat2 ** dirstat2)
{
 os_error * err;

          err=flex_free((flex_ptr)dirstring);
 if(!err) err=flex_free((flex_ptr)dirstat2);

 return(err);
}



os_error * listboxdirectory(char * path,listboxh listboxhandle)
{
 os_error * err;
 char       temp[256];
 fstat2   * dirstat2;
 char     * dirstring;
 int        dirstringn;
 int        i;


 err=getdirectory(&dirstringn,&dirstring,&dirstat2,path,"*.*",GETDIRDIR|GETDIRHIDDEN|GETDIRSYSTEM);
 if(!err)
 {
  sortdirectory(dirstringn,dirstring,dirstat2);
  for(i=0;i<dirstringn;i++)
  {
   unquoteicontext(temp,dirstring+dirstat2[i].name,sizeof(temp)/sizeof(TCHAR));

   cc_addlistboxstring(listboxhandle,temp);
  }
  freedirectory(&dirstring,&dirstat2);
 }

 return(err);
}

