/*->c.key */

#include <stdafx.h>

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <locale.h>

#include "os.h"
#include "flex.h"
#include "wimp.h"
#include "bits.h"
#include "deb.h"

#include "etc.h"


#include "keylegacy.h"

#include "key.h"





#define MNKEYS (sizeof(ktable)/sizeof(ktype))




typedef struct
{
 char     * name;
 int        code;
} ktype;



static ktype ktable[]=
{
 "Escape",   VK_ESCAPE,
 "F1",       VK_F1,
 "F2",       VK_F2,
 "F3",       VK_F3,
 "F4",       VK_F4,
 "F5",       VK_F5,
 "F6",       VK_F6,
 "F7",       VK_F7,
 "F8",       VK_F8,
 "F9",       VK_F9,
 "F10",      VK_F10,
 "F11",      VK_F11,
 "F12",      VK_F12,
 "Print",    VK_PRINT, 
 "SLock",    VK_SCROLL, 
 "Break",    VK_PAUSE,
 
 "`",        XVK_BACKAPOST,
 "1",        '1',
 "2",        '2',
 "3",        '3',
 "4",        '4',
 "5",        '5',
 "6",        '6',
 "7",        '7',
 "8",        '8',
 "9",        '9',
 "0",        '0',

 "-",        XVK_MINUS,
 "=",        XVK_EQUAL,
 "#",        XVK_HASH,
 "BS",       VK_BACK,
 "Insert",   VK_INSERT,
 "Home",     VK_HOME, 
 "PageUp",   VK_PRIOR, 
 "NLock",    VK_NUMLOCK,
 "K/",       VK_DIVIDE,
 "K*",       VK_MULTIPLY, 
 "K#",       VK_SEPARATOR,
 "Tab",      VK_TAB,
 "Q",        'Q',
 "W",        'W', 
 "E",        'E', 
 "R",        'R', 
 "T",        'T', 
 "Y",        'Y',
 "U",        'U', 
 "I",        'I',
 "O",        'O',
 "P",        'P',
 "[",        XVK_LSQBRA,
 "]",        XVK_RSQBRA,
 "\\",       XVK_BACKSLASH,
 "Delete",   VK_DELETE,
 "Copy",     VK_END,
 "PageDown", VK_NEXT,
 "K7",       VK_NUMPAD7,
 "K8",       VK_NUMPAD8,
 "K9",       VK_NUMPAD9,
 "K-",       VK_SUBTRACT,
 "A",        'A',
 "S",        'S',
 "D",        'D',
 "F",        'F',
 "G",        'G',
 "H",        'H',
 "J",        'J',
 "K",        'K',
 "L",        'L',
 ";",        XVK_SEMICOLON,
 "'",        XVK_APOST,
 "Return",   VK_RETURN,
 "K4",       VK_NUMPAD4,
 "K5",       VK_NUMPAD5,
 "K6",       VK_NUMPAD6,
 "K+",       VK_ADD,
 "Z",        'Z',
 "X",        'X',
 "C",        'C',
 "V",        'V',
 "B",        'B',
 "N",        'N',
 "M",        'M',
 ",",        XVK_COMMA,
 ".",        XVK_PERIOD,
 "/",        XVK_SLASH,
 "CUp",      VK_UP,
 "K1",       VK_NUMPAD1,
 "K2",       VK_NUMPAD2,
 "K3",       VK_NUMPAD3,
 "Space",    VK_SPACE,
 "CLeft",    VK_LEFT,
 "CRight",   VK_RIGHT,
 "CDown",    VK_DOWN,
 "K0",       VK_NUMPAD0,
 "K.",       VK_DECIMAL,
 "Enter",    VK_RETURN,

 "Help",     VK_HELP,
 "F13",      VK_F13,
 "F14",      VK_F14,
 "F15",      VK_F15,
 "F16",      VK_F16,
 "F17",      VK_F17,
 "F18",      VK_F18,
 "F19",      VK_F19,
 "F20",      VK_F20,
 "F21",      VK_F21,
 "F22",      VK_F22,
 "F23",      VK_F23,
 "F24",      VK_F24,

 // "Clear",    VK_CLEAR,      clashes with macro name
};







static char * keyprefix[KEYSHIFTN]=
{"","S_","C_","A_","CS_","AS_","AC_","ACS_",
 "W","WS_","WC_","WA_","WCS_","WAS_","WAC_","WACS_",
};

//static char * keycanonicalprefix[6]={"","\x8b","^","Act","^\x8b","Act\x8b"};

static char * longprefix[KEYSHIFTN]=
{"","Shift","Ctrl","Alt","Ctrl+Shift","Alt+Shift","Alt+Ctrl","Alt+Ctrl+Shift",
 "Win","Win+Shift","Win+Ctrl","Win+Alt","Win+Ctrl+Shift","Win+Alt+Shift","Win+Alt+Ctrl","Win+Alt+Ctrl+Shift"
};

//static int    prefixcode[6]={KEYVIRT,KEYVSHIFT|KEYVIRT,KEYVCTRL|KEYVIRT,KEYVACT|KEYVIRT,KEYVSHIFT|KEYVCTRL|KEYVIRT,KEYVSHIFT|KEYVACT|KEYVIRT};

static int    prefixcode[KEYSHIFTN]=
{KEYNORM,KEYSHIFT,KEYCTRL,KEYALT,KEYCTSH,KEYALSH,KEYALCT,KEYALCTSH,
 KEYWIN,KEYWINSH,KEYWINCT,KEYWINAL,KEYWINCTSH,KEYWINALSH,KEYWINALCT,KEYWINALCTSH
};

static int    prefixindex(int ccode)
{
 return((ccode>>8)& 0xFF);
}


/* returns either key type for string, or -1 for not a key string */

int keycanonicaltype(char * string)
{
 int i;
 int prefix=0;
 int hit=0;

 for(prefix=(KEYSHIFTN-1);prefix>0;prefix--)
 {
  i=0;
  while(1)
  {
   if(string[i]!=keyprefix[prefix][i]) break;
   i++;
   if(!keyprefix[prefix][i])
   {
    hit=1;
    string+=i;
    break;
   }
  }
  if(hit) break;
 }


 for(i=0;i<MNKEYS;i++)
 {
  if(!cstrcmp(ktable[i].name,string)) return(i | prefixcode[prefix]);
 }

 return(KEYNONE);
}



int keytype(char * string)
{
 int code;

 code=keycanonicaltype(string);
 if(code>=0)
 {
  return(keycanonical2code(code));
 }
 else
 {
  return(code);
 }
}

// idea is to either return a keypress or a code
// this is not so good because the keyboard layout rightly determines the right result

int keytypetext(char * string)
{
 int code;
 int ccode;


 ccode=keycanonicaltype(string);
 if(ccode>=0)
 {
  code=ktable[ccode & 0xFF].code;
  if(code==VK_RETURN && ((ccode & 0xFF00)==0)) code=RETURN;
  else
  if(code==VK_TAB && ((ccode & 0xFF00)==0)) code='\t';
  else
  {
   code=legacykeyfromcc(ccode);
//   cprintf("code %x ccode %x %s",code,ccode,ktable[ccode & 0xFF].name);
   if(code>0x100 || code==0x7F) code=keycanonical2code(ccode);
  }
 }
 else
 {
  code=-1;
 }

 return(code);
}


int isasciitextkey(int key)
{
	int ch;

	if(key & KEYVIRT)
	{
		ch=key & KEYVMASK;
		if((ch>='A' && ch<='Z') || (ch>='0' && ch<='9'))
		{
			if(!(key & (KEYVCTRL|KEYVALT|KEYVWIN)))
			{
				return(1);
			}
		}
	}

	return(0);
}








int keycode2canonical(int code)
{
 int    i;

 for(i=0;i<MNKEYS;i++)
 {
  if(ktable[i].code==(code & 0xFF))
  {
   code&=~KEYVIRT;


   if((code & (KEYVSHIFT|KEYVCTRL|KEYVALT))==(KEYVSHIFT|KEYVCTRL|KEYVALT)) i|=KEYALCTSH;
   else
   if((code & (KEYVSHIFT|KEYVALT))==(KEYVSHIFT|KEYVALT))    i|=KEYALSH;
   else
   if((code & (KEYVSHIFT|KEYVCTRL))==(KEYVSHIFT|KEYVCTRL))  i|=KEYCTSH;
   else
   if((code & (KEYVALT|KEYVCTRL))==(KEYVALT|KEYVCTRL))      i|=KEYALCT;
   else
   if(code & KEYVALT)   i|=KEYALT;
   else
   if(code & KEYVCTRL)  i|=KEYCTRL;
   else
   if(code & KEYVSHIFT) i|=KEYSHIFT;

			if(code & KEYVWIN)   i+=KEYWIN;

   return(i);
  }
 }
 return(KEYNONE);

}



int keycanonical2code(int ccode)
{
 int result;
 
 
 result=ktable[ccode & 0xFF].code | KEYVIRT;

 ccode=(ccode &0xFF00);

	if(ccode>=KEYWIN)
	{
		result|=KEYVWIN;
		ccode-=KEYWIN;
	}

 if(ccode==KEYSHIFT)  result|=KEYVSHIFT;
 else
 if(ccode==KEYCTRL)   result|=KEYVCTRL;
 else
 if(ccode==KEYALT)    result|=KEYVALT;
 else
 if(ccode==KEYCTSH)   result|=(KEYVSHIFT|KEYVCTRL);
 else                
 if(ccode==KEYALSH)   result|=(KEYVSHIFT|KEYVALT);
 else
 if(ccode==KEYALCT)   result|=(KEYVCTRL|KEYVALT);
 else
 if(ccode==KEYALCTSH) result|=(KEYVSHIFT|KEYVCTRL|KEYVALT);

  
 return(result);
}



char * keystringcanonical(int ccode)
{
 static char name[20];

 name[0]=0;

 if(ccode>0)
 {
//  strcpy(name,keycanonicalprefix[prefixindex(ccode)]);
  strcpy(name,longprefix[prefixindex(ccode)]);
  if(*name) strcat(name,"+");
  strcat(name,ktable[ccode & 0xFF].name);
 }

 return(name);
}




char * keylongstringcanonical(int ccode)
{
 static char name[20];

 name[0]=0;

 if(ccode>0)
 {
  strcpy(name,longprefix[prefixindex(ccode)]);
  if(*name) strcat(name,"+");

  ccode&=0xFF;
  if(ktable[ccode].name[0]=='K' && ktable[ccode].name[1]!=0)
  {
   strcat(name,"Keypad ");
   strcat(name,ktable[ccode].name+1);
  }
  else
  {
   strcat(name,ktable[ccode & 0xFF].name);
  }
 }

 return(name);
}


/* return string form for string */

char * keystring(int code)
{
 static char name[32];
 int         ccode;

 ccode=keycode2canonical(code);
 if(ccode>=0)
 {
  strcpy(name,keyprefix[prefixindex(ccode)]);
  strcat(name,ktable[ccode & 0xFF].name);
 }
 else name[0]=0;

 return(name);
}


// what key generates ch?

int keypressfromchar(int ch)
{
 short int code;
 int       kcode;

 code=VkKeyScan((char)ch);

 if(code!=-1)
 {
  kcode=code & 0xFF;

  if(code & 0x100) kcode|=KEYVSHIFT;
  if(code & 0x200) kcode|=KEYVCTRL;
  if(code & 0x400) kcode|=KEYVALT;

  return(keycode2canonical(kcode));
 }

 return(KEYNONE);
}



static int badcodes[]=
{
 F11,
 F12,
 SHFT_F11,
 SHFT_F12,
 CTRL_F11,
 CTRL_F12,
 CTSH_F11,
 CTSH_F12,
 F1,
 SHFT_F1,
 CTRL_F1,
 CTSH_F1,
};



int isbadfunc(int key)
{
 int i;
 
 for(i=0;i<sizeof(badcodes)/sizeof(int);i++)
 {
  if(badcodes[i]==key) return(1);
 }
 
 return(0);
}



/* key codes page 1198 PRM */

static int fcodes[]=
{
 F1,
 F2,
 F3,
 F4,
 F5,
 F6,
 F7,
 F8,
 F9,
 F10,
 F11,
 F12,

 SHFT_F1,
 SHFT_F2,
 SHFT_F3,
 SHFT_F4,
 SHFT_F5,
 SHFT_F6,
 SHFT_F7,
 SHFT_F8,
 SHFT_F9,
 SHFT_F10,
 SHFT_F11,
 SHFT_F12,

 CTRL_F1,
 CTRL_F2,
 CTRL_F3,
 CTRL_F4,
 CTRL_F5,
 CTRL_F6,
 CTRL_F7,
 CTRL_F8,
 CTRL_F9,
 CTRL_F10,
 CTRL_F11,
 CTRL_F12,

 CTSH_F1,
 CTSH_F2,
 CTSH_F3,
 CTSH_F4,
 CTSH_F5,
 CTSH_F6,
 CTSH_F7,
 CTSH_F8,
 CTSH_F9,
 CTSH_F10,
 CTSH_F11,
 CTSH_F12,

};




int isfunc(int key)
{
 int i;

 for(i=0;i<sizeof(fcodes)/sizeof(int);i++)
 {
  if(fcodes[i]==key) return(1);
 }

 return(0);
}









os_error * setkeyboardmode(int caps)
{
 return(NULL);
 USE(caps);
}


os_error * initkeyboard(int caps)
{
 return(NULL);
 USE(caps);
}





os_error * scrollkey(wimp_w window,int * key)
{
 int  code;
 HWND hwnd;


 hwnd=(HWND)window;
 code=*key;

 switch(code)
 {

          case (KEYVIRT|VK_HOME) :
               SendMessage (hwnd, WM_VSCROLL, SB_TOP, 0) ;
               break ;
               
          case (KEYVIRT|VK_END):
               SendMessage (hwnd, WM_VSCROLL, SB_BOTTOM, 0) ;
               break ;
               
          case (KEYVIRT|VK_PRIOR):
               SendMessage (hwnd, WM_VSCROLL, SB_PAGEUP, 0) ;
               break ;
               
          case (KEYVIRT|VK_NEXT):
               SendMessage (hwnd, WM_VSCROLL, SB_PAGEDOWN, 0) ;
               break ;

          case (KEYVIRT|VK_UP):
               SendMessage (hwnd, WM_VSCROLL, SB_LINEUP, 0) ;
               break ;
               
          case (KEYVIRT|VK_DOWN) :
               SendMessage (hwnd, WM_VSCROLL, SB_LINEDOWN, 0) ;
               break ;
               
          case (KEYVIRT|VK_LEFT) :
               SendMessage (hwnd, WM_HSCROLL, SB_PAGEUP, 0) ;
               break ;
               
          case (KEYVIRT|VK_RIGHT) :
               SendMessage (hwnd, WM_HSCROLL, SB_PAGEDOWN, 0) ;
               break ;

                 default:
                         return(NULL);
 }

 *key=-1;

 return(NULL);
}
