/*->h.mlo */


#define MLAST -1

#define MFINFO 0x1
#define MUSED  0x2

#define MSHADE 0x10
#define MTICK  0x1
#define MSEP   0x2


typedef os_error * (*menudecodefn)(int * menu,wimp_w window);
typedef os_error * (*menudynamicfn)(int * menu,char * handle,wimp_w window);

typedef struct menustr
{
 int            menuno;
 char         * menuname;
 char         * menuptr;
 int            flags;
 int            map;
 int            parent;
 int            entryinparent;
	int            tag;
 menudecodefn   decode;
 menudynamicfn  dynamic;
} menustr;


typedef struct menulink
{
 struct menulink  * next;
 menustr          * menus;
} menulink;


extern menustr * menufromhandle(int n);
extern void menutag(int n,int tag);

extern os_error * openupmenu(wimp_w window,int handle);
extern void setmenufns(int n,menudecodefn decode,menudynamicfn dynamic);
extern void setmenudynamic(int n,int item);
extern void setmenuflags(int n,int flags);
extern void menutag(int n,int tag);
extern void tickmenust(int n,int item,int state);
extern void unshademenust(int n,int item,int state);
extern os_error * readmenu(int n,int item,int size,TCHAR * buffer);
extern os_error * writemenu(int n,int item,TCHAR * buffer,int * change);

extern os_error * createusermenu(int n,menudecodefn decode,menudynamicfn dynamic);
extern os_error * createmainmenu(int n,menudecodefn decode,menudynamicfn dynamic);
extern os_error * addusermenu(int n,TCHAR * string,int flags,int id);
extern char     * completeusermenu(int n,TCHAR * title);
extern os_error * deleteusermenu(int n);
extern os_error * deletemainmenu(int n);


extern os_error * addmenus(TCHAR * path,TCHAR * leaf,menustr * menus,menulink * link);
extern os_error * updatemenus(menustr * menutable,menulink * link);

extern os_error * menulostart(TCHAR * path,TCHAR * leaf);
extern os_error * menulofinit(void);

extern os_error * addwindowmenu(wimp_w window,int menuhandle);
extern os_error * remwindowmenu(wimp_w handle,int menuhandle);

extern os_error * linkmenu(int child,int parent,int entryinparent);
extern os_error * clearmenu(int n);

extern os_error * refreshmenubar(wimp_w handle);

extern os_error * debugosmenu(int n);
