/*->h.poll */

extern int zerotime;
extern int keytime;

#ifdef _WIN64

typedef __int64 uservalue;

#else

typedef int uservalue;


#endif


typedef void (*zerofn)(uservalue userhandle);    /* external function */
typedef void (*pollfn)(uservalue userhandle);   
//typedef int  (*pollmaskfn)(uservalue userhandle,wimp_eventstr * wimpevent);
typedef os_error * (*redrfn)(wimp_w handle,uservalue userhandle);
typedef os_error * (*openfn)(wimp_w handle,uservalue userhandle,wimp_openstr * o);
typedef os_error * (*closefn)(wimp_w handle,uservalue userhandle);
//typedef os_error * (*ptrfn)(wimp_w handle,uservalue userhandle,int enter);
typedef os_error * (*clickfn)(wimp_w handle,uservalue userhandle,wimp_mousestr * m);
typedef os_error * (*dragfn)(wimp_w handle,uservalue userhandle,wimp_box * box);
typedef os_error * (*keyfn)(wimp_w handle,uservalue userhandle,int icon,int * key);
typedef os_error * (*caretfn)(wimp_w handle,uservalue userhandle,int gain);
typedef os_error * (*activatefn)(wimp_w handle,uservalue userhandle,wimp_w otherhandle,int code);
typedef os_error * (*messfn)(wimp_msgstr * msg,int * ack);
//typedef os_error * (*ackfn)(wimp_msgstr * msg);
typedef os_error * (*loadtypefn)(char * name,int type,mousestr * m,uservalue userhandle,
                                                               int * method);
typedef os_error * (*loadnamefn)(char * leaf,char * name,uservalue userhandle);
typedef os_error * (*loadfn)(char * name,int type,uservalue userhandle,int xvolatile);
typedef os_error * (*loadpostfn)(uservalue userhandle);
typedef os_error * (*savefn)(char * name,int type);
typedef os_error * (*intsavefn)(mousestr * m,char * name,int type);
typedef os_error * (*saveinfofn)(int * len);
typedef os_error * (*menufn)(int * menu);
//typedef os_error * (*prequitfn)(uservalue userhandle,int * ack,int prequit);
typedef os_error * (*pollwordfn)(int * address,int contents);
typedef os_error * (*helpfn)(wimp_w handle,uservalue userhandle,int icon,char ** p);
typedef os_error * (*setcursorfn)(wimp_w handle,uservalue userhandle,wimp_mousestr * m,int * set);
typedef os_error * (*editupdatefn)(wimp_w handle,int icon,uservalue userhandle);
typedef os_error * (*editcaretfn)(wimp_w handle,int icon,int gain,uservalue userhandle);
typedef os_error * (*mouseeventfn)(wimp_w handle,uservalue userhandle,wimp_w eventhandle,LPARAM lp,WPARAM wp,int * ack);

typedef os_error * (*hotkeyfn)(wimp_w handle,uservalue userhandle,int key);
typedef os_error * (*wheelfn)(wimp_w handle,uservalue userhandle,int delta,int buttons,int horizontal,int * ack);
typedef os_error * (*appcommandfn)(wimp_w handle,uservalue userhandle,wimp_w source,int cmd,int device,int buttons,int * ack);





extern os_error * addscheduledevent(zerofn fn,uservalue userhandle,int delay);
extern os_error * remscheduledevent(zerofn fn,uservalue userhandle);
extern os_error * addzeroevent(zerofn fn,uservalue userhandle);
extern os_error * remzeroevent(zerofn fn,uservalue userhandle);
extern os_error * addpollexit(pollfn fn,uservalue userhandle);
extern os_error * rempollexit(pollfn fn,uservalue userhandle);
extern os_error * addpollenter(pollfn fn,uservalue userhandle);
extern os_error * rempollenter(pollfn fn,uservalue userhandle);
//extern os_error * addpollmask(pollmaskfn fn,uservalue userhandle);
//extern os_error * rempollmask(pollmaskfn fn,uservalue userhandle);

extern os_error * addredrawevent(redrfn fn,wimp_w handle,uservalue userhandle);
extern os_error * remredrawevent(redrfn fn,wimp_w handle,uservalue userhandle);
extern os_error * addopenevent(openfn fn,wimp_w handle,uservalue userhandle);
extern os_error * remopenevent(openfn fn,wimp_w handle,uservalue userhandle);
extern os_error * addcloseevent(closefn fn,wimp_w handle,uservalue userhandle);
extern os_error * remcloseevent(closefn fn,wimp_w handle,uservalue userhandle);
//extern os_error * addpointerevent(ptrfn fn,wimp_w handle,uservalue userhandle);
//extern os_error * rempointerevent(ptrfn fn,wimp_w handle,uservalue userhandle);
extern os_error * addclickevent(clickfn fn,wimp_w handle,uservalue userhandle);
extern os_error * remclickevent(clickfn fn,wimp_w handle,uservalue userhandle);
extern os_error * startdrag(wimp_w handle,uservalue userhandle,dragfn fn);
extern os_error * startdrag2(wimp_w handle,uservalue userhandle,dragfn fn,clickfn fn2);
extern wimp_w     getdraghandle(void);
extern os_error * addkeyevent(keyfn fn,wimp_w handle,uservalue userhandle);
extern os_error * remkeyevent(keyfn fn,wimp_w handle,uservalue userhandle);
extern os_error * addcaretevent(caretfn fn,wimp_w handle,uservalue userhandle);
extern os_error * remcaretevent(caretfn fn,wimp_w handle,uservalue userhandle);
extern os_error * adddataopen(int type,loadfn fn);
extern os_error * adddataopenpost(int type,loadpostfn fn);
extern os_error * remdataopen(int type,loadfn fn);
extern os_error * remdataopenpost(int type,loadpostfn fn);
extern os_error * adddataload(wimp_w handle,uservalue userhandle,loadfn fn);
extern os_error * adddataloadpost(wimp_w handle,uservalue userhandle,loadpostfn fn);
extern os_error * adddataloadtype(wimp_w handle,uservalue userhandle,loadtypefn fn);
extern os_error * adddataloadname(wimp_w handle,uservalue userhandle,loadnamefn fn);
extern os_error * remdataload(wimp_w handle,uservalue userhandle,loadfn fn);
extern os_error * remdataloadpost(wimp_w handle,uservalue userhandle,loadpostfn fn);
extern os_error * remdataloadtype(wimp_w handle,uservalue userhandle,loadtypefn fn);
extern os_error * remdataloadname(wimp_w handle,uservalue userhandle,loadnamefn fn);
extern os_error * addmenuhandler(menufn fn);
//extern os_error * addprequit(prequitfn fn,uservalue userhandle);
//extern os_error * remprequit(prequitfn fn,uservalue userhandle);

extern os_error * addhelpevent(helpfn fn,wimp_w handle,uservalue userhandle);
extern os_error * remhelpevent(helpfn fn,wimp_w handle,uservalue userhandle);

//extern os_error * addack(ackfn fn,int ref);
extern os_error * addmessage(messfn fn,int message);
extern os_error * remmessage(messfn fn,int message);

extern os_error * addpollword(pollwordfn fn,int * pw);
extern os_error * rempollword(void);

extern os_error * addmousemoveevent(clickfn fn,wimp_w handle,uservalue userhandle);
extern os_error * remmousemoveevent(clickfn fn,wimp_w handle,uservalue userhandle);

extern os_error * addactevent(activatefn fn,wimp_w handle,uservalue userhandle);
extern os_error * remactevent(activatefn fn,wimp_w handle,uservalue userhandle);

extern os_error * addsetcursorevent(setcursorfn fn,wimp_w handle,uservalue userhandle);
extern os_error * remsetcursorevent(setcursorfn fn,wimp_w handle,uservalue userhandle);

extern os_error * addeditevent(editupdatefn fn,wimp_w handle,uservalue userhandle);
extern os_error * remeditevent(editupdatefn fn,wimp_w handle,uservalue userhandle);

extern os_error * addeditcaretevent(editcaretfn fn,wimp_w handle,uservalue userhandle);
extern os_error * remeditcaretevent(editcaretfn fn,wimp_w handle,uservalue userhandle);

extern os_error * adddeleteevent(closefn fn,wimp_w handle,uservalue userhandle);
extern os_error * remdeleteevent(closefn fn,wimp_w handle,uservalue userhandle);

extern os_error * addparentcloseevent(closefn fn,wimp_w handle,uservalue userhandle);
extern os_error * remparentcloseevent(closefn fn,wimp_w handle,uservalue userhandle);


extern os_error * addmouseevent(mouseeventfn fn,wimp_w handle,uservalue userhandle);
extern os_error * remmouseevent(mouseeventfn fn,wimp_w handle,uservalue userhandle);

extern os_error * addwheelevent(wheelfn fn,wimp_w handle,uservalue userhandle);
extern os_error * remwheelevent(wheelfn fn,wimp_w handle,uservalue userhandle);

extern os_error * addappcommandevent(appcommandfn fn,wimp_w handle,uservalue userhandle);
extern os_error * remappcommandevent(appcommandfn fn,wimp_w handle,uservalue userhandle);





/*
  !!! when you add facility for RISC OS 3 messages to be received
      messages only received if you declare you want them...
      remember this applies to ACKing of your own messages 

 */

//extern os_error * addwimpmessages(int * mess);


extern void       poll(void);
extern os_error * pollinit(void);
//extern void       pollfake(wimp_eventstr * ep);

extern os_error * fakedataopen(int type,char * name,int * ack);

extern os_error * dataopen(char * name,int xvolatile,int * ack);
extern int dataload(char * name,wimp_w loadhandle,mousestr * mouse);

typedef os_error * (*eventfn)(int eventn,wimp_w userhandle,void * data,int data1);
extern os_error * addevent(int eventn,eventfn eventf,uservalue userhandle);
extern os_error * remevent(int eventn,eventfn eventf,uservalue userhandle);
extern os_error * event(int eventn,void * data,int data1);

extern void pollquit(int code);

extern int polllevel(void);


extern void poll_check(char * where);

extern os_error * helpicon(wimp_w handle,int icon,wimp_w iconhandle);

extern os_error * addkeyeventicon(wimp_w handle,int icon);
extern os_error * remkeyeventicon(wimp_w handle,int icon);



extern os_error * addhotkey(hotkeyfn fn,wimp_w handle,uservalue userhandle,int key);
extern os_error * remhotkey(hotkeyfn fn,wimp_w handle,uservalue userhandle,int key);


#define POLLUNICODE 0x1

extern int pollsetflags(int orr,int bic);

