/*->c.temp */

#include <stdafx.h>


#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>


#include "os.h"
#include "wimp.h"
#include "wimpt.h"
#include "flex.h"


#include "err.h"
#include "alloc.h"
#include "etc.h"
#include "bits.h"
#include "encrypt.h"
#include "deb.h"


#include "fsx.h"
#include "applet.h"
#include "osunits.h"
#include "wos.h"
#include "poll.h"
#include "osddex.h"

#include "osglue.h"
#include "oserr.h"
#include "abx.h"

#include "temp.h"




static templink * firstlink;

static templink   locallink;


#define TSEQBASE 0x10000

#define TCHUNK (sizeof(templates)*8)

static int tempseq=TSEQBASE;



static BOOL CALLBACK dload(
  HMODULE hModule,  // module handle
  LPCTSTR lpszType, // pointer to resource type
  LPTSTR lpszName,  // pointer to resource name
  LPARAM lParam       // application-defined parameter
)
{
 os_error     * err;
 templink     * link;
 void         * ptr=NULL;     // compiler
 HANDLE         hDialog=NULL; // compiler
 HRSRC          hRsrc=NULL;   // compiler
 char         * name;


 link=(templink*)lParam;


          err=XFindResource(hModule,lpszName,lpszType,&hRsrc);
 if(!err) err=XLoadResource(hModule,hRsrc,(HGLOBAL*)&hDialog);
 if(!err) err=XLockResource(hDialog,(LPVOID*)&ptr);
 if(!err)
 {
//  cprintf("auto add %s",lpszName);

           err=salloc((flex_ptr)&name,strlen(lpszName)+1);
  if(!err) strcpy(name,lpszName);
  if(!err) err=schunk((flex_ptr)&link->temps,(tempseq-TSEQBASE+1)*sizeof(templates),TCHUNK);
  if(!err)
  {
   link->temps[tempseq-TSEQBASE].tempno=tempseq+1;
   link->temps[tempseq-TSEQBASE].spritearea=0;
   link->temps[tempseq-TSEQBASE].id.tempname=name;
   link->temps[tempseq-TSEQBASE].id.offset=ptr;
   tempseq++;
   link->temps[tempseq-TSEQBASE].tempno=TLAST;
  }
 }

 return(err==NULL);
}
 





os_error * addtemplates2a(TCHAR * path,TCHAR * leaf,templates * temptable,
                                     templink * link,ascaninstance instance)
{
 os_error  * err;
 templates * temps;
 HANDLE      hDialog; 
 HRSRC       hRsrc;

 err=NULL;




 if(link)
 {
  link->temps=temptable;
  link->next=firstlink;
  firstlink=link;
 }

// cprintf("addtemplates2 temptable %x instance %x",temptable,instance);

 temps=temptable;

 if(temptable)
 {
  while(temps->tempno!=TLAST)
  {
   err=XFindResource((HINSTANCE)instance,temps->id.tempname,RT_DIALOG,&hRsrc);
   if(err) break;

   err=XLoadResource((HINSTANCE)instance,hRsrc,(HGLOBAL*)&hDialog);
   if(err) break;

   err=XLockResource(hDialog,(LPVOID*)&temps->id.offset);
   if(err) break;

//   cprintf("name %s offset %x",temps->id.tempname,temps->id.offset);
 
   temps++;
  }
 }
 else
 {
  if(locallink.temps==NULL)
  {
   locallink.next=firstlink;
   firstlink=&locallink;

   err=salloc((flex_ptr)&locallink.temps,TCHUNK);
   if(!err)
   {
    locallink.temps[0].tempno=TLAST;
   }
  }

  if(!err) err=XEnumResourceNames((HINSTANCE)instance,RT_DIALOG,dload,(LONG_PTR)&locallink);
 }

 return(err); 

 USE(leaf);
 USE(path);
}





os_error * addtemplates(TCHAR * path,TCHAR * leaf,templates * temptable,
                                                            templink * link)
{
 return(addtemplates2a(path,leaf,temptable,link,(ascaninstance)AppInstance));
}


/* scan template tables */

os_error * findtemp(int tempno,wimp_wind ** ww)
{
 templink  * link;
 templates * temps;

 link=firstlink;

 while(link)
 {
  temps=link->temps;

  while(temps->tempno!=TLAST)
  {
   if(temps->tempno==tempno)
   {
    *ww=(wimp_wind*)(temps->id.offset);

    return(NULL);
   }
   temps++;
  }

  link=link->next;
 }

 return(geterrorf(ETEMPX,tempno));
}



os_error * findtempname(int * tempno,TCHAR * name)
{
 templink  * link;
 templates * temps;

 *tempno=0;

 link=firstlink;

 while(link)
 {
  temps=link->temps;

  while(temps->tempno!=TLAST)
  {
   if(!cstrcmp(temps->id.tempname,name)) 
   {
    *tempno=temps->tempno;
    return(NULL);
   }
   temps++;
  }

  link=link->next;
 }

 return(NULL);
}



os_error * createwindowtitle(int tempno,TCHAR * title,wimp_w * handle)
{
 os_error  * err;
 wimp_wind * wp;

 err=findtemp(tempno,&wp);
 if(!err)
 {
//  cprintf("create win title %x",wp);
//  err=wimp_create_wind(wp,handle);

  err=wimp_create_wind(wp,handle);
  if(!err)
  {
   if(title)
   {
    writetitle(*handle,title);
   }
  }
 }

 return(err);
}



os_error * createwindowtitleparent(int tempno,TCHAR * title,wimp_w * handle,wimp_w parent)
{
 os_error  * err;
 wimp_wind * wp;

 err=findtemp(tempno,&wp);
 if(!err)
 {
  cprintf("create win parent %x tempno=%x",wp,tempno);

  err=wimp_create_windparent(wp,handle,parent);
  if(!err)
  {
   if(title)
   {
    writetitle(*handle,title);
   }
  }
 }

 return(err);
}








os_error * createwindowheight(int tempno,wimp_w * handle,int h)
{
 os_error   * err;
 wimp_wind  * wp;
 RECT         rect;
 RECT         recto;
 int          w;

 err=findtemp(tempno,&wp);
 if(!err)
 {
//  wp->box.y0=wp->box.y1-h;

           err=wimp_create_wind(wp,handle);
  if(!err) err=XGetWindowRect((HWND)*handle,&recto);
  if(!err) err=XGetClientRect((HWND)*handle,&rect);

  w=recto.right-recto.left;
  h=yos2pix(h);
  h+=(recto.bottom-recto.top)-(rect.bottom-rect.top);

  SetWindowPos((HWND)*handle,HWND_TOP,0,0,w,h,SWP_NOACTIVATE|SWP_NOMOVE|SWP_NOZORDER);
 }

 return(err);
}


os_error * createwindow(int tempno,wimp_w * handle)
{
 return(createwindowtitle(tempno,NULL,handle));
}


os_error * createwindowparent(int tempno,wimp_w * handle,wimp_w parent)
{
 return(createwindowtitleparent(tempno,NULL,handle,parent));
}




/* called on mode change */

void tempmode(void)
{


}


os_error * tempremapwindow(wimp_w handle)
{


 return(NULL);
 USE(handle);
}


#ifdef NEVER

static  HWND       hwnd;
static  HWND       hwndscroll;
static  WNDPROC    OldScroll;

 SetClassLong(hwndscroll,GCL_WNDPROC,(LONG)OldScroll);

 
 hwnd=CreateWindow("Task",TEXT("temp"),
                          WS_OVERLAPPEDWINDOW,
                          CW_USEDEFAULT, CW_USEDEFAULT,
                          CW_USEDEFAULT, CW_USEDEFAULT,
                          NULL, NULL,AppInstance,NULL);
     
 hwndscroll=CreateWindow(TEXT("scrollbar"),NULL,
                                             WS_CHILD | WS_VISIBLE | 
                                             WS_TABSTOP | SBS_VERT,
                                             0, 0, 0, 0, 
                                             hwnd, (HMENU)22,AppInstance, NULL) ;


 OldScroll=(WNDPROC)SetClassLong(hwndscroll,GCL_WNDPROC,(LONG)ScrollProc);



static LRESULT CALLBACK ScrollProc (HWND hwnd, UINT message, 
                             WPARAM wParam, LPARAM lParam)
{

 cprintf("scrollproc");

 return CallWindowProc (OldScroll, hwnd, message, wParam, lParam) ;
}



#endif




os_error * finittemp(void)
{
 os_error * err;

 err=NULL;



 return(err);
}






os_error * inittemp(void)
{
 os_error * err;
 WNDCLASS   wndclass;
// WNDCLASSW  wndclassw;
 ATOM       atom;

 err=NULL;

 firstlink=NULL;


 memset(&wndclass,0,sizeof(wndclass));

 wndclass.style=CS_DBLCLKS;
 wndclass.lpfnWndProc=pollevent;
 wndclass.cbClsExtra=0;
 wndclass.cbWndExtra=DLGWINDOWEXTRA;
 wndclass.hInstance=AppInstance;
 wndclass.hIcon=LoadIcon(AppInstance,wimpt_programsprite());
 wndclass.hCursor=LoadCursor(NULL,IDC_ARROW);
 wndclass.hbrBackground=(HBRUSH)(COLOR_BTNFACE+1);
 wndclass.lpszMenuName=NULL;
 wndclass.lpszClassName=TEXT("Task");

 err=XRegisterClass(&wndclass,&atom);

/*
 memset(&wndclass,0,sizeof(wndclassw));

 wndclassw.style=CS_DBLCLKS;
 wndclassw.lpfnWndProc=pollevent;
 wndclassw.cbClsExtra=0;
 wndclassw.cbWndExtra=DLGWINDOWEXTRA;
 wndclassw.hInstance=AppInstance;
 wndclassw.hIcon=LoadIcon(AppInstance,wimpt_programsprite());
 wndclassw.hCursor=LoadCursor(NULL,IDC_ARROW);
 wndclassw.hbrBackground=(HBRUSH)(COLOR_BTNFACE+1);
 wndclassw.lpszMenuName=NULL;
 wndclassw.lpszClassName=L"TaskW";

 err=XRegisterClassW(&wndclassw,&atom);
*/


 memset(&wndclass,0,sizeof(wndclass));

 wndclass.style=CS_DBLCLKS;
 wndclass.lpfnWndProc=abxevent;
 wndclass.cbClsExtra=0;
 wndclass.cbWndExtra=ABXEXTRA;
 wndclass.hInstance=AppInstance;
 wndclass.hIcon=NULL;
 wndclass.hCursor=LoadCursor(NULL,IDC_ARROW);
 wndclass.hbrBackground=(HBRUSH)(COLOR_BTNFACE+1);
 wndclass.lpszMenuName=NULL;
 wndclass.lpszClassName=TEXT("abx");

 err=XRegisterClass(&wndclass,&atom);
 
 return(err);
}
