#include <stdafx.h>


#include <stdio.h>
#include <stdlib.h>


#include "os.h"

#include "etc.h"
#include "fsx.h"
#include "err.h"
#include "wimp.h"
#include "colour.h"
#include "transform.h"
#include "deb.h"


#include "osglue.h"
#include "osgraphics.h"
#include "oserr.h"



#include "wmf.h"







static void pmchecksum(PLACEABLEMETAHEADER *pmh)
{
 WORD *ptr;
 pmh->Checksum = 0;

 for(ptr = (WORD *) pmh; ptr < (WORD *)pmh->Checksum; ptr++)
    pmh->Checksum ^= *ptr;
}



static hdcstr * mfhdcptr;

static os_error * mfinit(HDC hdc,int maxx,int maxy)
{
 os_error   * err;
 unsigned int prev;


 graphicsnewhdc(&mfhdcptr);
 mfhdcptr->hdc=hdc;
 graphicsbaseinit2(mfhdcptr);
 mfhdcptr->osxres=180;
 mfhdcptr->osyres=-180;
 mfhdcptr->vduxres=180;
 mfhdcptr->vduyres=180;

 graphicssetcurrent(mfhdcptr);

 err=NULL;

          err=XSetWindowExtEx(hdc,maxx,maxy,NULL);
 if(!err) err=XMoveToEx(hdc,0,0,NULL);
 if(!err) err=XSetTextAlign(hdc,TA_TOP,&prev);


 return(err);
}


static os_error * mffinit(HDC hdc)
{

 graphicsclearcurrent(mfhdcptr);
 graphicsfinit2(mfhdcptr);
 graphicsdeletehdc(mfhdcptr);

 return(NULL);

 USE(hdc);
}



os_error * openwmf(int flags,int maxx,int maxy,metahandle * handle)
{
 os_error * err;
 HDC        hdc;

 err=XCreateMetaFile(NULL,&hdc);
 if(!err)
 {
  *handle=(metahandle)hdc;
  mfinit(hdc,maxx,maxy);
 }
 return(err);

 USE(flags);
}




os_error * closewmf(os_error * err,metahandle handle,TCHAR * filename)
{
 HMETAFILE              hmf;
 unsigned           int size;
 void                 * data;
 unsigned           int length;


 mffinit((HDC)handle); // currenthdc null'd

 if(err)
 {
  XCloseMetaFile((HDC)handle,&hmf);
  XDeleteMetaFile(hmf);
 }
 else
 {
  err=XCloseMetaFile((HDC)handle,&hmf);
  if(hmf)
  {
   err=XGetMetaFileBitsEx(hmf,0,NULL,&size);
   if(size)
   {
    data=malloc(size);
    if(data)
    {
     XGetMetaFileBitsEx(hmf,size,data,&length);

     err=fs_saveblock(filename,0,data,size);

     free(data);
    }
    else
    {
     err=geterror(EMEM);
    }
   }
   XDeleteMetaFile(hmf);
  }
 } 
 return(err);
}






os_error * openpmf(int flags,int maxx,int maxy,metahandle * handle)
{
 os_error * err;
 HDC        hdc;

 err=XCreateMetaFile(NULL,&hdc);
 if(!err)
 {
  *handle=(metahandle)hdc;
  mfinit(hdc,maxx,maxy);
 }

 return(err);

 USE(flags);
}





os_error * closepmf(os_error * err,metahandle handle,TCHAR * filename,int left,int right,int bottom,int top,int dpi)
{
 HMETAFILE              hmf;
 unsigned           int size;
 void                 * data;
 PLACEABLEMETAHEADER  * pmhdr;
 unsigned           int length;


 mffinit((HDC)handle); // currenthdc null'd

 if(err)
 {
  XCloseMetaFile((HDC)handle,&hmf);
  XDeleteMetaFile(hmf);
 }
 else
 {
  err=XCloseMetaFile((HDC)handle,&hmf);
  if(hmf)
  {
   err=XGetMetaFileBitsEx(hmf,0,NULL,&size);
   if(size)
   {
    data=malloc(size+PLACEABLESIZE);
    if(data)
    {
     XGetMetaFileBitsEx(hmf,size,((char*)data+PLACEABLESIZE),&length);
     pmhdr=(PLACEABLEMETAHEADER*)data;
     pmhdr->Key=PLACEABLEMAGIC;
     pmhdr->Bottom=(short)bottom;
     pmhdr->Left=(short)left;
     pmhdr->Top=(short)top;
     pmhdr->Right=(short)right;
     pmhdr->Handle=0;
     pmhdr->Inch=(short)dpi;
     pmhdr->Reserved=0;
     pmchecksum(pmhdr);

     err=fs_saveblock(filename,0,data,size+PLACEABLESIZE);

     free(data);
    }
    else
    {
     err=geterror(EMEM);
    }
   }
   XDeleteMetaFile(hmf);
  }
 }
 return(err);
}








// desc of form "CrossStar\0Grid\0" program name, picture name

// problem #1 for text this doesn't seem to auto calculate the area correctly
// problem #2 give it a size in mm 0.01's and it uses the OS dependent way of getting pixels

os_error * openemf(TCHAR * filename,int flags,int maxx,int maxy,metahandle * handle,TCHAR * desc)
{
 os_error * err;
 HDC        hdc;
 RECT       rect;

 if(GetVersion() & 0x80000000)          // W98
 {
  rect.bottom=(maxy*2540)/(cvdu.ydpi);
  rect.right=(maxx*2540)/(cvdu.xdpi);
 }
 else
 {
  hdc=CreateIC(TEXT("DISPLAY"),NULL,NULL,NULL); // DeleteDC below

  rect.bottom=(maxy*GetDeviceCaps(hdc,VERTSIZE)*100)/(GetDeviceCaps(hdc,VERTRES));
  rect.right=(maxx*GetDeviceCaps(hdc,HORZSIZE)*100)/(GetDeviceCaps(hdc,HORZRES));

  DeleteDC(hdc);
 }

 rect.top=0;
 rect.left=0;

 err=XCreateEnhMetaFile(NULL,filename,&rect,desc,&hdc);
 if(!err)
 {
  *handle=(metahandle)hdc;
  mfinit(hdc,maxx,maxy);
 }

 return(err);

 USE(flags);
}


os_error * closeemf(os_error * err,metahandle handle)
{
 HENHMETAFILE hemf;

 mffinit((HDC)handle); // current hdc null'd

 if(err)
 {
  XCloseEnhMetaFile((HDC)handle,&hemf);
  XDeleteEnhMetaFile(hemf);
 }
 else
 {
  err=XCloseEnhMetaFile((HDC)handle,&hemf);
  if(hemf)
  {
   XDeleteEnhMetaFile(hemf);
  }
 }

 return(err);
}






